/*
 *  linux/arch/arm/mach-mx1ads/cpu.c
 *
 *  Copyright (C) 2001 Deep Blue Solutions Ltd.
 *
 *  $Id: cpu.c,v 1.1.1.1 2005/01/15 09:30:26 bobby Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * CPU support functions
 */

/*  FIXME-
 *  Add support for clock change on the fly.  (Power)
 *
 */
#include <linux/config.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/cpufreq.h>
#include <linux/init.h>

#include <asm/hardware.h>
#include <asm/io.h>

__u32 mx1_id;
char *
mx1_id_string()
{
	static char string[256];

	switch (mx1_id) {
	case 0x04d4c01d:
		return "Codename Corsica";
	default:
		sprintf(string, "ID = %08X\n", mx1_id);
		return string;
	}
}

static int __init
cpu_init(void)
{
	mx1_id = inl(IO_ADDRESS(MX1_SIC_ID));
	printk("CPU: %s (ID=%08X)\n", mx1_id_string(), mx1_id);
	return 0;
}

__initcall(cpu_init);
