/*
 * arch/arm/mach-s3c2800/arch.c
 *
 * Samsung s3c2800 cpu
 *
 * Author: <source@mvista.com>
 *
 * 2003 (c) MontaVista Software, Inc. This file is licensed under
 * the terms of the GNU General Public License version 2. This program
 * is licensed "as is" without any warranty of any kind, whether express
 * or implied.
 */

#include <linux/config.h>
#include <linux/types.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/init.h>

#include <asm/hardware.h>
#include <asm/irq.h>
#include <asm/setup.h>
#include <asm/mach-types.h>

#include <asm/mach/arch.h>
#include <asm/mach/map.h>

extern void __init s3c2800_init_irq(void);

static void __init
fixup_s3c2800(struct machine_desc *desc, struct param_struct *params,
	     char **cmdline, struct meminfo *mi)
{
#ifdef CONFIG_MACH_FUJITSU_CAMELOT
#define SDRAM_SIZE	(8*1024*1024)
	/*
	 * SDRAM Bank 0 has one memory bank at start address 0x08000000 
	 */  
	mi->bank[0].start = PA_SDRAM_BASE;
	mi->bank[0].size =  SDRAM_SIZE;
	mi->bank[0].node =  0;
	mi->nr_banks = 1;
#endif

#if 0
	ROOT_DEV = MKDEV(RAMDISK_MAJOR,0);

#ifdef CONFIG_BLK_DEV_RAM_SIZE
	setup_ramdisk( 1, 0, 0, CONFIG_BLK_DEV_RAM_SIZE);
#else
	setup_ramdisk( 1, 0, 0, BLK_DEV_RAM_SIZE);
#endif
	setup_initrd( __phys_to_virt(RAMDISK_DN_ADDR), ZIP_RAMDISK_SIZE);
#endif
}

static void __init s3c2800_map_io(void)
{
#ifdef CONFIG_MACH_FUJITSU_CAMELOT
	extern void __init fujitsu_chamelot_map_io(void);
	fujitsu_chamelot_map_io();
#endif
}

#if 0
#define ustat0   (*(volatile unsigned *)(0xe0170010))
#define utx0	 (*(volatile unsigned char *)(0xe0170020))

void
debug_putc(char c)
{
	if (c == '\n')
		debug_putc('\r');

	/* wait until THR is empty */
        while (!(ustat0 & 0x2))
		;

	utx0 = c; 
}
#endif

MACHINE_START(FUJITSU_CAMELOT, "Samsung S3C2800")
	MAINTAINER("Montavista Software")
	BOOT_MEM(PA_SDRAM_BASE,PA_IO_PORT_BASE,VA_IO_PORT_BASE)
	BOOT_PARAMS(PA_SDRAM_BASE+0x100)
	FIXUP(fixup_s3c2800)
	MAPIO(s3c2800_map_io)
	INITIRQ(s3c2800_init_irq)
MACHINE_END
