#!/bin/sh
MODULE_NAME=ramdisk
RAMPATH=`pwd`/../$1
TMPPATH=${RAMPATH}/tmp
SOURCE=${RAMPATH}/romfs

# Clear in tmp path
rm -rf ${TMPPATH}/tmpmnt
rm -rf ${TMPPATH}/ramrootfs
mkdir ${TMPPATH}/tmpmnt

# Clear the old ramdisk
rm -f ${RAMPATH}/$MODULE_NAME.gz

# Make a temp file which size is 4096Kbytes
dd if=/dev/zero of=${TMPPATH}/ramrootfs bs=1k count=6400

# Create a ext2 filesystem
mke2fs -F -m 0 -i 2000 ${TMPPATH}/ramrootfs

# Mount it to tmpmnt/
mount -o loop -t ext2 ${TMPPATH}/ramrootfs ${TMPPATH}/tmpmnt

# Copy everything from kernel to this.
cd ${TMPPATH}/tmpmnt
echo ${SOURCE}
cp -av ${SOURCE}/*  .
cd ${TMPPATH}
# Unmount it the ext2 filesystem
umount ${TMPPATH}/tmpmnt
cat ${TMPPATH}/ramrootfs | gzip -9 > /${RAMPATH}/ramdisk.gz
echo Copying ramdisk image to ${RAMPATH}
cd ${RAMPATH}
#cp -f ramdisk.gz images/fs.ram
#cp -f linux-2.4.20_mvl31/arch/arm/boot/zImage images/.

cp -f ${RAMPATH}/ramdisk.gz ${RAMPATH}/img416/fs.ram
#cp -f linux-2.4.20_mvl31/arch/arm/boot/zImage img416/.
cd ${RAMPATH}/img416
./bb
cd `pwd`
sync
cp -f ${RAMPATH}/img416/zImage /tftpboot/
cp -f ${RAMPATH}/img416/fs.ram /tftpboot/

