#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "parser.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "PRO_file.h"
#include "cgi_def.h"
#include "h_var.h"

char 	cgi_buf[CGI_BUF_LEN];   /* buffer for do cgi r2t function */            
//char	err_msg_buf[ERR_MSG_BUF_LEN]={0}; /* buffer for do record error message */     
//char 	err_msg_fmt[ERR_MSG_FMT_LEN]; /* tmp buffer for format error message */

//---------------------------------------------------------------
// purpose: get get function index by key
// input: key  - function key
// ouput: get none return -1,or get one return one's index 
//---------------------------------------------------------------
int GetKeyFunIndex(char *key,keyfun_tab *kfun)
{
   int i;

   if(!kfun) return -1;
   for (i=0; kfun[i].key; i++) {
      if(strcmp(key,kfun[i].key)==0)
         return(i);
   } /* endfor */
   return -1;
}

//---------------------------------------------------------------
// purpose: parse html file,do cgi r2t function,then send the html file
// input: fname  - html file name,kfun - keyfun table
// ouput: ok return 0,error return 1
//---------------------------------------------------------------
int html_parser(char *fname, keyfun_tab *kfun)
{
#define MAX_TMP_LEN 256

/*
  html_parser function parse html stream, 
  search string like "@xxxxx#" 
  (x for any char,the string length must less than MAX_TMP_LEN)
  then do cgi save function.
*/
	
	FILE *fh;
	char ch;
	int state=0;/* 0 for searching '@'; 1 for searching '#' */
	char tmp[MAX_TMP_LEN]; /* tmp for scan */
	char *newbuf=NULL;
	int in=0;/* tmp array's index */
	int k;
	int ccode=0;
	
	fh=fopen(fname,"rt");
	if(fh==NULL) {
		return 1;
	}
	
	while((ch=fgetc(fh))!=EOF) {
		
		switch(state){
			case 0:/* searching '@' */
				if(ch=='@'){
					tmp[0]=ch;
					in=0;					
					state=1;
					break;
				}
				fwrite(&ch,sizeof(char),1,stdout);
				break;
				
			case 1:/* searching '#' */
				if((ch=='@')||(in>=MAX_TMP_LEN-1)){/*if get new '@' or tmp buf overflow */
					fwrite(tmp,sizeof(char),in+1,stdout);					
					in=0;	
					if(ch!='@'){		
						state=0;
						fwrite(&ch,sizeof(char),1,stdout);
					}
					else{
						tmp[0]=ch;
					}
					break;
				}		
				if(ch=='#'){
					in++;
					tmp[in]='\0';
					state=0;
					if(!kfun){
						break;
					}
					if((k=GetKeyFunIndex(tmp+1,kfun))!=-1){
						/* do cgi get function */
						cgi_buf[0]='\0';
						ccode=(*(kfun[k].r2tfun))(cgi_buf,&newbuf);	
						if(!ccode){
							cgi_buf[CGI_BUF_LEN-1]='\0';
							fwrite(cgi_buf,sizeof(char),strlen(cgi_buf),stdout);								
							if(newbuf){
								fwrite(newbuf,sizeof(char),strlen(newbuf),stdout);	
								free(newbuf);
								newbuf=NULL;							
							}
						}					
					}else{
						/* can't find cgi function */
						tmp[in]='#';
						fwrite(tmp,sizeof(char),in+1,stdout);
					}						
					break;
				}	
				in++;				
				tmp[in]=ch;				
				break;
			default:
				break;
		}			
	}	
	fclose(fh);
	return 0;	
}


//---------------------------------------------------------------
// purpose: do cgi t2r function
// input: head  - list head, kfun - keyfun table
// ouput: ok return 0,error return 1
//---------------------------------------------------------------
int do_cgi_t2r(LIST *head,keyfun_tab *kfun)
{
	keyfun_tab *p;
	int ccode=0;
	int err_state=0;
	char *val;
	if(!head||!kfun)
		return 1;

  	for(p=kfun;p->key;p++){
    	val=find_val(head,p->key);
		if(val==NULL)
			continue;
		if(p->t2rfun==NULL)
			continue;				
    	ccode=(p->t2rfun)(val);
    	if(ccode) {
			err_state=1;  
		}     	
	}  
	return err_state;
}
#if 0
//---------------------------------------------------------------
// purpose: get_err_msg do get error message from error message list
//			according to msg_no
// input: msg_no  - index of error message list,defined in h_bmsg.h
// ouput: return error message buffer, NULL to fail
// note : when error occur,you can do it,then must do fmt_err_msg,
//		  it will copy format buffer to gloabl err_msg_buf
//---------------------------------------------------------------
char *get_err_msg(int msg_no)
{
	FILE *fp;
	int i,len;
	
	fp=fopen("err_msg.list","r");
	if(fp==NULL)
		return NULL;
	if(msg_no<0 ||msg_no >= MESSAGE_LIST_SIZE)
		return NULL;
	for(i=0;i<=msg_no;i++)
		fgets(err_msg_fmt ,ERR_MSG_FMT_LEN,fp);
	if((len=strlen(err_msg_fmt))>0){
		if(err_msg_fmt[len-1]==0x0A)
			err_msg_fmt[len-1]='\0';/* remove 0A */
	}
	fclose(fp);
	return err_msg_fmt;
}

//---------------------------------------------------------------
// purpose: fmt_err_msg do format error message 
// input: format  - string buffer pointer from get_err_msg,
//		  ... - alterable args like sprintf
// ouput: none
// note : you can do fmt_err_msg only when no doing get_err_msg, 
//---------------------------------------------------------------
void fmt_err_msg(char *format, ...)
{
	va_list args;
	
	int i,len=strlen(err_msg_buf);
	if(!format)
		return;	
	for(i=0;format[i]!='\0';i++){
		if(i>0&&(format[i-1]=='\\')&&(format[i]=='n')){
			/* chage "\n" to 0x0D 0x0A */
			format[i-1]=0x0D;
			format[i]=0x0A;
		}
	}
	if(strlen(format)<(ERR_MSG_BUF_LEN-len)){
		va_start(args, format);
	    vsnprintf(err_msg_buf + len,ERR_MSG_BUF_LEN-len, format, args);
	    va_end(args);
	}
	else{
		memcpy(err_msg_buf + len,format,ERR_MSG_BUF_LEN-len);
	}
    err_msg_buf[ERR_MSG_BUF_LEN-1]='\0';
    return;
}

//---------------------------------------------------------------
// purpose: set_err_msg do cpoy current error message buffer to buf
// input: buf  - string buffer pointer from get_err_msg,
//		  buf1 - if buf overflow, can malloc new buffer to it,
//				 but now we ignore it, we guess the error message 
//				 buffer length must less than CGI_BUF_LEN
// ouput: none
// note: r2t_message may(or must) do set_err_msg
//---------------------------------------------------------------
void set_err_msg(char buf[CGI_BUF_LEN],char **buf1)
{
	int len=CGI_BUF_LEN-1;
	if(strlen(err_msg_buf)<CGI_BUF_LEN)
		len=strlen(err_msg_buf);

	memcpy(buf,err_msg_buf,len);
	buf[len]='\0';
	memset(	err_msg_buf, 0, ERR_MSG_BUF_LEN);
}
#endif
