#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_set_time(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_set_time_manually(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_year0(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_year1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_month0(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_month1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_day0(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_day1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_hour0(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_hour1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_minute0(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_minute1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_second0(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_second1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_pppoe_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_hide_master_head(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_master(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_master_wan_master(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_sub(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_sub_wan_sub2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_hide_enable_head(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_enable_upnp(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_hide_enable_tail(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_enable_config(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_upnp_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_enable_disable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mtu(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns2_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns2_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns2_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns2_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns3_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns3_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns3_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns3_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_set_time(const char *value);
static int t2r_year0(const char *value);
static int t2r_year1(const char *value);
static int t2r_month0(const char *value);
static int t2r_month1(const char *value);
static int t2r_day0(const char *value);
static int t2r_day1(const char *value);
static int t2r_hour0(const char *value);
static int t2r_hour1(const char *value);
static int t2r_minute0(const char *value);
static int t2r_minute1(const char *value);
static int t2r_second0(const char *value);
static int t2r_second1(const char *value);
static int t2r_pppoe_enable(const char *value);
static int t2r_wan_master(const char *value);
static int t2r_wan_sub(const char *value);
static int t2r_enable_upnp(const char *value);
static int t2r_enable_config(const char *value);
static int t2r_enable_disable(const char *value);
static int t2r_mtu(const char *value);
static int t2r_dns2_ip_1(const char *value);
static int t2r_dns2_ip_2(const char *value);
static int t2r_dns2_ip_3(const char *value);
static int t2r_dns2_ip_4(const char *value);
static int t2r_dns3_ip_1(const char *value);
static int t2r_dns3_ip_2(const char *value);
static int t2r_dns3_ip_3(const char *value);
static int t2r_dns3_ip_4(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"set_time",r2t_set_time,t2r_set_time},
	{"set_time_manually",r2t_set_time_manually,NULL},
	{"year0",r2t_year0,t2r_year0},
	{"year1",r2t_year1,t2r_year1},
	{"month0",r2t_month0,t2r_month0},
	{"month1",r2t_month1,t2r_month1},
	{"day0",r2t_day0,t2r_day0},
	{"day1",r2t_day1,t2r_day1},
	{"hour0",r2t_hour0,t2r_hour0},
	{"hour1",r2t_hour1,t2r_hour1},
	{"minute0",r2t_minute0,t2r_minute0},
	{"minute1",r2t_minute1,t2r_minute1},
	{"second0",r2t_second0,t2r_second0},
	{"second1",r2t_second1,t2r_second1},
	{"pppoe_enable",r2t_pppoe_enable,t2r_pppoe_enable},
	{"hide_master_head",r2t_hide_master_head,NULL},
	{"wan_master",r2t_wan_master,t2r_wan_master},
	{"wan_master_wan_master",r2t_wan_master_wan_master,NULL},
	{"wan_sub",r2t_wan_sub,t2r_wan_sub},
	{"wan_sub_wan_sub2",r2t_wan_sub_wan_sub2,NULL},
	{"poe_account_list",r2t_poe_account_list,NULL},
	{"hide_enable_head",r2t_hide_enable_head,NULL},
	{"enable_upnp",r2t_enable_upnp,t2r_enable_upnp},
	{"hide_enable_tail",r2t_hide_enable_tail,NULL},
	{"enable_config",r2t_enable_config,t2r_enable_config},
	{"upnp_message",r2t_upnp_message,NULL},
	{"enable_disable",r2t_enable_disable,t2r_enable_disable},
	{"mtu",r2t_mtu,t2r_mtu},
	{"DNS2_IP_1",r2t_dns2_ip_1,t2r_dns2_ip_1},
	{"DNS2_IP_2",r2t_dns2_ip_2,t2r_dns2_ip_2},
	{"DNS2_IP_3",r2t_dns2_ip_3,t2r_dns2_ip_3},
	{"DNS2_IP_4",r2t_dns2_ip_4,t2r_dns2_ip_4},
	{"DNS3_IP_1",r2t_dns3_ip_1,t2r_dns3_ip_1},
	{"DNS3_IP_2",r2t_dns3_ip_2,t2r_dns3_ip_2},
	{"DNS3_IP_3",r2t_dns3_ip_3,t2r_dns3_ip_3},
	{"DNS3_IP_4",r2t_dns3_ip_4,t2r_dns3_ip_4},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "dev_opt_cgi.c"

/*************************/
