#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_email_alert(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_email_outlog(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_email_aclog(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_send_log(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_send_log_set_time(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_log_schedule_day(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_log_schedule_time(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_log_schedule_ampm(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mail_to(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_subject(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_smtp_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_smtp_server(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_smtp_type_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ms_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ms_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ms_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ms_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_email_alert(const char *value);
static int t2r_email_outlog(const char *value);
static int t2r_email_aclog(const char *value);
static int t2r_send_log(const char *value);
static int t2r_log_schedule_day(const char *value);
static int t2r_log_schedule_time(const char *value);
static int t2r_log_schedule_ampm(const char *value);
static int t2r_mail_to(const char *value);
static int t2r_subject(const char *value);
static int t2r_smtp_type(const char *value);
static int t2r_smtp_server(const char *value);
static int t2r_ms_ip_1(const char *value);
static int t2r_ms_ip_2(const char *value);
static int t2r_ms_ip_3(const char *value);
static int t2r_ms_ip_4(const char *value);
static int t2r_port(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"email_alert",r2t_email_alert,t2r_email_alert},
	{"email_outlog",r2t_email_outlog,t2r_email_outlog},
	{"email_aclog",r2t_email_aclog,t2r_email_aclog},
	{"send_log",r2t_send_log,t2r_send_log},
	{"send_log_set_time",r2t_send_log_set_time,NULL},
	{"log_schedule_day",r2t_log_schedule_day,t2r_log_schedule_day},
	{"log_schedule_time",r2t_log_schedule_time,t2r_log_schedule_time},
	{"log_schedule_ampm",r2t_log_schedule_ampm,t2r_log_schedule_ampm},
	{"Mail_To",r2t_mail_to,t2r_mail_to},
	{"subject",r2t_subject,t2r_subject},
	{"smtp_type",r2t_smtp_type,t2r_smtp_type},
	{"smtp_server",r2t_smtp_server,t2r_smtp_server},
	{"smtp_type_ip",r2t_smtp_type_ip,NULL},
	{"MS_IP_1",r2t_ms_ip_1,t2r_ms_ip_1},
	{"MS_IP_2",r2t_ms_ip_2,t2r_ms_ip_2},
	{"MS_IP_3",r2t_ms_ip_3,t2r_ms_ip_3},
	{"MS_IP_4",r2t_ms_ip_4,t2r_ms_ip_4},
	{"port",r2t_port,t2r_port},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "email_cgi.c"

/*************************/
