#ifndef _EMAIL_CGI_C_
#define _EMAIL_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "email.h"
#include "parser.h"

static mail_conf conf;
static char *str_day_db[]={"Every Sunday","Every Monday","Every Tuesday",
			"Every Wednesday","Every Thursday","Every Friday","Every Saturday",
			"On Weekdays","Every Day",0};

static int r2t_email_alert(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	if(conf.dos_enable)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_email_outlog(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	if(conf.out_enable)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_email_aclog(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	if(conf.in_enable)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_send_log(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	if(conf.mail_type==0)
		strcpy(buf,str_checked);
	else
		strcpy(buf,"");
	return 0;
}

static int r2t_send_log_set_time(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	if(conf.mail_type==1)
		strcpy(buf,str_checked);
	else
		strcpy(buf,"");

	return 0;
}

static int r2t_log_schedule_day(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;

	buf[0]='\0';
	for(i=0; i<9; i++){
		if(i==conf.day){
			strcat(buf,option_sl);
			strcat(buf,str_day_db[i]);
			strcat(buf,option_e);


		}
		else{
			strcat(buf,option_s);
			strcat(buf,str_day_db[i]);
			strcat(buf,option_e);
		}

	}

	return 0;
}

static int r2t_log_schedule_time(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	char hour[4]={0};

	buf[0]='\0';

	for(i=1; i<13; i++){
		sprintf(hour,"%d",i);
		if(i==conf.hour){
			strcat(buf,option_sl);
			strcat(buf,hour);
			strcat(buf,option_e);
		}
		else{
			strcat(buf,option_s);
			strcat(buf,hour);
			strcat(buf,option_e);
		}
	}
	return 0;
}

static int r2t_log_schedule_ampm(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';

	if(conf.ampm==0){
		strcat(buf,option_sl);
		strcat(buf,"AM");
		strcat(buf,option_e);
		strcat(buf,option_s);
		strcat(buf,"PM");
		strcat(buf,option_e);
	}
	else{
		strcat(buf,option_s);
		strcat(buf,"AM");
		strcat(buf,option_e);
		strcat(buf,option_sl);
		strcat(buf,"PM");
		strcat(buf,option_e);
	}
	return 0;
}

static int r2t_mail_to(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	strcpy(buf,conf.receiver);
	return 0;
}

static int r2t_subject(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	strcpy(buf,conf.subject);
	return 0;
}

static int r2t_smtp_type(char buf[CGI_BUF_LEN],char **buf1)
{
	if(conf.smtp_type==0)
		strcpy(buf,str_checked);
	else
		strcpy(buf,"");

	return 0;
}
static int r2t_smtp_server(char buf[CGI_BUF_LEN],char **buf1)
{
	if(conf.smtp_type==0)
		strcpy(buf,conf.smtp_server);
	else
		strcpy(buf,"");

	return 0;
}

static int r2t_smtp_type_ip(char buf[CGI_BUF_LEN],char **buf1)
{
	if(conf.smtp_type==1)
		strcpy(buf,str_checked);
	else
		strcpy(buf,"");

	return 0;
}

static int r2t_ms_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",conf.smtp_serverip[0]);
	return 0;
}

static int r2t_ms_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",conf.smtp_serverip[1]);
	return 0;
}

static int r2t_ms_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",conf.smtp_serverip[2]);
	return 0;
}

static int r2t_ms_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",conf.smtp_serverip[3]);
	return 0;
}

static int r2t_port(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",conf.smtp_port);
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf,buf1);
    return 0;
}

static int t2r_email_alert(const char *value)
{
	if(value)
		conf.dos_enable=1;
	else
		conf.dos_enable=0;
	return 0;
}

static int t2r_email_outlog(const char *value)
{
	if(value)
		conf.out_enable=1;
	else
		conf.out_enable=0;
	return 0;
}

static int t2r_email_aclog(const char *value)
{
	if(value)
		conf.in_enable=1;
	else
		conf.in_enable=0;
	return 0;
}

static int t2r_send_log(const char *value)
{
	if(strcmp(value,"when_full")==0)
		conf.mail_type=0;
	else
		conf.mail_type=1;
	return 0;
}

static int t2r_log_schedule_day(const char *value)
{
	conf.day=str_db_search(str_day_db,value);
	return 0;
}

static int t2r_log_schedule_time(const char *value)
{
	conf.hour=atoi(value);
	return 0;
}

static int t2r_log_schedule_ampm(const char *value)
{
	if(strcmp(value,"AM")==0)
		conf.ampm=0;
	else
		conf.ampm=1;
	return 0;
}

static int t2r_mail_to(const char *value)
{
	strncpy(conf.receiver,value,MaxEmailLen);
	conf.receiver[MaxEmailLen]='\0';
	return 0;
}

static int t2r_subject(const char *value)
{
	strncpy(conf.subject,value,MaxEmailLen);
	conf.subject[MaxEmailLen]='\0';
	return 0;
}

static int t2r_smtp_type(const char *value)
{
	if(strcmp(value,"address")==0)
		conf.smtp_type=0;
	else
		conf.smtp_type=1;
	return 0;
}
static int t2r_smtp_server(const char *value)
{
    strncpy(conf.smtp_server, value, MaxEmailLen);
    conf.smtp_server[MaxEmailLen]='\0';
	return 0;
}

static int t2r_ms_ip_1(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= &conf.smtp_serverip[0];

    *(p) = ip;
    return (0);
}

static int t2r_ms_ip_2(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= &conf.smtp_serverip[1];

    *(p) = ip;
    return (0);
}

static int t2r_ms_ip_3(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= &conf.smtp_serverip[2];

    *(p) = ip;
    return (0);
}

static int t2r_ms_ip_4(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= &conf.smtp_serverip[3];

    *(p) = ip;
    return (0);
}

static int t2r_port(const char *value)
{
    int ip = atoi(value);
    int *p= &conf.smtp_port;

    *(p) = ip;
    return (0);
}

static int t2r_save(const char *value)
{
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}
static int t2r_close(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

int email_main(void)
{
	LIST *hd;
	int ccode;

	memset(&conf,0,sizeof(conf));
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}
		if(!do_cgi_t2r(hd,key_fun_tab)){
			ccode=SaveMailConf(&conf);
			WriteConfToFlash();
		}
		list_clear(hd);
	}
	else
		ReadMailConf(&conf);
	ccode=html_parser("email.htm",key_fun_tab);
	return ccode;
}

#endif
