#ifndef _ETHER_CGI_C_
#define _ETHER_CGI_C_

#include "parser.h"
#include "cgi-lib.h"
#include "wan.h"
#include "lan.h"
#include "system.h"
#include "fw.h"
#include "dev_opt.h"

static DHCP_CONF *p_conf = &dhcp_conf;


static int r2t_d_name(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%s",p_conf->dhcp_name);
    return(0);
}
static int r2t_domain_name(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%s",p_conf->domain_name);
    return(0);
}
static int r2t_dhcp_cl(char buf[CGI_BUF_LEN],char **buf1)
{
    if(p_conf->dhcpc_type == 0){
        strcpy(buf,str_checked);
    }
    return(0);
}
static int r2t_dhcp_cl_disable(char buf[CGI_BUF_LEN],char **buf1)
{
    if(p_conf->dhcpc_type == 1){
        strcpy(buf,str_checked);
    }
    return(0);
}
static int r2t_dev_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->ipAddress));
    return(0);
}
static int r2t_dev_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->ipAddress+1));
    return(0);
}
static int r2t_dev_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->ipAddress+2));
    return(0);
}
static int r2t_dev_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->ipAddress+3));
    return(0);
}
static int r2t_dev_mask_1(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->netMask));
    return(0);
}
static int r2t_dev_mask_2(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->netMask+1));
    return(0);
}
static int r2t_dev_mask_3(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->netMask+2));
    return(0);
}
static int r2t_dev_mask_4(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->netMask+3));
    return(0);
}
static int r2t_dev_gw_1(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->Gateway));
    return(0);
}
static int r2t_dev_gw_2(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->Gateway+1));
    return(0);
}
static int r2t_dev_gw_3(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->Gateway+2));
    return(0);
}
static int r2t_dev_gw_4(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->Gateway+3));
    return(0);
}
static int r2t_dns_type(char buf[CGI_BUF_LEN],char **buf1)
{
    if(p_conf->dhcp_dns_type == 0){
        strcpy(buf,str_checked);
    }
    return(0);
}
static int r2t_dns_type_fixed(char buf[CGI_BUF_LEN],char **buf1)
{
    if(p_conf->dhcp_dns_type == 1){
        strcpy(buf,str_checked);
    }
    return(0);
}
static int r2t_dns1_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->dns[0]));
    return(0);
}
static int r2t_dns1_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->dns[0]+1));
    return(0);
}
static int r2t_dns1_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->dns[0]+2));
    return(0);
}
static int r2t_dns1_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%d",*((unsigned char*)&p_conf->dns[0]+3));
    return(0);
}
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
    set_err_msg(buf,buf1);
    return(0);
}


static int t2r_d_name(const char *value)
{
    if(strlen(value)>=DHCP_NAME_LEN){
        setbit(glb_errlog,MSG1_ETHER);
    }
    else{
        strcpy(p_conf->dhcp_name, value);
    }    
    return(0);
}
static int t2r_domain_name(const char *value)
{
    if(strlen(value)>=DOMAIN_NAME_LEN){
        setbit(glb_errlog,MSG2_ETHER);
    }
    else{
        strcpy(p_conf->domain_name, value);
    }
    
    return(0);
}
static int t2r_dhcp_cl(const char *value)
{
    p_conf->dhcpc_type = str_db_search(dhcp_cl_db,value);
    return (0);
}
static int t2r_dev_ip_1(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->ipAddress;

    *p = ip;
    return (0);
}
static int t2r_dev_ip_2(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->ipAddress;

    *(p+1) = ip;
    return (0);
}
static int t2r_dev_ip_3(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->ipAddress;

    *(p+2) = ip;
    return (0);
}
static int t2r_dev_ip_4(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->ipAddress;

    *(p+3) = ip;
    return (0);
}
static int t2r_dev_mask_1(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->netMask;

    *p = ip;
    return (0);
}
static int t2r_dev_mask_2(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->netMask;

    *(p+1) = ip;
    return (0);
}
static int t2r_dev_mask_3(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->netMask;

    *(p+2) = ip;
    return (0);
}
static int t2r_dev_mask_4(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->netMask;

    *(p+3) = ip;
    return (0);
}
static int t2r_dev_gw_1(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->Gateway;

    *p = ip;
    return (0);
}
static int t2r_dev_gw_2(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->Gateway;

    *(p+1) = ip;
    return (0);
}
static int t2r_dev_gw_3(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->Gateway;

    *(p+2) = ip;
    return (0);
}
static int t2r_dev_gw_4(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->Gateway;

    *(p+3) = ip;
    return (0);
}
static int t2r_dns_type(const char *value)
{
    p_conf->dhcp_dns_type = str_db_search(dns_type_db,value);
    return (0);
}
static int t2r_dns1_ip_1(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->dns[0];

    *p = ip;
    return (0);
}
static int t2r_dns1_ip_2(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->dns[0];

    *(p+1) = ip;
    return (0);
}
static int t2r_dns1_ip_3(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->dns[0];

    *(p+2) = ip;
    return (0);
}
static int t2r_dns1_ip_4(const char *value)
{
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&p_conf->dns[0];

    *(p+3) = ip;
    return (0);
}
static int t2r_back(const char *value){
    return 0;
}

static int t2r_save(const char *value){
    return 0;
}

static int t2r_help(const char *value){
    return 0;
}

static int t2r_message(const char *value)
{
    return (0);
}

int ether_main(void)
{

	LIST *hd=NULL;
	DHCP_CONF *pConf=&dhcp_conf;
    
    	ReadDHCPSettings(pConf);   
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}
		if(!do_cgi_t2r(hd,key_fun_tab)){
		    	if(ErrlogIsSetted()){
		        	if(isset(glb_errlog,MSG1_ETHER)){		            
                    			char *msg=get_err_msg(MSG1_ETHER);
    		     	   		fmt_err_msg(msg,DHCP_NAME_LEN-1);
    		    		}
		        	if(isset(glb_errlog,MSG2_ETHER)){
                    			char *msg=get_err_msg(MSG2_ETHER);
    		        		fmt_err_msg(msg,DOMAIN_NAME_LEN-1);
    		    		}
    			}
    			else{
				StopWan();
    		   	 	if(!pConf->dhcpc_type){
    		   		     	pConf->ipAddress = pConf->netMask = pConf->Gateway = 0;
    			    	}
    			    	if(!pConf->dhcp_dns_type){
    			        	pConf->dns[0] = 0;
    			    	}
              	  		pConf->dns[1] = pConf->dns[2] = 0; /* on UI only one dns setting */
                
				SaveDHCPSettings(pConf);
 				set_wan_type(CONNECTION_DHCP);   
                		WriteConfToFlash();
                		if(fork()==0){
                			cgi_fork_do();
					StartWan();			
					exit(0);
				}
            		}            
		}
		list_clear(hd);
	}
   	return html_parser("ether.htm",key_fun_tab);
}
#endif //_ETHER_CGI_C_
