#ifndef _FW_SERV_CGI_C_
#define _FW_SERV_CGI_C_

#include "serv.h"

static serv_conf	*pConf=NULL;
static int		serv_num=0;

#define SAFEFREE(x)	do{	\
				if((x)!=NULL){		\
					free(x);	\
					(x)=NULL;	\
				}	\
			}while(0)
			
			
static int poe_account_index;


static int r2t_serv_list(char buf[CGI_BUF_LEN],char **buf1)
{
	serv_conf *p=pConf;
	
	
	*buf1=(char *)malloc((EntryNameLen+30+strlen(option_s)+strlen(option_e))*serv_num+1);
	while(p){
		char u_buf[30];
		
		strcat(*buf1,option_s);
		strcat(*buf1,p->name);
		sprintf(u_buf,"(%s:%s)",p->protocol,p->port_info);
		strcat(*buf1,u_buf);
		strcat(*buf1,option_e);
		p=p->next;
	}
	return 0;
}


static int r2t_ud_service(char buf[CGI_BUF_LEN],char **buf1)
{
	
	return 0;
}


static int r2t_svc_type(char buf[CGI_BUF_LEN],char **buf1)
{
	
	char *pro[4]={
		"TCP",
		"UDP",
		"TCP/UDP",
		"ICMP"
	};
	int i;
	
	
	for(i=0;i<4;i++){
		strcat(buf,option_s);
		strcat(buf,pro[i]);
		strcat(buf,option_e);
	}
	
	return 0;
}

static int r2t_port_start(char buf[CGI_BUF_LEN],char **buf1)
{
	
	return 0;
}


static int r2t_port_finish(char buf[CGI_BUF_LEN],char **buf1)
{
	
	return 0;
}


static int r2t_icmp_type(char buf[CGI_BUF_LEN],char **buf1)
{
	
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	
	return 0;
}

static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",poe_account_index);
	return 0;
}
//=============================SAVE FUNCTIONS=================================

static serv_conf	conf;
static char 		port_s[PortLen]={0};
static char 		port_e[PortLen]={0};

static char todo=0;

#define 	DEL	1
#define		ADD	2

static int t2r_serv_list(const char *value)
{
	return 0;
}

static int t2r_delete(const char *value)
{
	if(value&&strlen(value))
		todo=DEL;
	return 0;
}

static int t2r_ud_service(const char *value)
{
	strcpy(conf.name,value);
	return 0;
}

static int t2r_svc_type(const char *value)
{
	strcpy(conf.protocol,value);
	return 0;
}

static int t2r_port_start(const char *value)
{
	if(value)
		strcpy(port_s,value);
	return 0;
}
	
static int t2r_port_finish(const char *value)
{
	if(value){
		strcpy(port_e,value);
		sprintf(conf.port_info,"%s-%s",port_s,port_e);
	}
	return 0;
}
	
static int t2r_icmp_type(const char *value)
{
	if(value)
		strcpy(conf.port_info,value);
	return 0;
}

static int t2r_save(const char *value)
{
	if(value&&strlen(value))
		todo=ADD;
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_close(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

static int t2r_poe_ac_value(const char *value)
{
	poe_account_index=atoi(value);
	return 0;
}

int fw_serv_main(void)
{
    
	LIST *hd=NULL;
	int ccode;
	
	poe_account_index=-1;
	
	memset(&conf,0,sizeof(conf));
	hd=cgi_input_parse();
	if (strcmp(REQUEST_METHOD,POST) == 0){
		if(!hd){
			cgi_err("","");
		}		
		if(!do_cgi_t2r(hd,key_fun_tab)){
			
			if(todo==ADD)
				ccode=AddSERV(&conf,poe_account_index);
			else if(todo==DEL){
				char **items=NULL;
				int no=0,i;
				char *p;
				
				no=find_val_multi(hd,"serv_list",&items);
				for(i=0;i<no;i++){
					p=strchr(*(items+i),'(');
					if(p)
						*p=0;
				}
				
				ccode=DelSERV(items,no,poe_account_index);
				
				for(i=0;i<no;i++)
					SAFEFREE(*(items+i));
				SAFEFREE(items);
			}	
		}
		WriteConfToFlash();
		list_clear(hd);		
	}else{
		char *val;
		val=find_val(hd,"acc_index");
		if(val)
			poe_account_index=atoi(val);  
	}

	ReadSERV(&pConf,&serv_num,poe_account_index);

   	ccode=html_parser("fw_serv.htm",key_fun_tab);
   	if(pConf)
   		FreeSERV(pConf);
   	
   	return ccode;
}
#endif
