#ifndef _GRP_MEM_CGI_C_
#define _GRP_MEM_CGI_C_
#include "lan.h"
#include "groups.h"

static char group_name[WK_NAME_LEN];
static char other_name[WK_NAME_LEN];
static int which_submit;
static PC_DB_CONF_s tmp_pc;
struct in_addr group_ip,other_ip;

enum{
    BUT_DEL=1,
    BUT_ADD
};



int r2t__group_name_(char buf[CGI_BUF_LEN],char **buf1){
	strcpy(buf,get_err_msg(MSG1_GRP_MEM));
	switch(group_index){
	case 0:
		strcat(buf,get_err_msg(MSG1_GROUPS));
		break;
	case 1:
		strcat(buf,get_err_msg(MSG2_GROUPS));
		break;
	case 2:
		strcat(buf,get_err_msg(MSG3_GROUPS));
		break;
	case 3:
		strcat(buf,get_err_msg(MSG4_GROUPS));
		break;
	case 4:
		strcat(buf,get_err_msg(MSG5_GROUPS));
		break;
	}
	return 0;
}

int r2t_group_pc_list(char buf[CGI_BUF_LEN],char **buf1){
    short i;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;
    short len=0;

    *buf1 = malloc(PCDB_ENTRY_MAX_LEN * 255);

    if(!*buf1){ /*fail to allocate memory. */
        return 0;
    }
    for ( i=0, p_entry=p_pcdb_conf->p_database;
          i<p_pcdb_conf->number && p_entry;
          i++,p_entry = p_entry->next
    ){
        if(p_entry->group != group_index){
            continue;
        }
        len += sprintf(*buf1+len, "%s", option_s);
        len += sprintf(*buf1+len, "%s", p_entry->name);
        len += sprintf(*buf1+len, " (%u.%u.%u.%u) ", p_entry->ip_addr[0], p_entry->ip_addr[1], p_entry->ip_addr[2], p_entry->ip_addr[3]);
        len += sprintf(*buf1+len, " (%s) ", str_pctype_db(p_entry->iface));
        len += sprintf(*buf1+len, " (%s) ", str_pcreserve_db(p_entry->reserve));
        len += sprintf(*buf1+len, "%s", option_e);

    }
	return 0;
}

int r2t_other_pc_list(char buf[CGI_BUF_LEN],char **buf1){
    short i;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;
    short len=0;

    *buf1 = malloc(PCDB_ENTRY_MAX_LEN * 255);

    if(!*buf1){ /*fail to allocate memory. */
        return 0;
    }
    for (i=0, p_entry=p_pcdb_conf->p_database;
        i<p_pcdb_conf->number && p_entry;
        i++,p_entry = p_entry->next
    ){
        if(p_entry->group == group_index){
            continue;
        }
        len += sprintf(*buf1+len, "%s", option_s);
        len += sprintf(*buf1+len, "%s", p_entry->name);
        len += sprintf(*buf1+len, " (%u.%u.%u.%u) ", p_entry->ip_addr[0], p_entry->ip_addr[1], p_entry->ip_addr[2], p_entry->ip_addr[3]);
        len += sprintf(*buf1+len, " (%s) ", str_pctype_db(p_entry->iface));
        len += sprintf(*buf1+len, " (%s) ", str_pcreserve_db(p_entry->reserve));
        len += sprintf(*buf1+len, "%s", option_e);

    }
    GetDynamicPCInfo(*buf1+len, 0, NULL);
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
	return 0;
}

int t2r_group_pc_list(const char *value){
    char *p, *q;

    p = strchr(value, ' ');
    if (p){
        *p = '\0';
        strcpy(group_name, value);
        *p = ' ';
        
        p += 2;
        q = strchr(p,')');
        if(!q){
            return 0;
        }
        *q = '\0';
        inet_aton(p,&group_ip);
        *q = ')';
    }
	return 0;
}

int t2r_del(const char *value){
    which_submit = BUT_DEL;
	return 0;
}

int t2r_add(const char *value){
    which_submit = BUT_ADD;
	return 0;
}

int t2r_other_pc_list(const char *value){
    char *p, *q;

    p = strchr(value, ' ');
    if (p){
        *p = '\0';
        strcpy(other_name, value);
        *p = ' ';

        p += 2;
        q = strchr(p,')');
        if(!q){
            return 0;
        }
        *q = '\0';
        inet_aton(p,&other_ip);
        *q = ')';

    }
	return 0;
}

int t2r_close(const char *value){
	return 0;
}

int t2r_message(const char *value){
	return 0;
}

int grp_mem_main(){
	LIST *hd=NULL;
	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
	PC_DB_CONF_s *p_entry;
    int prev_gid = 0;

	ReadPCDBConf(p_pcdb_conf);

	/* Init value */
	which_submit = 0;
	*group_name = '\0';
	*other_name = '\0';
	group_ip.s_addr = other_ip.s_addr = 0;
	group_index = GetGrpIndex();

	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!do_cgi_t2r(hd,key_fun_tab)){
		    /* success */
		    switch(which_submit){
		    case BUT_DEL:
		        if ((p_entry = PCDBGetEntry(group_name)) != NULL){
		            p_entry->group = 0;
		        }
		        break;
		    case BUT_ADD:
		        if ((p_entry = PCDBGetEntry(other_name)) != NULL){
		            prev_gid = p_entry->group;
		            p_entry->group = group_index;
		        }
		        else{
		            /* Try dynamic table. */
		            struct lease_t *p_lease = GetDynPCInfo(other_name);
			    prev_gid = 0;
		            if(!p_lease){
		                break;
		            }
		            /* Fill in pc db info. */
		            memset( &tmp_pc, 0, sizeof(tmp_pc) );
		            memcpy(tmp_pc.mac_addr, p_lease->chaddr,6);
		            strcpy(tmp_pc.name, p_lease->hostname);
		            memcpy(tmp_pc.ip_addr, &p_lease->yiaddr,4);
		            tmp_pc.reserve = 0;
		            tmp_pc.group = group_index;
		            tmp_pc.mac_type = 0;
		            tmp_pc.access_type = 0;
		            tmp_pc.iface = 0;
		            PCDBAdd(p_pcdb_conf, &tmp_pc);
		        }
		        break;
		    default:
		        break;
		    }
		}
		SavePCDBConf(p_pcdb_conf);
		WriteConfToFlash();
		WriteScript();
//		StartFW();
        switch(which_submit){
        case BUT_DEL:            
            gid_modify(group_ip, group_index, 0);
            break;
        case BUT_ADD:
            gid_modify(other_ip, prev_gid, group_index);
            break;
        default:
            break;
        }  
		list_clear(hd);
	}
	ReadPCDBConf(p_pcdb_conf);
	return html_parser("grp_mem.htm",key_fun_tab);
}
#endif /* _GRP_MEM_CGI_C_ */
