#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_r_interface(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_protocol(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_s_add(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_s_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_s_port2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_d_add(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_d_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_d_port2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_icmp_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_direction(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_select1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_select2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_select3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_s_add(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_s_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_s_port2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_d_add(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_d_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_d_port2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_icmp_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_select4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_select1(const char *value);
static int t2r_select2(const char *value);
static int t2r_name(const char *value);
static int t2r_select3(const char *value);
static int t2r_s_add(const char *value);
static int t2r_s_port(const char *value);
static int t2r_s_port2(const char *value);
static int t2r_d_add(const char *value);
static int t2r_d_port(const char *value);
static int t2r_d_port2(const char *value);
static int t2r_icmp_type(const char *value);
static int t2r_select4(const char *value);
static int t2r_save(const char *value);
static int t2r_add(const char *value);
static int t2r_delete(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_todo(const char *value);


static keyfun_tab key_fun_tab[]={
	{"r_interface",r2t_r_interface,NULL},
	{"r_protocol",r2t_r_protocol,NULL},
	{"r_s_add",r2t_r_s_add,NULL},
	{"r_s_port",r2t_r_s_port,NULL},
	{"r_s_port2",r2t_r_s_port2,NULL},
	{"r_d_add",r2t_r_d_add,NULL},
	{"r_d_port",r2t_r_d_port,NULL},
	{"r_d_port2",r2t_r_d_port2,NULL},
	{"r_icmp_type",r2t_r_icmp_type,NULL},
	{"r_direction",r2t_r_direction,NULL},
	{"select1",r2t_select1,t2r_select1},
	{"select2",r2t_select2,t2r_select2},
	{"name",r2t_name,t2r_name},
	{"select3",r2t_select3,t2r_select3},
	{"s_add",r2t_s_add,t2r_s_add},
	{"s_port",r2t_s_port,t2r_s_port},
	{"s_port2",r2t_s_port2,t2r_s_port2},
	{"d_add",r2t_d_add,t2r_d_add},
	{"d_port",r2t_d_port,t2r_d_port},
	{"d_port2",r2t_d_port2,t2r_d_port2},
	{"icmp_type",r2t_icmp_type,t2r_icmp_type},
	{"select4",r2t_select4,t2r_select4},
	{"save",NULL,t2r_save},
	{"add",NULL,t2r_add},
	{"delete",NULL,t2r_delete},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"todo",r2t_todo,t2r_todo},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "ipv6_fire_cgi.c"

/*************************/
