#ifndef _FW_IPV6_CGI_C_
#define _FW_IPV6_CGI_C_
#include "v6_fw.h"
#include "ipv6.h"
#include "../libprofile/h_var.h"
#include "system.h"


static v6_fw_conf *pConf;
static v6_fw_conf conf;
static char todo=0;


static int 		s_port_s;
static int 		s_port_e;
static int 		d_port_s;
static int 		d_port_e;
static	int port_t;
static	char port_s[16];
static	char *sp;

static int r2t_r_interface(char buf[CGI_BUF_LEN],char **buf1)
{

	int i;
	v6_fw_conf *p;
	
	*buf='\0';
	p=pConf;
	while(p){
		if(!strcmp(p->interface,"LAN"))
			strcat(buf,"\"0\",");
		else
			strcat(buf,"\"1\",");
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	return 0;
}

static int r2t_r_protocol(char buf[CGI_BUF_LEN],char **buf1)
{

	int i;
	v6_fw_conf *p;
	
	*buf='\0';
	p=pConf;
	while(p){
		if(strcmp(p->protocol,"TCP")==0)
			strcat(buf,"\"0\",");
		if(strcmp(p->protocol,"UDP")==0)
			strcat(buf,"\"1\",");
		if(strcmp(p->protocol,"TCP/UDP")==0)
			strcat(buf,"\"2\",");
		if(strcmp(p->protocol,"ICMP")==0)
			strcat(buf,"\"3\",");
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	return 0;
}

static int r2t_r_s_add(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	char ip[FWIP6Len+3];
	v6_fw_conf *p;
	
	*buf='\0';
/*
	*buf1=(char *)malloc(fw_num*(FWIP6Len+3));
*/
	memset(buf,0,CGI_BUF_LEN);
	p=pConf;
	while(p){
		sprintf(ip,"\"%s\",",p->s_add);
		strcat(buf,ip);
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	return 0;
}

static int r2t_r_s_port(char buf[CGI_BUF_LEN],char **buf1)
{
	int i=0;
	v6_fw_conf *p;
	
	memset(buf,0,CGI_BUF_LEN);
	p=pConf;
	while(p){
		sp = p->s_port;
		sscanf(sp,"%d-%*d",&port_t);
		if (port_t){
			sprintf(port_s,"\"%d\",",port_t);
			strcat(buf,port_s); 
		}else{
			strcat(buf,"\"\",");
		}
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	return 0;
}

static int r2t_r_s_port2(char buf[CGI_BUF_LEN],char **buf1)
{
	int i=0;
	v6_fw_conf *p;

	*buf='\0';
	p=pConf;
	while(p){
		sp = p->s_port;
		sscanf(sp,"%*d-%d",&port_t);
		if (port_t){
			sprintf(port_s,"\"%d\",",port_t);
			strcat(buf,port_s); 
		}else{
			strcat(buf,"\"\",");
		}
		p=p->next;


	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	return 0;
}

static int r2t_r_d_add(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	char ip[FWIP6Len+3];
	v6_fw_conf *p;
	
	*buf='\0';
	p=pConf;
	while(p){
		sprintf(ip,"\"%s\",",p->d_add);
		strcat(buf,ip);
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	return 0;
}

static int r2t_r_d_port(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	v6_fw_conf *p;
	
	*buf='\0';
	memset(buf,0,CGI_BUF_LEN);
	p=pConf;
	while(p){
		sp = p->d_port;
		sscanf(sp,"%d-%*d",&port_t);
		if (port_t){
			sprintf(port_s,"\"%d\",",port_t);
			strcat(buf,port_s); 
		}else{
			strcat(buf,"\"\",");
		}
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	return 0; 
}

static int r2t_r_d_port2(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	v6_fw_conf *p;
	
	*buf='\0';
	p=pConf;
	memset(port_s,0,16);
	while(p){
		sp = p->d_port;
		sscanf(sp,"%*d-%d",&port_t);
		if (port_t){
			sprintf(port_s,"\"%d\",",port_t);
			strcat(buf,port_s); 
		}else{
			strcat(buf,"\"\",");
		}
			
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	return 0;
}

static int r2t_r_icmp_type(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	v6_fw_conf *p;
	
	*buf='\0';
	p=pConf;
	while(p){
		sp = p->icmp_type;
		if (*sp<='0'||*sp>'9'){
			strcpy(port_s,"\"\",");
			strcat(buf,port_s);
			p=p->next;
			continue;
		}
		sprintf(port_s,"\"%s\",",sp);
		strcat(buf,port_s);
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	
	return 0;
	
}

static int r2t_r_direction(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	v6_fw_conf *p;
	
	*buf='\0';
	p=pConf;
	while(p){
		if(strcmp(p->direction,"Inbound")==0)
			strcat(buf,"\"0\",");
		if(strcmp(p->direction,"Outbound")==0)
			strcat(buf,"\"1\",");
		if(strcmp(p->direction,"Both")==0)
			strcat(buf,"\"2\",");
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,
	return 0;
}



static int r2t_select1(char buf[CGI_BUF_LEN],char **buf1)
{
	char *pro[2]={
		"LAN",
		"WAN",
	};
	int i;
	
	*buf='\0';
	for(i=0;i<2;i++){
		strcat(buf,option_s);
		strcat(buf,pro[i]);
		strcat(buf,option_e);
	}

	return 0;	
}
static int r2t_name(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	return 0;	
}

static int r2t_select2(char buf[CGI_BUF_LEN],char **buf1)
{
	v6_fw_conf *p;
	
	*buf='\0';
	p=pConf;
	while(p){
		if(strcmp(conf.name,p->name)==0)
			strcat(buf,option_sl);
		else
			strcat(buf,option_s);
		strcat(buf,p->name);
		strcat(buf,option_e);
		p=p->next;
	}
	
	return 0;
}

static int r2t_select3(char buf[CGI_BUF_LEN],char **buf1)
{
	char *pro[4]={
		"TCP",
		"UDP",
		"TCP/UDP",
		"ICMP",
	};
	int i;
	
	*buf='\0';
	for(i=0;i<4;i++){
		strcat(buf,option_s);
		strcat(buf,pro[i]);
		strcat(buf,option_e);
	}

	return 0;
}

static int r2t_select4(char buf[CGI_BUF_LEN],char **buf1)
{
	char *pro[3]={
		"Inbound",
		"Outbound",
		"Both",
	};
	int i;
	
	*buf='\0';
	for(i=0;i<3;i++){
		strcat(buf,option_s);
		strcat(buf,pro[i]);
		strcat(buf,option_e);
	}

	return 0;
}

static int r2t_s_add(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	return 0;
}

static int r2t_s_port(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	return 0;
}
static int r2t_s_port2(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	return 0;
}

static int r2t_d_add(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	return 0;
}

static int r2t_d_port(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	return 0;
}
static int r2t_d_port2(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	return 0;
}

static int r2t_icmp_type(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	set_err_msg(buf,buf1);
	return 0;
}

static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	return 0;
}

//save function

static char old_fw_name[FWEntryNameLen];


static int t2r_select1(const char *value)
{
	strcpy(conf.interface,value);
	return 0;
}

static int t2r_select2(const char *value)
{
	strcpy(old_fw_name,value);
	return 0;
}

static int t2r_name(const char *value)
{
	strcpy(conf.name,value);
	return 0;
}

static int t2r_select3(const char *value)
{
	strcpy(conf.protocol,value);
	return 0;
}

static int t2r_select4(const char *value)
{
	strcpy(conf.direction,value);
	return 0;
}

static int t2r_s_add(const char *value)
{
	int ret;
	if (strlen(value)){
		ret = CheckV6(value);
		if (ret){
			setbit(glb_errlog,MSG6_IPV6FIR);
			return 0;
		}
	}
	strcpy(conf.s_add,value);
	return 0;
}

static int t2r_s_port(const char *value)
{
	s_port_s = 0;
	if(strlen(value)){
		s_port_s = atoi(value);
		if( s_port_s<1 || s_port_s>65534 || !*value){
			setbit(glb_errlog,MSG2_IPV6FIR);
			return 0;
		}
	}
	return 0;
}
static int t2r_s_port2(const char *value)
{
	s_port_e = 0;
	if(strlen(value)){
		s_port_e = atoi(value);
		if( s_port_e<1 || s_port_e>65534 || !*value){
			setbit(glb_errlog,MSG3_IPV6FIR);
			return 0;
		}
		sprintf(conf.s_port,"%d-%d",s_port_s,s_port_e);
	}else{
		sprintf(conf.s_port,"%d-%d",s_port_s,0);
	}
	
	return 0;
}

static int t2r_d_add(const char *value)
{
	int ret;
	if (strlen(value)){
		ret = CheckV6(value);
		if (ret){
			setbit(glb_errlog,MSG7_IPV6FIR);
			return 0;
		}
	}
	strcpy(conf.d_add,value);
	return 0;
}

static int t2r_d_port(const char *value)
{
	d_port_s = 0;
	if(strlen(value)){
		d_port_s = atoi(value);
		if( d_port_s<1 || d_port_s>65534|| !*value){
			setbit(glb_errlog,MSG4_IPV6FIR);
			return 0;
		}
	}
	return 0;
}
static int t2r_d_port2(const char *value)
{
	d_port_e = 0;
	if(strlen(value)){
		d_port_e = atoi(value);
		if( d_port_e<1 || d_port_e>65534 || !*value){
			setbit(glb_errlog,MSG5_IPV6FIR);
			return 0;
		}
		sprintf(conf.d_port,"%d-%d",d_port_s,d_port_e);
	}else{
                sprintf(conf.d_port,"%d-%d",d_port_s,0);
        }
	return 0;
}

static int t2r_icmp_type(const char *value)
{
	int i=atoi(value);
	if (value){
		if( i<0 || i>255 || !*value){
			setbit(glb_errlog,MSG1_IPV6FIR);
		}else{
			strcpy(conf.icmp_type,value);
		}
	}
	return 0;
}

static int t2r_save(const char *value)
{
	return 0;
}

static int t2r_add(const char *value)
{
	return 0;
}

static int t2r_delete(const char *value)
{
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

static int t2r_todo(const char *value)
{
	if(!strcmp(value,"save_fw6"))
		todo=SAVE;
	if(!strcmp(value,"add_fw6"))
		todo=ADD;
	if(!strcmp(value,"del_fw6"))
		todo=DEL;
	if (todo&&!strlen(conf.name)){
		setbit(glb_errlog,MSG8_IPV6FIR);
	}
	
	return 0;
}
int ipv6_fire_main()
{
 	LIST *hd=NULL;
    	int ccode;
	memset(glb_errlog,0,sizeof(glb_errlog));
	
    	pConf=&conf;
      	if (!(strcmp(conf.interface,"WAN")))
	    	ReadV6FWConf(IPV6_WAN_FW,&pConf);
	else
	    	ReadV6FWConf(IPV6_LAN_FW,&pConf);
		
    	if (strcmp(REQUEST_METHOD,POST) == 0){
   		hd=cgi_input_parse();
    		if(!hd){
	    		cgi_err("","");
		}
		if(!do_cgi_t2r(hd,key_fun_tab)){
			if(ErrlogIsSetted()){
			
				if(isset(glb_errlog,MSG1_IPV6FIR)){
					char *msg=get_err_msg(MSG1_IPV6FIR);
					fmt_err_msg(msg);
				}
				if(isset(glb_errlog,MSG2_IPV6FIR)){
					char *msg=get_err_msg(MSG2_IPV6FIR);
					fmt_err_msg(msg);
				}
				if(isset(glb_errlog,MSG3_IPV6FIR)){
					char *msg=get_err_msg(MSG3_IPV6FIR);
					fmt_err_msg(msg);
				}
				if(isset(glb_errlog,MSG4_IPV6FIR)){
				char *msg=get_err_msg(MSG4_IPV6FIR);
					fmt_err_msg(msg);
				}
				if(isset(glb_errlog,MSG5_IPV6FIR)){
					char *msg=get_err_msg(MSG5_IPV6FIR);
					fmt_err_msg(msg);
				}
				if(isset(glb_errlog,MSG6_IPV6FIR)){
					char *msg=get_err_msg(MSG6_IPV6FIR);
					fmt_err_msg(msg);
				}
				if(isset(glb_errlog,MSG7_IPV6FIR)){
					char *msg=get_err_msg(MSG7_IPV6FIR);
					fmt_err_msg(msg);
				}
				if(isset(glb_errlog,MSG8_IPV6FIR)){
					char *msg=get_err_msg(MSG8_IPV6FIR);
					fmt_err_msg(msg);
				}
			}else{
				if(todo==ADD||todo==SAVE){
					
					ccode=SaveV6FWConf(&conf);
				}
				else if(todo==DEL){
					ccode=DelV6FWConf(conf.interface,old_fw_name);
				}
				WriteFW6Script();
				RunV6FW();
				WriteConfToFlash();
			      	if (!(strcmp(conf.interface,"LAN")))
			    		ccode = ReadV6FWConf(IPV6_LAN_FW,&pConf);
			    	else {
		  			ccode = ReadV6FWConf(IPV6_WAN_FW,&pConf);
		  		}
		  	}
		}
		list_clear(hd);
	 }
   	ccode =  html_parser("ipv6_fire.htm",key_fun_tab);
	return ccode;
}

#endif
