#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ipv6.h"
#include "h_var.h"

V6_Lan_Conf 	v6_lan_conf;
int ReadIPV6LanConf(V6_Lan_Conf *conf);
int SaveIPV6LanConf(V6_Lan_Conf *conf);
int start_radvd(char *prefix);
int add_dns(char *dns);

static int r2t_lan_mac(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,v6_lan_conf.lan_mac);
	return 0;
}
static int r2t_lan_prefix(char buf[CGI_BUF_LEN],char **buf1)
{
	memcpy(buf,v6_lan_conf.lan_prefix,sizeof(v6_lan_conf.lan_prefix));
   	return 0;
}

static int r2t_lan_net_id(char buf[CGI_BUF_LEN],char **buf1)
{
	
	memcpy(buf,v6_lan_conf.lan_net_id,sizeof(v6_lan_conf.lan_net_id));
   	return 0;
}

static int r2t_lan_prelen(char buf[CGI_BUF_LEN],char **buf1)
{
	
	sprintf(buf,"%d",v6_lan_conf.lan_prelen);
   	return 0;
}

static int r2t_ra_host(char buf[CGI_BUF_LEN],char **buf1)
{
	if (v6_lan_conf.ra_host)
	strcpy(buf,"checked ");
	return 0;
}
static int r2t_ra_host_ra_off(char buf[CGI_BUF_LEN],char **buf1)
{
	if (v6_lan_conf.ra_host_ra_off)
	strcpy(buf,"checked ");
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int t2r_lan_prefix(const char *value)
{
	memcpy(v6_lan_conf.lan_prefix,value,sizeof(v6_lan_conf.lan_prefix));
	return 0;
}
static int t2r_lan_net_id(const char *value)
{
	memcpy(v6_lan_conf.lan_net_id,value,sizeof(v6_lan_conf.lan_net_id));
	return 0;
	
}
static int t2r_lan_prelen(const char *value)
{
	v6_lan_conf.lan_prelen=atoi(value);
	return 0;
}


static int t2r_ra_host(const char *value)
{
//	cgi_err(value,"t2r_ra_host");
	if (memcmp(value,"ra_on",5)==0 ){
		v6_lan_conf.ra_host = 1;
		v6_lan_conf.ra_host_ra_off = 0;
	}else{
		v6_lan_conf.ra_host = 0;
		v6_lan_conf.ra_host_ra_off = 1;
	
	}
	
	return 0;
}

static int t2r_save(const char *value)
{
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}
int ipv6_lan_main()
{
   	LIST *hd=NULL;
    	V6_Lan_Conf *pConf=&v6_lan_conf;
    	char addr[42];
    	int ccode;
	
    	ReadIPV6LanConf(pConf);
    	if (strcmp(REQUEST_METHOD,POST) == 0){
   		hd=cgi_input_parse();
    		if(!hd){
	    		cgi_err("","");
		}		
		if(!do_cgi_t2r(hd,key_fun_tab)){
			if(v6_lan_conf.lan_prefix[strlen(v6_lan_conf.lan_prefix)-1]!=':')
		    		sprintf(addr,"%s:%s",v6_lan_conf.lan_prefix,v6_lan_conf.lan_net_id);
			else
		    		sprintf(addr,"%s%s",v6_lan_conf.lan_prefix,v6_lan_conf.lan_net_id);
	
		    	ccode = CheckV6IP(addr);
		    	if(ccode)
		    		return ccode;
		    	ccode=SaveIPV6LanConf(pConf);
		    	config_v6_IP(addr, v6_lan_conf.lan_prelen,"eth0");
		    	
		    	if(v6_lan_conf.ra_host)
		    		start_radvd(v6_lan_conf.lan_prefix);
		    	else
		    		stop_radvd();
		}
	 }
    return html_parser("ipv6_lan.htm",key_fun_tab);
	
}

