#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_wan_mac(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_tun_relay(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_prefix(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_net_id(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_prelen(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ipv6_dns1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ipv6_dns2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ipv6_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ipv6_type_configure(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_remote_add_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_remote_add_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_remote_add_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_remote_add_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_remote_prefix(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ipv6_type_tunnel(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tun_relay(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_select(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tun_relay_define(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_end_point_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_end_point_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_end_point_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_end_point_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tun_prefix(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_wan_prefix(const char *value);
static int t2r_wan_net_id(const char *value);
static int t2r_wan_prelen(const char *value);
static int t2r_ipv6_dns1(const char *value);
static int t2r_ipv6_dns2(const char *value);
static int t2r_ipv6_type(const char *value);
static int t2r_remote_add_1(const char *value);
static int t2r_remote_add_2(const char *value);
static int t2r_remote_add_3(const char *value);
static int t2r_remote_add_4(const char *value);
static int t2r_remote_prefix(const char *value);
static int t2r_tun_relay(const char *value);
static int t2r_select(const char *value);
static int t2r_end_point_1(const char *value);
static int t2r_end_point_2(const char *value);
static int t2r_end_point_3(const char *value);
static int t2r_end_point_4(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_tun_prefix(const char *value);


static keyfun_tab key_fun_tab[]={
	{"wan_mac",r2t_wan_mac,NULL},
	{"r_tun_relay",r2t_r_tun_relay,NULL},
	{"wan_prefix",r2t_wan_prefix,t2r_wan_prefix},
	{"wan_net_id",r2t_wan_net_id,t2r_wan_net_id},
	{"wan_prelen",r2t_wan_prelen,t2r_wan_prelen},
	{"ipv6_dns1",r2t_ipv6_dns1,t2r_ipv6_dns1},
	{"ipv6_dns2",r2t_ipv6_dns2,t2r_ipv6_dns2},
	{"ipv6_type",r2t_ipv6_type,t2r_ipv6_type},
	{"ipv6_type_configure",r2t_ipv6_type_configure,NULL},
	{"remote_add_1",r2t_remote_add_1,t2r_remote_add_1},
	{"remote_add_2",r2t_remote_add_2,t2r_remote_add_2},
	{"remote_add_3",r2t_remote_add_3,t2r_remote_add_3},
	{"remote_add_4",r2t_remote_add_4,t2r_remote_add_4},
	{"remote_prefix",r2t_remote_prefix,t2r_remote_prefix},
	{"ipv6_type_tunnel",r2t_ipv6_type_tunnel,NULL},
	{"tun_relay",r2t_tun_relay,t2r_tun_relay},
	{"select",r2t_select,t2r_select},
	{"tun_relay_define",r2t_tun_relay_define,NULL},
	{"end_point_1",r2t_end_point_1,t2r_end_point_1},
	{"end_point_2",r2t_end_point_2,t2r_end_point_2},
	{"end_point_3",r2t_end_point_3,t2r_end_point_3},
	{"end_point_4",r2t_end_point_4,t2r_end_point_4},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"tun_prefix",r2t_tun_prefix,t2r_tun_prefix},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "ipv6_wan_cgi.c"

/*************************/
