#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ipv6.h"
#include "h_var.h"
int ReadIPV6WanConf(V6_Wan_Conf *conf);
int SaveIPV6WanConf(V6_Wan_Conf *conf);
int CheckV6IP(char *ip);
int config_v6_IP(char *addr,short prefix_len,char *interface);
int start_624_tunnel(char *prefix,char *remote_ip);
int run_ripng(void);
int add_dns(char *dns);

V6_Wan_Conf 	v6_wan_conf;
static int r2t_wan_mac(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,v6_wan_conf.wan_mac);
	return 0;
}


static int r2t_wan_prefix(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,v6_wan_conf.wan_prefix);
	return 0;
}

static int r2t_wan_net_id(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,v6_wan_conf.wan_net_id);
	return 0;
}

static int r2t_wan_prelen(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",v6_wan_conf.wan_prelen);
	return 0;
}

static int r2t_ipv6_dns1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,v6_wan_conf.ipv6_dns_1);
	return 0;
}

static int r2t_ipv6_dns2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,v6_wan_conf.ipv6_dns_2);
	return 0;
}

static int r2t_ipv6_type(char buf[CGI_BUF_LEN],char **buf1)
{
	if (v6_wan_conf.ipv6_type)
	strcpy(buf,"checked ");
	return 0;
}

static int r2t_ipv6_type_tunnel(char buf[CGI_BUF_LEN],char **buf1)
{
	if (v6_wan_conf.ipv6_type_tunnel)
	strcpy(buf,"checked ");
	return 0;
}

static int r2t_end_point_1(char buf[CGI_BUF_LEN],char **buf1)
{
     	sprintf(buf,"%d",*((unsigned char*)&v6_wan_conf.remote_ip));
	return 0;
}

static int r2t_end_point_2(char buf[CGI_BUF_LEN],char **buf1)
{
     	sprintf(buf,"%d",*((unsigned char*)&v6_wan_conf.remote_ip+1));
	return 0;
}

static int r2t_end_point_3(char buf[CGI_BUF_LEN],char **buf1)
{
     	sprintf(buf,"%d",*((unsigned char*)&v6_wan_conf.remote_ip+2));
	return 0;
}

static int r2t_end_point_4(char buf[CGI_BUF_LEN],char **buf1)
{
     	sprintf(buf,"%d",*((unsigned char*)&v6_wan_conf.remote_ip+3));
	return 0;
}

static int r2t_start_point_1(char buf[CGI_BUF_LEN],char **buf1)
{
    	unsigned char *p= (unsigned char *)&v6_wan_conf.wan_ip;
    
    	*buf = '\0';
    	if(v6_wan_conf.wan_ip){
        	sprintf(buf,"%u",*(p));
    	}
	return 0;
}

static int r2t_start_point_2(char buf[CGI_BUF_LEN],char **buf1)
{
    	unsigned char *p= (unsigned char *)&v6_wan_conf.wan_ip;
    
    	*buf = '\0';
    	if(v6_wan_conf.wan_ip){
        	sprintf(buf,"%u",*(p+1));
    	}
	return 0;
}

static int r2t_start_point_3(char buf[CGI_BUF_LEN],char **buf1)
{
    	unsigned char *p= (unsigned char *)&v6_wan_conf.wan_ip;
    
    	*buf = '\0';
    	if(v6_wan_conf.wan_ip){
        	sprintf(buf,"%u",*(p+2));
    	}
	return 0;
}

static int r2t_start_point_4(char buf[CGI_BUF_LEN],char **buf1)
{
    	unsigned char *p= (unsigned char *)&v6_wan_conf.wan_ip;
    
    	*buf = '\0';
    	if(v6_wan_conf.wan_ip){
        	sprintf(buf,"%u",*(p+3));
    	}
	return 0;
}

static int r2t_ipv6_routing(char buf[CGI_BUF_LEN],char **buf1)
{
	if(v6_wan_conf.ipv6_routing)
	strcpy(buf,"checked ");
	return 0;
}

static int r2t_ipv6_routing_static(char buf[CGI_BUF_LEN],char **buf1)
{
	if(v6_wan_conf.ipv6_routing_static)
	strcpy(buf,"checked ");
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}


///////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////
static int t2r_wan_prefix(const char *value)
{
	strcpy(v6_wan_conf.wan_prefix,value);
	return 0;
}

static int t2r_wan_net_id(const char *value)
{
	strcpy(v6_wan_conf.wan_net_id,value);
	return 0;
}

static int t2r_wan_prelen(const char *value)
{
	v6_wan_conf.wan_prelen=atoi(value);
	return 0;
}

static int t2r_ipv6_dns1(const char *value)
{
	strcpy(v6_wan_conf.ipv6_dns_1,value);
	return 0;
}

static int t2r_ipv6_dns2(const char *value)
{
	strcpy(v6_wan_conf.ipv6_dns_2,value);
	return 0;
}

static int t2r_ipv6_type(const char *value)
{
	if (strcmp(value,"native")==0 ){
		v6_wan_conf.ipv6_type = 1;
		v6_wan_conf.ipv6_type_tunnel = 0;
	}else{
		v6_wan_conf.ipv6_type = 0;
		v6_wan_conf.ipv6_type_tunnel = 1;
	
	}
	return 0;
}

static int t2r_end_point_1(const char *value)
{
    	int ip = atoi(value);
    	unsigned char *p= (unsigned char *)&v6_wan_conf.remote_ip;
    
    	*p = ip;
	return 0;
}

static int t2r_end_point_2(const char *value)
{
    	int ip = atoi(value);
    	unsigned char *p= (unsigned char *)&v6_wan_conf.remote_ip;
    
    	*(p+1) = ip;
	return 0;
}

static int t2r_end_point_3(const char *value)
{
    	int ip = atoi(value);
    	unsigned char *p= (unsigned char *)&v6_wan_conf.remote_ip;
    
    	*(p+2) = ip;
	return 0;
}

static int t2r_end_point_4(const char *value)
{
    	int ip = atoi(value);
    	unsigned char *p= (unsigned char *)&v6_wan_conf.remote_ip;
    
    	*(p+3) = ip;
	return 0;
}

static int t2r_start_point_1(const char *value)
{
	/*
    	int ip = atoi(value);
    	unsigned char *p= (unsigned char *)&v6_wan_conf.wan_ip;
    
    	*(p) = ip;
    	*/
	return 0;
}

static int t2r_start_point_2(const char *value)
{
/*
    	int ip = atoi(value);
    	unsigned char *p= (unsigned char *)&v6_wan_conf.wan_ip;
    
    	*(p+1) = ip;
*/	return 0;
}

static int t2r_start_point_3(const char *value)
{
	/*
    	int ip = atoi(value);
    	unsigned char *p= (unsigned char *)&v6_wan_conf.wan_ip;
    
    	*(p+2) = ip;
    	*/
	return 0;
}

static int t2r_start_point_4(const char *value)
{
	/*
    	int ip = atoi(value);
    	unsigned char *p= (unsigned char *)&v6_wan_conf.wan_ip;
    
    	*(p+3) = ip;
    	*/
	return 0;
}

static int t2r_ipv6_routing(const char *value)
{
	if (strcmp(value,"ripng")==0 ){
		v6_wan_conf.ipv6_routing = 1;
		v6_wan_conf.ipv6_routing_static = 0;
	}else{
		v6_wan_conf.ipv6_routing = 0;
		v6_wan_conf.ipv6_routing_static = 1;
	
	}
	return 0;
}

static int t2r_save(const char *value)
{
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

int ipv6_wan_main()
{
  	LIST *hd=NULL;
    	V6_Wan_Conf *pConf=&v6_wan_conf;
    	char addr[42];
    	char temp[8];
    	int ccode;
	
    	ReadIPV6WanConf(pConf);

    	if (strcmp(REQUEST_METHOD,POST) == 0){

  		hd=cgi_input_parse();
    		if(!hd){
	    		cgi_err("","");
		}		
		if(!do_cgi_t2r(hd,key_fun_tab)){
			if(v6_wan_conf.wan_prefix[strlen(v6_wan_conf.wan_prefix)-1]!=':')
		    		sprintf(addr,"%s:%s",v6_wan_conf.wan_prefix,v6_wan_conf.wan_net_id);
			else
		    		sprintf(addr,"%s%s",v6_wan_conf.wan_prefix,v6_wan_conf.wan_net_id);
	
		    	ccode = CheckV6IP(addr);
		    	if(ccode){
		    		cgi_err("IP error\n","wan main");
		    	}
		    	ccode = CheckV6IP(v6_wan_conf.ipv6_dns_1);
		    	if(ccode){
		    		cgi_err("IP error\n","primary dns");
		    	}
		    	ccode = CheckV6IP(v6_wan_conf.ipv6_dns_2);
		    	if(ccode){
		    		cgi_err("IP error\n","second dns");
		    	}
		    	ccode=SaveIPV6WanConf(pConf);
		    	config_v6_IP(addr, v6_wan_conf.wan_prelen,ETH_WAN);
		    	
		    	if (v6_wan_conf.ipv6_dns_1){
		    		ccode = add_dns(v6_wan_conf.ipv6_dns_1);
		    		if (ccode)
		    			cgi_err("add dns","1");
		    	}
		    	if (v6_wan_conf.ipv6_dns_2){
		    		
		    		ccode = add_dns(v6_wan_conf.ipv6_dns_2);
		    		if (ccode){
		    			sprintf(temp,"%d\n",ccode);
		    			cgi_err("add dns ",temp);
		    		}
		    	}
		    	
		    	memset(addr,'\0',42);

		    	sprintf(addr,"%d.%d.%d.%d\n",v6_wan_conf.remote_ip[0],v6_wan_conf.remote_ip[1],v6_wan_conf.remote_ip[2],v6_wan_conf.remote_ip[3]);
			if (v6_wan_conf.ipv6_type_tunnel)
	    			start_624_tunnel(v6_wan_conf.tun_prefix,addr);
	    		else
	    			stop_tunnel();
	    		
	    		if(v6_wan_conf.ipv6_routing)
	    			run_ripng();
	    		else
	    			stop_ripng();
	    		

		}
	 }
    return html_parser("ipv6_wan.htm",key_fun_tab);
	
}
