#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include "file_func.h"
#include "cgi-lib.h"
#include "parser.h"

//extern int mkdhcpdconf_main(void);
//extern int mkpoeconf_main(void);
//extern int mkoptfile_main(void);
extern int sys_init_main(void);
//extern int mkdnsconf_main(void);
extern int mkcrontab_main(void);

typedef struct{
    char *cgi_file;
    int (*main_func)(void);
}NAME_FUNC_LIST;

NAME_FUNC_LIST file_func_db[]={
    #include "file_func.list"
//    {"mkdhcpdconf",     mkdhcpdconf_main    },
//    {"mkpoeconf",	mkpoeconf_main	    },
//    {"mkoptfile",       mkoptfile_main      },
    {"sys_init",	sys_init_main       },
//    {"mkdnsconf",	        mkdnsconf_main      },
	{"mkcrontab",	        mkcrontab_main      },
    {NULL,NULL}
};

#define CGI_RUNNING_FLAG	"/var/run/running"

int main(int argc , char **argv){
    int i=0,ret=0,fd=-1;
    static int cgi_file = 0;

	if(strstr(basename(argv[0]),".cgi"))
		cgi_file=1;
	if(cgi_file&&(strcmp(REQUEST_METHOD,POST)==0)){
		if(!access(CGI_RUNNING_FLAG,F_OK))
			return -1;
		fd = open(CGI_RUNNING_FLAG,O_WRONLY|O_CREAT|O_EXCL,0666);
		if(fd <=0 && errno == EEXIST){
			return -1;
		}
		close(fd);
	}
    for(i=0;file_func_db[i].cgi_file;i++){
        if(!strcmp(file_func_db[i].cgi_file,(char *)basename(argv[0]))){
            break;
        }
    }
    if(!file_func_db[i].cgi_file){
    	if(cgi_file)
    		unlink(CGI_RUNNING_FLAG);
        return 0;
    }
	ret=file_func_db[i].main_func();
	if(cgi_file)
		unlink(CGI_RUNNING_FLAG);

	return(ret);
}
