/***************************************************************************
 *  This Program will build /var/crontab according to /etc/system.conf     *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <arpa/inet.h>
#include "mkcrontab.h"
#include "groups.h"
#include "sch_def.h"

static sch_def_conf	schConf;
static group_conf grpConf;

static char hs1[3]={0};
static char ms1[3]={0};
static char hf1[3]={0};
static char mf1[3]={0};

static char hs2[3]={0};
static char ms2[3]={0};
static char hf2[3]={0};
static char mf2[3]={0};

#define EMPTY_STR	do {	\
				strcpy(hs1,"");	\
				strcpy(ms1,"");	\
				strcpy(hf1,"");	\
				strcpy(mf1,"");	\
				strcpy(hs2,"");	\
				strcpy(ms2,"");	\
				strcpy(hf2,"");	\
				strcpy(mf2,"");	\
			}while(0)


#define SCH_HALF_FORMAT     "%[0-9]:%[0-9]-%[0-9]:%[0-9]"
#define SCH_FULL_FORMAT     "%[0-9]:%[0-9]-%[0-9]:%[0-9] %[0-9]:%[0-9]-%[0-9]:%[0-9]"

#define RC_SCH_FILE         "/etc/rc.d/rc.sch"
#define SCH_START           "start"
#define SCH_STOP            "stop"

#define FORMAT_STR          "%s %s * * %d root %s %s %d\n"
#define CRONTAB_TMP	"/var/crontab.tmp"

int mkcrontab_main(void){
    int i, j;
	FILE *fp,*tfp;
	char cmd[50];
	char buf[312];

	sprintf(cmd,"cp -f %s %s 2>/dev/null",CRONTAB_FILE, CRONTAB_TMP);
	system(cmd);
	if((tfp=fopen(CRONTAB_TMP,"r"))==NULL)
        return -1;
	if((fp=fopen(CRONTAB_FILE,"w"))==NULL){
		fclose(tfp);
		return -1;
	}
	while(fgets(buf,sizeof(buf),tfp)){
		if(strstr(buf,RC_SCH_FILE))
			continue;
		else
			fputs(buf,fp);
	}

	fclose(tfp);
	remove(CRONTAB_TMP);
	for(i=0;i<GROUP_NUM;i++){
	
		memset(&grpConf, 0, sizeof(grpConf));
	        memset(&schConf, 0, sizeof(schConf));

		ReadGroup(i,&grpConf);
	        ReadSchDef(&schConf,i);

		if(GROUP_BASE_SCHEDULE == grpConf.schedule){

			for(j=0;j<WEEK_DAY;j++){
				if(strlen(schConf.weekday[j])==11){
					sscanf(schConf.weekday[j],SCH_HALF_FORMAT,hs1,ms1,hf1,mf1);
			
				}
		
				else if(strlen(schConf.weekday[j])==23){
					sscanf(schConf.weekday[j],SCH_FULL_FORMAT,hs1,ms1,hf1,mf1,hs2,ms2,hf2,mf2);
				}
			    	/* min hour day month week user command start|stop grpno */
				if(strlen(schConf.weekday[j])){
					fprintf(fp, FORMAT_STR, ms1, hs1, j, RC_SCH_FILE, SCH_START, i);
					fprintf(fp, FORMAT_STR, mf1, hf1, j, RC_SCH_FILE, SCH_STOP, i);
			        }

				if(strlen(schConf.weekday[j])==23){
					fprintf(fp, FORMAT_STR, ms2, hs2, j, RC_SCH_FILE, SCH_START, i);
					fprintf(fp, FORMAT_STR, mf2, hf2, j, RC_SCH_FILE, SCH_STOP, i);
				}
			}
		}
	}


    fclose(fp);
    return 0;
}



