#ifndef _MKDHCPDCONF_H_
#define _MKDHCPDCONF_H_
#include "h_const.h"
#include "mk_var.h"

struct config_keyword {
	char keyword[20];
	char def[40];
};

enum{
    DHCPD_CONF_START,
    DHCPD_CONF_END,
    DHCPD_CONF_IFACE,
    DHCPD_CONF_DNS1,
    DHCPD_CONF_DNS2,
    DHCPD_CONF_DNS3,
    DHCPD_CONF_SUBNET,
    DHCPD_CONF_ROUTER,
    DHCPD_CONF_DOMAIN,
    DHCPD_CONF_LEASE,
    DHCPD_CONF_NUM
};

#define DHCPD_START_DEFAULT             LAN_START_IP_DEFAULT
#define DHCPD_END_DEFAULT               LAN_END_IP_DEFAULT
#define DHCPD_IFACE_DEFAULT             LAN_ITF
#define DHCPD_SUBNET_DEFAULT            LAN_MASK_DEFAULT
#define DHCPD_ROUTER_DEFAULT            LAN_IP_DEFAULT
#define DHCPD_DOMAIN_DEFAULT            "local"
#define DHCPD_LEASE_DEFAULT             "259200"
#define DHCPD_DNS_DEFAULT               ""

#define UDHCPD_CONF_FILE                "/var/udhcpd.conf"

#define RESOLV_CONF                     "/etc/resolv.conf"
#define MAX_LINE_LEN                    128
#define NAMESERVER                      "nameserver"
#define COMMENT                         '#'

#define MAX_DNS_NUM                     3


#define isLineEnd(x)                    ( (0x0a==(x)) || (0x0d==(x)) )
#define isSeparate(x)                   ( (' '==(x)) || ('\t'==(x)) )
#define isDecimal(x)                    ( ((x) >= '0') && ((x) <= '9') )
#define isDot(x)                        ( ((x) == '.') )

#define MKDHCPD_OK                      0
#define MKDHCPD_WRITE_ERR               -1

#endif /* _MKDHCPDCONF_H_ */

