#ifndef _MKOPTFILE_H_
#define _MKOPTFILE_H_
#include "mk_var.h"

#define MAX_KEY_LEN             33
#define MAX_VALUE_LEN           41

#define OPTFILE                 "/var/optfile"

#define MKOPTFILE_OK            0
#define MKOPTFILE_FAIL          -1
struct option {
	char key[MAX_KEY_LEN];
	char value[MAX_VALUE_LEN];
};


enum{
    /* /sbin/lan */
    MKOPT_ITEM_LAN_IP,
    MKOPT_ITEM_LAN_MASK,
    MKOPT_ITEM_LAN_IP2,
    MKOPT_ITEM_LAN_MASK2,
    MKOPT_ITEM_LAN_BROADCAST,
    MKOPT_ITEM_START_IP,
    MKOPT_ITEM_FINISH_IP,
    MKOPT_ITEM_DHCPD_ENABLE,

    /* /sbin/wan */
    MKOPT_ITEM_WAN_CONNECTION,
    MKOPT_ITEM_WAN_DHCPC_TYPE,
    MKOPT_ITEM_WAN_IP,
    MKOPT_ITEM_WAN_MASK,
    MKOPT_ITEM_WAN_BROADCAST,
    MKOPT_ITEM_WAN_GATEWAY,
    MKOPT_ITEM_WAN_DNS,
    MKOPT_ITEM_WAN_SPPPoE_DNS1,
    MKOPT_ITEM_WAN_SPPPoE_DNS2,
    MKOPT_ITEM_WAN_SPPPoE_DEMAND,
    MKOPT_ITEM_WAN_SPPPoE_IDLE_TIME,

    /* /sbin/modem-ppp-{start,stop} */
    MKOPT_ITEM_MDM_TELEPHONE,
    MKOPT_ITEM_MDM_SPEED,
    MKOPT_ITEM_MDM_RETRY,
    MKOPT_ITEM_DEMAND,
    MKOPT_ITEM_MDM_IDLETIME,
    MKOPT_ITEM_MDM_FIXDNS,
    MKOPT_ITEM_MDM_DNS1,
    MKOPT_ITEM_MDM_DNS2,

    /* Backup DNS */
    MKOPT_ITEM_BACKUP_DNS1,
    MKOPT_ITEM_BACKUP_DNS2,
    

    MKOPT_ITEM_MAX
};

enum{
    /* /sbin/wan */
    MKOPT_APPEND_ITEM_WAN_DHCP,
    MKOPT_APPEND_ITEM_WAN_SPPPoE,
    MKOPT_APPEND_ITEM_WAN_MPPPoE,
    MKOPT_APPEND_ITEM_WAN_LOCALOFF,//ada
    MKOPT_APPEND_ITEM_WAN_MODEM,
	MKOPT_APPEND_ITEM_WAN_DHCPC_TYPE_DYNAMIC,
    MKOPT_APPEND_ITEM_WAN_DHCPC_TYPE_FIXED,
    MKOPT_APPEND_ITEM_WAN_SPOE_USERNAME,
    MKOPT_APPEND_ITEM_WAN_SPOE_PASSWD,
    MKOPT_APPEND_ITEM_WAN_MPOE_USERNAME0,
    MKOPT_APPEND_ITEM_WAN_MPOE_PASSWD0,
    MKOPT_APPEND_ITEM_WAN_MPOE_USERNAME1,
    MKOPT_APPEND_ITEM_WAN_MPOE_PASSWD1,            
    /* /sbin/modem-ppp-{start,stop} */
    MKOPT_APPEND_ITEM_MDM_USERNAME,
    MKOPT_APPEND_ITEM_MDM_PASSWORD,

    MKOPT_APPEND_ITEM_MAX
};

    
#endif /* _MKOPTFILE_H_ */
