#ifndef _MKPOECONF_H_
#define _MKPOECONF_H_
#include "mk_var.h"

#define ETH_DEFAULT                     IFACE_ETH1
#define SERVICENAME_DEFAULT             ""
#define ACNAME_DEFAULT                  ""
#define USERCTL_DEFAULT                 ""
#define CONNECT_POLL_DEFAULT            2
#define CONNECT_TIMEOUT_DEFAULT         10
#define PING_DEFAULT                    '.'
#define FORCEPING_DEFAULT               0 
#define PIDFILE_DEFAULT                "/var/run/pppoe-adsl%d.pid"
#define SYNCHRONOUS_DEFAULT             YESNO_NO
#define CLAMPMSS_DEFAULT                1412
#define LCP_INTERVAL_DEFAULT            20
#define LCP_FAILURE_DEFAULT             3
#define PPPOE_TIMEOUT_DEFAULT           60
#define FIREWALL_DEFAULT                FIREWALL_NONE
#define PPPOE_EXTRA_DEFAULT             ""
#define PPPD_EXTRA_DEFAULT              ""
#define LINUX_PLUGIN_DEFAULT            ""


#define IP_STR_LEN      (sizeof("255.255.255.255"))

#define PPPOE_CONF_FILE         "/etc/ppp/pppoe%d.conf"

#define     MKPOE_OK            0
#define     MKPOE_NOT_POE       -1
#define     MKPOE_READ_ERR      -2
#define     MKPOE_WRITE_ERR     -3

typedef struct{
    char *ETH;                      /* "eth0" , "eth1"                              */
    char *USER;                     /* Point to conf                                */
    char *SERVICENAME;              /* Point to conf                                */
    char *ACNAME;                   /* Point to conf                                */
    char DEMAND[6];                 /* "no" or number (seconds)                     */
    char IDLE_TIME[6];              /* number (seconds)                             */
    char *DNSTYPE;                  /* "NOCHANGE" , "SPECIFY" , "SERVER"            */
    char DNS1[IP_STR_LEN];
    char DNS2[IP_STR_LEN];
    char *USERCTL;                  /* "yes" , ""                                   */
    char *PEERDNS;                  /* "yes" , ""                                   */
    int  CONNECT_POLL;
    int  CONNECT_TIMEOUT;
    char PING;
    char FORCEPING; 
    char *PIDFILE;                  /* PID_FILE                                     */
    char *SYNCHRONOUS;              /* "yes" , "no"                                 */
    int  CLAMPMSS;
    int  LCP_INTERVAL;
    int  LCP_FAILURE;
    int  PPPOE_TIMEOUT;
    char *FIREWALL;                 /* "NONE" , "STANDALONE" , "MASQUERADE"          */
    char *PPPOE_EXTRA;              /* ""                                            */
    char *PPPD_EXTRA;               /* ""                                            */
    char *LINUX_PLUGIN;             /* ""                                            */
    char LOCAL_IP[IP_STR_LEN];
}PPPOE_CONF_CONF;   
    

#endif /* _MKPOECONF_H_ */
