//#define _BB_DEBUG_
#ifndef _PC_DB_CGI_C_
#define _PC_DB_CGI_C_
#include <stdio.h>
#include <string.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "lan.h"
#include "h_bmsg.h"

static LAN_CONF *pConf=&lan_conf;

static PC_DB_CONF_s add_pc;
static char todo, name[WK_NAME_LEN];
static unsigned char ip4;
static struct in_addr del_ip;



enum {
    PC_DB_NONE,
    PC_DB_DEL,
    PC_DB_ADD
};

static int r2t_pc_list(char buf[CGI_BUF_LEN],char **buf1)
{
    short i;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;
    short len=0;

    *buf1 = malloc(PCDB_ENTRY_MAX_LEN * 255);

    if(!*buf1){ /*fail to allocate memory. */
        return 0;
    }


    for ( i=0, p_entry=p_pcdb_conf->p_database;
          i<p_pcdb_conf->number && p_entry;
          i++, p_entry = p_entry->next
    ){
        len += sprintf(*buf1+len, "%s", option_s);
        len += sprintf(*buf1+len, "%s", p_entry->name);
        len += sprintf(*buf1+len, " (%u.%u.%u.%u) ", p_entry->ip_addr[0], p_entry->ip_addr[1], p_entry->ip_addr[2], p_entry->ip_addr[3]);
        len += sprintf(*buf1+len, " (%s) ", str_pctype_db(p_entry->iface));
        len += sprintf(*buf1+len, " (%s) ", str_pcreserve_db(p_entry->reserve));
        len += sprintf(*buf1+len, "%s", option_e);

    }

    GetDynamicPCInfo(*buf1+len, 0, NULL);

    return (0);
}
static int r2t_add_pc_name(char buf[CGI_BUF_LEN],char **buf1)
{
    return (0);
}
static int r2t_lan_ip_prefix(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf, "%u.%u.%u.", *((unsigned char*)&pConf->LanIPAddr), *((unsigned char*)&pConf->LanIPAddr+1), *((unsigned char*)&pConf->LanIPAddr+2));
    return (0);
}
static int r2t_add_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
    return (0);
}
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
    set_err_msg(buf,buf1);
    return (0);
}
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{
    todo = PC_DB_NONE;
    return (0);
}


static int t2r_pc_list(const char *value)
{
    char *p;
    char *q;
    p=strchr(value, ' ');
    if (!p)
        return 0;
    *p = 0x0;
    strcpy(add_pc.name, value);
    *p = ' ';

    p += 2; /* p point to the begining of ip. */
    q = strchr(p,')');
    if(!q){
        del_ip.s_addr = 0;
        return 0;
    }
    *q = '\0';
    inet_aton(p, &del_ip);
    return (0);
}


static int t2r_add_new_pc(const char *value){
    return 0;
}

static int t2r_add_pc_name(const char *value)
{
    if(strlen(value) >= WK_NAME_LEN || !*value){
        setbit(glb_errlog,MSG1_PC_DB);
    }
    else{
        strcpy(name, value);
    }
    return (0);
}
static int t2r_add_ip_4(const char *value)
{
    int ip = atoi(value);
    ip4 = (unsigned char)ip;
    return (0);
}

static int t2r_delete_pc(const char *value){
    return (0);
}

static int t2r_refresh(const char *value){
    return (0);
}

static int t2r_list_pcs(const char *value){
    return (0);
}

static int t2r_adv_pcdb(const char *value){
    return (0);
}

static int t2r_help(const char *value){
    return (0);
}

static int t2r_message(const char *value)
{
    return (0);
}
static int t2r_todo(const char *value)
{
    if (!strcmp(value, "delete_pc"))
        todo = PC_DB_DEL;
    else if (!strcmp(value, "add_new_pc"))
        todo = PC_DB_ADD;
    return (0);
}

/* need add error check for add and delete */
int pc_db_main(void)
{
	LIST *hd=NULL;
	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    int ret;

	ReadLanSettings(&lan_conf);
	ReadPCDBConf(p_pcdb_conf);
    memset(glb_errlog,0,sizeof(glb_errlog));

	if (strcmp(REQUEST_METHOD,POST) == 0)
	{
		hd=cgi_input_parse();
		if(!hd)
		{
			cgi_err("","");
		}

		if(!do_cgi_t2r(hd,key_fun_tab))
		{
            switch (todo)
		    {
		        case PC_DB_ADD:
        		    if(isset(glb_errlog,MSG1_PC_DB)){
        		        char *msg=get_err_msg(MSG1_PC_DB);
        		        fmt_err_msg(msg,WK_NAME_LEN-1);
                        break;
        		    }
#ifdef _BB_DEBUG_
            sprintf(bb_buf, "<%s><%d>, name<%s>", __FILE__, __LINE__, name);
            bb_trace(bb_buf);
#endif
		            strcpy(add_pc.name, name);
		            memcpy(add_pc.ip_addr, &pConf->LanIPAddr, 3);
		            add_pc.ip_addr[3] = ip4;
                    memset(add_pc.mac_addr, 0, 6);
                    add_pc.reserve = 1;
                    add_pc.group =0;
                    add_pc.mac_type = 0;
                    add_pc.access_type = 0;
                    add_pc.iface = 0;
                    ret = PCDBAdd(p_pcdb_conf, &add_pc);
		        break;
    		        case PC_DB_DEL:
//    		            debug("%s:%s()[%d]: pc_name is %s.",__FILE__,__FUNCTION__,__LINE__,add_pc.name);
//                        PCDBDel(p_pcdb_conf, add_pc.name);
                        delPCInWholePC(p_pcdb_conf, add_pc.name,del_ip.s_addr);
    		        break;
    		        default:
    		        break;
            }
            WriteConfToFlash();
    	}
	}
  	return html_parser("pc_db.htm",key_fun_tab);
}

#endif
#ifdef _BB_DEBUG_
char bb_buf[500];
void bb_trace(char *pFormatString, ...)
{
    FILE *fh;

	fh=fopen("/var/debug","a");
    if (!fh)
        return;
    strcat(pFormatString, "\n");
    fprintf(fh, pFormatString);

    fclose(fh);
}
#endif
