#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_pc_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_add_pc_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_type_dhcp_reserve(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ip_prefix(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_add_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_type_fixed(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fix_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fix_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fix_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fix_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mac_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mac_type_fixed(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_mac(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_pc_list(const char *value);
static int t2r_edit_pc(const char *value);
static int t2r_delete(const char *value);
static int t2r_add_pc_name(const char *value);
static int t2r_ip_type(const char *value);
static int t2r_add_ip_4(const char *value);
static int t2r_fix_ip_1(const char *value);
static int t2r_fix_ip_2(const char *value);
static int t2r_fix_ip_3(const char *value);
static int t2r_fix_ip_4(const char *value);
static int t2r_mac_type(const char *value);
static int t2r_wan_mac(const char *value);
static int t2r_add(const char *value);
static int t2r_update(const char *value);
static int t2r_clearf(const char *value);
static int t2r_refresh(const char *value);
static int t2r_list_pcs(const char *value);
static int t2r_std_pcdb(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_todo(const char *value);


static keyfun_tab key_fun_tab[]={
	{"pc_list",r2t_pc_list,t2r_pc_list},
	{"edit_pc",NULL,t2r_edit_pc},
	{"delete",NULL,t2r_delete},
	{"add_pc_name",r2t_add_pc_name,t2r_add_pc_name},
	{"ip_type",r2t_ip_type,t2r_ip_type},
	{"ip_type_dhcp_reserve",r2t_ip_type_dhcp_reserve,NULL},
	{"lan_ip_prefix",r2t_lan_ip_prefix,NULL},
	{"add_IP_4",r2t_add_ip_4,t2r_add_ip_4},
	{"ip_type_fixed",r2t_ip_type_fixed,NULL},
	{"fix_IP_1",r2t_fix_ip_1,t2r_fix_ip_1},
	{"fix_IP_2",r2t_fix_ip_2,t2r_fix_ip_2},
	{"fix_IP_3",r2t_fix_ip_3,t2r_fix_ip_3},
	{"fix_IP_4",r2t_fix_ip_4,t2r_fix_ip_4},
	{"mac_type",r2t_mac_type,t2r_mac_type},
	{"mac_type_fixed",r2t_mac_type_fixed,NULL},
	{"wan_mac",r2t_wan_mac,t2r_wan_mac},
	{"add",NULL,t2r_add},
	{"update",NULL,t2r_update},
	{"clearf",NULL,t2r_clearf},
	{"refresh",NULL,t2r_refresh},
	{"list_pcs",NULL,t2r_list_pcs},
	{"std_pcdb",NULL,t2r_std_pcdb},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"todo",r2t_todo,t2r_todo},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "pc_dba_cgi.c"

/*************************/
