//#define _BB_DEBUG_
#ifdef _BB_DEBUG_
extern char bb_buf[];
extern void bb_trace(char *pFormatString, ...);
#endif
#ifndef _PC_DBA_CGI_C_
#define _PC_DBA_CGI_C_
#define _SNT_UDHCP_
#include <stdio.h>
#include <string.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "lan.h"
#include "h_bmsg.h"
#include "h_const.h"

#include "../../real/udhcp/files.h"

static PC_DB_CONF_s tmp_pc;
static char todo, name[WK_NAME_LEN],prev_name[WK_NAME_LEN];

static LAN_CONF *pConf=&lan_conf;
static struct in_addr del_ip;

static int r2t_pc_list(char buf[CGI_BUF_LEN],char **buf1)
{
    short i;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;
    unsigned char mac_addr[18];
    short len=0;

    *buf1 = malloc(PCDB_ENTRY_MAX_LEN * 255);

    if(!*buf1){ /*fail to allocate memory. */
        return 0;
    }


    for ( i=0, p_entry=p_pcdb_conf->p_database;
          i<p_pcdb_conf->number && p_entry;
          i++, p_entry = p_entry->next
    ){
        len += sprintf(*buf1+len, "%s", option_s);
        len += sprintf(*buf1+len, "%s", p_entry->name);
        len += sprintf(*buf1+len, " (%u.%u.%u.%u) ", p_entry->ip_addr[0], p_entry->ip_addr[1], p_entry->ip_addr[2], p_entry->ip_addr[3]);
	    printf_haddr(mac_addr, p_entry->mac_addr, '-');
        len += sprintf(*buf1+len, " (%s) ", mac_addr);

        len += sprintf(*buf1+len, " (%s) ", str_pctype_db(p_entry->iface));
        len += sprintf(*buf1+len, " (%s) ", str_pcreserve_db(p_entry->reserve));
        len += sprintf(*buf1+len, "%s", option_e);

    }
    GetDynamicPCInfo(*buf1+len, 1, NULL);
    return (0);
}

static int r2t_add_pc_name(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf, tmp_pc.name);
	return 0;
}

static int r2t_ip_type(char buf[CGI_BUF_LEN],char **buf1)
{
    if ((tmp_pc.reserve != 1) &&(tmp_pc.reserve != 2))
        strcpy(buf, str_checked);
	return 0;
}

static int r2t_ip_type_dhcp_reserve(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.reserve == 1)
        strcpy(buf, str_checked);
	return 0;
}

static int r2t_lan_ip_prefix(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf, "%u.%u.%u.", *((unsigned char*)&pConf->LanIPAddr), *((unsigned char*)&pConf->LanIPAddr+1), *((unsigned char*)&pConf->LanIPAddr+2));
	return 0;
}

static int r2t_add_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.reserve == 1)
        sprintf(buf, "%d", tmp_pc.ip_addr[3]);
	return 0;
}

static int r2t_ip_type_fixed(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.reserve == 2)
        strcpy(buf, str_checked);
	return 0;
}

static int r2t_fix_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.reserve == 2)
        sprintf(buf, "%d", tmp_pc.ip_addr[0]);
	return 0;
}

static int r2t_fix_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.reserve == 2)
        sprintf(buf, "%d", tmp_pc.ip_addr[1]);
	return 0;
}

static int r2t_fix_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.reserve == 2)
        sprintf(buf, "%d", tmp_pc.ip_addr[2]);
	return 0;
}

static int r2t_fix_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.reserve == 2)
        sprintf(buf, "%d", tmp_pc.ip_addr[3]);
	return 0;
}

static int r2t_mac_type(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.mac_type == 0)
        sprintf(buf, str_checked);
	return 0;
}

static int r2t_mac_type_fixed(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.mac_type == 1)
        sprintf(buf, str_checked);
	return 0;
}

static int r2t_wan_mac(char buf[CGI_BUF_LEN],char **buf1)
{
    if (tmp_pc.mac_type == 1)
        printf_haddr(buf, tmp_pc.mac_addr, 0);
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
    set_err_msg(buf,buf1);
	return 0;
}

static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}
#if 0
static int r2t_prev_name(char buf[CGI_BUF_LEN],char **buf1){
    return 0;
}
#endif
static int t2r_pc_list(const char *value)
{
    char *p;
    char *q;
    p=strchr(value, ' ');
    if (!p)
        return 0;
    *p = 0x0;
    strcpy(name, value);
    *p = ' ';

    p += 2; /* p point to the begining of ip. */
    q = strchr(p,')');
    if(!q){
        del_ip.s_addr = 0;
        return 0;
    }
    *q = '\0';
    inet_aton(p, &del_ip);
    return (0);
}

static int t2r_edit_pc(const char *value){
    return 0;
}

static int t2r_delete(const char *value){
    return 0;
}

static int t2r_add_pc_name(const char *value)
{
    if(strlen(value) >= WK_NAME_LEN || !*value){
        setbit(glb_errlog,MSG1_PC_DB);
    }
    else{
        strcpy(tmp_pc.name, value);
    }
	return 0;
}
static char * ip_type_db[]={"dhcp_auto","dhcp_reserve","fixed",0};
static int t2r_ip_type(const char *value)
{
	tmp_pc.reserve = str_db_search(ip_type_db,value);
	return 0;
}

static int t2r_add_ip_4(const char *value)
{
    if (tmp_pc.reserve == 1)
    {

        tmp_pc.ip_addr[0] = *((unsigned char *)&pConf->LanIPAddr);
        tmp_pc.ip_addr[1] = *((unsigned char *)&pConf->LanIPAddr+1);
        tmp_pc.ip_addr[2] = *((unsigned char *)&pConf->LanIPAddr+2);
        tmp_pc.ip_addr[3] = atoi(value);
    }
	return 0;
}

static int t2r_fix_ip_1(const char *value)
{
    if (tmp_pc.reserve == 2)
        tmp_pc.ip_addr[0] = atoi(value);
	return 0;
}

static int t2r_fix_ip_2(const char *value)
{
    if (tmp_pc.reserve == 2)
        tmp_pc.ip_addr[1] = atoi(value);
    return 0;
}

static int t2r_fix_ip_3(const char *value)
{
    if (tmp_pc.reserve == 2)
        tmp_pc.ip_addr[2] = atoi(value);
	return 0;
}

static int t2r_fix_ip_4(const char *value)
{
    if (tmp_pc.reserve == 2)
        tmp_pc.ip_addr[3] = atoi(value);
	return 0;
}
static char * mac_type_db[]={"ping","fixed",0};
static int t2r_mac_type(const char *value)
{
	tmp_pc.mac_type = str_db_search(mac_type_db,value);
	return 0;
}

static int t2r_wan_mac(const char *value)
{
	int i;

    for(i=0;i<6;i++){
    	char temp[3];
    	strncpy(temp,&value[i*2],2);
    	temp[2]=0;
    	tmp_pc.mac_addr[i] = get_hex(temp);
    }

    return 0;
}

static int t2r_add(const char *value){
    return (0);
}

static int t2r_update(const char *value){
    return (0);
}

static int t2r_clearf(const char *value){
    return (0);
}

static int t2r_refresh(const char *value){
    return (0);
}

static int t2r_list_pcs(const char *value){
    return (0);
}

static int t2r_std_pcdb(const char *value){
    return (0);
}

static int t2r_help(const char *value){
    return (0);
}

static int t2r_message(const char *value)
{
	return 0;
}
#if 0
static int t2r_prev_name(const char *value){
    strcpy(prev_name,value);
    return 0;
}
#endif
enum{
PC_DBA_MOD,
PC_DBA_DEL,
PC_DBA_ADD,
PC_DBA_UPDATE
};
static char * todo_type_db[]={"edit_pc","delete","add","update",0};
int t2r_todo(const char *value)
{
	todo = str_db_search(todo_type_db,value);
	return 0;
}

int pc_dba_main()
{
	LIST *hd=NULL;
	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
	PC_DB_CONF_s *p_entry;

	ReadLanSettings(&lan_conf);
	ReadPCDBConf(p_pcdb_conf);
	memset(glb_errlog,0,sizeof(glb_errlog));

	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!do_cgi_t2r(hd,key_fun_tab)){
		    /* success */
            if( ErrlogIsSetted() && (PC_DBA_ADD == todo || PC_DBA_UPDATE == todo)) {
    		    if(isset(glb_errlog,MSG1_PC_DB)){
    		        char *msg=get_err_msg(MSG1_PC_DB);
    		        fmt_err_msg(msg,WK_NAME_LEN-1);
    		    }
    		}
		    else{
                switch (todo)
    		    {
    		        case PC_DBA_MOD:
                        if ((p_entry = PCDBGetEntry(name)) != NULL)
                        {
                            memcpy(&tmp_pc, p_entry, sizeof(PC_DB_CONF_s));
                        }
                        else{
                            memset(&tmp_pc, 0x0, sizeof(PC_DB_CONF_s));
                        }
    		        break;
                    case PC_DBA_DEL:
#ifdef _BB_DEBUG_
                sprintf(bb_buf, "<%s><%d>, name<%s>,", __FILE__, __LINE__, name);
                bb_trace(bb_buf);
#endif
//                        PCDBDel(p_pcdb_conf, name);
                        delPCInWholePC(p_pcdb_conf, name,del_ip.s_addr);
                    break;
                    case PC_DBA_ADD:
                    	if( tmp_pc.mac_type == 0){
                            if(arpCheck(LAN_ITF, tmp_pc.mac_addr, tmp_pc.ip_addr) != 1){
                		        char *msg=get_err_msg(MSG7_PC_DB);
                		        fmt_err_msg(msg);
                		        break;
                		    }
                            /* Before Add, delete it. */
                            {
                                char *pcName = PCDBGetNameByIP(tmp_pc.ip_addr);
                                unsigned int ip;

                                memcpy(&ip,tmp_pc.ip_addr,4);
                                delPCInWholePC(p_pcdb_conf, pcName, ip);
                                ReadPCDBConf(p_pcdb_conf);
                            }
                        }
                        PCDBAdd(p_pcdb_conf, &tmp_pc);

                    break;
                    case PC_DBA_UPDATE:
#ifdef _BB_DEBUG_
                        sprintf(bb_buf, "<%s><%d>, name<%s>,", __FILE__, __LINE__, name);
                        bb_trace(bb_buf);
#endif
                        if ((p_entry = PCDBGetEntry(prev_name)) != NULL)
                        {
                            tmp_pc.next = p_entry->next;
                            memcpy(p_entry, &tmp_pc, sizeof(PC_DB_CONF_s));
                            SavePCDBConf(p_pcdb_conf);
                        }
                    default:
                    break;
    		    }
    		    WriteConfToFlash();
    		} /* if( ErrlogIsSetted() )  */
	    }
	    list_clear(hd);
	}
	return html_parser("pc_dba.htm",key_fun_tab);
}
#endif
