#ifndef _PPPOE_CGI_C_
#define _PPPOE_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>

#include "wan.h"
#include "parser.h"
#include "system.h"
#include "lan.h"
#include "fw.h"
#include "dev_opt.h"

static int r2t_poe_ac_name(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,single_pppoe_conf.accountName);
    return(0);    
}

static int r2t_user_name(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,single_pppoe_conf.userName);
    return(0);    
}

static int r2t_password(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,single_pppoe_conf.password);
    return(0);    
}


static int r2t_connect_type(char buf[CGI_BUF_LEN],char **buf1){
    int i,select_index;
    
    select_index = single_pppoe_conf.dialMode;
    for(i=0;i<DIAL_MODE_NUM-1;i++){
        if(i==select_index){
            strcat(buf,option_sl);
        }
        else{
            strcat(buf,option_s);
        }
        strcat(buf,conn_type_db[i]);
        strcat(buf,option_e);
    }
    return 0;
}

static int r2t_idle_time(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char idletime;
    switch(single_pppoe_conf.dialMode){
    case ALWAYSON:
        idletime = 0;
        break;
    case DOD:
        idletime = single_pppoe_conf.DOD_idleTime;
        break;
    case MANUALLY:
        idletime = single_pppoe_conf.Manual_idelTime;
        break;
    default:
        idletime = 0;
    }
    sprintf(buf,"%u",idletime);
    return 0;
}

    
static int r2t_dhcp_cl(char buf[CGI_BUF_LEN],char **buf1){
    if(single_pppoe_conf.ipType == TYPE_DYNAMIC){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_dhcp_cl_disable(char buf[CGI_BUF_LEN],char **buf1){

    if(single_pppoe_conf.ipType != TYPE_DYNAMIC){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_dev_ip_1(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.ipAddress;
    
    if(single_pppoe_conf.ipAddress){
        sprintf(buf,"%u",*p);
    }
    return 0;
}

static int r2t_dev_ip_2(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.ipAddress;
    if(single_pppoe_conf.ipAddress){
        sprintf(buf,"%u",*(p+1));
    }
    return 0;
}

static int r2t_dev_ip_3(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.ipAddress;
    
    if(single_pppoe_conf.ipAddress){
        sprintf(buf,"%u",*(p+2));
    }
    return 0;
}

static int r2t_dev_ip_4(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.ipAddress;
    
    if(single_pppoe_conf.ipAddress){
        sprintf(buf,"%u",*(p+3));
    }
    return 0;
}

static int r2t_dev_mask_1(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.netMask;
    
    if(single_pppoe_conf.netMask){
        sprintf(buf,"%u",*(p));
    }
    return 0;
}

static int r2t_dev_mask_2(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.netMask;
    
    if(single_pppoe_conf.netMask){
        sprintf(buf,"%u",*(p+1));
    }
    return 0;
}

static int r2t_dev_mask_3(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.netMask;
    
    if(single_pppoe_conf.netMask){
        sprintf(buf,"%u",*(p+2));
    }
    return 0;
}

static int r2t_dev_mask_4(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.netMask;
    
    if(single_pppoe_conf.netMask){
        sprintf(buf,"%u",*(p+3));
    }
    return 0;
}

enum{
    SINGLE_POE_PRIVATE,
    SINGLE_POE_UNNUM,
    SINGLE_POE_BOTH,
    SINGLE_POE_NONE,
    SINGLE_POE_NUM
};

static int r2t_single_type(char buf[CGI_BUF_LEN],char **buf1){
    int i;
    
    //Corega do not want fix ip when pppoe
    for(i=1;i<SINGLE_POE_NUM-1;i++){
        switch(i){
        default:
        case 1:
            if(TYPE_UNNUMBERED == single_pppoe_conf.ipType){
                strcat(buf,option_sl);
            }
            else{
                strcat(buf,option_s);
            }
            break;
        case 2:
            if(TYPE_UNNUMBERED_PRIVATE == single_pppoe_conf.ipType){
                strcat(buf,option_sl);
            }
            else{
                strcat(buf,option_s);
            }
            break;
        }
        strcat(buf,poe_type_db[i]);
        strcat(buf,option_e);
    }
    return 0;
}

static int r2t_dns_type(char buf[CGI_BUF_LEN],char **buf1){
    
    if(!single_pppoe_conf.dnsType){
       strcpy(buf,str_checked);
    }
    return 0;
}
    
static int r2t_dns_type_fixed(char buf[CGI_BUF_LEN],char **buf1){
    if(single_pppoe_conf.dnsType){
       strcpy(buf,str_checked);
    }
    return 0;
}
    
static int r2t_dns1_ip_1(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.dns;
    
    if(single_pppoe_conf.dns){
        sprintf(buf,"%u",*p);
    }
    return 0;
}

static int r2t_dns1_ip_2(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.dns;
    
    if(single_pppoe_conf.dns){
        sprintf(buf,"%u",*(p+1));
    }
    return 0;
}

static int r2t_dns1_ip_3(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.dns;
    
    if(single_pppoe_conf.dns){
        sprintf(buf,"%u",*(p+2));
    }
    return 0;
}

static int r2t_dns1_ip_4(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char *p= (unsigned char *)&single_pppoe_conf.dns;
    
    if(single_pppoe_conf.dns){
        sprintf(buf,"%u",*(p+3));
    }
    return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
    set_err_msg(buf,buf1);
    return 0;
}

static int t2r_poe_ac_name(const char *value){
    
    if(strlen(value) >= PPPOE_ACCOUNT_NAME_LEN || !*value){
        setbit(glb_errlog,MSG2_PPPOE_M);
    }
    else{
        strcpy(single_pppoe_conf.accountName,value);
    }    
    return 0;
}

    
static int t2r_user_name(const char *value){
    if(strlen(value) >= PPPOE_USER_NAME_LEN || !*value){
        setbit(glb_errlog,MSG3_PPPOE_M);
    }
    else{
        strcpy(single_pppoe_conf.userName,value);
    }    
    return 0;
}

static int t2r_password(const char *value){
    if(strlen(value) >= PPPOE_PASSWORD_LEN || !*value){
        setbit(glb_errlog,MSG4_PPPOE_M);
    }
    else{
        strcpy(single_pppoe_conf.password,value);
    }    
    return 0;
}
    
static int t2r_connect_type(const char *value){
    single_pppoe_conf.dialMode = str_db_search(conn_type_db,value);
    return 0;
}   
    
static int t2r_idle_time(const char *value){
    int idletime = atoi(value);
    
    if(idletime< PPPOE_IDLE_MIN || idletime > PPPOE_IDLE_MAX){
        idletime = PPPOE_IDLE_DEFAULT;
    }    
    switch(single_pppoe_conf.dialMode){
    case ALWAYSON:
        break;
    case DOD:
        single_pppoe_conf.DOD_idleTime = idletime;
        break;
    case MANUALLY:
        single_pppoe_conf.Manual_idelTime = idletime;
        break;
    default:
        single_pppoe_conf.DOD_idleTime = single_pppoe_conf.Manual_idelTime = PPPOE_IDLE_DEFAULT;
        break;
    }
    return 0;
}

static int t2r_dhcp_cl(const char *value){
    
    single_pppoe_conf.ipType=str_db_search(dhcp_cl_db,value);
    return 0;
}
    
static int t2r_dev_ip_1(const char *value){
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.ipAddress;
    
    *p = ip;
    return 0;
}   
    
static int t2r_dev_ip_2(const char *value){
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.ipAddress;
    
    *(p+1) = ip;
    return 0;
}

static int t2r_dev_ip_3(const char *value){
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.ipAddress;
    
    *(p+2) = ip;
    return 0;
}

static int t2r_dev_ip_4(const char *value){
    int ip = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.ipAddress;
    
    *(p+3) = ip;
    
    return 0;
}

static int t2r_dev_mask_1(const char *value){
    int mask = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.netMask;
    
    *(p+0) = mask;
    return 0;
}

static int t2r_dev_mask_2(const char *value){
    int mask = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.netMask;
    
    *(p+1) = mask;
    return 0;
}

static int t2r_dev_mask_3(const char *value){
    int mask = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.netMask;
    
    *(p+2) = mask;
    return 0;
}

static int t2r_dev_mask_4(const char *value){
    int mask = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.netMask;
    
    *(p+3) = mask;
    return 0;
}

static int t2r_single_type(const char *value){
    int poe_type;
    
    if(single_pppoe_conf.ipType != TYPE_DYNAMIC){    
        poe_type = str_db_search(poe_type_db,value);
        switch(poe_type){
        case 1: /* Unnumbered IP */
            single_pppoe_conf.ipType = TYPE_UNNUMBERED;
            break;
        default:
        case 2: /* Unnumbered IP + Private */
            single_pppoe_conf.ipType = TYPE_UNNUMBERED_PRIVATE;
            break;
        }
    }    
    return 0;
}

static int t2r_dns_type(const char *value){
    
    single_pppoe_conf.dnsType = str_db_search(dns_type_db,value);
    return 0;
}

static int t2r_dns1_ip_1(const char *value){
    int dns = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.dns[0];
    
    *(p+0) = dns;
    return 0;
}

static int t2r_dns1_ip_2(const char *value){
    int dns = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.dns[0];
    
    *(p+1) = dns;
    return 0;
}

static int t2r_dns1_ip_3(const char *value){
    int dns = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.dns[0];
    
    *(p+2) = dns;
    return 0;
}

static int t2r_dns1_ip_4(const char *value){
    int dns = atoi(value);
    unsigned char *p= (unsigned char *)&single_pppoe_conf.dns[0];
    
    *(p+3) = dns;
    return 0;
}

static int t2r_back(const char *value){
    return 0;
}

static int t2r_save(const char *value){
    return 0;
}

static int t2r_help(const char *value){
    return 0;
}

static int t2r_message(const char *value){
    return 0;
}

int pppoe_main(void)
{
	LIST *hd=NULL;
	SINGLE_PPPOE_CONF *pConf=&single_pppoe_conf;
	LAN_CONF *pLanConf=&lan_conf;
	char prev_ipType;
	int needRestartLan=0;
	
	memset(glb_errlog,0,sizeof(glb_errlog));
    	ReadSinglePPPoESettings(pConf);
    	ReadLanSettings(pLanConf);
    	prev_ipType = pConf->ipType;   
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}
		if(!do_cgi_t2r(hd,key_fun_tab)){
		    	if(ErrlogIsSetted()){
    		    		if(isset(glb_errlog,MSG2_PPPOE_M)){
    		        		char *msg=get_err_msg(MSG2_PPPOE_M);
    		        		fmt_err_msg(msg,PPPOE_ACCOUNT_NAME_LEN-1);
    		    		}
    		    		if(isset(glb_errlog,MSG3_PPPOE_M)){
    		        		char *msg=get_err_msg(MSG3_PPPOE_M);
    		        		fmt_err_msg(msg,PPPOE_USER_NAME_LEN-1);
    		    		}
    		    		if(isset(glb_errlog,MSG4_PPPOE_M)){
    		        		char *msg=get_err_msg(MSG4_PPPOE_M);
    		        		fmt_err_msg(msg,PPPOE_PASSWORD_LEN-1);
    		    		}
    			}    		
			else{
				StopWan();
		        
                		switch(pConf->ipType){
                		case TYPE_DYNAMIC:                      /* PPPoE fix IP */
                    			pConf->ipAddress = pConf->netMask = 0;
					if((TYPE_UNNUMBERED == prev_ipType)||(TYPE_UNNUMBERED_PRIVATE == prev_ipType)){
						RestoreLANSettings(pLanConf);
						needRestartLan=1;
					}
                    			break;
                    
                		case TYPE_FIXED:                        /* PPPoE fix IP */
                    			break;
                                   
               	 		case TYPE_UNNUMBERED:                   /* PPPoE Unnumbered IP. */
                    			/*In Unnumbered mode , need to change lan IP to be the same as wan IP. */
                    			pLanConf->LanIPAddr = pConf->ipAddress;
                    			pLanConf->NetMaskIPAddr = pConf->netMask;
                    
                  	  		/* Lan only one IP. */
                    			pLanConf->LanIPAddr2 = pLanConf->NetMaskIPAddr2 = 0;
                    
                    			/* Disable the DHCP server. */
                    			pLanConf->DhcpEnable = DHCP_DISABLE;
					needRestartLan=1;
                    			break;
                                     
                		case TYPE_UNNUMBERED_PRIVATE:
                    			RestoreLANSettings(pLanConf);
                    			pLanConf->LanIPAddr2 = pConf->ipAddress;
                    			pLanConf->NetMaskIPAddr2 = pConf->netMask;
					needRestartLan=1;
                    			break;
                                        
                		default:
                    			break;
                		}
			}
    			if(!pConf->dnsType){
    				pConf->dns[0] = 0;
    			}
			SaveSinglePPPoESettings(pConf);      
			SaveLanSettings(pLanConf);
			set_wan_type(CONNECTION_SINGLE_PPPOE);        
                	WriteConfToFlash();
			if(fork()==0){
				cgi_fork_do();
				if(needRestartLan)
					StartLAN(0);
				StartWan();
				exit(0);
			}
            	}            
		list_clear(hd);
	}
   	return html_parser("pppoe.htm",key_fun_tab);
}
#endif /* _PPPOE_CGI_C_ */
