#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_poe_ac_names(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_session(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_user_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_password(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_connect_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_idle_time(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_type_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mask_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mask_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mask_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mask_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_udp_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_udp_packet_len(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns_type_fixed(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns2_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns2_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns2_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns2_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_traffic_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_netbios_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_primary_ac(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_secondary_ac(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_poe_ac_names(const char *value);
static int t2r_session(const char *value);
static int t2r_poe_ac_name(const char *value);
static int t2r_user_name(const char *value);
static int t2r_password(const char *value);
static int t2r_connect_type(const char *value);
static int t2r_idle_time(const char *value);
static int t2r_lan_type_enable(const char *value);
static int t2r_ip_1(const char *value);
static int t2r_ip_2(const char *value);
static int t2r_ip_3(const char *value);
static int t2r_ip_4(const char *value);
static int t2r_mask_1(const char *value);
static int t2r_mask_2(const char *value);
static int t2r_mask_3(const char *value);
static int t2r_mask_4(const char *value);
static int t2r_udp_enable(const char *value);
static int t2r_udp_packet_len(const char *value);
static int t2r_dns_type(const char *value);
static int t2r_dns1_ip_1(const char *value);
static int t2r_dns1_ip_2(const char *value);
static int t2r_dns1_ip_3(const char *value);
static int t2r_dns1_ip_4(const char *value);
static int t2r_dns2_ip_1(const char *value);
static int t2r_dns2_ip_2(const char *value);
static int t2r_dns2_ip_3(const char *value);
static int t2r_dns2_ip_4(const char *value);
static int t2r_traffic_enable(const char *value);
static int t2r_netbios_enable(const char *value);
static int t2r_add_ip(const char *value);
static int t2r_add_url(const char *value);
static int t2r_add_port(const char *value);
static int t2r_back(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_primary_ac(const char *value);
static int t2r_secondary_ac(const char *value);
static int t2r_message(const char *value);
static int t2r_todo(const char *value);


static keyfun_tab key_fun_tab[]={
	{"poe_ac_names",r2t_poe_ac_names,t2r_poe_ac_names},
	{"session",r2t_session,t2r_session},
	{"poe_ac_name",r2t_poe_ac_name,t2r_poe_ac_name},
	{"user_name",r2t_user_name,t2r_user_name},
	{"password",r2t_password,t2r_password},
	{"connect_type",r2t_connect_type,t2r_connect_type},
	{"idle_time",r2t_idle_time,t2r_idle_time},
	{"lan_type_enable",r2t_lan_type_enable,t2r_lan_type_enable},
	{"IP_1",r2t_ip_1,t2r_ip_1},
	{"IP_2",r2t_ip_2,t2r_ip_2},
	{"IP_3",r2t_ip_3,t2r_ip_3},
	{"IP_4",r2t_ip_4,t2r_ip_4},
	{"MASK_1",r2t_mask_1,t2r_mask_1},
	{"MASK_2",r2t_mask_2,t2r_mask_2},
	{"MASK_3",r2t_mask_3,t2r_mask_3},
	{"MASK_4",r2t_mask_4,t2r_mask_4},
	{"udp_enable",r2t_udp_enable,t2r_udp_enable},
	{"udp_packet_len",r2t_udp_packet_len,t2r_udp_packet_len},
	{"dns_type",r2t_dns_type,t2r_dns_type},
	{"dns_type_fixed",r2t_dns_type_fixed,NULL},
	{"DNS1_IP_1",r2t_dns1_ip_1,t2r_dns1_ip_1},
	{"DNS1_IP_2",r2t_dns1_ip_2,t2r_dns1_ip_2},
	{"DNS1_IP_3",r2t_dns1_ip_3,t2r_dns1_ip_3},
	{"DNS1_IP_4",r2t_dns1_ip_4,t2r_dns1_ip_4},
	{"DNS2_IP_1",r2t_dns2_ip_1,t2r_dns2_ip_1},
	{"DNS2_IP_2",r2t_dns2_ip_2,t2r_dns2_ip_2},
	{"DNS2_IP_3",r2t_dns2_ip_3,t2r_dns2_ip_3},
	{"DNS2_IP_4",r2t_dns2_ip_4,t2r_dns2_ip_4},
	{"traffic_enable",r2t_traffic_enable,t2r_traffic_enable},
	{"netbios_enable",r2t_netbios_enable,t2r_netbios_enable},
	{"add_ip",NULL,t2r_add_ip},
	{"add_url",NULL,t2r_add_url},
	{"add_port",NULL,t2r_add_port},
	{"back",NULL,t2r_back},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"primary_ac",r2t_primary_ac,t2r_primary_ac},
	{"secondary_ac",r2t_secondary_ac,t2r_secondary_ac},
	{"message",r2t_message,t2r_message},
	{"todo",r2t_todo,t2r_todo},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "pppoe_m_cgi.c"

/*************************/
