#ifndef _REMOTEMG_CGI_C_
#define _REMOTEMG_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "remotemg.h"
#include "parser.h"
#include "system.h"

#include "wan.h"             //ada

static remotemg conf;
//static char ip[16];

//ada
static MULTI_PPPOE_CONF mpoe_conf;
static int poe_account_index;
static int wan_type;
static enum{
	CHANGE_ACCOUNT,
	SAVE
}which_submit;

//ada

static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	if(wan_type == CONNECTION_MULTI_PPPOE){
        strcpy(buf,str_poe_ac_list_head);
        for(i=0;i<MAX_PPPOE_ACCOUNT;i++){
            if(i == poe_account_index){
                strcat(buf,option_sl);
            }
            else{
                strcat(buf,option_s);
            }
            strcat(buf,mpoe_conf.account[i].poe_ac_name);
            strcat(buf,option_e);
        }
        strcat(buf,str_poe_ac_list_tail);
        }
	return 0;
}

static int r2t_remote_mg(char buf[CGI_BUF_LEN],char **buf1)
{
	if(conf.remote_mg)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_remote_port(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.remote_port);
	return 0;
}

static int r2t_dport_ip(char buf[CGI_BUF_LEN],char **buf1)
{
	GetConnectionStatus(&if_status);
	strcpy(buf,inet_ntoa(if_status.ip));
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf,buf1);
	return 0;
}


static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
        strcpy(buf,mpoe_conf.account[poe_account_index].poe_ac_name);       //ada
	return 0;
}

static int t2r_remote_mg(const char *value)
{
	conf.remote_mg=1;
	return 0;
}

static int t2r_remote_port(const char *value)
{
	int i=atoi(value);
	if( i<1 || i>65534 || !*value){
		setbit(glb_errlog,MSG1_RMG);
	}
	else{
		conf.remote_port=i;
	}
	return 0;
}

static int t2r_save(const char *value)
{
	which_submit=SAVE;        //ada
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

static int t2r_poe_ac_value(const char *value)
{
	//ada
	int i;
	if(*value){
	    for(i=0;*value&&i<MAX_PPPOE_ACCOUNT;i++){
	        if(!strcmp(value,mpoe_conf.account[i].poe_ac_name)){
	            poe_account_index = i;  
	            break;
	        }
	    }	
	}         
        //ada 	
	return 0;
}

int remotemg_main(void)
{
	LIST *hd=NULL;
	int ccode;

	memset(glb_errlog,0,sizeof(glb_errlog));

	//ada
	which_submit = CHANGE_ACCOUNT;  		
	memset(&mpoe_conf, 0, sizeof(MULTI_PPPOE_CONF));	
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){
		poe_account_index=0;		
		ReadMultiPPPoESettings(&mpoe_conf);
	}
	else
	{
		poe_account_index=-1;		
	}
	//ada
	
	memset(&conf,0,sizeof(conf));
	ReadRemoteConf(&conf,poe_account_index);   //ada

	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!hd)
			cgi_err("","");
		if(!do_cgi_t2r(hd,key_fun_tab)){
			if(ErrlogIsSetted()){
    		    if(isset(glb_errlog,MSG1_RMG)){
    		        char *msg=get_err_msg(MSG1_RMG);
    		        fmt_err_msg(msg);
    		    }
    		}
    		else{
        //ada
    			if(which_submit==SAVE){
    			ccode=SaveRemoteConf(&conf,poe_account_index);
				WriteConfToFlash();
				}
		    	else if(which_submit==CHANGE_ACCOUNT){
					ReadRemoteConf(&conf,poe_account_index);	
				}
        //ada
			}
		}
		list_clear(hd);
	}	
	return html_parser("remotemg.htm",key_fun_tab);
}			
	
#endif /*_REMOTEMG_CGI_C_*/
