#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_r_dest_ip1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_dest_ip2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_dest_ip3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_dest_ip4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_mask_ip1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_mask_ip2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_mask_ip3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_mask_ip4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_gw_ip1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_gw_ip2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_gw_ip3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_gw_ip4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_metric(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_iface(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_rip_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_rt_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dest_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dest_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dest_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dest_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_gw_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_gw_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_gw_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_gw_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_metric(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_if_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_rt_list(const char *value);
static int t2r_dest_ip_1(const char *value);
static int t2r_dest_ip_2(const char *value);
static int t2r_dest_ip_3(const char *value);
static int t2r_dest_ip_4(const char *value);
static int t2r_lan_mask_1(const char *value);
static int t2r_lan_mask_2(const char *value);
static int t2r_lan_mask_3(const char *value);
static int t2r_lan_mask_4(const char *value);
static int t2r_gw_ip_1(const char *value);
static int t2r_gw_ip_2(const char *value);
static int t2r_gw_ip_3(const char *value);
static int t2r_gw_ip_4(const char *value);
static int t2r_metric(const char *value);
static int t2r_clear(const char *value);
static int t2r_add(const char *value);
static int t2r_update(const char *value);
static int t2r_delete(const char *value);
static int t2r_list_all(const char *value);
static int t2r_help(const char *value);
static int t2r_todo(const char *value);
static int t2r_message(const char *value);
static int t2r_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"r_dest_ip1",r2t_r_dest_ip1,NULL},
	{"r_dest_ip2",r2t_r_dest_ip2,NULL},
	{"r_dest_ip3",r2t_r_dest_ip3,NULL},
	{"r_dest_ip4",r2t_r_dest_ip4,NULL},
	{"r_mask_ip1",r2t_r_mask_ip1,NULL},
	{"r_mask_ip2",r2t_r_mask_ip2,NULL},
	{"r_mask_ip3",r2t_r_mask_ip3,NULL},
	{"r_mask_ip4",r2t_r_mask_ip4,NULL},
	{"r_gw_ip1",r2t_r_gw_ip1,NULL},
	{"r_gw_ip2",r2t_r_gw_ip2,NULL},
	{"r_gw_ip3",r2t_r_gw_ip3,NULL},
	{"r_gw_ip4",r2t_r_gw_ip4,NULL},
	{"r_metric",r2t_r_metric,NULL},
	{"r_iface",r2t_r_iface,NULL},
	{"rip_list",r2t_rip_list,NULL},
	{"RT_LIST",r2t_rt_list,t2r_rt_list},
	{"DEST_IP_1",r2t_dest_ip_1,t2r_dest_ip_1},
	{"DEST_IP_2",r2t_dest_ip_2,t2r_dest_ip_2},
	{"DEST_IP_3",r2t_dest_ip_3,t2r_dest_ip_3},
	{"DEST_IP_4",r2t_dest_ip_4,t2r_dest_ip_4},
	{"LAN_MASK_1",r2t_lan_mask_1,t2r_lan_mask_1},
	{"LAN_MASK_2",r2t_lan_mask_2,t2r_lan_mask_2},
	{"LAN_MASK_3",r2t_lan_mask_3,t2r_lan_mask_3},
	{"LAN_MASK_4",r2t_lan_mask_4,t2r_lan_mask_4},
	{"GW_IP_1",r2t_gw_ip_1,t2r_gw_ip_1},
	{"GW_IP_2",r2t_gw_ip_2,t2r_gw_ip_2},
	{"GW_IP_3",r2t_gw_ip_3,t2r_gw_ip_3},
	{"GW_IP_4",r2t_gw_ip_4,t2r_gw_ip_4},
	{"metric",r2t_metric,t2r_metric},
	{"if_list",r2t_if_list,NULL},
	{"clear",NULL,t2r_clear},
	{"add",NULL,t2r_add},
	{"update",NULL,t2r_update},
	{"delete",NULL,t2r_delete},
	{"LIST_ALL",NULL,t2r_list_all},
	{"help",NULL,t2r_help},
	{"todo",r2t_todo,t2r_todo},
	{"message",r2t_message,t2r_message},
	{"value",r2t_value,t2r_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "routing_cgi.c"

/*************************/
