#include <arpa/inet.h>
#include <string.h>
#include <time.h>
#include "lan.h"
#include "serv.h"
#include "groups.h"
#include "sch_def.h"


#define LIMIT        "-m limit --limit 1/m"
#define LOG_LEVEL    "--log-level info"
#define LOG_PREFIX   "--log-prefix "


#if 0
#define	GROUP(x)	(0x01<<(gindex))
#else
/* Now, one PC only in one group , but I think that upper is better. */
#define GROUP(x)	(gindex)
#endif /**/

extern int iptables(char *arg);

int sh_acc_ctrl_main(int argc, char *argv[])
{
	char arg[200];
	char CHAIN[10],ip[32],mask[32],ADDR[200],SERVICE[100],TARGET[10],IN_SCH[10];
	char ADDR_bak[200],SERVICE_bak[100];
	int i=1;
	LAN_CONF conf;
	struct in_addr ina;
	serv_conf *pserv=NULL,*ps; //ada
	PC_DB_CONF_s *pdb; //ada
	int serv_num=0;	 //ada
	char *p; //ada		
	int gindex; //ada
	int Have_PC=0;	 //ada
	group_conf group;//ada

	ReadLanSettings(&conf);
	ina.s_addr = conf.LanIPAddr;
	sprintf(ip, "%s", inet_ntoa(ina));
	ina.s_addr = conf.NetMaskIPAddr;
	sprintf(mask, "%s", inet_ntoa(ina));
			
	pc_db_link_init();        //ada
	ReadPCDBConf(&pc_db_conf);     //ada
		
	ReadSERV(&pserv,&serv_num,-1);	//ada	
			
	while(argc>1){
		memset(&ADDR,0,sizeof(ADDR));
		memset(&SERVICE,0,sizeof(SERVICE));
		
	        sprintf(CHAIN, "group%s", argv[i]);

	        sprintf(arg, "-F %s", CHAIN);
		iptables(arg);
		
		switch(atoi(argv[i])){	        
	        case 0:
	        case 1:
	        case 2:
	        case 3:
	        case 4:
	        	gindex = atoi(argv[i]);
	        	break;
	        default:
	        	return 1;
	        }
	        
		ReadGroup(gindex, &group);
		if(GROUP_BASE_SCHEDULE ==  group.schedule){
		    strcpy(IN_SCH,inSchedule(gindex,time(0)) ? "yes" : "no");
		}
		else{
		    strcpy(IN_SCH, "yes");
		}
	        switch(group.block){
	        case BLOCK_NONE:
			strcpy(TARGET, "ACCEPT");
		    	break;
		case BLOCK_ALL:
		    	strcpy(TARGET, "DROPALL");
		    	break;		
		case BLOCK_SELECT:
			strcpy(TARGET, "DROP");
			break;
	        default:
		        break;

		}
		if(gindex==0){
			sprintf(ADDR, "%s/%s ", ip, mask);
			Have_PC = 1;
		}
		else{
			int len=0;
			pdb=pc_db_conf.p_database;
			Have_PC = 0;
			while(pdb){
#if 0
				if((pdb->group)&GROUP(gindex))
#else
                    		if( (pdb->group) == GROUP(gindex) )
#endif /* #if 0 */
                    		{
                    			len += sprintf(ADDR+len,"%d.%d.%d.%d ",pdb->ip_addr[0],pdb->ip_addr[1],pdb->ip_addr[2],pdb->ip_addr[3]);//ada
				        Have_PC = 1;
				}
					pdb=pdb->next;
			}
		}
		strcpy(ADDR_bak,ADDR);//ada

		ps=pserv;
		if( Have_PC ){
			/* If no PC in this group , why we need print port ? */
			int len=0;
    			while(ps){
    				if(serv_in_group(ps->name,gindex)){
    					p=strchr(ps->port_info,'-');
    					if(p)
    						*p=':';
    					len += sprintf(SERVICE+len,"%s-%s ",ps->protocol,ps->port_info);//ada
    				}
    				ps=ps->next;
    			}
    		}
    		strcpy(SERVICE_bak,SERVICE);//ada

		
		if(!strcmp(IN_SCH, "yes")){
	        	sprintf(arg, "-A %s -s 0/0", CHAIN);
			iptables(arg);
		}else{				        	        	
	        	sprintf(arg, "-A %s -j RETURN", CHAIN);
			iptables(arg);
		}
			
		if(!strcmp(TARGET, "DROP")){
			char *q1,*q2,*pro,*port;
			int j;
			int timer=1;  //ada
			strcpy(SERVICE,SERVICE_bak);
			q1=strtok(SERVICE," ");
        		while(q1)
        		{
				pro=strtok(q1,"-");  //ada
				port=strtok(NULL,"-");  //ada
				strcpy(ADDR,ADDR_bak);
				q2=strtok(ADDR," ");
        			while(q2)
        			{
					if(!strcmp(pro, "TCP/UDP")){
						sprintf(arg, "-A %s -i %s -p tcp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s \"DROPPED PACKET: \"", CHAIN, LAN_ITF,q2, ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    					iptables(arg);
						sprintf(arg, "-A %s -i %s -p tcp -s %s -d ! %s/%s --dport %s -j %s", CHAIN, LAN_ITF,q2, ip, mask, port, TARGET);
	    					iptables(arg);
						sprintf(arg, "-A %s -i %s -p udp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s \"DROPPED PACKET: \"", CHAIN, LAN_ITF,q2, ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    					iptables(arg);	    				
						sprintf(arg, "-A %s -i %s -p udp -s %s -d ! %s/%s --dport %s -j %s", CHAIN, LAN_ITF,q2, ip, mask, port, TARGET);
	    					iptables(arg);
	    				}else if(!strcmp(pro, "TCP")){
						sprintf(arg, "-A %s -i %s -p tcp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s \"DROPPED PACKET: \"", CHAIN, LAN_ITF,q2, ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    					iptables(arg);
						sprintf(arg, "-A %s -i %s -p tcp -s %s -d ! %s/%s --dport %s -j %s", CHAIN, LAN_ITF,q2, ip, mask, port, TARGET);
	    					iptables(arg);
	    				}else if(!strcmp(pro, "UDP")){
						sprintf(arg, "-A %s -i %s -p udp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s \"DROPPED PACKET: \"", CHAIN, LAN_ITF,q2, ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    					iptables(arg);	    				
						sprintf(arg, "-A %s -i %s -p udp -s %s -d ! %s/%s --dport %s -j %s", CHAIN, LAN_ITF,q2, ip, mask, port, TARGET);
	    					iptables(arg);
	    				}else if(!strcmp(pro, "ICMP")){
						sprintf(arg, "-A %s -i %s -p icmp --icmp-type %s -s %s -d ! %s/%s %s -j LOG %s %s \"DROPPED PACKET: \"", CHAIN, LAN_ITF, port,q2, ip, mask, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    					iptables(arg);	    				
						sprintf(arg, "-A %s -i %s -p icmp --icmp-type %s -s %s -d ! %s/%s -j %s", CHAIN, LAN_ITF, port,q2, ip, mask, TARGET);
	    					iptables(arg);
	    				}else{
						sprintf(arg, "-A %s -i %s -p %s -s %s -d ! %s/%s %s -j LOG %s %s \"DROPPED PACKET: \"", CHAIN, LAN_ITF, pro,q2, ip, mask, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    					iptables(arg);	    				
						sprintf(arg, "-A %s -i %s -p %s -s %s -d ! %s/%s -j %s", CHAIN, LAN_ITF, pro,q2, ip, mask, TARGET);
	    					iptables(arg);
	    				}
	    				q2=strtok(NULL," ");
	    			}
					strcpy(SERVICE,SERVICE_bak);
					q1=strtok(SERVICE," ");
					for(j=0;j<timer;j++)
          			q1=strtok(NULL," ");
					timer++;
        		}
        	}else if(!strcmp(TARGET, "ACCEPT")){
	    		i++;
	    		argc--;
	    		continue;
	    	}else{
	    		char *q;
			q=strtok(ADDR," ");
        		while(q)
        		{
				sprintf(arg, "-A %s -i %s -s %s %s -j LOG %s %s \"DROPPED PACKET: \"", CHAIN, LAN_ITF, q, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    			iptables(arg);
				sprintf(arg, "-A %s -i %s -s %s -j DROP", CHAIN, LAN_ITF, q);
	    			iptables(arg);
          			q=strtok(NULL," ");
        		}        						
	    	}
	    	i++;
	    	argc--;
	} 		        		
	FreeSERV(pserv); //ada		        		
	return 0;
}
