#include <stdio.h>
#include <arpa/inet.h>
#include <string.h>
#include <time.h>
#include "lan.h"
#include "serv.h"
#include "groups.h"
#include "sch_def.h"

#define LIMIT        "-m limit --limit 1/m"
#define LOG_LEVEL    "--log-level info"
#define LOG_PREFIX   "--log-prefix \"DROPPED PACKET: \""


#if 0
#define	GROUP(x)	(0x01<<(gindex))
#else
/* Now, one PC only in one group , but I think that upper is better. */
#define GROUP(x)	(gindex)
#endif /**/

extern int iptables(char *arg);

int sh_gid_modify_main(int argc, char *argv[])
{
	char arg[200];
	char CHAIN[10],ip[32],mask[32],ACTION[10],SERVICE[200],TARGET[10];
	char SERVICE_bak[100];
	int i=1;
	LAN_CONF conf;
	struct in_addr ina;
	char *p;		
	int gindex;
	int Have_PC=0;
	int serv_num=0;
	int len=0;
	serv_conf *pserv=NULL,*ps;
	PC_DB_CONF_s *pdb;
	group_conf group;
		
	pc_db_link_init();        //ada
	ReadPCDBConf(&pc_db_conf);          //ada	

	ReadLanSettings(&conf);
	ina.s_addr = conf.LanIPAddr;
	sprintf(ip, "%s", inet_ntoa(ina));
	ina.s_addr = conf.NetMaskIPAddr;
	sprintf(mask, "%s", inet_ntoa(ina));
	
	ReadSERV(&pserv,&serv_num,-1);	
			
	while(argc>1){
		len=0;
		memset(&SERVICE,0,sizeof(SERVICE));	
		
	        sprintf(CHAIN, "group%s", argv[i+2]);
		
		switch(atoi(argv[i+2])){	        
	        case 0:
	        case 1:
	        case 2:
	        case 3:
	        case 4:
	        	gindex = atoi(argv[i+2]);
	        	break;
	        default:
	        	return 1;
	        }

		ReadGroup(gindex, &group);
	        switch(group.block){
	        case BLOCK_NONE:
			strcpy(TARGET, "ACCEPT");
		    	break;
		case BLOCK_ALL:
		    	strcpy(TARGET, "DROPALL");
		    	break;		
		case BLOCK_SELECT:
			strcpy(TARGET, "DROP");
			break;
	        default:
		        break;
		}
/*		if(gindex==0){
			Have_PC = 1;
		}
		else{
			pdb=pc_db_conf.p_database;
			Have_PC = 0;
			while(pdb){
#if 0
				if((pdb->group)&GROUP(gindex))
#else
                    		if( (pdb->group) == GROUP(gindex) )
#endif // #if 0 
                    		{
				        Have_PC = 1;
				}
				pdb=pdb->next;
			}
		}*/

		ps=pserv;
//		if( Have_PC ){
			/* If no PC in this group , why we need print port ? */
    			while(ps){
    				if(serv_in_group(ps->name,gindex)){
    					p=strchr(ps->port_info,'-');
    					if(p)
    						*p=':';
    					len += sprintf(SERVICE+len,"%s-%s ",ps->protocol,ps->port_info);//ada   					
    				}
    				ps=ps->next;
    			}
//    		}
    		strcpy(SERVICE_bak,SERVICE);//ada
		
		if(!strcmp(argv[i],"add"))
			strcpy(ACTION, "-A");
		else if(!strcmp(argv[i],"del"))
			strcpy(ACTION, "-D");
		else{		
			return 1;
		}

		if(!strcmp(TARGET, "ACCEPT")){
			sprintf(arg, "%s %s -i %s -s %s -j ACCEPT", ACTION, CHAIN, LAN_ITF, argv[i+1]);
	    		iptables(arg);			
	    		i = i+3;
	    		argc = argc-3;
	    		continue;
	    	}else if(!strcmp(TARGET, "DROPALL")){
			sprintf(arg, "%s %s -i %s -s %s -j DROP", ACTION, CHAIN, LAN_ITF, argv[i+1]);
	    		iptables(arg);	
	    	}else if(!strcmp(TARGET, "DROP")){
			char *s,*pro,*port;
			int j;
			int timer=1;  //ada
			strcpy(SERVICE,SERVICE_bak);//ada
			s=strtok(SERVICE," ");
        		while(s)
        		{
        			pro=strtok(s,"-");
        			port=strtok(NULL,"-");
				if(!strcmp(pro, "TCP/UDP")){
					sprintf(arg, "%s %s -i %s -p tcp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, argv[i+1], ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    				iptables(arg);
					sprintf(arg, "%s %s -i %s -p tcp -s %s -d ! %s/%s --dport %s -j %s", ACTION, CHAIN, LAN_ITF, argv[i+1], ip, mask, port, TARGET);
	    				iptables(arg);
					sprintf(arg, "%s %s -i %s -p udp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, argv[i+1], ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    				iptables(arg);
					sprintf(arg, "%s %s -i %s -p udp -s %s -d ! %s/%s --dport %s -j %s", ACTION, CHAIN, LAN_ITF, argv[i+1], ip, mask, port, TARGET);
	    				iptables(arg);
	    			}else if(!strcmp(pro, "TCP")){
					sprintf(arg, "%s %s -i %s -p tcp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, argv[i+1], ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    				iptables(arg);
					sprintf(arg, "%s %s -i %s -p tcp -s %s -d ! %s/%s --dport %s -j %s", ACTION, CHAIN, LAN_ITF, argv[i+1], ip, mask, port, TARGET);
	    				iptables(arg);
	    			}else if(!strcmp(pro, "UDP")){
					sprintf(arg, "%s %s -i %s -p udp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, argv[i+1], ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    				iptables(arg);
					sprintf(arg, "%s %s -i %s -p udp -s %s -d ! %s/%s --dport %s -j %s", ACTION, CHAIN, LAN_ITF, argv[i+1], ip, mask, port, TARGET);
	    				iptables(arg);
	    			}else if(!strcmp(pro, "ICMP")){
					sprintf(arg, "%s %s -i %s -p icmp --icmp-type %s -s %s -d ! %s/%s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, port, argv[i+1], ip, mask, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    				iptables(arg);
					sprintf(arg, "%s %s -i %s -p icmp --icmp-type %s -s %s -d ! %s/%s -j %s", ACTION, CHAIN, LAN_ITF, port, argv[i+1], ip, mask, TARGET);
	    				iptables(arg);
	    			}else{
					sprintf(arg, "%s %s -i %s -p %s -s %s -d ! %s/%s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, pro, argv[i+1], ip, mask, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    				iptables(arg);
					sprintf(arg, "%s %s -i %s -p %s -s %s -d ! %s/%s -j %s", ACTION, CHAIN, LAN_ITF, pro, argv[i+1], ip, mask, TARGET);
	    				iptables(arg);
	    			}
	    				strcpy(SERVICE,SERVICE_bak);
					s=strtok(SERVICE," ");
					for(j=0;j<timer;j++)
						s=strtok(NULL," ");
					timer++;
          		}
        	}
	    	i = i+3;
	    	argc = argc-3;
	}
	FreeSERV(pserv); 		        		
	return 0;
}
