#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>

extern int sh_icmp_main(int argc, char *argv[]);
extern int sh_chain_init_main(int argc, char *argv[]);
extern int sh_dmz_main(int argc, char *argv[]);
extern int sh_dos_main(int argc, char *argv[]);
extern int sh_remote_main(int argc, char *argv[]);
extern int sh_sch_main(int argc, char *argv[]);
extern int sh_nat_main(int argc, char *argv[]);
extern int sh_sevice_modify_main(int argc, char *argv[]);
extern int sh_acc_ctrl_main(int argc, char *argv[]);
extern int sh_vs_main(int argc, char *argv[]);
extern int sh_reaim_main(int argc, char *argv[]);
extern int sh_static_rules_main(int argc, char *argv[]);
extern int sh_vpn_pass_main(int argc, char *argv[]);
extern int sh_spec_app_main(int argc, char *argv[]);
extern int sh_security_main(int argc, char *argv[]);
extern int sh_gid_modify_main(int argc, char *argv[]);

typedef struct{
    char *sh_name;
    int (*sh_main_func)(int argc, char *argv[]);
}SH_FUNC_LIST;

static SH_FUNC_LIST file_func_db[]={
//    {"sh_icmp",			sh_icmp_main	},
    {"sh_chain_init",		sh_chain_init_main	},
    {"sh_dmz",			sh_dmz_main	},
    {"sh_dos",			sh_dos_main	},
    {"sh_remote",		sh_remote_main	},
    {"sh_sch",			sh_sch_main	},
    {"sh_nat",			sh_nat_main	},
//    {"sh_sevice_modify",	sh_sevice_modify_main	},
    {"sh_acc_ctrl",		sh_acc_ctrl_main	}, 
    {"sh_vs",			sh_vs_main	},   
    {"sh_reaim",		sh_reaim_main	},
    {"sh_static_rules",		sh_static_rules_main	},
//    {"sh_vpn_pass",		sh_vpn_pass_main	},  
//    {"sh_spec_app",		sh_spec_app_main	},
    {"sh_security",		sh_security_main	},  
    {"sh_gid_modify",		sh_gid_modify_main	},         
    {NULL,NULL}
};

int main(int argc , char **argv){
    int i; 
    for(i=0;file_func_db[i].sh_name;i++){
        if(!strcmp(file_func_db[i].sh_name,(char *)basename(argv[0]))){
            break;
        }
    }

    if(!file_func_db[i].sh_main_func){
        return 0;
    }
    return file_func_db[i].sh_main_func(argc, argv);
}
