#include <arpa/inet.h>
#include <string.h>
#include "lan.h"
#include "h_const.h"
#define LIMIT        "-m limit --limit 1/m"
#define LOG_LEVEL    "--log-level info"
#define LOG_PREFIX   "--log-prefix \"DROPPED PACKET: \""
#define TARGET       "DROP"


#if 0
#define	GROUP(x)	(0x01<<(i))
#else
/* Now, one PC only in one group , but I think that upper is better. */
#define GROUP(x)	(i)
#endif /**/

int sh_sevice_modify_main(int argc, char *argv[])
{   
	char arg[200];
	char ADDR[200],ip[32],mask[32],ACTION[10],CHAIN[10];
	char *protocol,*port;
	int i=2;
	PC_DB_CONF_s *pdb;	
	LAN_CONF conf;
	struct in_addr ina;

        sprintf(CHAIN, "group%s", argv[1]);
        
	ReadLanSettings(&conf);
	ina.s_addr = conf.LanIPAddr;
	sprintf(ip, "%s", inet_ntoa(ina));
	ina.s_addr = conf.NetMaskIPAddr;
	sprintf(mask, "%s", inet_ntoa(ina));

	pc_db_link_init();        //ada
	ReadPCDBConf(&pc_db_conf);          //ada

	if(!strcmp(argv[1],"0")){
		sprintf(ADDR, "%s/%s ", ip, mask);
	}else{
		int index;	
		if(!strcmp(argv[1],"1")){
			index = 1;
		}else if(!strcmp(argv[1],"2")){
			index = 2;
		}else if(!strcmp(argv[1],"3")){
			index = 3;
		}else if(!strcmp(argv[1],"4")){
			index = 4;
		}else{
			return 1;
		}
		pdb=pc_db_conf.p_database;
		while(pdb){
#if 0
			if((pdb->group)&GROUP(index))
#else
                    	if( (pdb->group) == GROUP(index) )
#endif /* #if 0 */
                        {
                        	char temp[50];
				sprintf(temp,"%d.%d.%d.%d ",pdb->ip_addr[0],pdb->ip_addr[1],pdb->ip_addr[2],pdb->ip_addr[3]);
				strcat(ADDR,temp);
			}
			pdb=pdb->next;
		}
	}
	
	while(argc > 2){
		char *g;
		if(!strcmp(argv[i],"add"))
			strcpy(ACTION, "-A");
		else if(!strcmp(argv[i],"del"))
			strcpy(ACTION, "-D");
		else{		
			return 1;
		}
		protocol=strtok(argv[i+1],"-");
        	port=strtok(NULL,"-");		

		g=strtok(ADDR," ");
		while(g)
        	{
			if(!strcmp(protocol, "TCP/UDP")){
				sprintf(arg, "%s %s -i %s -p tcp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, g, ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    			iptables(arg);
				sprintf(arg, "%s %s -i %s -p tcp -s %s -d ! %s/%s --dport %s -j %s", ACTION, CHAIN, LAN_ITF, g, ip, mask, port, TARGET);
	    			iptables(arg);
				sprintf(arg, "%s %s -i %s -p udp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, g, ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    			iptables(arg);	    				
				sprintf(arg, "%s %s -i %s -p udp -s %s -d ! %s/%s --dport %s -j %s", ACTION, CHAIN, LAN_ITF, g, ip, mask, port, TARGET);
	    			iptables(arg);
	    		}else if(!strcmp(protocol, "TCP")){
				sprintf(arg, "%s %s -i %s -p tcp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, g, ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    			iptables(arg);
				sprintf(arg, "%s %s -i %s -p tcp -s %s -d ! %s/%s --dport %s -j %s", ACTION, CHAIN, LAN_ITF, g, ip, mask, port, TARGET);
	    			iptables(arg);
	    		}else if(!strcmp(protocol, "UDP")){	    				
				sprintf(arg, "%s %s -i %s -p udp -s %s -d ! %s/%s --dport %s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, g, ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    			iptables(arg);	    				
				sprintf(arg, "%s %s -i %s -p udp -s %s -d ! %s/%s --dport %s -j %s", ACTION, CHAIN, LAN_ITF, g, ip, mask, port, TARGET);
	    			iptables(arg);
	    		}else if(!strcmp(protocol, "ICMP")){
				sprintf(arg, "%s %s -i %s -p icmp --icmp-type %s -s %s -d ! %s/%s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, port, g, ip, mask, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    			iptables(arg);	    				
				sprintf(arg, "%s %s -i %s -p icmp --icmp-type %s -s %s -d ! %s/%s -j %s", ACTION, CHAIN, LAN_ITF, g, ip, mask, port, TARGET);
	    			iptables(arg);	    							
	    		}else{
				sprintf(arg, "%s %s -i %s -p %s -s %s -d ! %s/%s %s -j LOG %s %s", ACTION, CHAIN, LAN_ITF, protocol, g, ip, mask, port, LIMIT, LOG_LEVEL, LOG_PREFIX);
	    			iptables(arg);	    				
				sprintf(arg, "%s %s -i %s -p %s -s %s -d ! %s/%s -j %s", ACTION, CHAIN, LAN_ITF, protocol, g, ip, mask, TARGET);
	    			iptables(arg);
	    		}
			g=strtok(NULL," ");												
		}
		argc = argc - 2;
		i = i+2;
	}
	return 0;
}
