#include <stdio.h>
#include <stdlib.h>
#include "h_const.h"
#define LIMIT_LOG        	"-m limit --limit 1/m --limit-burst 1 -j LOG --log-level info --log-prefix"
#define S_FORWARD_CHAIN         "static_forward" 
#define S_INPUT_CHAIN           "static_input" 
#define B_FORWARD_CHAIN         "bottom_forward" 
#define B_INPUT_CHAIN           "bottom_input" 
#define INPUT_SPEED             20 
#define INPUT_ICMP_SPEED        100 
#define TCP_SERVICES            "-m multiport -p tcp --dports 21,23,80,1900" 
#define UDP_SERVICES            "-m multiport -p udp --dports 53,67,69,1900" 

extern int iptables(char *arg);

int sh_static_rules_main(int argc, char *argv[])
{   
	char arg[200];

	sprintf(arg, "-A %s -p tcp --tcp-flags SYN,RST SYN -j TCPMSS --clamp-mss-to-pmtu", S_FORWARD_CHAIN);
	iptables(arg);	

	sprintf(arg, "-A %s  -p tcp --tcp-flag ALL SYN,PSH,ACK,URG %s \"DOS ATTACK(SPAU_SCAN): \"", S_INPUT_CHAIN, LIMIT_LOG);
	iptables(arg);
	sprintf(arg, "-A %s  -p tcp --tcp-flag ALL SYN,PSH,ACK,URG -j DROP", S_INPUT_CHAIN);
	iptables(arg);
			
	sprintf(arg, "-A %s  -p tcp --tcp-flag ALL SYN,PSH,ACK,URG  %s \"DOS ATTACK(SPAU_SCAN): \"", S_FORWARD_CHAIN, LIMIT_LOG);
	iptables(arg);
	sprintf(arg, "-A %s  -p tcp --tcp-flag ALL SYN,PSH,ACK,URG -j DROP", S_FORWARD_CHAIN);
	iptables(arg);
	
	sprintf(arg, "-A %s -p icmp --icmp-type echo-request -m pkttype --pkt-type broadcast %s \"DOS ATTACK(SMURF_SCAN): \"", S_INPUT_CHAIN, LIMIT_LOG);
	iptables(arg);	
	sprintf(arg, "-A %s -p icmp --icmp-type echo-request -m pkttype --pkt-type broadcast %s \"DOS ATTACK(SMURF_SCAN): \"", S_FORWARD_CHAIN, LIMIT_LOG);
	iptables(arg);
	
	system("/bin/echo 1 >/proc/sys/net/ipv4/icmp_echo_ignore_broadcasts");
	
	sprintf(arg, "-A %s -p tcp --tcp-flag ALL NONE %s \"DOS ATTACK(NULL_SCAN): \"", S_INPUT_CHAIN, LIMIT_LOG);
	iptables(arg);
	sprintf(arg, "-A %s -p tcp --tcp-flag ALL NONE -j DROP", S_INPUT_CHAIN);
	iptables(arg);
		
	sprintf(arg, "-A %s -p tcp --tcp-flag ALL NONE %s \"DOS ATTACK(NULL_SCAN): \"", S_FORWARD_CHAIN, LIMIT_LOG);
	iptables(arg);
	sprintf(arg, "-A %s -p tcp --tcp-flag ALL NONE -j DROP", S_FORWARD_CHAIN);
	iptables(arg);
	
	sprintf(arg, "-A %s -m state --state ESTABLISHED,RELATED -j ACCEPT", B_FORWARD_CHAIN);
	iptables(arg);
	sprintf(arg, "-A %s -m state --state ESTABLISHED,RELATED -j ACCEPT", B_INPUT_CHAIN);
	iptables(arg);	

	sprintf(arg, "-A %s -i %s %s -m state --state NEW -m limit --limit %d/s --limit-burst %d -j ACCEPT", B_INPUT_CHAIN, LAN_ITF, TCP_SERVICES, INPUT_SPEED, INPUT_SPEED);
	iptables(arg);
	sprintf(arg, "-A %s -i %s %s -m state --state NEW %s \"DOS ATTACK(INPUT TCP): \"", B_INPUT_CHAIN, LAN_ITF, TCP_SERVICES, LIMIT_LOG);
	iptables(arg);
	
	sprintf(arg, "-A %s -i %s %s -j ACCEPT", B_INPUT_CHAIN, LAN_ITF, UDP_SERVICES);
	iptables(arg);

        sprintf(arg, "-A %s -i %s -j ACCEPT", B_INPUT_CHAIN, LOC_ITF);
	iptables(arg);
	
	sprintf(arg, "-A %s -i %s -p icmp -m limit --limit %d/s --limit-burst %d -j ACCEPT", B_INPUT_CHAIN, LAN_ITF, INPUT_ICMP_SPEED, INPUT_ICMP_SPEED);
	iptables(arg);
	sprintf(arg, "-A %s -i %s -p icmp %s \"DOS ATTACK(INPUT ICMP): \"", B_INPUT_CHAIN, LAN_ITF, LIMIT_LOG);
	iptables(arg);							
	return 0;
}
