#include "h_const.h"

#define VPN_CHAIN        "vpn_pass"
#define URLF_CHAIN       "url_filter"
#define ICMP_CHAIN       "icmp_echo"
#define PPTP             "pptp" 
#define IPSEC            "ipsec"
#define L2TP             "l2tp"
#define URL_FILTER       "url_filter"
#define ICMP_ECHO        "icmp_echo" 
int sh_vpn_pass_main(int argc, char *argv[])
{   
	char arg[100];
	char TARGET[10];
	int i=1;
	
	while(argc>1){
		if(!strcmp(argv[i],"enable")){
			i=i+2;
			argc=argc-2;
			continue;
		}else{
			strcpy(TARGET,"DROP");
		}
		if(!strcmp(argv[i+1],PPTP)){
			sprintf(arg, "-R %s 1 -p tcp --dport 1723 -j %s", VPN_CHAIN, TARGET);
			iptables(arg);
		}else if(!strcmp(argv[i+1],L2TP)){
			sprintf(arg, "-R %s 2 -p udp --sport 1701 --dport 1701 -j %s", VPN_CHAIN, TARGET);
			iptables(arg);
		}else if(!strcmp(argv[i+1],IPSEC)){
			sprintf(arg, "-R %s 3 -p udp --dport 500 -j %s", VPN_CHAIN, TARGET);
			iptables(arg);
			sprintf(arg, "-R %s 4 -p ESP -j %s", VPN_CHAIN, TARGET);
			iptables(arg);			
			sprintf(arg, "-R %s 5 -p AH -j %s", VPN_CHAIN, TARGET);
			iptables(arg);			
		}else if(!strcmp(argv[i+1],URL_FILTER)){
			sprintf(arg, "-F %s", URLF_CHAIN);
			iptables(arg);
			if(!strcmp(argv[i],"enable")){
				sprintf(arg, "-A %s -i %s -p tcp --dport 80 -j QUEUE", URLF_CHAIN, LAN_ITF);
				iptables(arg);
			}			
		}else if(!strcmp(argv[i+1],ICMP_ECHO)){			
			sprintf(arg, "-R %s 1 -i ! %s -p icmp --icmp-type echo-request -j %s", ICMP_ECHO, LAN_ITF, TARGET);
			iptables(arg);
		}else{
			printf("items must be pptp, l2tp, ipsec, url-filter, or icmp-echo!");
		}
		i=i+2;
		argc=argc-2;
	}
	return 0;
}
