#include <arpa/inet.h>
#include <string.h>
#include "h_const.h"
#include "lan.h"
#include "system.h"

#define DEBUG	       "1"
int sh_vs_modify_main(int argc, char *argv[])
{   
	char arg[200];
	char ACTION[10], ip[32], mask[32], WAN_ITF[10], WAN_IP[32], vs_ext_port[20], vs_int_port[20];
	char *start_in, *end_in, *start_ex, *end_ex, *protocol;
	LAN_CONF conf;
	struct in_addr ina;
		
	ReadLanSettings(&conf);
	ina.s_addr = conf.LanIPAddr;
	sprintf(ip, "%s", inet_ntoa(ina));
	ina.s_addr = conf.NetMaskIPAddr;
	sprintf(mask, "%s", inet_ntoa(ina));

	GetConnectionStatus(&if_status);
	strcpy(WAN_IP,inet_ntoa(if_status.ip));	
	ReadSystemSettings(&system_conf);
	switch(system_conf.Connection){
		case CONNECTION_DHCP: /* DHCP */
			strcpy(WAN_ITF,"eth1");
        		break;
		default:
			strcpy(WAN_ITF,"ppp0");;
        		break;
	}		

	if(!strcmp(argv[1],"add"))
		strcpy(ACTION, "-A");
	else if(!strcmp(argv[1],"del"))
		strcpy(ACTION, "-D");
	else{		
		return 1;
	}
	if(!DEBUG){
		printf("action        is  %s", ACTION);
		printf("server IP     is  %s", argv[2]);
		printf("protocol      is  %s", argv[3]);
		printf("external port is  %s", argv[4]);			
		printf("internalport  is  %s", argv[5]);
		printf("");
	}
	strcpy(vs_int_port,argv[5]);
	start_in=strtok(argv[5],":");
        end_in=strtok(NULL,":");
        strcpy(vs_ext_port,argv[4]);
	start_in=strtok(argv[4],":");
        end_in=strtok(NULL,":");        
        protocol=strtok(argv[3]," ");
        while(protocol){
	        sprintf(arg, "-t nat %s NAT_VS_DNAT_CHAIN -p %s --dport %s -j DNAT --to %s:%s-%s", ACTION, protocol, vs_ext_port, argv[2], start_in, end_in);
		iptables(arg);				        	        	
	        sprintf(arg, "-t nat %s NAT_VS_SNAT_CHAIN -o %s -s %s/%s -d %s -p %s --dport %s -j SNAT --to %s", ACTION, LAN_ITF, ip, mask, argv[2], protocol, vs_int_port, ip);
		iptables(arg);
	        sprintf(arg, "-t nat %s NAT_VS_SNAT_CHAIN -o %s -s %s -p %s  --sport %s -j SNAT --to %s:%s-%s", ACTION, WAN_ITF, argv[2], protocol, argv[4], WAN_IP, start_ex, end_ex);
		iptables(arg);		 
		protocol =  strtok(NULL," ");
	}
					
	return 0;
}
