#ifndef _ST_DHCP_CGI_C_
#define _ST_DHCP_CGI_C_
#include "wan.h"
#include "system.h"
#include <netinet/in.h>

static unsigned long lease, remain;
static char cmd[10];

int r2t_dport_phadd(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%02x:%02x:%02x:%02x:%02x:%02x",
		if_status.mac[0],
		if_status.mac[1],
		if_status.mac[2],
        if_status.mac[3],
		if_status.mac[4],
		if_status.mac[5]);
								
    return 0;
}

int r2t_dport_ip(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,inet_ntoa(if_status.ip));
    return 0;
}

int r2t_dport_mask(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,inet_ntoa(if_status.mask));
    return 0;
}

int r2t_dport_gw(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,inet_ntoa(if_status.gw));
    return 0;
}

int r2t_dport_dns(char buf[CGI_BUF_LEN],char **buf1)
{
    struct in_addr *dns_pp=GetDNSIPFromFile(RESOLV_FILE);
 	INT16 i,first=0;
	for (i=0;i<MAX_DNS_NUM; i++){
        if(first==0){
			if(dns_pp[i].s_addr){
				strcat(buf,inet_ntoa(dns_pp[i]) );
				first=1;
			}
		}
		else{
		    if(dns_pp[i].s_addr){
			    strcat(buf,str_brk);
		 	    strcat(buf,inet_ntoa(dns_pp[i]) );
		    }
		}
	}
   return 0;
}

int r2t_dhcp_client_enable(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%s",(dhcp_conf.dhcpc_type)?get_err_msg(MSG3_ST_DHCP):get_err_msg(MSG2_ST_DHCP));     
    return 0;
}

int r2t_lease_tm(char buf[CGI_BUF_LEN],char **buf1){
	CHAR day_str[20],hour_str[20],min_str[20];
	DWORD day,hour,minute;
	DWORD sec;

	memset(day_str,0,20);
	memset(hour_str,0,20);
	memset(min_str,0,20);

    if(!dhcp_conf.dhcpc_type){
    	sec=lease;
    	day=(sec/(24*3600));
    	hour=(sec-day*24*3600)/3600;
    	minute=(sec-day*24*3600-hour*3600)/60;
#ifdef _OEM_022_
    	if (sec == 0xffffffff)
    	{
    		sprintf(day_str,"0");
    		sprintf(hour_str,"0");
    		sprintf(min_str,"0");
    	}
    	else
#endif
    	{
    		sprintf(day_str,"%ld",day);
    		sprintf(hour_str,"%ld",hour);
    		sprintf(min_str,"%ld",minute);
    	}
    	strcpy(buf,day_str);
    	strcat(buf,get_err_msg(MSG4_ST_DHCP));
    	strcat(buf,hour_str);
    	strcat(buf,get_err_msg(MSG5_ST_DHCP));
    	strcat(buf,min_str);
    	strcat(buf,get_err_msg(MSG6_ST_DHCP));
    }
    else{
        strcpy(buf,get_err_msg(MSG7_ST_DHCP));
    }    
    return 0;
}

int r2t_expire_tm(char buf[CGI_BUF_LEN],char **buf1){
	CHAR day_str[20],hour_str[20],min_str[20];
	DWORD day,hour,minute;
	DWORD sec;

	memset(day_str,0,20);
	memset(hour_str,0,20);
	memset(min_str,0,20);

    if(!dhcp_conf.dhcpc_type){
    	sec=remain;
    	day=(sec/(24*3600));
    	hour=(sec-day*24*3600)/3600;
    	minute=(sec-day*24*3600-hour*3600)/60;
#ifdef _OEM_022_
    	if (sec == 0xffffffff)
    	{
    		sprintf(day_str,"0");
    		sprintf(hour_str,"0");
    		sprintf(min_str,"0");
    	}
    	else
#endif
    	{
    		sprintf(day_str,"%ld",day);
    		sprintf(hour_str,"%ld",hour);
    		sprintf(min_str,"%ld",minute);
    	}
    	strcpy(buf,day_str);
    	strcat(buf,get_err_msg(MSG4_ST_DHCP));
    	strcat(buf,hour_str);
    	strcat(buf,get_err_msg(MSG5_ST_DHCP));
    	strcat(buf,min_str);
    	strcat(buf,get_err_msg(MSG6_ST_DHCP));
    }    
    else{
        strcpy(buf,get_err_msg(MSG7_ST_DHCP));
    }    
    return 0;
}

int r2t__release_(char buf[CGI_BUF_LEN],char **buf1)
{
   if(if_status.ip.s_addr==0){
	sprintf(buf,"%s","");
    }else{
	sprintf(buf,"%s","");
    }
    return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_dhcp_client(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%s",(dhcp_conf.dhcpc_type)?"false":"true"); 
    return 0;
}

int t2r_release(const char *value)
{
    if(strcmp(value,"")==0)
	strcpy(cmd,"stop");
    else
	strcpy(cmd,"restart");
    return 0;
}

int t2r_refresh(const char *value)
{
	return 0;
}

int t2r_help(const char *value)
{
	return 0;
}

int t2r_close(const char *value)
{
	return 0;
}

int t2r_message(const char *value)
{
	return 0;
}

int t2r_dhcp_client(const char *value)
{
   return 0;
}

int st_dhcp_main()
{
	LIST *hd=NULL;

	GetLeaseAndRemainTime(&lease,&remain);
	ReadDHCPSettings(&dhcp_conf);
 
	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
			if(!strcmp(cmd,"stop"))
				StopWanDHCP();
			else if(!strcmp(cmd,"restart"))
				StartWanDHCP();
		}
		list_clear(hd);
	}
	GetIfaceStatus(ETH_WAN,&if_status);
	return html_parser("st_dhcp.htm",key_fun_tab);
}
#endif /* _ST_DHCP_CGI_C_ */
