#ifndef _ST_CGI_C_
#define _ST_CGI_C_
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <net/if.h>
#include "system.h"
#include "cgi-lib.h"
#include "wan.h"

static MULTI_PPPOE_CONF mpoe_conf;
static int poe_session_index;
static int wan_type;

static enum{
    CONNECT_PPPOE=1,
    DISCONN_PPPOE,
    CHANGE_SESSION
}which_submit;

int r2t_dport_phadd(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,print_mac(if_status.mac,':'));
	return 0;
}

int r2t_dport_ip(char buf[CGI_BUF_LEN],char **buf1){

    strcpy(buf,inet_ntoa(if_status.ip));
    if( !strcmp(buf,DOD_IP) ){
        *buf = '\0';
    }
	return 0;
}

int r2t_dport_mask(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,inet_ntoa(if_status.mask));
    if( !strcmp(inet_ntoa(if_status.ip), DOD_IP) ){
        *buf = '\0';
    }
	return 0;
}

int r2t_pppoe_link(char buf[CGI_BUF_LEN],char **buf1){
    if(if_status.flag&IFF_UP){
        sprintf(buf,"%s",dhcp_server_status_db[IF_UP]);
    }
    else{
        sprintf(buf,"%s",dhcp_server_status_db[IF_DOWN]);
    }

    if( !strcmp(inet_ntoa(if_status.ip), DOD_IP) ){
        sprintf(buf,"%s",dhcp_server_status_db[IF_DOWN]);
    }
	return 0;
}

int r2t_modem_log(char buf[CGI_BUF_LEN],char **buf1)
{
    *buf1 = malloc(MAX_POELOG_LEN);
    if(! *buf1){
        return 0;
    }
    GetPPPoELog(*buf1, poe_session_index);
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
    set_err_msg(buf,buf1);
	return 0;
}

int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_poe_session_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	if(wan_type==CONNECTION_MULTI_PPPOE){	
		sprintf(buf,"%s","ڑw: <select name=\"session\" size=\"1\" onChange=\"getSession()\">");
		for(i=0;i<MAX_PPPOE_SESSION;i++){
			if(i == poe_session_index){
				strcat(buf,option_sl);
			}
			else{
				strcat(buf,option_s);
			}
			strcat(buf,session_db[i+1]);
			strcat(buf,option_e);
		}
 		strcat(buf,"</select><br>");
	}else
		sprintf(buf,"%s","&nbsp;");
	return 0;
}

int r2t_poe_session(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d", poe_session_index);	
    return 0;
}

int t2r_modem_log(const char *value)
{
	return 0;
}

int t2r_clr_log(const char *value){
    ClearPPPoELog(poe_session_index);
	return 0;
}

int t2r_dial(const char *value){
    which_submit = CONNECT_PPPOE;
	return 0;
}

int t2r_hang_up(const char *value){

    which_submit = DISCONN_PPPOE;
	return 0;
}

int t2r_refresh(const char *value){
	return 0;
}

int t2r_help(const char *value){
	return 0;
}

int t2r_close(const char *value){
	return 0;
}

int t2r_message(const char *value){
	return 0;
}

int t2r_todo(const char *value){
	return 0;
}

int t2r_poe_session(const char *value){
	poe_session_index = atoi(value);
	return 0;
}


int st_poe_main(){
	LIST *hd=NULL;
	BYTE mac[6];
	char ifname[8]="ppp0";
	
	which_submit=CHANGE_SESSION;
	poe_session_index=0;
	/* For I can not get ppp iface's MAC ,get ethx MAC first.*/
	GetIfaceStatus(ETH_WAN,&if_status);
	memcpy(mac,if_status.mac,6);
	
	memset(&mpoe_conf, 0, sizeof(MULTI_PPPOE_CONF));	
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){		
//		ReadMultiPPPoESettings(&mpoe_conf);
	}else{
//		ReadSinglePPPoESettings(&single_pppoe_conf);		
	}

	hd=cgi_input_parse();
	if(strcmp(REQUEST_METHOD,POST)==0){
		if(!do_cgi_t2r(hd,key_fun_tab)){
			/* success */
			switch(which_submit){
			case DISCONN_PPPOE:
				if(wan_type==CONNECTION_SINGLE_PPPOE){
					SINGLE_PPPOE_CONF spoe_conf;
					ReadSinglePPPoESettings(&spoe_conf);
					if(spoe_conf.dialMode!=DOD)
						StopWanSPPPoE();
				}
				else
					StopWanMPPPoE(poe_session_index);
				break;					
			case CONNECT_PPPOE:
				if(wan_type==CONNECTION_SINGLE_PPPOE){
					SINGLE_PPPOE_CONF spoe_conf;
					ReadSinglePPPoESettings(&spoe_conf);
					if(spoe_conf.dialMode!=DOD)
						StartWanSPPPoE();
				}
				else
					StartWanMPPPoE(poe_session_index);
				break;
			case CHANGE_SESSION:
				break;
			}
		}
//		list_clear(hd);
		
	}else{
	        char *val;
	        val=find_val(hd,"ses_index");	
		if(val)			
			poe_session_index=atoi(val);
	}
			/* Get ppp iface's status , copy MAC back. */
			sprintf(ifname,"ppp%d",poe_session_index);
			GetIfaceStatus(ifname,&if_status);
			memcpy(if_status.mac,mac,6);

	return html_parser("st_poe.htm",key_fun_tab);
}
#endif /* _ST_CGI_C_ */
