#ifndef _STATUS_CGI_C_
#define _STATUS_CGI_C_
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <net/if.h>
#include "system.h"
#include "lan.h"
#include "wan.h"


static DEVICE_INFO device_info;
static IFACE_STATUS if0_status;

int r2t_connection_method(char buf[CGI_BUF_LEN],char **buf1){
    
	if(system_conf.Connection==CONNECTION_DHCP){
		strcpy(buf,"Direct");
	}
#ifdef _WAN_MODEM_
	else if(system_conf.Connection==CONNECTION_MODEM){
		strcpy(buf,"_CAbv");
	}
#endif
	//ada
	else if(system_conf.Connection==CONNECTION_LOCAL_OFFICE){
		strcpy(buf,"Direct");
	}//ada
	else{
		strcpy(buf,"PPPoE");
	}
    
	return 0;
}

int r2t_broadband_modem(char buf[CGI_BUF_LEN],char **buf1){
    
	return 0;
}

int r2t_internet_connection(char buf[CGI_BUF_LEN],char **buf1){
    
    if(if_status.flag&IFF_UP){
        sprintf(buf,"%s",Connection_status_db[CONNECTION_UP]);
    }
    else{
        sprintf(buf,"%s",Connection_status_db[CONNECTION_DOWN]);
    }
    
    if( system_conf.Connection != CONNECTION_DHCP 
      && !strcmp(inet_ntoa(if_status.ip), DOD_IP) ){
        sprintf(buf,"%s",Connection_status_db[CONNECTION_DOWN]);
    }
    
        
	return 0;
}

int r2t_wan_ip(char buf[CGI_BUF_LEN],char **buf1)
{
    
    strcpy(buf,inet_ntoa(if_status.ip));
    if( system_conf.Connection != CONNECTION_DHCP 
      && !strcmp(inet_ntoa(if_status.ip), DOD_IP) ){
        *buf = '\0';
    }
	return 0;
}


int r2t_lan_ip(char buf[CGI_BUF_LEN],char **buf1)
{
      strcpy(buf,inet_ntoa(if0_status.ip));	
	return 0;
}

int r2t_lan_mask(char buf[CGI_BUF_LEN],char **buf1){
    
	strcpy(buf,inet_ntoa(if0_status.mask));
	return 0;
}

int r2t_dhcp_status(char buf[CGI_BUF_LEN],char **buf1){
    
    if(lan_conf.DhcpEnable == DHCP_ENABLE){
        strcpy(buf,dhcp_server_status_db[0]);
    }
    else{
        strcpy(buf,dhcp_server_status_db[1]);
    }    
	return 0;
}

int r2t_device_name(char buf[CGI_BUF_LEN],char **buf1){
    
    strcpy(buf,device_info.device_name);
	return 0;
}

int r2t_fw_version(char buf[CGI_BUF_LEN],char **buf1){
    
    strcpy(buf,device_info.FWVersion);    
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
	return 0;
}

int r2t_sec_wan_name(char buf[CGI_BUF_LEN],char **buf1)
{
	if(system_conf.Connection==CONNECTION_MULTI_PPPOE){
		strcpy(buf,"ZbVQ:");
	}
        return 0;
}

int r2t_sec_wan_ip(char buf[CGI_BUF_LEN],char **buf1)
{
	IFACE_STATUS if2_status;
	if(system_conf.Connection==CONNECTION_MULTI_PPPOE){
		GetIfaceStatus("ppp1",&if2_status);
		strcpy(buf,inet_ntoa(if2_status.ip));		
	}
	return 0;
}

int t2r_refresh(const char *value){
	return 0;
}

int t2r_conn_log(const char *value){
	return 0;
}

int t2r_upgrade(const char *value){
	return 0;
}

static int t2r_cfg_save(const char *value){
    return 0;
}

int t2r_sys_data(const char *value){
	return 0;
}

int t2r_sys_diag(const char *value){
	return 0;
}

int t2r_logs(const char *value){
	return 0;
}

int t2r_email(const char *value){
	return 0;
}

int t2r_help(const char *value){
	return 0;
}

int t2r_message(const char *value){
	return 0;
}

int status_main()
{
	LIST *hd=NULL;
	
	ReadLocalSettings(&local_conf);//ada	
	ReadSystemSettings(&system_conf);
	GetConnectionStatus(&if_status);
	ReadLanSettings(&lan_conf);
	ReadDHCPSettings(&dhcp_conf);
	memset(&device_info,'\0',sizeof(device_info));
	get_device_info(&device_info);
	GetIfaceStatus(LAN_ITF, &if0_status);	
	
	
	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
		}
		list_clear(hd);
	}
	return html_parser("status.htm",key_fun_tab);
}
#endif /* _STATUS_CGI_C_ */
