#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <net/if.h>
#include "h_var.h"
#include "system.h"
#include "lan.h"
#include "wan.h"

static DEVICE_INFO device_info;
static IFACE_STATUS  if1_status,if2_status,lan_if_status;

int r2t_device_name(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf,device_info.device_name);
	return 0;
}

int r2t_fw_version(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,device_info.FWVersion); 
	return 0;
}

int r2t_hadd_id(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%02x%02x%02x%02x%02x%02x"
        ,device_info.dbHWID[0],device_info.dbHWID[1],device_info.dbHWID[2]
        ,device_info.dbHWID[3],device_info.dbHWID[4],device_info.dbHWID[5]); 
	return 0;
}

int r2t_connect_method(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%s","PPPoE");
	return 0;
}

int r2t_wan_mac_addr(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%02x%02x%02x%02x%02x%02x"
        ,if_status.mac[0],if_status.mac[1],if_status.mac[2]
        ,if_status.mac[3],if_status.mac[4],if_status.mac[5]); 
	return 0;
}

int r2t_wan_ip1(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf,inet_ntoa(if1_status.ip));
	return 0;
}

int r2t_wan_mask1(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf,inet_ntoa(if1_status.mask));
	return 0;
}

int r2t_dport_dns1(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_wan_ip2(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf,inet_ntoa(if2_status.ip));
	return 0;
}

int r2t_wan_mask2(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf,inet_ntoa(if2_status.mask));
	return 0;
}

int r2t_dport_dns2(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_lan_mac_addr(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%02x%02x%02x%02x%02x%02x"
        ,lan_if_status.mac[0],lan_if_status.mac[1],lan_if_status.mac[2]
        ,lan_if_status.mac[3],lan_if_status.mac[4],lan_if_status.mac[5]); 
	return 0;
}

int r2t_lan_ip(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf,inet_ntoa(lan_if_status.ip));
	return 0;
}

int r2t_lan_mask(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf,inet_ntoa(lan_if_status.mask));
	return 0;
}

int r2t_dhcp_enable(char buf[CGI_BUF_LEN],char **buf1)
{
    if(lan_conf.DhcpEnable == DHCP_ENABLE){
        strcpy(buf,dhcp_cl_db[0]);
    }
    else{
        strcpy(buf,dhcp_cl_db[1]);
    }
	return 0;
}

int r2t_dhcp_start_ip(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%u.%u.%u.%u",
       *((unsigned char*)&(lan_conf.StartIp)),
       *(((unsigned char*)&(lan_conf.StartIp))+1),
       *(((unsigned char*)&(lan_conf.StartIp))+2),
       *(((unsigned char*)&(lan_conf.StartIp))+3));
	return 0;
}

int r2t_dhcp_end_ip(char buf[CGI_BUF_LEN],char **buf1)
{
    sprintf(buf,"%u.%u.%u.%u",
       *((unsigned char*)&(lan_conf.FinishIp)),
       *(((unsigned char*)&(lan_conf.FinishIp))+1),
       *(((unsigned char*)&(lan_conf.FinishIp))+2),
       *(((unsigned char*)&(lan_conf.FinishIp))+3));
	return 0;
}

int sys_rpt2_main()
{
	ReadLanSettings(&lan_conf);
	ReadDHCPSettings(&dhcp_conf);
	memset(&device_info,'\0',sizeof(device_info));
	get_device_info(&device_info);
    GetIfaceStatus(LAN_ITF,&lan_if_status);
    GetIfaceStatus("ppp0",&if1_status);
    GetIfaceStatus("ppp1",&if2_status);

	return html_parser("sys_rpt2.htm",key_fun_tab);
}

