#ifndef _SYS_RPT_C_
#define _SYS_RPT_C_
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <net/if.h>
#include "h_var.h"
#include "system.h"
#include "lan.h"
#include "wan.h"

static DEVICE_INFO device_info;
static IFACE_STATUS  lan_if_status;

int r2t_device_name(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,device_info.device_name);
	return 0;
}

int r2t_fw_version(char buf[CGI_BUF_LEN],char **buf1){   
    strcpy(buf,device_info.FWVersion); 
	return 0;
}

int r2t_hadd_id(char buf[CGI_BUF_LEN],char **buf1){

    sprintf(buf,"%02x%02x%02x%02x%02x%02x"
        ,device_info.dbHWID[0],device_info.dbHWID[1],device_info.dbHWID[2]
        ,device_info.dbHWID[3],device_info.dbHWID[4],device_info.dbHWID[5]); 
	return 0;
}

int r2t_connect_method(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,Connection_sys_rpt_db[(BYTE)system_conf.Connection]);
	return 0;
}

int r2t_wan_mac_addr(char buf[CGI_BUF_LEN],char **buf1){
    sprintf(buf,"%02x%02x%02x%02x%02x%02x"
        ,if_status.mac[0],if_status.mac[1],if_status.mac[2]
        ,if_status.mac[3],if_status.mac[4],if_status.mac[5]); 

	return 0;
}

int r2t_wan_ip(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,inet_ntoa(if_status.ip));
	return 0;
}

int r2t_wan_mask(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,inet_ntoa(if_status.mask));
	return 0;
}

int r2t_wan_gw(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,inet_ntoa(if_status.gw));
    
    if( !strcmp(buf,"0.0.0.0") ){
        *buf = '\0';
    }
    
	return 0;
}

int r2t_dhcpc_enable(char buf[CGI_BUF_LEN],char **buf1){
    
    strcpy(buf,dhcp_server_status_db[(BYTE)dhcp_conf.dhcpc_type]);    
	return 0;
}

int r2t_dport_dns(char buf[CGI_BUF_LEN],char **buf1){
    struct in_addr *dns_pp=GetDNSIPFromFile(RESOLV_FILE);
 	INT16 i,first=0;

	for (i=0;i<MAX_DNS_NUM; i++){
        if(first==0){
			if(dns_pp[i].s_addr){
				strcat(buf,inet_ntoa(dns_pp[i]) );
				first=1;
			}
		}
		else{
		    if(dns_pp[i].s_addr){
			    strcat(buf,str_brk);
		 	    strcat(buf,inet_ntoa(dns_pp[i]) );
		    }
		}
	}    
	return 0;
}

int r2t_lan_mac_addr(char buf[CGI_BUF_LEN],char **buf1){

    sprintf(buf,"%02x%02x%02x%02x%02x%02x"
        ,lan_if_status.mac[0],lan_if_status.mac[1],lan_if_status.mac[2]
        ,lan_if_status.mac[3],lan_if_status.mac[4],lan_if_status.mac[5]); 
    
	return 0;
}

int r2t_lan_ip(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,inet_ntoa(lan_if_status.ip));
	return 0;
}

int r2t_lan_mask(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,inet_ntoa(lan_if_status.mask));
	return 0;
}

int r2t_dhcp_enable(char buf[CGI_BUF_LEN],char **buf1){
    if(lan_conf.DhcpEnable == DHCP_ENABLE){
        strcpy(buf,dhcp_cl_db[0]);
    }
    else{
        strcpy(buf,dhcp_cl_db[1]);
    }
	return 0;
}

int r2t_dhcp_start_ip(char buf[CGI_BUF_LEN],char **buf1){
    sprintf(buf,"%u.%u.%u.%u",
       *((unsigned char*)&(lan_conf.StartIp)),
       *(((unsigned char*)&(lan_conf.StartIp))+1),
       *(((unsigned char*)&(lan_conf.StartIp))+2),
       *(((unsigned char*)&(lan_conf.StartIp))+3));
	return 0;
}

int r2t_dhcp_end_ip(char buf[CGI_BUF_LEN],char **buf1){
    sprintf(buf,"%u.%u.%u.%u",
       *((unsigned char*)&(lan_conf.FinishIp)),
       *(((unsigned char*)&(lan_conf.FinishIp))+1),
       *(((unsigned char*)&(lan_conf.FinishIp))+2),
       *(((unsigned char*)&(lan_conf.FinishIp))+3));
    
	return 0;
}

int sys_rpt_main()
{
	LIST *hd=NULL;

	ReadSystemSettings(&system_conf);
	GetConnectionStatus(&if_status);
	ReadLanSettings(&lan_conf);
	ReadDHCPSettings(&dhcp_conf);
	memset(&device_info,'\0',sizeof(device_info));
	get_device_info(&device_info);
    GetIfaceStatus(LAN_ITF,&lan_if_status);

	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
		}
		list_clear(hd);
	}
	return html_parser("sys_rpt.htm",key_fun_tab);
}
#endif /* _SYS_RPT_C_ */
