#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_full_fw_version(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts1ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts1ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts1ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts1ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts2ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts2ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts2ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts2ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts3ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts3ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts3ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ts3ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_thoverride(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_hwmark(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_lwmark(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_maxsessions(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_block_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_blocktime(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_mac(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_default(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_pc(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_ts1ip_1(const char *value);
static int t2r_ts1ip_2(const char *value);
static int t2r_ts1ip_3(const char *value);
static int t2r_ts1ip_4(const char *value);
static int t2r_ts2ip_1(const char *value);
static int t2r_ts2ip_2(const char *value);
static int t2r_ts2ip_3(const char *value);
static int t2r_ts2ip_4(const char *value);
static int t2r_ts3ip_1(const char *value);
static int t2r_ts3ip_2(const char *value);
static int t2r_ts3ip_3(const char *value);
static int t2r_ts3ip_4(const char *value);
static int t2r_spi_thoverride(const char *value);
static int t2r_spi_hwmark(const char *value);
static int t2r_spi_lwmark(const char *value);
static int t2r_spi_maxsessions(const char *value);
static int t2r_spi_block_enable(const char *value);
static int t2r_spi_blocktime(const char *value);
static int t2r_wan_mac(const char *value);
static int t2r_copydefault(const char *value);
static int t2r_copypc(const char *value);
static int t2r_default(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_wan_default(const char *value);
static int t2r_wan_pc(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"full_fw_version",r2t_full_fw_version,NULL},
	{"ts1ip_1",r2t_ts1ip_1,t2r_ts1ip_1},
	{"ts1ip_2",r2t_ts1ip_2,t2r_ts1ip_2},
	{"ts1ip_3",r2t_ts1ip_3,t2r_ts1ip_3},
	{"ts1ip_4",r2t_ts1ip_4,t2r_ts1ip_4},
	{"ts2ip_1",r2t_ts2ip_1,t2r_ts2ip_1},
	{"ts2ip_2",r2t_ts2ip_2,t2r_ts2ip_2},
	{"ts2ip_3",r2t_ts2ip_3,t2r_ts2ip_3},
	{"ts2ip_4",r2t_ts2ip_4,t2r_ts2ip_4},
	{"ts3ip_1",r2t_ts3ip_1,t2r_ts3ip_1},
	{"ts3ip_2",r2t_ts3ip_2,t2r_ts3ip_2},
	{"ts3ip_3",r2t_ts3ip_3,t2r_ts3ip_3},
	{"ts3ip_4",r2t_ts3ip_4,t2r_ts3ip_4},
	{"poe_account_list",r2t_poe_account_list,NULL},
	{"spi_thoverride",r2t_spi_thoverride,t2r_spi_thoverride},
	{"spi_hwmark",r2t_spi_hwmark,t2r_spi_hwmark},
	{"spi_lwmark",r2t_spi_lwmark,t2r_spi_lwmark},
	{"spi_maxsessions",r2t_spi_maxsessions,t2r_spi_maxsessions},
	{"spi_block_enable",r2t_spi_block_enable,t2r_spi_block_enable},
	{"spi_blocktime",r2t_spi_blocktime,t2r_spi_blocktime},
	{"wan_mac",r2t_wan_mac,t2r_wan_mac},
	{"copydefault",NULL,t2r_copydefault},
	{"copypc",NULL,t2r_copypc},
	{"default",NULL,t2r_default},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"wan_default",r2t_wan_default,t2r_wan_default},
	{"wan_pc",r2t_wan_pc,t2r_wan_pc},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "techsupp_cgi.c"

/*************************/
