#ifndef _ONISHI_CGI_C_
#define _ONISHI_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "h_var.h"
#include "techsupp.h"
#include "parser.h"
#include "system.h"          
#include "wan.h"
#include "dev_opt.h"

static techsupp_conf conf; 
static DEVICE_INFO device_info;

static MULTI_PPPOE_CONF mpoe_conf;
static int poe_account_index;
static int wan_type;
static enum{
	CHANGE_ACCOUNT,
	SAVE
}which_submit;
            
int r2t_full_fw_version(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,device_info.FullFWVersion);	
	return 0;
}

int r2t_ts1ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts1ip[0]);	
	return 0;
}

int r2t_ts1ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts1ip[1]);
	return 0;
}

int r2t_ts1ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts1ip[2]);
	return 0;
}

int r2t_ts1ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts1ip[3]);
	return 0;
}

int r2t_ts2ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts2ip[0]);
	return 0;
}

int r2t_ts2ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts2ip[1]);
	return 0;
}

int r2t_ts2ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts2ip[2]);
	return 0;
}

int r2t_ts2ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts2ip[3]);
	return 0;
}

int r2t_ts3ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts3ip[0]);
	return 0;
}

int r2t_ts3ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts3ip[1]);
	return 0;
}

int r2t_ts3ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts3ip[2]);
	return 0;
}

int r2t_ts3ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.ts3ip[3]);
	return 0;
}

int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	if(wan_type == CONNECTION_MULTI_PPPOE){
        strcpy(buf,str_poe_ac_list_head);
        for(i=0;i<MAX_PPPOE_ACCOUNT;i++){
            if(i == poe_account_index){
                strcat(buf,option_sl);
            }
            else{
                strcat(buf,option_s);
            }
            strcat(buf,mpoe_conf.account[i].poe_ac_name);
            strcat(buf,option_e);
        }
        strcat(buf,str_poe_ac_list_tail);
        }	
	return 0;
}

int r2t_spi_thoverride(char buf[CGI_BUF_LEN],char **buf1)
{
	if(conf.overridesetting)
		strcpy(buf,str_checked);
	return 0;
}

int r2t_spi_hwmark(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.hmark);	
	return 0;
}

int r2t_spi_lwmark(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.lmark);
	return 0;
}

int r2t_spi_maxsessions(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.maxsession);
	return 0;
}

int r2t_spi_block_enable(char buf[CGI_BUF_LEN],char **buf1)
{
	if(conf.blockenable)
		strcpy(buf,str_checked);
	return 0;
}

int r2t_spi_blocktime(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",conf.blocktime);	
	return 0;
}

int r2t_wan_mac(char buf[CGI_BUF_LEN],char **buf1)
{
	 sprintf(buf,"%02x%02x%02x%02x%02x%02x",
            (unsigned char)conf.mac[0],(unsigned char)conf.mac[1],(unsigned char)conf.mac[2],(unsigned char)conf.mac[3],(unsigned char)conf.mac[4],(unsigned char)conf.mac[5]);	
//	strcpy(buf,conf.mac);	
	return 0;
}

int r2t_wan_default(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%02x%02x%02x%02x%02x%02x",if_status.mac[0],if_status.mac[1],if_status.mac[2],if_status.mac[3],if_status.mac[4],if_status.mac[5]);
	return 0;
}

int r2t_wan_pc(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mpoe_conf.account[poe_account_index].poe_ac_name);
	return 0;
}

int t2r_ts1ip_1(const char *value)
{
	conf.ts1ip[0]= atoi(value);	
	return 0;
}

int t2r_ts1ip_2(const char *value)
{
	conf.ts1ip[1]= atoi(value);
	return 0;
}

int t2r_ts1ip_3(const char *value)
{
	conf.ts1ip[2]= atoi(value);
	return 0;
}

int t2r_ts1ip_4(const char *value)
{
	conf.ts1ip[3]= atoi(value);
	return 0;
}

int t2r_ts2ip_1(const char *value)
{
	conf.ts2ip[0]= atoi(value);
	return 0;
}

int t2r_ts2ip_2(const char *value)
{
	conf.ts2ip[1]= atoi(value);
	return 0;
}

int t2r_ts2ip_3(const char *value)
{
	conf.ts2ip[2]= atoi(value);
	return 0;
}

int t2r_ts2ip_4(const char *value)
{
	conf.ts2ip[3]= atoi(value);
	return 0;
}

int t2r_ts3ip_1(const char *value)
{
	conf.ts3ip[0]= atoi(value);
	return 0;
}

int t2r_ts3ip_2(const char *value)
{
	conf.ts3ip[1]= atoi(value);
	return 0;
}

int t2r_ts3ip_3(const char *value)
{
	conf.ts3ip[2]= atoi(value);
	return 0;
}

int t2r_ts3ip_4(const char *value)
{
	conf.ts3ip[3]= atoi(value);
	return 0;
}

int t2r_spi_thoverride(const char *value)
{
	conf.overridesetting = 1;
	return 0;
}

int t2r_spi_hwmark(const char *value)
{
//	if (conf.overridesetting)	
		conf.hmark=atoi(value);
	return 0;
}

int t2r_spi_lwmark(const char *value)
{
//	if (conf.overridesetting)
		conf.lmark=atoi(value);
	return 0;
}

int t2r_spi_maxsessions(const char *value)
{
//	if (conf.overridesetting)
		conf.maxsession=atoi(value);
	return 0;
}

int t2r_spi_block_enable(const char *value)
{
	conf.blockenable=1;
	return 0;
}

int t2r_spi_blocktime(const char *value)
{
//	if (conf.blockenable)
		conf.blocktime=atoi(value);
	return 0;
}

int t2r_wan_mac(const char *value)
{
    int i;

    if(strlen(value)<12)
	return INVALID_WAN_MAC;
    if (!check_hex(value)) {
        return INVALID_HEX;
    }
    
    for(i=0;i<6;i++)
    {   CHAR temp[3];
    	strncpy(temp,&value[i*2],2);
    	temp[2]=0;
    	conf.mac[i] = get_hex(temp);
    }	
	
	return 0;
}

int t2r_copydefault(const char *value)
{
	return 0;
}

int t2r_copypc(const char *value)
{
	return 0;
}

int t2r_default(const char *value)
{
	return 0;
}

int t2r_save(const char *value)
{
	which_submit=SAVE;
	return 0;
}

int t2r_help(const char *value)
{
	return 0;
}

int t2r_wan_default(const char *value)
{
	return 0;
}

int t2r_wan_pc(const char *value)
{
	return 0;
}

int t2r_message(const char *value)
{
	return 0;
}

int t2r_poe_ac_value(const char *value)
{
	int i;
	if(*value){
	    for(i=0;*value&&i<MAX_PPPOE_ACCOUNT;i++){
	        if(!strcmp(value,mpoe_conf.account[i].poe_ac_name)){
	            poe_account_index = i;  
	            break;
	        }
	    }	
	} 	
	return 0;
}

int techsupp_main()
{
	LIST *hd=NULL;
	int ccode;
//	char buf[200];
	
	GetIfaceStatus(ETH_WAN,&if_status);
	get_device_info(&device_info);
	memset(glb_errlog,0,sizeof(glb_errlog));
	
	which_submit = CHANGE_ACCOUNT;  		
	memset(&mpoe_conf, 0, sizeof(MULTI_PPPOE_CONF));	
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){	
		poe_account_index=0;		
		ReadMultiPPPoESettings(&mpoe_conf);
	}
	else
	{
		poe_account_index=-1;		
	}	
	
	memset(&conf,0,sizeof(conf));
	ReadTechsuppConf(&conf,poe_account_index);
	
	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();	
		if(!hd)
			cgi_err("","");
		memset(&conf,0,sizeof(conf));			
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
    			if(which_submit==SAVE){
				ccode=SaveTechsuppConf(&conf,poe_account_index);				
				WriteConfToFlash();
				if(fork()==0){
					cgi_fork_do();
					Daytime();
					exit(0);
				}
			}
			else if(which_submit==CHANGE_ACCOUNT){
			    	ReadTechsuppConf(&conf,poe_account_index);
		        }
		}
	}
	return html_parser("techsupp.htm",key_fun_tab);
}

#endif
