#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_dest_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dest_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dest_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dest_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dest_ip_end(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_net_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_net_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_net_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_net_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_net_ip_end(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_list_set(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_dest_ip_1(const char *value);
static int t2r_dest_ip_2(const char *value);
static int t2r_dest_ip_3(const char *value);
static int t2r_dest_ip_4(const char *value);
static int t2r_dest_ip_end(const char *value);
static int t2r_add(const char *value);
static int t2r_net_ip_1(const char *value);
static int t2r_net_ip_2(const char *value);
static int t2r_net_ip_3(const char *value);
static int t2r_net_ip_4(const char *value);
static int t2r_net_ip_end(const char *value);
static int t2r_add_net(const char *value);
static int t2r_ip_list(const char *value);
static int t2r_sel_all(const char *value);
static int t2r_sel_none(const char *value);
static int t2r_del(const char *value);
static int t2r_del_all(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);
static int t2r_poe_list_set(const char *value);


static keyfun_tab key_fun_tab[]={
	{"dest_IP_1",r2t_dest_ip_1,t2r_dest_ip_1},
	{"dest_IP_2",r2t_dest_ip_2,t2r_dest_ip_2},
	{"dest_IP_3",r2t_dest_ip_3,t2r_dest_ip_3},
	{"dest_IP_4",r2t_dest_ip_4,t2r_dest_ip_4},
	{"dest_IP_end",r2t_dest_ip_end,t2r_dest_ip_end},
	{"add",NULL,t2r_add},
	{"net_ip_1",r2t_net_ip_1,t2r_net_ip_1},
	{"net_ip_2",r2t_net_ip_2,t2r_net_ip_2},
	{"net_ip_3",r2t_net_ip_3,t2r_net_ip_3},
	{"net_ip_4",r2t_net_ip_4,t2r_net_ip_4},
	{"net_ip_end",r2t_net_ip_end,t2r_net_ip_end},
	{"add_net",NULL,t2r_add_net},
	{"ip_list",r2t_ip_list,t2r_ip_list},
	{"sel_all",NULL,t2r_sel_all},
	{"sel_none",NULL,t2r_sel_none},
	{"del",NULL,t2r_del},
	{"del_all",NULL,t2r_del_all},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{"poe_list_set",r2t_poe_list_set,t2r_poe_list_set},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "trf_def_cgi.c"

/*************************/
