#ifndef _VOIP_CGI_C_
#define _VOIP_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "voip.h"
#include "h_var.h"
#include "parser.h"

static voip_conf conf ;

static int r2t_voipenable(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(strcmp(conf.voipenable, "voipenable")==0)
	{
		strcpy(buf, str_checked);
	}
	return 0 ;    
}

static int r2t_sip1_address(char buf[CGI_BUF_LEN],char **buf1)
{
	
	strcpy(buf, conf.sip1_address);
	return 0 ;   
}

static int r2t_sip2_address(char buf[CGI_BUF_LEN],char **buf1)
{
	
	strcpy(buf, conf.sip2_address);
	return 0 ; 
}

static int r2t_sip_protocol(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(strcmp(conf.sip_protocol, "TCP")==0)
	{
		sprintf(buf, "%sTCP\n%sUDP\n", option_sl, option_s) ;
	}
	else if(strcmp(conf.sip_protocol, "UDP")==0)
	{
		sprintf(buf, "%sTCP\n%sUDP\n", option_s,option_sl) ;
	}
	return 0 ;
}

static int r2t_sip_port(char buf[CGI_BUF_LEN],char **buf1)
{
	
	strcpy(buf, conf.sip_port) ;
	return 0 ; 
}

static int r2t_sip_loginname(char buf[CGI_BUF_LEN],char **buf1)
{
	
	strcpy(buf, conf.sip_loginname) ;
	return 0 ; 
}

static int r2t_sip_loginpass(char buf[CGI_BUF_LEN],char **buf1)
{
	
//	strcpy(buf, conf.sip_loginpass) ;
	strcpy(buf, "password") ;
	return 0 ; 
}

static int r2t_callerid(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(strcmp(conf.callerID, "callerID")==0)
	{
		strcpy(buf, str_checked) ;
	}
	return 0 ; 
}

static int r2t_dialtype(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(strcmp(conf.dialtype, "tone")==0)
	{
		strcpy(buf, str_checked) ;
	}
	return 0 ; 
}

static int r2t_dialtype_pulse(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if( strcmp(conf.dialtype, "pulse")==0)
	{
		strcpy(buf, str_checked) ;
	}
	return 0 ; 
}

static int r2t_server_prefix(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[30] ;
	int i ;
	int option ;
	
	
	sprintf(buf, "%sNone\n", option_s) ;
	option = atoi(conf.server_prefix) ;
	
	for(i=1; i<10; i++)
	{
		if(i==option)
		{
			sprintf(tmp, "%s%d\n", option_sl, i) ;
			strcat(buf, tmp) ;
		}
		else
		{
			sprintf(tmp, "%s%d\n", option_s, i) ;
			strcat(buf, tmp) ;
		}
	}
	return 0 ;
}

static int r2t_pb_prefix(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[30] ;
	int i ;
	int option ;
	
	
	sprintf(buf, "%sNone\n",option_s) ;
	option = atoi(conf.pb_prefix) ;

	for(i=1; i<10; i++)
	{
		if(i==option)
		{
			sprintf(tmp, "%s%d\n", option_sl, i) ;
			strcat(buf, tmp) ;
		}
		else
		{
			sprintf(tmp, "%s%d\n", option_s, i) ;
			strcat(buf, tmp) ;
		}
	}
	return 0 ;
}
static int r2t_reg_timeout(char buf[CGI_BUF_LEN],char **buf1)
{
	        set_err_msg(buf, buf1) ;
		        return 0 ;
}
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf, buf1) ;
	return 0 ;
}

static int t2r_voipenable(const char *value)
{

	strcpy(conf.voipenable, value) ;
	return 0 ;
}

static int t2r_sip1_address(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		fmt_err_msg("No primary SIP server address!!!\n") ;
		return 1 ;
	}
	else if(strlen(value) > VOIP_MaxAddr1Len)
	{
		fmt_err_msg("Primary SIP server address is too long!!!\n") ;
       		strcpy(conf.sip1_address, "") ;
       		return 1 ;
	}
	else
	{
		strcpy(conf.sip1_address, value) ;
		return 0 ;		
	}
}

static int t2r_sip2_address(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		fmt_err_msg("No secondary SIP server address!!!\n") ;
		return 1 ;
	}
	else if(strlen(value) > VOIP_MaxAddr2Len)
	{
		fmt_err_msg("Secondary SIP server address is too long!!!\n") ;
       		strcpy(conf.sip2_address, "") ;
       		return 1 ;
	}
	else
	{
		strcpy(conf.sip2_address, value) ;
		return 0 ;		
	}
}

static int t2r_sip_protocol(const char *value)
{
	strcpy(conf.sip_protocol, value) ;
	return 0 ;
}

static int t2r_sip_port(const char *value)
{
	unsigned int sip_port ;
	
	sip_port = atol(value) ;
	
	if((65535>sip_port)&&(sip_port>1))
	{
		strcpy(conf.sip_port, value) ;
		return 0 ;
	}
	else
	{
		fmt_err_msg("SIP port range is 1~65535!!!\n") ;
       		strcpy(conf.sip_port, "");
		return 1 ;
	}
}

static int t2r_sip_loginname(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		fmt_err_msg("No SIP server login name!!!\n") ;
		return 1 ;
	}
	else if(strlen(value) > VOIP_MaxNameLen)
	{
		fmt_err_msg("SIP server login name is too long!!!\n") ;
       		strcpy(conf.sip_loginname, "");
       		return 1 ;
	}
	else
	{
		strcpy(conf.sip_loginname, value);
		return 0 ;
	}
}

static int t2r_sip_loginpass(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		fmt_err_msg("No SIP server login password!!!\n") ;
		return 1 ;
	}
	else if(strlen(value) > VOIP_MaxPwdLen)
	{
		fmt_err_msg("SIP server login password is too long!!!\n") ;
       		strcpy(conf.sip_loginpass, "");
       		return 1 ;
	}
	else
	{
		strcpy(conf.sip_loginpass, value);
		return 0 ;
	}
}

static int t2r_callerid(const char *value)
{
	if(value==NULL)
		strcpy(conf.callerID, "") ;
	else
		strcpy(conf.callerID, value) ;
	return 0 ;
}

static int t2r_dialtype(const char *value)
{
	if(value==NULL)
		strcpy(conf.dialtype, "") ;
	else
		strcpy(conf.dialtype, value) ;
	return 0 ;
}

static int t2r_server_prefix(const char *value)
{
	strcpy(conf.server_prefix, value) ;
	return 0 ;
}

static int t2r_pb_prefix(const char *value)
{
	strcpy(conf.pb_prefix, value) ;
	return 0 ;
}

static int t2r_phonebook(const char *value)
{
	return 0;
}

static int t2r_save(const char *value)
{
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}
static int t2r_reg_timeout(const char *value)
{
	        return 0;
}
static int t2r_message(const char *value)
{
	return 0;
}

int voip_main()
{
	LIST *hd=NULL ;
//	int ccode ;
	
	memset(glb_errlog, 0, sizeof(glb_errlog));
	memset(&conf,0,sizeof(conf));
	if(strcmp(REQUEST_METHOD, POST)==0)
	{
		hd=cgi_input_parse() ;
		
		if(!hd)
		{
			cgi_err("","");
		}

		if(!do_cgi_t2r(hd, key_fun_tab))
		{
			SaveVOIPConf(&conf) ;
//			fmt_err_msg("Save config!!!") ;
		}
	}
	ReadVOIPConf(&conf);	
	return html_parser("voip.htm", key_fun_tab) ;
}

#endif /* _VOIP_CGI_C_ */
