#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_r_vs_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_vs_pc_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_protocol(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_in_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_ex_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_in_end_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r_ex_end_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vs_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vs_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vs_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vs_pc_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vs_protocol(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vs_inport(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vs_export(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vs_in_endport(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vs_ex_endport(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_linked_to(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_num_predefined(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_vs_list(const char *value);
static int t2r_defaults(const char *value);
static int t2r_disable_all(const char *value);
static int t2r_vs_enable(const char *value);
static int t2r_vs_name(const char *value);
static int t2r_vs_pc_list(const char *value);
static int t2r_vs_protocol(const char *value);
static int t2r_vs_inport(const char *value);
static int t2r_vs_export(const char *value);
static int t2r_vs_in_endport(const char *value);
static int t2r_vs_ex_endport(const char *value);
static int t2r_clear(const char *value);
static int t2r_add(const char *value);
static int t2r_update(const char *value);
static int t2r_delete(const char *value);
static int t2r_help(const char *value);
static int t2r_todo(const char *value);
static int t2r_linked_to(const char *value);
static int t2r_num_predefined(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"r_vs_enable",r2t_r_vs_enable,NULL},
	{"r_vs_pc_list",r2t_r_vs_pc_list,NULL},
	{"r_protocol",r2t_r_protocol,NULL},
	{"r_in_port",r2t_r_in_port,NULL},
	{"r_ex_port",r2t_r_ex_port,NULL},
	{"r_in_end_port",r2t_r_in_end_port,NULL},
	{"r_ex_end_port",r2t_r_ex_end_port,NULL},
	{"poe_account_list",r2t_poe_account_list,NULL},
	{"vs_list",r2t_vs_list,t2r_vs_list},
	{"defaults",NULL,t2r_defaults},
	{"disable_all",NULL,t2r_disable_all},
	{"vs_enable",r2t_vs_enable,t2r_vs_enable},
	{"vs_name",r2t_vs_name,t2r_vs_name},
	{"vs_pc_list",r2t_vs_pc_list,t2r_vs_pc_list},
	{"vs_protocol",r2t_vs_protocol,t2r_vs_protocol},
	{"vs_inport",r2t_vs_inport,t2r_vs_inport},
	{"vs_export",r2t_vs_export,t2r_vs_export},
	{"vs_in_endport",r2t_vs_in_endport,t2r_vs_in_endport},
	{"vs_ex_endport",r2t_vs_ex_endport,t2r_vs_ex_endport},
	{"clear",NULL,t2r_clear},
	{"add",NULL,t2r_add},
	{"update",NULL,t2r_update},
	{"delete",NULL,t2r_delete},
	{"help",NULL,t2r_help},
	{"todo",r2t_todo,t2r_todo},
	{"linked_to",r2t_linked_to,t2r_linked_to},
	{"num_predefined",r2t_num_predefined,t2r_num_predefined},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "vs_cgi.c"

/*************************/
