#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_wep_auth(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wep(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wep_64bit(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key1_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key1_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key1_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key1_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key1_5(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_default_key64(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key2_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key2_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key2_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key2_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key2_5(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key3_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key3_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key3_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key3_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key3_5(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key4_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key4_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key4_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key4_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_key4_5(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wep_128bit(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_5(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_6(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_7(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_8(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_9(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_10(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_11(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_12(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_k128_1_13(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_passphrase(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_wep_auth(const char *value);
static int t2r_wep(const char *value);
static int t2r_key1_1(const char *value);
static int t2r_key1_2(const char *value);
static int t2r_key1_3(const char *value);
static int t2r_key1_4(const char *value);
static int t2r_key1_5(const char *value);
static int t2r_default_key64(const char *value);
static int t2r_key2_1(const char *value);
static int t2r_key2_2(const char *value);
static int t2r_key2_3(const char *value);
static int t2r_key2_4(const char *value);
static int t2r_key2_5(const char *value);
static int t2r_key3_1(const char *value);
static int t2r_key3_2(const char *value);
static int t2r_key3_3(const char *value);
static int t2r_key3_4(const char *value);
static int t2r_key3_5(const char *value);
static int t2r_key4_1(const char *value);
static int t2r_key4_2(const char *value);
static int t2r_key4_3(const char *value);
static int t2r_key4_4(const char *value);
static int t2r_key4_5(const char *value);
static int t2r_k128_1_1(const char *value);
static int t2r_k128_1_2(const char *value);
static int t2r_k128_1_3(const char *value);
static int t2r_k128_1_4(const char *value);
static int t2r_k128_1_5(const char *value);
static int t2r_k128_1_6(const char *value);
static int t2r_k128_1_7(const char *value);
static int t2r_k128_1_8(const char *value);
static int t2r_k128_1_9(const char *value);
static int t2r_k128_1_10(const char *value);
static int t2r_k128_1_11(const char *value);
static int t2r_k128_1_12(const char *value);
static int t2r_k128_1_13(const char *value);
static int t2r_passphrase(const char *value);
static int t2r_keygen(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"wep_auth",r2t_wep_auth,t2r_wep_auth},
	{"wep",r2t_wep,t2r_wep},
	{"wep_64bit",r2t_wep_64bit,NULL},
	{"key1_1",r2t_key1_1,t2r_key1_1},
	{"key1_2",r2t_key1_2,t2r_key1_2},
	{"key1_3",r2t_key1_3,t2r_key1_3},
	{"key1_4",r2t_key1_4,t2r_key1_4},
	{"key1_5",r2t_key1_5,t2r_key1_5},
	{"default_key64",r2t_default_key64,t2r_default_key64},
	{"key2_1",r2t_key2_1,t2r_key2_1},
	{"key2_2",r2t_key2_2,t2r_key2_2},
	{"key2_3",r2t_key2_3,t2r_key2_3},
	{"key2_4",r2t_key2_4,t2r_key2_4},
	{"key2_5",r2t_key2_5,t2r_key2_5},
	{"key3_1",r2t_key3_1,t2r_key3_1},
	{"key3_2",r2t_key3_2,t2r_key3_2},
	{"key3_3",r2t_key3_3,t2r_key3_3},
	{"key3_4",r2t_key3_4,t2r_key3_4},
	{"key3_5",r2t_key3_5,t2r_key3_5},
	{"key4_1",r2t_key4_1,t2r_key4_1},
	{"key4_2",r2t_key4_2,t2r_key4_2},
	{"key4_3",r2t_key4_3,t2r_key4_3},
	{"key4_4",r2t_key4_4,t2r_key4_4},
	{"key4_5",r2t_key4_5,t2r_key4_5},
	{"wep_128bit",r2t_wep_128bit,NULL},
	{"k128_1_1",r2t_k128_1_1,t2r_k128_1_1},
	{"k128_1_2",r2t_k128_1_2,t2r_k128_1_2},
	{"k128_1_3",r2t_k128_1_3,t2r_k128_1_3},
	{"k128_1_4",r2t_k128_1_4,t2r_k128_1_4},
	{"k128_1_5",r2t_k128_1_5,t2r_k128_1_5},
	{"k128_1_6",r2t_k128_1_6,t2r_k128_1_6},
	{"k128_1_7",r2t_k128_1_7,t2r_k128_1_7},
	{"k128_1_8",r2t_k128_1_8,t2r_k128_1_8},
	{"k128_1_9",r2t_k128_1_9,t2r_k128_1_9},
	{"k128_1_10",r2t_k128_1_10,t2r_k128_1_10},
	{"k128_1_11",r2t_k128_1_11,t2r_k128_1_11},
	{"k128_1_12",r2t_k128_1_12,t2r_k128_1_12},
	{"k128_1_13",r2t_k128_1_13,t2r_k128_1_13},
	{"passphrase",r2t_passphrase,t2r_passphrase},
	{"keygen",NULL,t2r_keygen},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "w_wep_cgi.c"

/*************************/
