#ifndef _WIRELESS_CGI_C_
#define _WIRELESS_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wireless.h"



static int r2t__device_name_(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,"Corega VR888T");
    return 0;
}

static int r2t_ssid(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,wireless_conf.pcmcia.BSSID);
    return 0;
}

static int r2t_w_channel(char buf[CGI_BUF_LEN],char **buf1){
    int i;
    
    *buf = '\0';
    for(i=0;i<13;i++){
        if(i == wireless_conf.pcmcia.Channel){
            strcat(buf,option_sl);
        }
        else{
            strcat(buf,option_s);
        }
        sprintf(buf+strlen(buf),"%d", i+1);
        strcat(buf,option_e);
    }
    return 0;
}        
            
static int r2t_wep_status(char buf[CGI_BUF_LEN],char **buf1){

    *buf = '\0';
    if(!wireless_conf.pcmcia.Encryption){
		strcpy(buf,"OFF");
		return 0;
	}
	if(wireless_conf.pcmcia.Encryption  &&(wireless_conf.pcmcia.key_length==5)){
		strcpy(buf,"64 Bit");
		return 0;
	}
	if(wireless_conf.pcmcia.Encryption  &&(wireless_conf.pcmcia.key_length==13)){
		strcpy(buf,"128 Bit");
		return 0;
	}
	return 0;
}

static int r2t_lan_ac(char buf[CGI_BUF_LEN],char **buf1){
    *buf = '\0';
    if(wireless_conf.ClientAccessMode&ALL_ACCESS_LAN){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_lan_ac_some(char buf[CGI_BUF_LEN],char **buf1){
    *buf = '\0';
    if(wireless_conf.ClientAccessMode&SOME_ACCESS_LAN){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_int_ac(char buf[CGI_BUF_LEN],char **buf1){
    *buf = '\0';
    if(wireless_conf.ClientAccessMode&ALL_ACCESS_WAN){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_int_ac_some(char buf[CGI_BUF_LEN],char **buf1){
    *buf = '\0';
    if(wireless_conf.ClientAccessMode&SOME_ACCESS_WAN){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
    *buf = '\0';
    return 0;
}

static int r2t_incompatible_card(char buf[CGI_BUF_LEN],char **buf1){
    *buf = '\0';
    return 0;
}

static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1){
    *buf = '\0';
    return 0;
}

//=============================SAVE FUNCTIONS=================================
static char BSSID[32+1];
static int t2r_ssid(const char *value){
    strncpy(BSSID,value,32);
    BSSID[32] = '\0';
    return 0;
}

static char Channel;
static int t2r_w_channel(const char *value){
    Channel = atoi(value)-1;
    return 0;
}

static int t2r_wep(const char *value){
    return 0;
}

static int t2r_baserate(const char *value){
    return 0;
}

static int t2r_lan_pcs(const char *value){
    return 0;
}

static int t2r_int_pcs(const char *value){
    return 0;
}

unsigned char ClientAccessMode;
static char *str_lan_db[]={"some","everyone",0};
static int t2r_lan_ac(const char *value){
    /* Clear bit first */
    ClientAccessMode &= ~ALL_ACCESS_LAN;
    ClientAccessMode &= ~SOME_ACCESS_LAN;
    
    /* Set bit*/
    if(str_db_search(str_lan_db,value)==0){
        ClientAccessMode |= SOME_ACCESS_LAN;
    }
    else{
        ClientAccessMode |= ALL_ACCESS_LAN;
    }
    return 0;
}
static int t2r_int_ac(const char *value){
    /* Clear bit first */
    ClientAccessMode &= ~ALL_ACCESS_WAN;
    ClientAccessMode &= ~SOME_ACCESS_WAN;
    
    /* Set bit*/
    if(str_db_search(str_lan_db,value)==0){
        ClientAccessMode |= SOME_ACCESS_WAN;
    }
    else{
        ClientAccessMode |= ALL_ACCESS_WAN;
    }
    return 0;
}

static int t2r_save(const char *value){
    return 0;
}

static int t2r_help(const char *value){
    return 0;
}

static int t2r_message(const char *value){
    return 0;
}

static int t2r_incompatible_card(const char *value){
    return 0;
}

static int t2r_todo(const char *value){
    return 0;
}

int wireless_main(void){
    
	LIST *hd=NULL;
	WIRELESS_CONF *pConf=&wireless_conf;
	int ccode;

	ReadWirelessSettings(pConf);
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}		
		if(!do_cgi_t2r(hd,key_fun_tab)){
		    pConf->pcmcia.Channel = Channel;
		    strcpy(pConf->pcmcia.BSSID,BSSID);
		    pConf->ClientAccessMode=ClientAccessMode;
            ccode=SaveWirelessSettings(pConf);
		    
		    WriteConfToFlash();
		    SetWirelessNormal();
		}
	}
   	return html_parser("wireless.htm",key_fun_tab);
}
#endif /* _WIRELESS_CGI_C_ */
