#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_connect_status(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_access_method(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ipaddress_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_user_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_user_pass(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mask_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mask_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mask_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mask_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_gw_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_gw_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_gw_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_gw_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_date_time(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_next(const char *value);
static int t2r_cancelfinish(const char *value);
static int t2r_connect_status(const char *value);
static int t2r_access_method(const char *value);
static int t2r_ipaddress_type(const char *value);
static int t2r_user_name(const char *value);
static int t2r_user_pass(const char *value);
static int t2r_ip_1(const char *value);
static int t2r_ip_2(const char *value);
static int t2r_ip_3(const char *value);
static int t2r_ip_4(const char *value);
static int t2r_mask_1(const char *value);
static int t2r_mask_2(const char *value);
static int t2r_mask_3(const char *value);
static int t2r_mask_4(const char *value);
static int t2r_gw_1(const char *value);
static int t2r_gw_2(const char *value);
static int t2r_gw_3(const char *value);
static int t2r_gw_4(const char *value);
static int t2r_dns1_ip_1(const char *value);
static int t2r_dns1_ip_2(const char *value);
static int t2r_dns1_ip_3(const char *value);
static int t2r_dns1_ip_4(const char *value);
static int t2r_date_time(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"next",NULL,t2r_next},
	{"cancelfinish",NULL,t2r_cancelfinish},
	{"connect_status",r2t_connect_status,t2r_connect_status},
	{"access_method",r2t_access_method,t2r_access_method},
	{"ipaddress_type",r2t_ipaddress_type,t2r_ipaddress_type},
	{"user_name",r2t_user_name,t2r_user_name},
	{"user_pass",r2t_user_pass,t2r_user_pass},
	{"ip_1",r2t_ip_1,t2r_ip_1},
	{"ip_2",r2t_ip_2,t2r_ip_2},
	{"ip_3",r2t_ip_3,t2r_ip_3},
	{"ip_4",r2t_ip_4,t2r_ip_4},
	{"mask_1",r2t_mask_1,t2r_mask_1},
	{"mask_2",r2t_mask_2,t2r_mask_2},
	{"mask_3",r2t_mask_3,t2r_mask_3},
	{"mask_4",r2t_mask_4,t2r_mask_4},
	{"gw_1",r2t_gw_1,t2r_gw_1},
	{"gw_2",r2t_gw_2,t2r_gw_2},
	{"gw_3",r2t_gw_3,t2r_gw_3},
	{"gw_4",r2t_gw_4,t2r_gw_4},
	{"dns1_ip_1",r2t_dns1_ip_1,t2r_dns1_ip_1},
	{"dns1_ip_2",r2t_dns1_ip_2,t2r_dns1_ip_2},
	{"dns1_ip_3",r2t_dns1_ip_3,t2r_dns1_ip_3},
	{"dns1_ip_4",r2t_dns1_ip_4,t2r_dns1_ip_4},
	{"date_time",r2t_date_time,t2r_date_time},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "wiz_home_cgi.c"

/*************************/
