var HelpOptionsVar = "width=480,height=420,scrollbars,toolbar,resizable,dependent=yes";
var GlossOptionsVar = "width=420,height=180,scrollbars,toolbar,resizable,dependent=yes";
var bigsub   = "width=540,height=460,scrollbars,menubar,resizable,status,dependent=yes";
var bigsub_url   = "width=620,height=460,scrollbars,menubar,resizable,status,dependent=yes";
var smallsub = "width=500,height=320,scrollbars,resizable,dependent=yes";
var smallsub_ip = "width=500,height=360,scrollbars,resizable,dependent=yes"; /* This is for trf_def */
var sersub   = "width=500,height=380,scrollbars,resizable,status,dependent=yes";
var memsub   = "width=630,height=320,scrollbars,menubar,resizable,status,dependent=yes";
var helpWinVar = null;
var glossWinVar = null;
var datSubWinVar = null;
var ValidStr = 'abcdefghijklmnopqrstuvwxyz0123456789-';
var hex_str = "ABCDEFabcdef0123456789";

function showMsg()
{
	var msgVar=document.forms[0].message.value;
	if (msgVar.length > 1) 
		alert(msgVar);
}

function closeWin(win_var)
{
	if   ((win_var != null) && (win_var.closed == false)) 
			win_var.close();
}

function openHelpWin(file_name)
{
   helpWinVar = window.open(file_name,'help_win',HelpOptionsVar);
   if (helpWinVar.focus)
		setTimeout('helpWinVar.focus()',200);
}

function openGlossWin()
{
	glossWinVar = window.open('','gloss_win',GlossOptionsVar);
	if (glossWinVar.focus)
		setTimeout('glossWinVar.focus()',200);
}

function openDataSubWin(filename,win_type)
{
	closeWin(datSubWinVar);
	datSubWinVar = window.open(filename,'datasub_win',win_type);
	if (datSubWinVar.focus)
		setTimeout('datSubWinVar.focus()',200); 
}

function closeSubWins()
{
	closeWin(helpWinVar);
	closeWin(glossWinVar);
	closeWin(datSubWinVar);
}

function checkBlank(fieldObj, fname)
{
	var msg = "";
	if (fieldObj.value.length < 1)
		msg = addstr(msg_blank,fname);
	return msg;
}

function checkNoBlanks(fObj, fname)
{
	var space = " ";
 	if (fObj.value.indexOf(space) >= 0 )
			return addstr(msg_space,fname);
	else return "";
}

function checkValid(text_input_field, field_name, Valid_Str, max_size, mustFill)
{
	var error_msg= "";
	var size = text_input_field.value.length;
	var str = text_input_field.value;

	if ((mustFill) && (size != max_size) )
		error_msg = addstr(msg_blank_in,field_name);
 	for (var i=0; i < size; i++)
  	{
    	if (!(Valid_Str.indexOf(str.charAt(i)) >= 0))
    	{
			error_msg = addstr(msg_invalid,field_name,Valid_Str);
			break;
    	}
  	}
  	return error_msg;
}

function checkInt(text_input_field, field_name, min_value, max_value, required)
// NOTE: Doesn't allow negative numbers, required is true/false
{
	var str = text_input_field.value;
	var error_msg= "";
	if (text_input_field.value.length==0) // blank
	{
		if (required)
			error_msg = addstr(msg_blank,field_name);
	}
	else // not blank, check contents
	{
		for (var i=0; i < str.length; i++)
		{
			if ((str.charAt(i) < '0') || (str.charAt(i) > '9'))
				error_msg = addstr(msg_check_invalid,field_name);
		}
		if (error_msg.length < 2) // don't parse if invalid
		{
			var int_value = parseInt(str,10);
			if (int_value < min_value)
                                error_msg = addstr(msg_check_invalid,field_name);
			if (int_value > max_value)
                                error_msg = addstr(msg_check_invalid,field_name);
		}
	}
	return error_msg;
}

function checkInt_onlyMessage(text_input_field, min_value, max_value, required,blankMsg,noIntMsg,littleMsg,BigMsg)
// NOTE: Doesn't allow negative numbers, required is true/false
{
	var str = text_input_field.value;
	var error_msg= "";
	
	if (text_input_field.value.length==0) // blank
	{
		if (required)
			error_msg = blankMsg;
	}
	else // not blank, check contents
	{
		for (var i=0; i < str.length; i++)
		{
			if ((str.charAt(i) < '0') || (str.charAt(i) > '9'))
				error_msg = noIntMsg;
		}
		if (error_msg.length < 2) // don't parse if invalid
		{
			var int_value = parseInt(str,10);
			if (int_value < min_value)
                                error_msg = littleMsg;
			if (int_value > max_value)
                                error_msg = BigMsg;
		}
	}
	return error_msg;
}

function isBigger(str_a, str_b)
//  true if a bigger than b
{
	var int_value_a = parseInt(str_a,10);
	var int_value_b = parseInt(str_b,10);
	return (int_value_a > int_value_b);
}

function in_array(array_var, search_item)
{
	for (var i = 0; i < array_var.length; i++)
	{
		if (array_var[i] == search_item)
			return i;
	}
	return -1;
}

function in_sel_list(sel_obj, search_item)
{
	for (var i = 0; i < sel_obj.options.length; i++)
	{
		if (sel_obj.options[i].text == search_item)
			return true;
	}
	return false;
}
/*all 0 and all 1 is valid*/
function checkValidMask(field1,field2,field3,field4){    
    var error_msg= "";
    var a_validMask=new Array(0xffffffff,0xfffffffe,0xfffffffc,0xfffffff8,0xfffffff0,
                                         0xffffffe0,0xffffffc0,0xffffff80,0xffffff00,
                                         0xfffffe00,0xfffffc00,0xfffff800,0xfffff000,
                                         0xffffe000,0xffffc000,0xffff8000,0xffff0000,
                                         0xfffe0000,0xfffc0000,0xfff80000,0xfff00000,
                                         0xffe00000,0xffc00000,0xff800000,0xff000000,
                                         0xfe000000,0xfc000000,0xf8000000,0xf0000000,
                                         0xe0000000,0xc0000000,0x80000000,0x00000000);
    var value1 = parseInt(field1.value,10);
    var value2 = parseInt(field2.value,10);
    var value3 = parseInt(field3.value,10);
    var value4 = parseInt(field4.value,10);
    var valueAll = Math.abs(((value1*256+value2)*256+value3)*256+value4);        
    
    for(var i=0;i<33;i++){
        if(valueAll == a_validMask[i]){
            return error_msg;
        }
    }    
    error_msg = addstr(msg_check_invalid,msg_mask_field);
    return error_msg;   

}    

function len(fieldObj)
{
	return fieldObj.value.length;
}

function zeroIP(fn) // true if 0 
{
	return (parseInt(fn.value,10)==0);
}

function chkSelected(selObj, err_msg)
{
    if(!(selObj.selectedIndex >= 0 ))
	{
	    alert(err_msg);
	    return false;
	}
	return true;
}

function blankIP(ip){
    return ((ip.value.length = 0) || (parseInt(ip.value,10)==0));
}
    
function checkIp(ip1,ip2,ip3,ip4, msg, rq_flag)
{
	if( (rq_flag == false) && blankIP(ip1) && blankIP(ip2) && blankIP(ip3) && blankIP(ip4) )
		return "";
	var errmsg =  checkInt(ip1,msg,1,254,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip2,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip3,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip4,msg,1,254,true);
	return errmsg;
}

function checkNetMask(ip1,ip2,ip3,ip4)
{
    var errmsg="";

    if(zeroIP(ip1) && zeroIP(ip2) && zeroIP(ip3) && zeroIP(ip4)){
        errmsg = addstr(msg_check_invalid,msg_mask_field);
    }    
    else{
        errmsg = checkInt(ip1, msg_mask_field,0, 255, true);
        errmsg = (errmsg.length > 1) ? errmsg : checkInt(ip2, msg_mask_field,0, 255, true);
        errmsg = (errmsg.length > 1) ? errmsg : checkInt(ip3, msg_mask_field,0, 255, true);
        errmsg = (errmsg.length > 1) ? errmsg : checkInt(ip4, msg_mask_field,0, 255, true);
    }
    errmsg = (errmsg.length > 1) ? errmsg : checkValidMask(ip1,ip2,ip3,ip4);
	return errmsg;
}

function selAll(selObj, set_to)  // Select list, true/false
{
	for (var i = 0; i < selObj.options.length; i++)
		selObj.options[i].selected = set_to;
}

function changeAccount()
{
    var cf = document.forms[0];
    
    cf.poe_ac_value.value = cf.poe_ac_list.options[cf.poe_ac_list.selectedIndex].text;
    cf.submit();
}

function portCheckData()
{
 	var cf = document.forms[0];
	var msg = "";
	msg = checkInt_onlyMessage(cf.port, 1, 65534,true,msg_port_blank,msg_port_int,msg_port_little,msg_port_big);
	msg = (msg.length > 1) ? msg : checkInt_onlyMessage(cf.port_e, 1, 65534,false,msg_port_blank,msg_port_int,msg_port_little,msg_port_big);
	if(cf.port_e.value.length == 0){
	    cf.port_e.value = cf.port.value;
	}
	msg = (msg.length > 1) ? msg : isBigger(cf.port.value,cf.port_e.value)?msg_entry_greater:"";
	if (msg.length > 1)
	{
		alert(msg);
		return false;
	}

	return true;	
}

function timeisInvalid(year,month,day,hour,minute,second){
    var isInvalid = 0;
    var realYear = year+2000;

    if(year > 36 || month > 12 || day > 31){
        isInvalid = 1;
    }
    else{
        if(2 == month){//perhaps leap month
            if(realYear%400==0 || (realYear%4==0 && realYear%100!=0)){//leap year
                if(day > 29){
                    isInvalid = 1;
                }
            }
            else{
                if(day > 28){
                    isInvalid = 1;
                }
            }
        }
        else{
            if(((month<=7) && (month%2==1)) || ((month>=8) && (month%2==0))){
                if(day > 31){
                    isInvalid = 1;
                }
            }
            else{
                if(day > 30){
                    isInvalid = 1;
                }
            }
        }
    }
    if(hour > 23 || minute > 59 || second > 59){
        isInvalid = 1;
    }
    return isInvalid;
}

function checkEqual(str1,str2,str3,str4,str5,str6){
    var str_a = new Array(str1,str2,str3,str4,str5,str6);
    for (var i=0; i < 6; i++){
        for(var j=0;j<6;j++){
            if(i==j || str_a[i].length ==0 || str_a[j].length ==0){
                continue;
            }
            if(str_a[i] == str_a[j]){
                return 1;
            }
        }
    }
    return 0;
}
function radioSelectedIndex(radio_object) // index of selected item, -1 if none
{
	if (!radio_object)
		return -1;
	var size = radio_object.length;
	if(isNaN(size))
	{
		if(radio_object.checked == true)
			return 0;
		else
			return -1;
	}
	for (var i = 0; i < size; i++)
	{
		if(!(radio_object[i]))
			return (radio_object.checked) ? 0 : -1;
		if (radio_object[i].checked)
			return(i);
	}
	if(radio_object.checked == true)
		return 0;
	else
		return -1;
}

/* This function only for trf_def[0-4].htm */
function trf_def_checkData(buttonName)
{
 	var cf = document.forms[0];
	var msg = "";
	if(buttonName == "add"){
    	msg = checkIp(cf.dest_IP_1,cf.dest_IP_2,cf.dest_IP_3,cf.dest_IP_4,msg_traffic_ip,true);
    	msg = (msg.length > 1) ? msg : checkInt(cf.dest_IP_end,msg_traffic_ip,0,254,true);
    	msg = (msg.length > 1) ? msg : cf.dest_IP_end.value == "0" ? "" : isBigger(cf.dest_IP_4.value,cf.dest_IP_end.value) ? addstr(msg_check_invalid,msg_traffic_ip) : "";
    }
    else{
        msg = checkInt(cf.net_ip_1, msg_network,1, 255, true);
        msg = (msg.length > 1) ? msg : checkInt(cf.net_ip_2, msg_network,0, 255, true);
        msg = (msg.length > 1) ? msg : checkInt(cf.net_ip_3, msg_network,0, 255, true);
        msg = (msg.length > 1) ? msg : checkInt(cf.net_ip_4, msg_network,0, 255, true);
        msg = (msg.length > 1) ? msg : checkInt(cf.net_ip_end, msg_network,0,32, true);
    }    
    if (msg.length > 1)
    {
    	alert(msg);
    	return false;
    }
    return true;
}

/* This function only for trf_def[0-4].htm */
function trf_def_delAll(selObj)
{ 
  if (selObj.options.length == 0)
  {
  	alert(msg_none_to_delete)
	return false;
  }
  else
  	return (confirm(msg_del_all));
}

function select_set(selObj,setObj)
{
	var set=0;
	for (var i = 0; i < selObj.options.length; i++){
		if(selObj.options[i].selected){
			set+=Math.pow(2,i);
		}
	}
	setObj.value=set;
	return;
}

function in_array_range(array_var, search_item, array_end_var, search_end_item,nocareIndex){

    var begin_val = parseInt(search_item,10);
    var end_val = parseInt(search_end_item,10);

	for (var i = 0; i < array_var.length; i++)
	{
        if ( i == nocareIndex){
            continue;
        }

		if (
		     ( begin_val >= array_var[i] && begin_val <= array_end_var[i] )
		  || ( end_val >= array_var[i] && end_val <= array_end_var[i] )
		  || ( begin_val <= array_var[i] && end_val >= array_end_var[i] )
		  ){
		    return i;
		}
	}
    return -1;
}
