#ifndef _PARSER_H_
#define _PARSER_H_
#include "cgi_def.h"
#include "cgi-lib.h"
#include "cgi_err.h"

#define GET "GET"
#define POST "POST"



typedef int (*r2tFun)(char buf[CGI_BUF_LEN],char **buf1);
//-------------------------------------------------------------------
// purpose: r2tFun do get configuration data, and do cgi r2t function
// input:   buf - buffer for the return data
//         *buf1 - if the return data > CGI_BUF_LEN bytes then r2tFun
//                 must allocate a buffer by itself and put the
//                 buffer address in *buf1
// ouput: 0 - success
// Note:  If r2tFun return data in *buf1 then caller must free
//          the memory after using the data
//-----------------------------------------------------------------



typedef int (*t2rFun)(const char *value);
//-----------------------------------------------------------------
// purpose: t2rFun do cgi t2r function, and save the value 
// input : value - value to save
// ouput: 0 - success
//-----------------------------------------------------------------



typedef int (*ActionFun)(LIST *head);

typedef struct keyfun_tab{
        char *key;
        r2tFun r2tfun;
        t2rFun t2rfun;

}keyfun_tab;

int html_parser(char *fname, keyfun_tab *kfun);
int do_cgi_t2r(LIST *head,keyfun_tab *kfun);

#if 0
char *get_err_msg(int msg_no);
void fmt_err_msg(char *format, ...);
void set_err_msg(char buf[CGI_BUF_LEN],char **buf1);
#endif
#define VALUE_LEN_LEN 4

#endif /* _PARSER_H_ */
