#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#ifndef DPROXY_H
#define DPROXY_H

#define PORT 53
#define NAME_SIZE 255
#define MAX_PACKET_SIZE 512
#define BUF_SIZE NAME_SIZE

typedef u_int16_t uint16;
typedef u_int32_t uint32;

#include "dns.h"

#ifndef DNS_TIMEOUT
#define DNS_TIMEOUT 10
#endif
#ifndef NAME_SERVER_DEFAULT
//#define NAME_SERVER_DEFAULT "198.95.251.10"
#ifndef _BACKUP_DNS_
#define NAME_SERVER_DEFAULT "202.102.14.141"
#else
#define NAME_SERVER_DEFAULT {"1.2.3.4","172.31.11.249", "202.102.15.162"}
#endif
#endif
#ifndef CONFIG_FILE_DEFAULT
//#define CONFIG_FILE_DEFAULT "/etc/dproxy.conf"
#define CONFIG_FILE_DEFAULT "/var/dproxy.conf"
#endif
#ifndef DENY_FILE_DEFAULT
#define DENY_FILE_DEFAULT "/etc/dproxy.deny"
#endif
#ifndef CACHE_FILE_DEFAULT
#define CACHE_FILE_DEFAULT "/var/cache/dproxy.cache"
#endif
#ifndef HOSTS_FILE_DEFAULT
#define HOSTS_FILE_DEFAULT "/etc/hosts"
#endif
#ifndef PURGE_TIME_DEFAULT
#define PURGE_TIME_DEFAULT 48 * 60 * 60
#endif
#ifndef PPP_DEV_DEFAULT
#define PPP_DEV_DEFAULT "/var/run/ppp0.pid"
#endif
#ifndef DHCP_LEASES_DEFAULT
#define DHCP_LEASES_DEFAULT "/var/state/dhcp/dhcpd.leases"
#endif
#ifndef PPP_DETECT_DEFAULT
//#define PPP_DETECT_DEFAULT 1
#define PPP_DETECT_DEFAULT 0
#endif

#ifndef DEMAND_DEFAULT
#define DEMAND_DEFAULT  0
#endif /* DEMAND_DEFAULT */

#ifndef DEBUG_FILE_DEFAULT
//#define DEBUG_FILE_DEFAULT "/var/log/dproxy.debug.log"
#define DEBUG_FILE_DEFAULT "/var/log"
#endif

//#define _DEBUG_
#ifdef _DEBUG_
void debug_perror( char * msg );
void debug(char *fmt, ...);
#else /* _DEBUG_ */
#define debug(fmg,...)
#define debug_perror(msg)
#endif /* _DEBUG_ */

#endif
