#ifndef _LED_H_
#define _LED_H_

/* 0.1 sec */
#define FAST_INTERVAL 5*HZ/100
/* 0.3 sec */
#define SLOW_INTERVAL 15*HZ/100

#define LED_FAST 1
#define LED_SLOW 0

/* number of GPIO */
#define GPIO_NUM       5
/* all gpio were negative logic */

#define GPIO_ADSL_ACT  3
#define GPIO_TEST      0
#define GPIO_ADSL_DOWN 3
#define GPIO_RESET     4
#define GPIO_WLAN      2
#define GPIO_POWER     1

struct led_data_s{
	unsigned long gpio_pin;
	unsigned int  count;
	int           logic;        /* -1 negative +1 */
	int           speed;        /* 0:slow 1:fast */
	int           last_stat;    /* last stat 0:off 1:on 2:previous*/
	int           init;         /* 0:off 1:on */
};

#endif
