#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include "PRO_file.h"
#include "PRO_GetStr.h"
#include "PRO_SetStr.h"
#include "PRO_GetInt.h"
#include "PRO_SetInt.h"
#include "PRO_SetMultiItemStr.h"
#include "dev_opt.h"
#include "system.h"
#include "wan.h"
#include "h_const.h"
#include "h_var.h"

#define SYSCONF "/var/system.conf"
#define OPTIONS	"/var/options"
#define DPROXYF "/var/dproxy.conf"

devopt_conf dev_opt_conf;
static SINGLE_PPPOE_CONF single_pppoe_conf;
//static DHCP_CONF dhcp_conf;
int ReadDevConf(devopt_conf *conf, int poe_acc_index)
{
	FILE *fp;
	char ip[16];
	char no[3];   //ada	
	char key[10];  //ada
	char time[20];
	
	fp=fopen(SYSCONF,"r");
	if(!fp)
		return -1;
		
	//ada	
	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';
	sprintf(key,"%sDNS1",no);	
	PRO_GetStr(DEVOPT_Section,key,ip,16,fp);
	extract_ip(ip,conf->dev_dns_1);

	sprintf(key,"%sDNS2",no);	
	PRO_GetStr(DEVOPT_Section,key,ip,16,fp);
	extract_ip(ip,conf->dev_dns_2);
	
	sprintf(key,"%sUPNP",no);
	PRO_GetInt(DEVOPT_Section,key,&(conf->upnp_en),fp);
	
	sprintf(key,"%sCONFIG",no);	
	PRO_GetInt(DEVOPT_Section,key,&(conf->port_map),fp);
	
	sprintf(key,"%sWAN_DIAL",no);
	PRO_GetInt(DEVOPT_Section,key,&(conf->wan_dial),fp);	
	
	sprintf(key,"%sMTU",no);
	PRO_GetInt(DEVOPT_Section,key,&(conf->mtu),fp);	
	
	sprintf(key,"pppoe_enable");
	PRO_GetInt(DEVOPT_Section,key,&(conf->pppoe_enable),fp);
	
	sprintf(key,"upnp_session");
	PRO_GetInt(DEVOPT_Section,key,&(conf->upnp_session),fp);
	
	sprintf(key,"time_set");
	PRO_GetInt(DEVOPT_Section,key,&(conf->time_set),fp);	

	PRO_GetStr(DEVOPT_Section,"time",time, 20, fp);
	sscanf(time,"%d/%d/%d %d:%d:%d", 
	                   &conf->stm.tm_year, &conf->stm.tm_mon,  &conf->stm.tm_mday,					
			   &conf->stm.tm_hour, &conf->stm.tm_min,  &conf->stm.tm_sec);
	fclose(fp);
	return 0;
}

int CheckDevConf(devopt_conf *conf)
{
	if((conf->upnp_en !=0) && (conf->upnp_en !=1))
		return INVALID_UPNP;

	if((conf->port_map !=0) && (conf->port_map !=1))
		return INVALID_CONFIG;

	if((conf->wan_dial !=0) && (conf->wan_dial !=1))
		return INVALID_DISABLE;

	if((conf->mtu<1) && (conf->mtu>1500))
		return INVALID_MTU;
	return 0;
}

int AddBackupDNS(int poe_acc_index)
{
	FILE *fp;
	char dns1[16],dns2[16],dns[40],str_dns[40];
	int exist;
	fp = fopen(RESOLV_FILE,"r+");
	if(!fp){ 
		return -1;
	}
	ReadDevConf(&dev_opt_conf, poe_acc_index);
	sprintf(dns1,"%d.%d.%d.%d",dev_opt_conf.dev_dns_1[0],dev_opt_conf.dev_dns_1[1],dev_opt_conf.dev_dns_1[2],dev_opt_conf.dev_dns_1[3]);
	sprintf(dns2,"%d.%d.%d.%d",dev_opt_conf.dev_dns_2[0],dev_opt_conf.dev_dns_2[1],dev_opt_conf.dev_dns_2[2],dev_opt_conf.dev_dns_2[3]);

	if(strcmp(dns1,"0.0.0.0")){
		sprintf(dns,"nameserver %s\n",dns1);
		exist=0;
	        while(fgets(str_dns,sizeof(str_dns),fp)){
			if(!strcmp(str_dns,dns)){
				exist=1;
				break;
			}
		}
		if(!exist){
			fseek(fp, 0L, SEEK_END);
			fprintf(fp,"%s",dns);
		}
    	}

	if(strcmp(dns2,"0.0.0.0")){
		rewind(fp);
		sprintf(dns,"nameserver %s\n",dns2);
		exist=0;
	        while(fgets(str_dns,sizeof(str_dns),fp)){
			if(!strcmp(str_dns,dns)){
				exist=1;
				break;
			}
		}
		if(!exist){
			fseek(fp, 0L, SEEK_END);
			fprintf(fp,"%s",dns);
		}
    	}

	fclose(fp);
	return 0;

}

int SaveDevConf(devopt_conf *conf,int poe_acc_index)
{
	multi_items all_items[10];
	char dns1[16],dns2[16],upnp[2],config[2],disable[2],mtu[4],
			pppoe_enable[2],upnp_session[2],time_set[2],time[20];
	int ret;
	FILE *fp=NULL;
	char no[3];   //ada
	ret=CheckDevConf(conf);
	if(ret)
		return ret;
		
	//ada
	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';	
	sprintf(all_items[0].key,"%sDNS1",no);
	sprintf(dns1,"%d.%d.%d.%d",conf->dev_dns_1[0],conf->dev_dns_1[1],conf->dev_dns_1[2],conf->dev_dns_1[3]);
	all_items[0].value=dns1;

	sprintf(all_items[1].key,"%sDNS2",no);
	sprintf(dns2,"%d.%d.%d.%d",conf->dev_dns_2[0],conf->dev_dns_2[1],conf->dev_dns_2[2],conf->dev_dns_2[3]);
	all_items[1].value=dns2;

	sprintf(all_items[2].key,"%sUPNP",no);
	sprintf(upnp,"%d",conf->upnp_en);
	all_items[2].value=upnp;

	sprintf(all_items[3].key,"%sCONFIG",no);
	sprintf(config,"%d",conf->port_map);
	all_items[3].value=config;

	sprintf(all_items[4].key,"%sWAN_DIAL",no);
	sprintf(disable,"%d",conf->wan_dial);
	all_items[4].value=disable;

	sprintf(all_items[5].key,"%sMTU",no);
	sprintf(mtu,"%d",conf->mtu);
	all_items[5].value=mtu;

	sprintf(all_items[6].key,"pppoe_enable");
	sprintf(pppoe_enable,"%d",conf->pppoe_enable);
	all_items[6].value=pppoe_enable;

	sprintf(all_items[7].key,"upnp_session");
	sprintf(upnp_session,"%d",conf->upnp_session);
	all_items[7].value=upnp_session;
	
	sprintf(all_items[8].key,"time_set");
	sprintf(time_set,"%d",conf->time_set);
	all_items[8].value=time_set;

	sprintf(all_items[9].key,"time");
	sprintf(time,"%d/%d/%d %d:%d:%d",
			conf->stm.tm_year, conf->stm.tm_mon,  conf->stm.tm_mday,
			 conf->stm.tm_hour,  conf->stm.tm_min,  conf->stm.tm_sec);
	all_items[9].value=time;

	ret=PRO_SetMultiItemStr(DEVOPT_Section,all_items,10,SYSCONF);
	if(ret)
		return ret;
	ret=AddBackupDNS(poe_acc_index);
	if (ret)
		return ret;

	fp=fopen(OPTIONS,"wt");
	if(!fp)
		return -1;
	fprintf(fp,"lock\nnoauth\nnobsdcomp\nnodeflate\nmtu %s\nmru %s\n"
	"lcp-echo-failure 10\nlcp-echo-interval 10\ndefaultroute\n",mtu,mtu);
	fclose(fp);
	return 0;
}


#define DPROXYF "/var/dproxy.conf"

int mkdproxyconf(void){
    struct in_addr *dns_p;
    FILE *fp;
    int demand;

    fp = fopen(DPROXYF,"w");
    if(!fp){
        return -1;
    }

    /* Make nameserver(1,2,3) */

    dns_p = GetDNSIPFromFile(RESOLV_FILE);

    fprintf(fp,"name_server = %s\n",inet_ntoa(dns_p[0]));
    fprintf(fp,"name_server2 = %s\n",inet_ntoa(dns_p[1]));
    fprintf(fp,"name_server3 = %s\n",inet_ntoa(dns_p[2]));

    ReadSystemSettings(&system_conf);

    if( CONNECTION_DHCP == system_conf.Connection ){
        fprintf(fp,"ppp_detect = %s\n","no");
    }
    else{
        fprintf(fp,"ppp_detect = %s\n","yes");
    }

    fprintf(fp,"purge_time = 172800\n");
    fprintf(fp,"deny_file = /etc/dproxy.deny\n");
    fprintf(fp,"cache_file = /var/cache/dproxy.cache\n");
    fprintf(fp,"hosts_file = /etc/hosts\n");
    fprintf(fp,"dhcp_lease_file = \n");
    fprintf(fp,"ppp_dev = /var/run/ppp0.pid\n");
    fprintf(fp,"debug_file = /var/log/dproxy.debug\n");

    switch(system_conf.Connection){
    case CONNECTION_DHCP:
        demand = 0;
        break;
    case CONNECTION_SINGLE_PPPOE:
        ReadSinglePPPoESettings(&single_pppoe_conf);
        if(DOD == single_pppoe_conf.dialMode){
            demand = 1;
        }
        else{
            demand = 0;
        }
        break;
#ifdef _WAN_MODEM_
    case CONNECTION_MODEM:
        ReadModemSettings(&mdm_conf);
        if(DOD == mdm_conf.mdm_dialMode){
            demand = 1;
        }
        else{
            demand = 0;
        }
        break;
#endif
    default:
        demand = 0;
        break;
    }
    fprintf(fp,"demand = %s\n",demand?"yes":"no");

    fclose(fp);

    return 0;
}


/*******************************************************
 * 1.resolv.conf's format                              *
 *                                                     *
 *  |nameserver                    |                   *
 *  |nameserver                    |                   *
 *  |nameserver                    |                   *
 *  |nameserver                    |                   *
 *  |nameserver                    |                   *
 *  |nameserver                    |                   *
 *  |nameserver                    |                   *
 *                                                     *
 *  every line is "nameserver[]{20}"                   *
 *  total 1+4+2 lines. 1 for pre dns, 3 dns from server*
 *  and 2 backup dns                                   *
 *                                                     *
 *  dns from server will read from /var/serverdns.tmp  *
 *  If can not read , means server dns is null         *
 *  After read dns from server , need to remove file   *
 *******************************************************/
int mkresolvconf(void){
    FILE *fp;
    struct in_addr prefer_dns;
    struct in_addr *server_dns_p;
    int ret,i;
    BYTE *p;
    char cmd[100];

    /* 0. Make template of /etc/resolv.conf */
    fp = fopen(RESOLV_FILE,"w+");
    if(!fp){
        /* ooo, I can not write to resolv.conf! */
        return -1;
    }

    for(i=0;i<1+4+2;i++){
        fprintf(fp,PER_DNS_LINE);
    }


    /* 1. Make pre dns. */
    ret = GetPreferDNS(&prefer_dns);
    if(ret){
        fclose(fp);
        return -1;
    }

    fseek( fp, 0L, SEEK_SET);
    if(prefer_dns.s_addr){
        fprintf(fp,"nameserver %s",inet_ntoa(prefer_dns));
    }
    else{
        fprintf(fp,"#");
    }

    /* 2. Make server dns. */
    server_dns_p = GetDNSIPFromFile(SERVER_DNS_TMP);
    for(i=0;i<MAX_DNS_NUM;i++){
        fseek( fp, (i+1) * (sizeof(PER_DNS_LINE)-1), SEEK_SET);
        if(server_dns_p[i].s_addr){
            fprintf(fp,"nameserver %s",inet_ntoa(server_dns_p[i]));
        }
        else{
            fprintf(fp,"#");
        }
    }

    /* 2.1 remove tempfile */
    sprintf(cmd,"rm %s -f 2>/dev/null",SERVER_DNS_TMP);
    system(cmd);


    /* 3. Make backup dns. */

    ReadDevConf(&dev_opt_conf,-1);

    /* 3.1 first backup dns. */
    fseek( fp, (MAX_DNS_NUM+1) * (sizeof(PER_DNS_LINE)-1), SEEK_SET);
    p = dev_opt_conf.dev_dns_1;
    if(*p != 0){
        fprintf(fp,"nameserver %u.%u.%u.%u",p[0],p[1],p[2],p[3]);
    }
    else{
        fprintf(fp,"#");
    }

    /* 3.1 second backup dns. */
    fseek( fp, (MAX_DNS_NUM+2) * (sizeof(PER_DNS_LINE)-1), SEEK_SET);
    p = dev_opt_conf.dev_dns_2;
    if(*p != 0){
        fprintf(fp,"nameserver %u.%u.%u.%u",p[0],p[1],p[2],p[3]);
    }
    else{
        fprintf(fp,"#");
    }

    fclose(fp);
    return 0;
}

int StopUPnP(void)
{
	FILE *fp;
	int pid;

	if((fp=fopen(UPNPD_PIDFILE,"r"))==NULL)
		return 0;
	pid=0;
	fscanf(fp,"%d",&pid);
	fclose(fp);

	if(pid){
		int timeout=6;
		kill((pid_t)pid, SIGINT);
		while(1){
			if(access(UPNPD_PIDFILE,F_OK)!=0)
				break;	
			if(timeout==0){
				kill((pid_t)pid, SIGKILL);	
				remove(UPNPD_PIDFILE);			
			}
			timeout--;		
			sleep(1);
			
		}
	}
	return 0;
}

int StartUPnP(void)
{
	devopt_conf conf;
	int ret=0;
	FILE *fp;
	int pid=0;

	ret=ReadDevConf(&conf,-1);
	if(ret)
		return ret;
	if(!conf.upnp_en)
		return 0;
		
	if((fp=fopen(UPNPD_PIDFILE,"r"))!=NULL){
		fscanf(fp,"%d", &pid);
		fclose(fp);
		if(pid!=0){
			char piddir[20];
			sprintf(piddir,"/proc/%d", pid);
			if(access(piddir, F_OK)==0)
				return 0;
			else
				remove(UPNPD_PIDFILE);
		}
	}
#if 0
	if(fork()==0){
		cgi_fork_do();	
		execl("/sbin/upnpd","upnpd",NULL);
		exit(-1);
	}
#endif
	system("/sbin/upnpd >/dev/null 2>&1 &");
	return 0;
}

int Daytime(void)
{
#define DAYTIME "/sbin/daytime"
	devopt_conf *pConf;
	char cmd[128];
	ReadDevConf(&dev_opt_conf, -1);
	pConf=&dev_opt_conf;
	if(pConf->time_set){
#ifdef _PC_TEST_
		sprintf(cmd,"/bin/date +\"%%Y/%%m/%%d %%H:%%M:%%S\" -s \"%d/%d/%d %d:%d:%d\"  >/dev/null 2>&1 &",
#else
		sprintf(cmd,"/bin/date +\"%%Y/%%m/%%d %%H:%%M:%%S\" -s \"%d.%d.%d-%d:%d:%d\"  >/dev/null 2>&1 &",			
#endif
				pConf->stm.tm_year+2000,pConf->stm.tm_mon,pConf->stm.tm_mday,
				pConf->stm.tm_hour,pConf->stm.tm_min,pConf->stm.tm_sec);
		system(cmd);	
	}else{
		sprintf(cmd,"%s >/dev/null 2>&1 &", DAYTIME);
		system(cmd);
	}
	return 0;
}
