#ifndef _DEV_OPT_H_
#define _DEV_OPT_H_
#include <time.h>
typedef struct devopt_conf{
	unsigned char dev_dns_1[4];
	unsigned char dev_dns_2[4];
	int upnp_en;
	int port_map;
	int wan_dial;
	int mtu;
	int pppoe_enable;
	int upnp_session;
	int time_set;
	struct tm stm;
}devopt_conf;

#define DEVOPT_Section 	"DEVOPT"
#define DNS1		"dev_dns_1"
#define DNS2		"dev_dns_2"
#define UPNP		"upnp_enable"
#define CONFIG		"port_map"
#define WAN_DIAL 	"wan_dial"
#define MTU			"mtu"


extern devopt_conf dev_opt_conf;

extern void extract_ip(char *ip, unsigned char dst[4]);
int ReadDevConf(devopt_conf *conf, int poe_acc_index);  //ada
int SaveDevConf(devopt_conf *conf, int poe_acc_index);  //ada

int mkdproxyconf(void);
int mkresolvconf(void);
int StartUPnP(void);
int StopUPnP(void);
int AddBackupDNS(int poe_acc_index);
int Daytime(void);

#define PER_DNS_LINE        "nameserver                    \n"
#define SERVER_DNS_TMP      "/var/serverdns.tmp"

#define INVALID_UPNP			1
#define INVALID_CONFIG			2
#define INVALID_DISABLE			3
#define INVALID_MTU				4
#define UPNPD_PIDFILE 	"/var/run/upnpd.pid"
#endif
