#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>

//Check if string is "IP/MASK IP/MASK IP/MASK ..." ?
int IsIPaddrlist(char *addr)
{
	char *str,*p;
	char *ip;
	int mask;
	
	if(strlen(addr)<2)
		return 0;
	if(strcmp(addr,"\"\"")==0)
		return 1;
	str=(char *)alloca(strlen(addr)-2);
	
	if(sscanf(addr,"\"%[^\"]\"",str)<0)
		return 0;
	while(str)
	{
		p=strchr(str,' ');
		if(p)
			*p=0;
		ip=(char *)alloca(strlen(str)+1);
		mask=0;
		if(sscanf(str,"%[^/ ]/%d",ip,&mask)<0)
			return 0;
		if(inet_addr(ip)==INADDR_NONE||(mask<0||mask>32))
			return 0;
		if(p)
			str=p+1;
		else
			break;
	}
	return 1;
}

int IsMACaddr(char *addr)
{
	int i;
	
	if(strlen(addr)!=17)
		return 0;
	for(i=2;i<16;i=i+3)
		if(addr[i]!=':')
			return 0;
	for(i=0;i<18       ;i++)
	{
		if(i==2||i==5||i==8||i==11||i==14)
			continue;
		if((addr[i]<'0'||addr[i]>'9')&&(addr[i]<'A'||addr[i]>'F'))
			return 0;
	}
	return 1;
}

//Check if string is "MAC MAC MAC ..." ?
int IsMACaddrlist(char *addr)
{
	char *str,*p,*q;

	if(strlen(addr)<2)
		return 0;
	if(strcmp(addr,"\"\"")==0)
		return 1;
	str=(char *)alloca(strlen(addr)-2);
	
	if(sscanf(addr,"\"%[^\"]\"",str)<0)
		return 0;
	q=str;
	while(q)
	{
		p=strchr(q,' ');
		if(p)
			*p=0;
		if(!IsMACaddr(q))
			return 0;
		if(p)
			q=p+1;
		else
			break;
	}
	return 1;
}

//Check if string is "PORT PORT:PORT ..." ?
int IsPortlist(char *addr)
{
	char *str,*p;
	unsigned int s_port,e_port;
	int port;
	
	if(strlen(addr)<2)
		return 0;
	if(strcmp(addr,"\"\"")==0)
		return 1;
	str=(char *)alloca(strlen(addr)-2);
	
	if(sscanf(addr,"\"%[^\"]\"",str)<0)
		return 0;
	while(str)
	{
		p=strchr(str,' ');
		if(p)
			*p=0;	
		if(strchr(str,':'))
		{
			s_port=e_port=0;
			if(sscanf(str,"%u:%u",&s_port,&e_port)<0)
				return 0;
			if(s_port>=e_port)
				return 0;
			if(s_port>65535||e_port>65535)
				return 0;
		}
		else
		{
			port=0;
			port=atoi(str);
			if(port>65535||port<=0)
				return 0;
		}
		if(p)
			str=p+1;
		else
			break;
	}
	return 1;
}
