#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <time.h>

#include "internet.h"
#include "security.h"
#include "serv.h"
#include "ud_sap.h"
#include "vs.h"
#include "lan.h"
#include "system.h"
#include "wan.h"
#include "groups.h"
#include "internet.h"
#include "security.h"
#include "ud_sap.h"
#include "vs.h"
#include "remotemg.h"
#include "logging.h"
#include "sch_def.h"

#define STOP_ARG		"stop"

#define	ACCEPT		"ACCEPT"
#define	DROP		"DROP"
#define DROPALL     "DROPALL"

#if 0
#define	GROUP(x)	(0x01<<(i))
#else
/* Now, one PC only in one group , but I think that upper is better. */
#define GROUP(x)	(i)
#endif /**/
#define	STR_PRO(x)	(((x)==PRO_TCP)?"tcp":"udp")

#ifndef _SH2C_
int WriteCommScript(void){
    FILE *fp;
    LAN_CONF lan;
    struct in_addr ina;
    

    fp=fopen(IPT_COMM,"w");
	
	ReadLanSettings(&lan);
	fprintf(fp,"LAN_ITF=%s\n",LAN_ITF);
	
	ina.s_addr=lan.LanIPAddr;
	fprintf(fp,"LAN_IP=%s\n",inet_ntoa(ina));
	
	ina.s_addr=lan.NetMaskIPAddr;
	fprintf(fp,"LAN_MASK=%s\n\n",inet_ntoa(ina));

	GetConnectionStatus(&if_status);
	fprintf(fp,"WAN_IP=%s\n",inet_ntoa(if_status.ip));
	ReadSystemSettings(&system_conf);
	switch(system_conf.Connection){
		case CONNECTION_DHCP: /* DHCP */
			fprintf(fp,"WAN_ITF=eth1\n\n");
        		break;
		default:
			fprintf(fp,"WAN_ITF=ppp0\n\n");
        		break;
	}
    
    fclose(fp);
    return 0;
}

static int WriteFLTScript(void)
{
	FILE *fp,*sapConf_fp;
	LAN_CONF lan;
	SINGLE_PPPOE_CONF *pSinglePPPoEConf=&single_pppoe_conf;
	group_conf group;
	PC_DB_CONF_s *pdb;
	serv_conf *pserv=NULL,*ps;
	int serv_num=0;
	int i;
	char *p;
//	internet_conf internet;
	secu_conf secu;
	sap_conf sap;
	struct in_addr ina;
	remotemg remoteConf;
	log_conf logConf;
	int Have_PC=0;


	pc_db_link_init();
	ReadPCDBConf(&pc_db_conf);


	fp=fopen(IPT_FILTER,"w");

//lan here
	ReadLanSettings(&lan);
	fprintf(fp,"LAN_ITF=%s\n",LAN_ITF);
	ina.s_addr=lan.LanIPAddr;
	fprintf(fp,"LAN_IP=%s\n",inet_ntoa(ina));
	ina.s_addr=lan.NetMaskIPAddr;
	fprintf(fp,"LAN_MASK=%s\n\n",inet_ntoa(ina));

//wan here
	GetConnectionStatus(&if_status);
	fprintf(fp,"WAN_IP=%s\n",inet_ntoa(if_status.ip));
	ReadSystemSettings(&system_conf);
	switch(system_conf.Connection){
		case CONNECTION_DHCP: /* DHCP */
			fprintf(fp,"WAN_ITF=eth1\n\n");
        		break;
		default:
			fprintf(fp,"WAN_ITF=ppp0\n\n");
        		break;
	}
//nat enable here
    /* NAT default is yes.*/
    ReadSinglePPPoESettings(pSinglePPPoEConf);
    if( CONNECTION_SINGLE_PPPOE == system_conf.Connection
    && TYPE_UNNUMBERED == pSinglePPPoEConf->ipType
    ){
        /* In PPPoE Unnumbered mode , NAT should be disable. */
        fprintf(fp,"NAT_ENABLE=no\n\n");
    }
    else{
        fprintf(fp,"NAT_ENABLE=yes\n\n");
    }

//access control here
	ReadSERV(&pserv,&serv_num,-1);
	for(i=0;i<5;i++){
		ReadGroup(i, &group);
//		debug("group %d schedule is %d.",i,group.schedule);
		if(GROUP_BASE_SCHEDULE ==  group.schedule){
		    fprintf(fp,"ACC_%d_IN_SCH=%s\n", i, inSchedule(i,time(0)) ? "yes" : "no");
		}
		else{
		    fprintf(fp,"ACC_%d_IN_SCH=%s\n", i, "yes");
		}


        switch(group.block){
        case BLOCK_NONE:
			fprintf(fp,"ACC_%d=%s\n",i,ACCEPT);
		    break;
		case BLOCK_ALL:
		    fprintf(fp,"ACC_%d=%s\n",i,DROPALL);
		    break;		
		case BLOCK_SELECT:
			fprintf(fp,"ACC_%d=%s\n",i,DROP);
			break;
        default:
            break;
		}		

			if(i==0){
				fprintf(fp,"ACC_%d_ADDR=\"$LAN_IP/$LAN_MASK\"\n",i);
				Have_PC = 1;
			}
			else{
				fprintf(fp,"ACC_%d_ADDR=\"",i);
				pdb=pc_db_conf.p_database;
				Have_PC = 0;
				while(pdb){
#if 0
					if((pdb->group)&GROUP(i))
#else
                    if( (pdb->group) == GROUP(i) )
#endif /* #if 0 */
                    {
						fprintf(fp,"%d.%d.%d.%d ",pdb->ip_addr[0],
							pdb->ip_addr[1],pdb->ip_addr[2],pdb->ip_addr[3]);
				        Have_PC = 1;
				    }
					pdb=pdb->next;
				}
				fprintf(fp,"\"\n");
			}

			fprintf(fp,"ACC_%d_PORT=\"",i);
			ps=pserv;
			if( Have_PC ){
			    /* If no PC in this group , why we need print port ? */
    			while(ps){
    				if(serv_in_group(ps->name,i)){
    					p=strchr(ps->port_info,'-');
    					if(p)
    						*p=':';
    					fprintf(fp,"%s-%s ",ps->protocol,ps->port_info);
    				}
    				ps=ps->next;
    			}
    		}
			fprintf(fp,"\"\n\n");
		}
	FreeSERV(pserv);

#if 0
//sap here
	ReadInternet(&internet);
	for(i=0;i<APP_NUM;i++){
		if(strlen(internet.pc_name[i]))
			fprintf(fp,"%s=1\n",internet.app_name[i]);
		else
			fprintf(fp,"%s=0\n",internet.app_name[i]);
	}
	fprintf(fp,"\n");

#endif /* #if 0 */
//user sap here
    sapConf_fp = fopen(SAP_CONF_FILE,"w");
	for(i=1;i<MAX_UD_SAP+1;i++){
		ReadSAP(i,&sap);
		if(sap.enable==ENABLE){
			fprintf(fp,"SAP_%d=%s\n",i,sap.name);
			fprintf(fp,"SAP_%d_EXT_PRO=\"%s\"\n",i,STR_PRO(sap.ext_protocol));
			fprintf(fp,"SAP_%d_EXT_PORT=\"%s:%s\"\n",i,sap.ext_ports,sap.ext_porte);
			fprintf(fp,"SAP_%d_IN_PRO=\"%s\"\n",i,STR_PRO(sap.in_protocol));
			fprintf(fp,"SAP_%d_IN_PORT=\"%s:%s\"\n\n",i,sap.in_ports,sap.in_porte);

            /* Write /var/sapconf */

            if(sapConf_fp){
                fprintf(sapConf_fp,"%d %d %d %d %d %d\n",
                    sap.in_protocol == PRO_TCP ? IPPROTO_TCP : IPPROTO_UDP,
                    atoi(sap.in_ports),
                    atoi(sap.in_porte),
                    sap.ext_protocol == PRO_TCP ? IPPROTO_TCP : IPPROTO_UDP,
                    atoi(sap.ext_ports),
                    atoi(sap.ext_porte)
                );
            } /* if(sapConf_fp) */
		} /* if(sap.enable==ENABLE) */
	} /* for(i=1;i<MAX_UD_SAP+1;i++) */
	if(sapConf_fp) {
	    fclose(sapConf_fp);
	}

//security here
	ReadSecu(&secu,-1);
	fprintf(fp,"ICMP=%d\n",secu.icmp);
	fprintf(fp,"IPSEC=%d\n",secu.ipsec);
	fprintf(fp,"PPTP=%d\n",secu.pptp);
	fprintf(fp,"L2TP=%d\n",secu.l2tp);
	fprintf(fp,"URL=%d\n\n",secu.url);

//Log here
    ReadLogging(&logConf,-1);
    fprintf(fp,"OUT_LOG_ENABLE=%d\n",logConf.outlog_en);
    fprintf(fp,"AC_LOG_ENABLE=%d\n",logConf.inlog_en);
    fprintf(fp,"FW_LOG_ENABLE=%d\n",logConf.fwlog_en);


//DOS here

	fprintf(fp,"\nDOS=%d\n",secu.dos);

//remotemg here
    ReadRemoteConf(&remoteConf,-1);                  //ada
    if(remoteConf.remote_mg){
        fprintf(fp,"\nREMOTE_ENABLE=yes\n");
    }
    else{
        fprintf(fp,"\nREMOTE_ENABLE=no\n");
    }
    fprintf(fp,"\nREMOTE_PORT=%d\n",remoteConf.remote_port);


	fflush(fp);
	fclose(fp);
	return 0;
}


static int WriteNATScript(void)
{
	FILE *fp;
	vs_conf *pvs=NULL,*pv;
	int vs_num=0,i=1;
	char *p;
	internet_conf internet;

	pc_db_link_init();
	ReadPCDBConf(&pc_db_conf);

	fp=fopen(IPT_NAT,"w");
	ReadVS(&pvs,&vs_num,-1);
	pv=pvs;
	while(pv){
		if(pv->enable){
    		fprintf(fp,"VS_%d=\"%s\"\n",i,pv->name);
    		fprintf(fp,"VS_%d_EN=%d\n",i,pv->enable);
			fprintf(fp,"VS_%d_SERVER=%s\n",i,inet_ntoa(pv->pc_ip));

			p=strchr(pv->protocol,'/');
			if(p)
				*p=' ';
			fprintf(fp,"VS_%d_PRO=\"%s\"\n",i,pv->protocol);
			fprintf(fp,"VS_%d_IN_PORT=\"%s:%s\"\n",i,pv->in_p,pv->in_endp);
			fprintf(fp,"VS_%d_EXT_PORT=\"%s:%s\"\n\n",i,pv->ext_p,pv->ext_endp);
		    i++;
		}
		pv=pv->next;
	}
	FreeVS(pvs);
	fprintf(fp,"VS_TOTAL=%d\n\n",i-1);

	ReadInternet(&internet, -1);
	if(internet.pc_dmz.s_addr){
        fprintf(fp,"DMZ=%s\n",inet_ntoa(internet.pc_dmz));
	}
	else
		fprintf(fp,"DMZ=\n");
	fflush(fp);
	fclose(fp);
	return 0;
}

int WriteScript(void)
{
	WriteFLTScript();
	WriteNATScript();
	return 0;
}
#else
int WriteScript(void){return 0;}
int WriteFLTScript(){return 0;}
int WriteNATScript(){return 0;}
int WriteCommScript(void){return 0;}
#endif

#if 0
int StartFW(void)
{
#ifndef _PC_TEST_
	char cmd[256];
	sprintf(cmd,"%s >/dev/null 2>&1",IPT_SH_FILTER);
	if(system(cmd))
		return FW_RUN_SCRIPT_ERR;
#endif /* _PC_TEST_ */
	return 0;
}

int StopFW(void)
{
	char cmd[256];
	sprintf(cmd,"%s %s >/dev/null 2>&1",IPT_SH_FILTER,STOP_ARG);
	if(system(cmd))
		return FW_RUN_SCRIPT_ERR;

	return 0;
}
#endif
int FWInit(void){
    
    /* Security init. */
{
    secu_conf secu;
    
    ReadSecu(&secu,-1);
    secu_modify(1, NULL, &secu);
}    
    /* VS init.*/
    VSChainInit();
    
    /* DMZ init */
{
    internet_conf internet;
    
    ReadInternet(&internet, -1);
    dmz_modify(&internet);
}
    /* Access control init. */
{
    ServiceInit();
}    
    /* NAT init. */
{
    char cmd[128];
    int nat_enable = 1;
    
	ReadSystemSettings(&system_conf);
	if( system_conf.Connection == CONNECTION_SINGLE_PPPOE) {
		ReadSinglePPPoESettings(&single_pppoe_conf);
		if(single_pppoe_conf.ipType == TYPE_UNNUMBERED){
			nat_enable = 0;
		}
	}else if( system_conf.Connection == CONNECTION_LOCAL_OFFICE) {
			nat_enable = 0;
	}
    sprintf(cmd,"%s %s", CMD_NAT_SH, nat_enable ? "enable":"disable");
    system(cmd);
}
    /* Remote management*/
{
    remotemg conf;
    
    ReadRemoteConf(&conf,-1);               //ada
    remotemg_modify(&conf);
}
    /* Remove the first rule in FORWARD. 
     * It is a temp rule to prevent any packet forward before init finish.
     */
{
    system("/sbin/iptables -D FORWARD 1");
}

    return 0;    
}


int FWRestart(void){
    return 0;
}
