#ifndef _FW_H_
#define _FW_H_
#include "cgi-lib.h"
#include "h_const.h"
#define IPAddrLen       16      //Length of ip address (xxx.xxx.xxx.xxx)
#define CommonNameLen   16      //Length of commom name
#define HWAddrLen       18      //Length of hw address (xx:xx:xx:xx:xx:xx)
#define MacAddrLen      13      //Length of mac address
#define EntryNameLen    17      //Length of entry name
#define IFLen           6       //Length of interface
#define	PortLen		6	//Length of PORT (xxxxx)


#define IPT_FILTER		"/var/ipt_filter"
#define	IPT_NAT			"/var/ipt_nat"
#define	IPT_COMM		"/var/ipt_comm"

#ifdef _SH2C_
#define	IPT_SH_FILTER		"/htdocs/sh_ip_filter"
#define CMD_NAT_SH          "/htdocs/sh_nat"
//#define	IPT_SH_NAT		"/htdocs/sh_ip_nat"
#else
#define	IPT_SH_FILTER		"/etc/rc.d/ip_filter"
#define CMD_NAT_SH          "/etc/rc.d/nat.sh"
//#define	IPT_SH_NAT		"/etc/rc.d/ip_nat"
#endif
#define MAX_ACC_NUM	5
#define	MAX_SAP_NUM	6
#define	MAX_VS_NUM	6

#define	ALLOW		1
#define	BLOCK		0

#define	ACCEPT		"ACCEPT"
#define	DROP		"DROP"

#define	PRO_ICMP	0
#define	PRO_TCP		1
#define	PRO_UDP		2
#define	PRO_TCP_UDP	3

#define	AcceptLen	7	//ACCEPT DROP
#define	AddrTypeLen	4	//IP MAC


int WriteScript(void);
int StartFW(void);
int StopFW(void);


enum{
    FW_GROUP_READ_ERR=1,
    FW_GROUP_NOT_EXIST,
    FW_GROUP_BLOCK_ERR,
    FW_GROUP_APP_ERR,
    FW_GROUP_GID_ERR,
    FW_GROUP_SCHEDULE_ERR,

    FW_INTER_NOT_EXIST,
    FW_INTER_APP_ERR,
    FW_INTER_PC_ERR,
    FW_INTER_DMZ_ERR,
    FW_INTER_SAVE_ERR,

    FW_SCH_NOT_EXIST,
    FW_SCH_MON_ERR,
    FW_SCH_TUE_ERR,
    FW_SCH_WED_ERR,
    FW_SCH_THU_ERR,
    FW_SCH_FRI_ERR,
    FW_SCH_SAT_ERR,
    FW_SCH_SUN_ERR,
    FW_SCH_SAVE_ERR,

    FW_SECU_READ_ERR,
    FW_SECU_NOT_EXIST,
    FW_SECU_DOS_ERR,
    FW_SECU_URL_ERR,
    FW_SECU_ICMP_ERR,
    FW_SECU_IPSEC_ERR,
    FW_SECU_PPTP_ERR,
    FW_SECU_L2TP_ERR,

    FW_SERV_READ_ERR,
    FW_SERV_NOT_EXIST,
    FW_SERV_NAME_ERR,
    FW_SERV_RESV_ERR,
    FW_SERV_PRO_ERR,
    FW_SERV_PORT_ERR,
    FW_SERV_ADD_ERR,
    FW_SERV_DEL_ERR,

    FW_UDSAP_ID_ERR,
    FW_UDSAP_READ_ERR,
    FW_UDSAP_NOT_EXIST,
    FW_UDSAP_ENABLE_ERR,
    FW_UDSAP_NAME_ERR,
    FW_UDSAP_INPRO_ERR,
    FW_UDSAP_EXTPRO_ERR,
    FW_UDSAP_INPORTS_ERR,
    FW_UDSAP_INPORTE_ERR,
    FW_UDSAP_INPORT_RANGER_ERR,
    FW_UDSAP_EXTPORTS_ERR,
    FW_UDSAP_EXTPORTE_ERR,
    FW_UDSAP_EXTPORT_RANGER_ERR,
    FW_UDSAP_SAVE_ERR,

    FW_VS_READ_ERR,
    FW_VS_NOT_EXIST,
    FW_VS_NAME_ERR,
    FW_VS_RESV_ERR,
    FW_VS_ENABLE_ERR,
    FW_VS_PC_ERR,
    FW_VS_INPORT_ERR,
    FW_VS_EXTPORT_ERR,
    FW_VS_ADD_ERR,
    FW_VS_DEL_ERR,
    FW_VS_UPDATE_ERR,

    FW_FILE_NOT_EXIST,

    FW_RUN_SCRIPT_ERR,

    FW_MEM_ERR
};

int FWInit(void);
int WriteCommScript(void);
int FWRestart(void);

#endif
