#ifndef _GROUPS_H_
#define _GROUPS_H_

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "fw.h"

/**********
[GROUPS]

Group0=Always BLOCK NONE
Group1=Schedule BLOCK NONE
Group2=Schedule BLOCK SELECTED 04 app1 app2 app3 app4
Group3=Always BLOCK NONE
Group4=Schedule BLOCK NONE
**********/

#define	BLOCK_ALL	2
#define	BLOCK_SELECT	1
#define	BLOCK_NONE	0

#define	GROUPS_SEC	"GROUPS"


#define	GROUP0	"Group0"
#define	GROUP1	"Group1"
#define	GROUP2	"Group2"
#define	GROUP3	"Group3"
#define	GROUP4	"Group4"

#define	GROUP_NUM	5


#ifdef _SH2C_
#define CMD_ACC_CTRL_SH         "/htdocs/sh_acc_ctrl"
#define CMD_GID_MODIFY_SH       "/htdocs/sh_gid_modify"
#else
#define CMD_ACC_CTRL_SH         "/etc/rc.d/acc_ctrl.sh"
#define CMD_GID_MODIFY_SH       "/etc/rc.d/gid-modify.sh"
#endif


typedef struct group_conf{
	int	    block;
    int     schedule;
	char	**appname;
}group_conf;

enum{
    GROUP_BASE_SCHEDULE,
    GROUP_ALWAYS
};


int ReadGroup(int gid,group_conf *p);

int SaveGroup(int gid,group_conf *group,int num);

void FreeGroup(group_conf *p);

int serv_in_group(char *name,int gid);

int RecorderGrpIndex(int groupIndex);
int GetGrpIndex(void);

int ServiceInit(void);

int Service_modify(int groupIndex);

int gid_modify(struct in_addr ip, int prev_gid, int curr_gid);

#endif
