#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "internet.h"
#include "PRO_GetStr.h"
#include "PRO_SetMultiItemStr.h"
#include "wan.h"

#define SYS_CONF	"/var/system.conf"

int ReadInternet(internet_conf *internet, int poe_acc_index)
{
	FILE *fp;
	int i;
	char key[10];
	char buf[APP_NAME_LEN+CommonNameLen+2],*p;
	char no[3];
	
	fp=fopen(SYS_CONF,"r");
	if(!fp)
		return FW_FILE_NOT_EXIST;
	for(i=0;i<APP_NUM;i++){
		sprintf(key,"%d",i+1);
		PRO_GetStr(INTERNET_SEC,key,buf,sizeof(buf),fp);
		p=strchr(buf,':');
		if(p)
			*p=0;
		strcpy(internet->app_name[i],buf);
		if(p)
			strcpy(internet->pc_name[i],p+1);
		else
			strcpy(internet->pc_name[i],"");
	}
	
	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';	
	sprintf(key,"%sDMZ",no);
	PRO_GetStr(INTERNET_SEC,key,buf,sizeof(buf),fp);
	if(strlen(buf)){
	    if( !inet_aton(buf,&internet->pc_dmz)){
	        internet->pc_dmz.s_addr = 0;
	    }
	}	
	else{
	    internet->pc_dmz.s_addr = 0;
    }

    fclose(fp);

	return 0;
}

static int CheckInternet(internet_conf *internet)
{
	int i;
	
	if(!internet)
		return FW_INTER_NOT_EXIST;
	for(i=0;i<APP_NUM;i++){
		if(strlen(internet->app_name[i])>APP_NAME_LEN)
			return FW_INTER_APP_ERR;
		if(strlen(internet->pc_name[i])>CommonNameLen)
			return FW_INTER_PC_ERR;
	}
	return 0;
}

int SaveInternet(internet_conf *internet, int poe_acc_index)
{
	int i;
	int ret;
	multi_items mi[APP_NUM+1];
	char buf[APP_NUM][APP_NAME_LEN+CommonNameLen+2];
	char no[3];
		
	ret=CheckInternet(internet);
	if(ret)
		return ret;
	
	for(i=0;i<APP_NUM;i++){
		sprintf(mi[i].key,"%d",i+1);
		if(strlen(internet->pc_name[i]))
			sprintf(buf[i],"%s:%s",internet->app_name[i],internet->pc_name[i]);
		else
//			strcpy(buf[i],internet->app_name[i]);
			sprintf(buf[i],"%s:",internet->app_name[i]);
		mi[i].value=buf[i];
	}
	
	
	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';	
	sprintf(mi[APP_NUM].key,"%sDMZ",no);
	mi[APP_NUM].value=inet_ntoa(internet->pc_dmz);
	
	ret=PRO_SetMultiItemStr(INTERNET_SEC,mi,APP_NUM+1,SYS_CONF);
	if(ret)
		return FW_INTER_SAVE_ERR;
//	WriteScript();

//	StartFW();

	dmz_modify(internet);
	
	return 0;
}

int dmz_modify(internet_conf *internet){
    char cmd[128];
    
    sprintf(cmd,"%s %s %s", CMD_DMZ_SH, internet->pc_dmz.s_addr?"enable":"disable", 
            internet->pc_dmz.s_addr?inet_ntoa(internet->pc_dmz):"");
    
    debug(cmd);
    
    return system(cmd);
}

    
