#ifndef _SCH_DEF_H_
#define _SCH_DEF_H_

#include "fw.h"

/************
[SCH_DEF]
MON=09 00 12 00 13 00 18 00
TUE=07 30 16 00
WED=
THU=
FRI=
SAT=
SUN=
....
************/

#define MAX_SCH_LEN	24

#define	SCH_DEF_SEC	"SCH_DEF"

#define MON	"MON"
#define	TUE	"TUE"
#define WED	"WED"
#define	THU	"THU"
#define FRI	"FRI"
#define	SAT	"SAT"
#define SUN	"SUN"

enum{
    SUNDAY,
    MONDAY,
    TUESDAY,
    WEDNESDAY,
    THURSDAY,
    FRIDAY,
    SATURDAY,
    WEEK_DAY
};

#define SCH_HALF_FORMAT     "%[0-9]:%[0-9]-%[0-9]:%[0-9]"
#define SCH_FULL_FORMAT     "%[0-9]:%[0-9]-%[0-9]:%[0-9] %[0-9]:%[0-9]-%[0-9]:%[0-9]"

#define SCH_HALF_FORMAT_PRT     "%s:%s-%s:%s"
#define SCH_FULL_FORMAT_PRT     "%s:%s-%s:%s %s:%s-%s:%s"


#ifdef _SH2C_
#define CMD_SCH_SH              "/htdocs/sh_sch"
#else
#define CMD_SCH_SH              "/etc/rc.d/sch.sh"
#endif


typedef struct sch_def_conf{
/*
	char mon[MAX_SCH_LEN];
	char tue[MAX_SCH_LEN];
	char wed[MAX_SCH_LEN];
	char thu[MAX_SCH_LEN];
	char fri[MAX_SCH_LEN];
	char sat[MAX_SCH_LEN];
	char sun[MAX_SCH_LEN];
*/
    char weekday[WEEK_DAY][MAX_SCH_LEN];
}sch_def_conf;

int ReadSchDef(sch_def_conf *sch, int groupIndex);

int SaveSchDef(sch_def_conf *sch, int groupIndex);

int inSchedule(int groupIndex, time_t givenTime);

int sch_modify(int gid , time_t givenTime);
#endif
