#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "security.h"
#include "PRO_GetInt.h"
#include "PRO_SetMultiItemStr.h"

#include "wan.h"             //ada
#include "logging.h"
#define	SYS_CONF	"/var/system.conf"

int ReadSecu(secu_conf *secu,int poe_acc_index)
{
	FILE *fp;
	int ret=0;
	char key[20];
	char no[3];
		
	if(!secu)
		return 0;
	fp=fopen(SYS_CONF,"r");
	if(!fp)
		return FW_FILE_NOT_EXIST;
		
	//ada	
	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';	
	sprintf(key,"%sDOS",no);
        ret+=PRO_GetInt(SECU_SEC,key,&secu->dos,fp);
	sprintf(key,"%sURL",no);
	ret+=PRO_GetInt(SECU_SEC,key,&secu->url,fp);
	sprintf(key,"%sICMP",no);
        ret+=PRO_GetInt(SECU_SEC,key,&secu->icmp,fp);
	sprintf(key,"%sIPSEC",no);
	ret+=PRO_GetInt(SECU_SEC,key,&secu->ipsec,fp);
	sprintf(key,"%sPPTP",no);
        ret+=PRO_GetInt(SECU_SEC,key,&secu->pptp,fp);
	sprintf(key,"%sL2TP",no);
	ret+=PRO_GetInt(SECU_SEC,key,&secu->l2tp,fp);	
		

	fclose(fp);
	if(ret)
		return FW_SECU_READ_ERR;

	return 0;
}

static int CheckSecu(secu_conf *secu)
{
	if(!secu)
		return FW_SECU_NOT_EXIST;
	if(secu->dos<DISABLE||secu->dos>DOS_LOW)
		return FW_SECU_DOS_ERR;
	if(secu->url<DISABLE||secu->url>ENABLE)
		return FW_SECU_URL_ERR;
	if(secu->icmp<DISABLE||secu->icmp>ENABLE)
		return FW_SECU_ICMP_ERR;
	if(secu->ipsec<DISABLE||secu->ipsec>ENABLE)
		return FW_SECU_IPSEC_ERR;
	if(secu->pptp<DISABLE||secu->pptp>ENABLE)
		return FW_SECU_PPTP_ERR;
	if(secu->l2tp<DISABLE||secu->l2tp>ENABLE)
		return FW_SECU_L2TP_ERR;
		
	return 0;
}

int SaveSecu(secu_conf *secu,int poe_acc_index)
{
	int ret;
	int i;
	multi_items mi[6];
	char value[6][2];
	secu_conf prev_secu;
	char no[3];

	
	ret=CheckSecu(secu);
	if(ret)
		return ret;

	//ada	
	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';	
	sprintf(mi[0].key,"%sDOS",no);
	sprintf(mi[1].key,"%sURL",no);
	sprintf(mi[2].key,"%sICMP",no);
	sprintf(mi[3].key,"%sIPSEC",no);
	sprintf(mi[4].key,"%sPPTP",no);
	sprintf(mi[5].key,"%sL2TP",no);	
	

	sprintf(value[0],"%1d",secu->dos);
	sprintf(value[1],"%1d",secu->url);
	sprintf(value[2],"%1d",secu->icmp);
	sprintf(value[3],"%1d",secu->ipsec);
	sprintf(value[4],"%1d",secu->pptp);
	sprintf(value[5],"%1d",secu->l2tp);
	
	for(i=0;i<6;i++)
		mi[i].value=value[i];
	
	/* Before save settings, check if modified. */
	ReadSecu(&prev_secu,poe_acc_index);	
	
	ret=PRO_SetMultiItemStr(SECU_SEC,mi,6,SYS_CONF);

//	WriteScript();
//    WriteCommScript();
	secu_modify(0, &prev_secu, secu);
	
	//StartFW();
	
	return ret;
}

int secu_modify(int init, secu_conf *prev_secu, secu_conf *curr_secu){
    /* Now I do not care DoS. */
    
    char cmd[200];
    char dos_cmd[200];
    int len =0;
    char *str_enable = "enable";
    char *str_disable = "disable";
    int do_cmd=0,do_dos=0;
    log_conf logConf;
    
    *cmd = '\0';
    *dos_cmd = '\0';
    
    len += sprintf(cmd+len, "%s", CMD_SECURITY_SH);
    if(init){
        len += sprintf(cmd+len, "%s", " init");
        do_cmd = 1;
    }    
    
    if(init || prev_secu->url != curr_secu->url){
		/* Only if out_log and url are both disabled, we can disable ip queue. */
		int prev_status=0,curr_status=0;
		
		ReadLogging(&logConf,-1);
		if(!init){
		    prev_status = logConf.outlog_en || prev_secu->url;
		}
		curr_status = logConf.outlog_en || curr_secu->url;
		
		if((init&&curr_status) || (!init && prev_status != curr_status) ){		
		    len += sprintf(cmd+len, " %s url-filter", curr_status == ENABLE ? str_enable : str_disable);
        do_cmd = 1;
    }
    }
    
    if(init || prev_secu->icmp != curr_secu->icmp){
        len += sprintf(cmd+len, " %s icmp-echo", curr_secu->icmp == ENABLE ? str_enable : str_disable);
        do_cmd = 1;
    }
    
    if(init || prev_secu->ipsec != curr_secu->ipsec){
        len += sprintf(cmd+len, " %s ipsec", curr_secu->ipsec == ENABLE ? str_enable : str_disable);
        do_cmd = 1;
    }
    
    if(init || prev_secu->pptp != curr_secu->pptp){
        len += sprintf(cmd+len, " %s pptp", curr_secu->pptp == ENABLE ? str_enable : str_disable);
        do_cmd = 1;
    }
    
    if(init || prev_secu->l2tp != curr_secu->l2tp){
        len += sprintf(cmd+len, " %s l2tp", curr_secu->l2tp == ENABLE ? str_enable : str_disable);
        do_cmd = 1;
    }
    
    
    if(init || prev_secu->dos != curr_secu->dos){
	int cmd_level;
	switch(curr_secu->dos){
	case DISABLE:
	    cmd_level = 0;
	    break;
	case DOS_LOW:
	    cmd_level = 1;
	    break;	    
	case DOS_MEDIUM:
	    cmd_level = 2;
	    break;	    
	case DOS_HIGH:
	    cmd_level = 3;
	    break;
	default:
	    cmd_level = 0;
	    break;
	}
        sprintf(dos_cmd, "%s %d", CMD_DOS_SH, cmd_level);
        do_dos = 1;
    }    
        
    debug(cmd);
    debug(dos_cmd);
    debug("do_cmd is %d do_dos is %d.",do_cmd,do_dos);
    
    if(do_cmd){
        system(cmd);
    }
    
    if(do_dos){
        system(dos_cmd);
    }
    return 0;
}
