#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ud_sap.h"
#include "PRO_SetStr.h"
#include "PRO_GetStr.h"
#include "h_var.h"

#define SYS_CONF	"/var/system.conf"
static char *protocol_db[]={"ICMP", "TCP", "UDP", "TCP/UDP", 0};
/* id start from 1!! */
int ReadSAP(int id,sap_conf *sap)
{
	FILE *fp;
	char key[2];
	char buf[50];
	char in_protocol[4];
	char ext_protocol[4];

	if(id<1 || id > MAX_UD_SAP)
		return FW_UDSAP_ID_ERR;

	fp=fopen(SYS_CONF,"r");
	if(!fp)
		return FW_FILE_NOT_EXIST;

	memset(buf,0,sizeof(buf));
	memset(sap,0,sizeof(sap_conf));

	sprintf(key,"%1d",id);
	if(PRO_GetStr(UD_SAP_SEC,key,buf,sizeof(buf),fp)){
		fclose(fp);
		return FW_UDSAP_READ_ERR;
	}
	fclose(fp);

//	debug("%s:%s():[%d] buf is %s.",__FILE__,__FUNCTION__,__LINE__,buf);
	sscanf(buf,"%d %s %s %s %s %s %s %s",&sap->enable,sap->name,
		in_protocol,sap->in_ports,sap->in_porte,
		ext_protocol,sap->ext_ports,sap->ext_porte);
	sap->in_protocol = str_db_search(protocol_db,in_protocol);
	sap->ext_protocol = str_db_search(protocol_db,ext_protocol);

	return 0;
}


static int CheckSAP(sap_conf *sap)
{
	int ports,porte;

	if(!sap)
		return FW_UDSAP_NOT_EXIST;
	if(sap->enable!=ENABLE && sap->enable!=DISABLE)
		return FW_UDSAP_ENABLE_ERR;
	if(!strlen(sap->name))
		return FW_UDSAP_NAME_ERR;
	if(sap->in_protocol!=PRO_TCP && sap->in_protocol!=PRO_UDP )
		return FW_UDSAP_INPRO_ERR;
	if(sap->ext_protocol!=PRO_TCP && sap->ext_protocol!=PRO_UDP )
		return FW_UDSAP_EXTPRO_ERR;

	ports=atoi(sap->in_ports);
	porte=atoi(sap->in_porte);
	if(ports<=0 || ports>=65536)
		return FW_UDSAP_INPORTS_ERR;
	if(porte<=0 || porte>=65536)
		return FW_UDSAP_INPORTE_ERR;
	if(ports>porte)
		return FW_UDSAP_INPORT_RANGER_ERR;

	ports=atoi(sap->ext_ports);
	porte=atoi(sap->ext_porte);
	if(ports<=0 || ports>=65536)
		return FW_UDSAP_EXTPORTS_ERR;
	if(porte<=0 || porte>=65536)
		return FW_UDSAP_EXTPORTE_ERR;
	if(ports>porte)
		return FW_UDSAP_EXTPORT_RANGER_ERR;

	return 0;
}

int SaveSAP(int id,sap_conf *sap)
{
	int ret;
	char key[2];
	char buf[50];

	if(id<1&&id>MAX_UD_SAP)
		return FW_UDSAP_ID_ERR;

	ret=CheckSAP(sap);
	if(ret)
		return ret;

	sprintf(key,"%1d",id);
	if(strlen(sap->name))
		sprintf(buf,"%d %s %s %s %s %s %s %s",sap->enable,sap->name,
			protocol_db[sap->in_protocol],sap->in_ports,sap->in_porte,
			protocol_db[sap->ext_protocol],sap->ext_ports,sap->ext_porte);
	else
		strcpy(buf,"");

	ret=PRO_SetStr(UD_SAP_SEC,key,buf,SYS_CONF);
	if(ret)
		return FW_UDSAP_SAVE_ERR;
//	WriteScript();
//	StartFW();
	return 0;
}

