#ifndef _VS_H_
#define _VS_H_
#include <netinet/in.h>

#include "fw.h"

/**********
[VS]

name1=0/1 0/1 TCP/UDP in_port out_port
...

**********/

#define	VS_SEC		"VS"

#define	RESERVERED_NUM	6


#define	RESERVERED	1
#define	UNRESERVERED	0

#define	ENABLE		1
#define	DISABLE		0

#ifdef _SH2C_
#define VS_MODIFY   "/htdocs/sh_vs"
#else
#define VS_MODIFY   "/etc/rc.d/vs.sh"
#endif

enum{
    DEL_VS,
    ADD_VS
};

typedef struct vs_conf{
	char		        name[EntryNameLen];
	int		            reserver;
	int		            enable;
	struct in_addr      pc_ip;
	char		        protocol[10];
	char		        in_p[PortLen];
	char		        ext_p[PortLen];
	char                in_endp[PortLen];
	char		        ext_endp[PortLen];
	struct vs_conf	    *next;
}vs_conf;

int ReadVS(vs_conf **p,int *num, int poe_acc_index);

void FreeVS(vs_conf *p);

int AddVS(vs_conf *p, int poe_acc_index);

int DelVS(char *name, int poe_acc_index);

int UpdateVS(char *name,vs_conf *p, int poe_acc_index);

int ResetVS(int poe_acc_index);

int DisableAllVS(int poe_acc_index);

int vs_modify(vs_conf *p,int add);
int vs_clear();
vs_conf *GetVSByName(char *name, int poe_acc_index);
int VSChainInit(void);
#endif
