#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include "i_urlf.h"

#include "wan.h" //ada
#include "system.h" //ada

void FreeSite(char **plist)
{
	char **url=plist;
	while(*url){
		free(*url);
		url++;
	}
	free(plist);
}
		
int GetSite(char ***site,int *sitenum,int poe_acc_index)
{
	FILE *fh;
	char buf[134]={0};
	char **list=NULL;
	char *p=NULL;
	int num=0;
	char key[10]; //ada
	char no[3]; //ada
	
	fh=fopen(SYSCONF,"r");
	if(!fh)
		return OpenConfErr;	
	list=(char **)malloc(sizeof(list)*MAX_SITE_NUM);
	if (!list)
		return MallocMemErr;
	memset(list,0,sizeof(list)*MAX_SITE_NUM);
	while(fgets(buf,sizeof(buf),fh)){
		if(num>MAX_SITE_NUM)
				break;
		//ada
		if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
			sprintf(no,"%d",poe_acc_index+1);
		else
			no[0]='\0';	
		sprintf(key,"%surlf=",no); //ada
			
		if(strstr(buf,key)==buf){
			*(list+num)=malloc(MAX_SITE_LEN);
			if(*(list+num)==NULL){
				FreeSite(list);
				return MallocMemErr;
			}
			memset(*(list+num),0,MAX_SITE_LEN);
			p=strchr(buf,'\n');
			if(p)
				*p=0;
			strcpy(*(list+num),buf+strlen(key));
			num++;
		}
	}
	*(list+num)=NULL;
	*site=list;
	*sitenum=num;
	fclose(fh);
	
	return FILTER_OK;
}

int AddSite(char *site,int poe_acc_index)
{
	FILE *fh,*fp;
	int fd;
	char *p=NULL;
	char buf[134]={0},tmp[134]={0};
	char tempf[]="/var/tempfile.XXXXXX";
	char key[10]; //ada
	char no[3]; //ada
	
	if(!site)
		return -1;
	if(strstr(site,"http://")==site)
		site=&site[7];
	fd=mkstemp(tempf);
	if(fd==-1)
		return -1;
	close(fd);
	fp=fopen(tempf,"w");
	if(!fp)
		return OpenConfErr;
	fh=fopen(SYSCONF,"r");
	if(!fh){
		fclose(fp);
		remove(tempf); 
		return OpenConfErr;
	}	
	while(fgets(buf,sizeof(buf),fh)){
/*		if(strstr(buf,FILTER)==buf){
			fputs(buf,fp);
			fprintf(fp,"%s%s\n",KEY,site);
			continue;
		}*/
		//ada
		if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
			sprintf(no,"%d",poe_acc_index+1);
		else
			no[0]='\0';	
		sprintf(key,"%surlf=",no); //ada
		
		if(strstr(tmp,key) && (strstr(buf,"\n")==buf || strstr(buf,"[")==buf)){
			fprintf(fp,"%s%s\n",key,site);
			tmp[0]='\0';
		}
		if(strstr(buf,FILTER)){
			strcpy(tmp,key);
		}
		if(strstr(buf,key)==buf){
			strcpy(tmp,buf);
			p=strchr(tmp,'\n');
			if(p)
				*p=0;
			if(strcmp(tmp+strlen(key),site)==0)
				continue;
		}
		fputs(buf,fp);
	}
	fclose(fh);
	fclose(fp);
	rename(tempf,SYSCONF);
	chown(SYSCONF,99,99);
		
	return FILTER_OK;
}
	
int DelSite(char *site,int poe_acc_index)
{
	FILE *fh,*fp;
	int fd;
	char *p=NULL;
	char buf[134]={0},tmp[134]={0};
	char tempf[]="/var/tempfile.XXXXXX";
	char key[10]; //ada
	char no[3]; //ada
	
	if(!site)
		return -1;
	fd=mkstemp(tempf);
	if(fd==-1)
		return -1;
	close(fd);
	fp=fopen(tempf,"w");
	if(!fp)
		return OpenConfErr;
	fh=fopen(SYSCONF,"r");
	if(!fh){
		fclose(fp);
		remove(tempf); 
		return OpenConfErr;
	}	
	while(fgets(buf,sizeof(buf),fh)){
		//ada
		if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
			sprintf(no,"%d",poe_acc_index+1);
		else
			no[0]='\0';	
		sprintf(key,"%surlf=",no); //ada		
		if(strstr(buf,key)==buf){
			strcpy(tmp,buf);
			p=strchr(tmp,'\n');
			if(p)
				*p=0;
			if(!strcmp(tmp+strlen(key),site))
				continue;
		}
		fputs(buf,fp);
	}
	fclose(fh);
	fclose(fp);
	rename(tempf,SYSCONF);
	chown(SYSCONF,99,99);
	return FILTER_OK;
}

int DelAllSite(int poe_acc_index)
{
	FILE *fh,*fp;
	int fd;
	char buf[134]={0};
	char tempf[]="/var/tempfile.XXXXXX";
	char key[10]; //ada
	char no[3]; //ada
	
	fd=mkstemp(tempf);
	if(fd==-1)
		return -1;
	close(fd);
	fp=fopen(tempf,"w");
	if(!fp)
		return OpenConfErr;
	fh=fopen(SYSCONF,"r");
	if(!fh){
		fclose(fp);
		remove(tempf); 
		return OpenConfErr;
	}	
	while(fgets(buf,sizeof(buf),fh)){
		//ada
		if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
			sprintf(no,"%d",poe_acc_index+1);
		else
			no[0]='\0';	
		sprintf(key,"%surlf=",no); //ada		
		if(strstr(buf,key)==buf){
				continue;
		}
		fputs(buf,fp);
	}
	fclose(fh);
	fclose(fp);
	rename(tempf,SYSCONF);
	chown(SYSCONF,99,99);
	return FILTER_OK;
}

int restart_urlgw(void){
    system("killall url_gw 2>/dev/null ; /sbin/url_gw");
    return 0;
}
