#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "PRO_file.h"        //ada

#include "PRO_GetInt.h"
#include "PRO_SetInt.h"
#include "PRO_SetMultiItemStr.h"
#include "logging.h"
#include "lan.h"
#include "wan.h"  //ada

extern void printf_haddr(char * buf, unsigned char * haddr, char separator);
int ReadLogging(log_conf *conf , int logging_poe_session_index)  //ada)
{
	FILE *fp;
	char no[3];   //ada	
	char key[10];  //ada
	
	fp=fopen(SYSCONF,"r");
	if(!fp)
		return -1;
	
	//ada	
	if(logging_poe_session_index>=0&&logging_poe_session_index<MAX_PPPOE_SESSION)
		sprintf(no,"%d",logging_poe_session_index+1);
	else
		no[0]='\0';
	sprintf(key,"%sout_log_en",no);		
	PRO_GetInt(SECTION,key,&(conf->outlog_en),fp);

	sprintf(key,"%saccess_log_en",no);		
	PRO_GetInt(SECTION,key,&(conf->inlog_en),fp);

	sprintf(key,"%sfw_log_en",no);		
	PRO_GetInt(SECTION,key,&(conf->fwlog_en),fp);
	//ada
	fclose(fp);
	return 0;
}

int CheckLogging(log_conf *conf)
{
	if ((conf->outlog_en !=0) && (conf->outlog_en !=1))
		return INVALID_OUTLOG_ENABLE;
	
	if ((conf->inlog_en !=0) && (conf->inlog_en !=1))
		return INVALID_INLOG_ENABLE;
	
	if ((conf->fwlog_en !=0) && (conf->fwlog_en !=1))
		return INVALID_FWLOG_ENABLE;
	
	return 0;
}

int SaveLogging(log_conf *conf , int logging_poe_session_index)
{
	multi_items all_items[3];
	char out[2],in[2],fw[2];
	int ret;
	char no[3];   //ada	
	
	ret=CheckLogging(conf);
	if(ret)
		return ret;
	
	//ada	
	if(logging_poe_session_index>=0&&logging_poe_session_index<MAX_PPPOE_SESSION)
		sprintf(no,"%d",logging_poe_session_index+1);
	else
		no[0]='\0';
	sprintf(all_items[0].key,"%sout_log_en",no);	
	sprintf(out,"%d",conf->outlog_en);
	all_items[0].value=out;
	
	sprintf(all_items[1].key,"%saccess_log_en",no);	
	sprintf(in,"%d",conf->inlog_en);
	all_items[1].value=in;
	
	sprintf(all_items[2].key,"%sfw_log_en",no);		
	sprintf(fw,"%d",conf->fwlog_en);
	all_items[2].value=fw;
	//ada
	ret=PRO_SetMultiItemStr(SECTION,all_items,3,SYSCONF);
	if(ret)
		return ret;
	if((conf->inlog_en==0) && (access(ACCESSLOG,F_OK)==0))
		truncate(ACCESSLOG,0);
	if((conf->outlog_en==0) && (access(FILTERLOG,F_OK)==0))
		truncate(FILTERLOG,0);
	if((conf->fwlog_en==0) && (access(DOSLOG,F_OK)==0))
		truncate(DOSLOG,0);
		
	return 0;
}

void FreeUrlLog(url_list *list)
{
	url_list *p;
	
	p=list;
	while(p){
		list=list->next;
		free(p);
		p=list;
	}
	return;
}

int GetUrlLog(url_list **list,int *url_num)
{
	FILE *fp;
	url_list *p=NULL,*q=NULL;
	char buf[196];
	int ccode=0,num=0,len=0;
	
	fp=fopen(FILTERLOG,"r");
	if(!fp)
		return -1;
	*list=NULL;
	while(fgets(buf,sizeof(buf),fp)){
//		if(strstr(buf,URL_FILTER)){
			p=(url_list *)malloc(sizeof(url_list));
			if(!p){
				ccode=MallocErr;
				FreeUrlLog(*list);
				return ccode;
			}
			memset(p,0,sizeof(url_list));
			strncpy(p->date,buf,6);
			p->date[6]='\0';
			
			strncpy(p->time,buf+7,8);
			p->time[8]='\0';
			
			if (strchr(buf, '\n')) 
				*(strchr(buf, '\n')) = '\0';
			if(strstr(buf,"blocked")){
				strcpy(p->block,"blocked");
				*(strstr(buf,"blocked"))='\0';
			}
			len=strlen(URL_FILTER)+1;
			sscanf(strstr(buf,URL_FILTER)+len,"%s %s",p->saddr,p->host);
			
			if(*list==NULL){
				*list=q=p;
			}
			else{
				q->next=p;
				q=p;
			}
			num++;
//		}
	}
	fclose(fp);
	*url_num=num;
	return ccode;
}

void FreeDosLog(dos_log *log)
{
	dos_log *p;
	
	p=log;
	while(p){
		log=log->next;
		free(p);
		p=log;
	}
	return;
}

int GetDosLog(dos_log **doslog,int *dosnum)
{
	FILE *fp;
	dos_log *p=NULL,*q=NULL;
	char buf[256];
	char *p0,saddr[16],dst[16];
	int in=0,out=0;
	int ccode=0,num=0;
	
	fp=fopen(DOSLOG,"r");
	if(!fp)
		return -1;
	*doslog=NULL;
	while(fgets(buf,sizeof(buf),fp)){
		p=(dos_log *)malloc(sizeof(dos_log));
		if(!p){
			ccode=MallocErr;
			FreeDosLog(*doslog);
			return ccode;
		}
		memset(p,0,sizeof(dos_log));
		
		strncpy(p->time,buf+7,8);
		p->time[8]='\0';
		if (strstr(buf, "LEN=")) 
			*(strstr(buf, "LEN=")) = '\0';
		p0=strstr(buf,"DST=");
		if(p0){
			strcpy(dst,p0+4);
		}
		*p0=0;
		p0=strstr(buf,"SRC=");
		if(p0){
			strcpy(saddr,p0+4);
		}
		*p0=0;
		if (strstr(buf, "MAC=")) 
			*(strstr(buf, "MAC=")) = '\0';
		p0=strstr(buf,"OUT=");
		if(strcmp((p0+4)," ")){
			out=1;
		}
		*p0=0;
		p0=strstr(buf,"IN=");
		if(strcmp((p0+3)," ")){
			in=1;
		}
		
		if((in) && (out))
			strcpy(p->direction,"forward");
		else if(in)
			strcpy(p->direction,"incoming");
		else if(out)
			strcpy(p->direction,"outgoing");
		
		sprintf(p->information,"From %s to %s",saddr,dst);
		strcpy(p->action,"DROP");
		strcpy(p->reason,DOS_FILTER);
		
		if(*doslog==NULL){
			*doslog=q=p;
		}
		else{
			q->next=p;
			q=p;
		}
		num++;
		in=0;
		out=0;
	}
	fclose(fp);
	*dosnum=num;
	return ccode;
}

void FreeAccessLog(access_log *log)
{
	access_log *p;
	
	p=log;
	while(p){
		log=log->next;
		free(p);
		p=log;
	}
}

int GetAccessLog(access_log **accesslog,int *access_num)
{
	FILE *fp;
	access_log *p=NULL,*q=NULL;
	char buf[256];
	char *p0;
	struct in_addr ipaddr;
	PC_DB_CONF_s *p_entry;
	int ccode=0,num=0;
	unsigned char *ip;
	
	fp=fopen(ACCESSLOG,"r");
	if(!fp)
		return -1;
	*accesslog=NULL;
	pc_db_link_init();
	ReadPCDBConf(&pc_db_conf);
	while(fgets(buf,sizeof(buf),fp)){
		p=(access_log *)malloc(sizeof(access_log));
		if(!p){
			ccode=MallocErr;
			FreeAccessLog(*accesslog);
			return ccode;
		}
		memset(p,0,sizeof(access_log));
		
		strncpy(p->date,buf,6);
		p->date[6]='\0';
			
		strncpy(p->time,buf+7,8);
		p->time[8]='\0';
		
		p0=strstr(buf,"DPT=");
		if(p0){
			*strchr(p0,' ')=0;
			p->port=atoi(p0+4);
		}
		p0=strstr(buf,"DST=");
		if(p0){
			*strchr(p0,' ')=0;
			strcpy(p->dst,p0+4);
		}
		*p0=0;
		p0=strstr(buf,"SRC=");
		if(p0){
			*strchr(p0,' ')=0;
			strcpy(p->saddr,p0+4);
		}
		*p0=0;
		inet_aton(p->saddr,&ipaddr);
		ip=(unsigned char *)&(ipaddr.s_addr);
		p0=PCDBGetNameByIP(ip);
		strcpy(p->pcname,p0);
		p_entry=PCDBGetEntry(p->pcname);
		printf_haddr(p->mac,p_entry->mac_addr,':');
		
		if(*accesslog==NULL){
			*accesslog=q=p;
		}
		else{
			q->next=p;
			q=p;
		}
		num++;
	}
	fclose(fp);
	*access_num=num;
	
	return ccode;
}

