#ifndef _LOGGING_H_
#define _LOGGING_H_

#define  URL_MAX_LEN        128
#define  MAX_LOG_NUM		100
typedef struct log_conf{
	int outlog_en;
	int inlog_en;
	int fwlog_en;
}log_conf;

typedef struct url_list{
	char date[8];
	char time[9];
	char saddr[16];
	char host[URL_MAX_LEN];
	char block[8];
	struct url_list *next;
}url_list;

typedef struct dos_log{
	char time[9];
	char direction[10];
	char information[42];
	char action[8];
	char reason[12];
	struct dos_log *next;
}dos_log;

typedef struct access_log{
	char date[8];
	char time[9];
	char pcname[18];
	char saddr[16];
	char dst[16];
	char mac[18];
	int port;
	struct access_log *next;
}access_log;

#define SECTION 	"LOGGING"

#define SYSCONF     "/var/system.conf"
#define FILTERLOG 	"/var/log/filter.log"
#define ACCESSLOG 	"/var/log/access.log"
#define DOSLOG 		"/var/log/dos.log"

#define URL_FILTER 	"URL FILTER"
#define DOS_FILTER	"DOS ATTACK"
#define ACCESS		"DROPPED PACKET"

int ReadLogging(log_conf *conf , int logging_poe_session_index);   //ada
int SaveLogging(log_conf *conf , int logging_poe_session_index);   //ada
void FreeUrlLog(url_list *list);
void FreeDosLog(dos_log *log);
void FreeAccessLog(access_log *log);
int GetUrlLog(url_list **list,int *url_num);
int GetDosLog(dos_log **doslog,int *dosnum);
int GetAccessLog(access_log **accesslog,int *access_num);

#define INVALID_OUTLOG_ENABLE 	1
#define INVALID_INLOG_ENABLE 	2
#define INVALID_FWLOG_ENABLE 	3
#define MallocErr			4

#endif
