#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "h_bmsg.h"
#include "cgi_def.h"
#include "cgi_err.h"

char	err_msg_buf[ERR_MSG_BUF_LEN]={0}; /* buffer for do record error message */
char 	err_msg_fmt[ERR_MSG_FMT_LEN]; /* tmp buffer for format error message */

//---------------------------------------------------------------
// purpose: get_err_msg do get error message from error message list
//			according to msg_no
// input: msg_no  - index of error message list,defined in h_bmsg.h
// ouput: return error message buffer, NULL to fail
// note : when error occur,you can do it,then must do fmt_err_msg,
//		  it will copy format buffer to gloabl err_msg_buf
//---------------------------------------------------------------
char *get_err_msg(int msg_no)
{
	FILE *fp;
	int i,len;

	fp=fopen("err_msg.list","r");
	if(fp==NULL)
		return NULL;
	if(msg_no<0 ||msg_no >= MESSAGE_LIST_SIZE)
		return NULL;
	for(i=0;i<=msg_no;i++)
		fgets(err_msg_fmt ,ERR_MSG_FMT_LEN,fp);
	if((len=strlen(err_msg_fmt))>0){
		if(err_msg_fmt[len-1]==0x0A)
			err_msg_fmt[len-1]='\0';/* remove 0A */
	}
	fclose(fp);
	return err_msg_fmt;
}

//---------------------------------------------------------------
// purpose: fmt_err_msg do format error message
// input: format  - string buffer pointer from get_err_msg,
//		  ... - alterable args like sprintf
// ouput: none
// note : you can do fmt_err_msg only when no doing get_err_msg,
//---------------------------------------------------------------
void fmt_err_msg(char *format, ...)
{
	va_list args;

	int i,len=strlen(err_msg_buf);
	if(!format)
		return;
	for(i=0;format[i]!='\0';i++){
		if(i>0&&(format[i-1]=='\\')&&(format[i]=='n')){
			/* chage "\n" to 0x0D 0x0A */
			format[i-1]=0x0D;
			format[i]=0x0A;
		}
	}
	if(strlen(format)<(ERR_MSG_BUF_LEN-len)){
		va_start(args, format);
	    vsnprintf(err_msg_buf + len,ERR_MSG_BUF_LEN-len, format, args);
	    va_end(args);
	}
	else{
		memcpy(err_msg_buf + len,format,ERR_MSG_BUF_LEN-len);
	}
    err_msg_buf[ERR_MSG_BUF_LEN-1]='\0';
    return;
}

//---------------------------------------------------------------
// purpose: set_err_msg do cpoy current error message buffer to buf
// input: buf  - string buffer pointer from get_err_msg,
//		  buf1 - if buf overflow, can malloc new buffer to it,
//				 but now we ignore it, we guess the error message
//				 buffer length must less than CGI_BUF_LEN
// ouput: none
// note: r2t_message may(or must) do set_err_msg
//---------------------------------------------------------------
void set_err_msg(char buf[CGI_BUF_LEN],char **buf1)
{
	int len=CGI_BUF_LEN-1;
	if(strlen(err_msg_buf)<CGI_BUF_LEN)
		len=strlen(err_msg_buf);

	memcpy(buf,err_msg_buf,len);
	buf[len]='\0';
	memset(	err_msg_buf, 0, ERR_MSG_BUF_LEN);
}
