#ifndef _ROUTING_H_
#define _ROUTING_H_

#define	MaxIPLen			16
#define MAX_ROUTE_NUM		20
#define MAX_ROUTE_LEN  		100

typedef struct rt_table{
	char ipaddr[MaxIPLen];
	char netmask[MaxIPLen];
	char gateway[MaxIPLen];
	int metric;
	struct rt_table *next;
}rt_table;


#define Route_Section 	"ROUTING"
#define RIP_ENABLE			"rip_enable"
#define RTLIST_KEY			"rtlist="

#define RT_LIST 	"/var/rt_list"

#define ReadRoutingConfErr 	-1
#define	GetRtListErr		1
#define AddRtListErr		2
#define DelRtListErr		3
#define MallocMemErr		4

int GetRtList(rt_table **table,int *routenum);
void FreeRtList(rt_table *table);
int ReadRipEnable(int *rip_enable);
int SaveRipEnable(int rip_enable);
int AddRtList(char *addr,char *mask,char *gateway, int metric,int n);
int DelRtList(char *addr,char *mask,char *gateway,int metric);

int GetAllRoute(rt_table **rttable,int *rtnum);
int InitRoute(void);

#endif
