#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "schling.h"
#include <signal.h>

static char *days[] ={
		"0",//none
		"1",//Monday
		"2",//Tuesday
		"3",//Wenseday
		"4",//Thurseday
		"5",//Friday
		"6",//Saturday
		"7",//Sunday
		"1-5",	//weekdays
		"*"	//everydays
  	};

static char *all_action[]={
	"/sbin/smtpc",
};
#define CRONTAB "/var/crontab"
//#define _DEBUG_

int Schl_Add(Schl_Act * sheditem, int schltype)
{
	FILE *fp, *tfp;
	char buf[256],buf1[168];
	char schtmpfile[]="/tmp/tmp.XXXXXX";
	int ret,fd;

   fp = fopen(CRONTAB,"r");
   if (fp == NULL)
		return SCHL_ERR_READ_FILE;

	fd=mkstemp(schtmpfile);
   	if(fd==-1){
		fclose(fp);
		return SCHL_ERR_READ_FILE;
	}
	close(fd);
	tfp = fopen(schtmpfile,"w");
	if (tfp == NULL)
		return SCHL_ERR_READ_FILE;

	if(schltype==SCHL_TYP_WEEKLY)   {
		switch(sheditem->task)
		{
			case SCHL_EMAIL:
				sprintf(buf1,"%d %d * * %s root %s %s &>/dev/null \n",
					sheditem->min,sheditem->hour,days[sheditem->date],
						all_action[SCHL_EMAIL],sheditem->tsk_para?sheditem->tsk_para:"");
			break;

			default:
				return SCHL_ERR_INPUT;
			break;

		}
	}
   else
   {

   	switch(sheditem->task)
		{

			default:
				return SCHL_ERR_INPUT;
			break;
		}
	}

   while(fgets(buf,256,fp))
   {
      if(strncmp(buf,buf1,strlen(buf1))==0)
      {
	      fclose(fp);
	      fclose(tfp);
	      unlink(schtmpfile);
         return SCHL_ERR_DUPLCATE_TASK;
      }
      fputs(buf,tfp);
   }

	fputs(buf1,tfp);

	fclose(fp);
  	fclose(tfp);

  	sprintf(buf,"/bin/cp -f %s %s.bak >/dev/null",CRONTAB,CRONTAB);
#ifdef _DEBUG_
printf("content:(for add function) is %s\n",buf);
#endif
  	system(buf);
	sync();
  	unlink(CRONTAB);
	sync();
	sprintf(buf,"/bin/cp -f %s %s >/dev/null",schtmpfile,CRONTAB);
	ret=system(buf);
	sync();
  	unlink(schtmpfile);
  	sync();
#ifdef _DEBUG_
printf("return:(for rename function) is %d\n",ret);
#endif
  	return ret;

}

int Schl_Del(int type)
{
	FILE *fp,*tfp;
	char schtmpfile[]="/tmp/XXXXXX";
	char buf[256],buftmp[128];
	int ret,fd;

  	fp = fopen(CRONTAB,"r");
  	if (fp == NULL)
     		return SCHL_ERR_READ_FILE;

	fd=mkstemp(schtmpfile);
	if(fd==-1){
		fclose(fp);
     	return SCHL_ERR_READ_FILE;
	}
     close(fd);

  	tfp = fopen(schtmpfile,"w");
  	if (tfp == NULL)
     		return SCHL_ERR_READ_FILE;

 	sprintf(buftmp,"%s",all_action[type]);
  	while(fgets(buf,sizeof(buf),fp))
  	{
		if (strstr(buf,buftmp))
    			continue;
    	fputs(buf,tfp);
  	}
  	fclose(fp);
  	fclose(tfp);

  	sprintf(buf,"/bin/cp -f %s %s.bak >/dev/null",CRONTAB,CRONTAB);
#ifdef _DEBUG_
printf("content:(for del function) is %s\n",buf);
#endif
  	system(buf);
	sync();
  	unlink(CRONTAB);
	sync();
	sprintf(buf,"/bin/cp -f %s %s >/dev/null",schtmpfile,CRONTAB);
	ret=system(buf);
	sync();
  	unlink(schtmpfile);
	sync();
#ifdef _DEBUG_
printf("return:(for del function) is %d\n",ret);
#endif
  	return ret;
}

int Schl_Start (void)
{
	return system("/sbin/crond &>/dev/null");
}

int Schl_Stop (void )
{
	return system("/bin/killall crond &>/dev/null");
}

int Schl_Restart(void)
{
	Schl_Stop();
	return Schl_Start();
}
