#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "PRO_file.h"
#include "PRO_GetStr.h"
#include "PRO_SetStr.h"
#include "PRO_GetInt.h"
#include "PRO_SetInt.h"
#include "PRO_SetMultiItemStr.h"
#include "techsupp.h"
#include "system.h"
#include "wan.h"
#include "h_var.h"

#define SYSCONF "/var/system.conf"

int ReadTechsuppConf(techsupp_conf *conf, int poe_acc_index){
	FILE *fp;
	char ip[16],wan_mac[18];  //ada
	char no[3]; 	
	char key[20];
	
	if(!conf)
		return -1;	 
	
	fp=fopen(SYSCONF,"rt");
	if(!fp)
		return -1;
		
	PRO_GetStr(Section,"ts1ip",ip,16,fp);
	extract_ip(ip,conf->ts1ip);	
	PRO_GetStr(Section,"ts2ip",ip,16,fp);
	extract_ip(ip,conf->ts2ip);	
	PRO_GetStr(Section,"ts3ip",ip,16,fp);
	extract_ip(ip,conf->ts3ip);	

	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';

	sprintf(key,"%soverridesetting",no);
	PRO_GetInt(Section,key,&(conf->overridesetting),fp);
	
	sprintf(key,"%shmark",no);	
	PRO_GetInt(Section,key,&(conf->hmark),fp);
	
	sprintf(key,"%slmark",no);
	PRO_GetInt(Section,key,&(conf->lmark),fp);	
	
	sprintf(key,"%smaxsession",no);
	PRO_GetInt(Section,key,&(conf->maxsession),fp);	
	
	sprintf(key,"%sblockenable",no);
	PRO_GetInt(Section,key,&(conf->blockenable),fp);	
	
	sprintf(key,"%sblocktime",no);
	PRO_GetInt(Section,key,&(conf->blocktime),fp);	

/*	sprintf(key,"%smac",no);	
	PRO_GetStr(Section,key,wan_mac,18,fp);
	extract_mac(wan_mac,conf->mac);*/
	PRO_GetStr(Section,"mac",wan_mac,18,fp);
	extract_mac(wan_mac,conf->mac);
			
	fclose(fp);
	return 0;
}

int CheckTechsuppConf(techsupp_conf *conf)
{
	if((conf->overridesetting !=0) && (conf->overridesetting !=1))
		return INVALID_OVERRIDESETTING;

	if((conf->blockenable !=0) && (conf->blockenable !=1))
		return INVALID_BLOCKENABLE;
	if(!check_mac(conf->mac))
		return INVALID_WAN_MAC;
	return 0;
}

int SaveTechsuppConf(techsupp_conf *conf, int poe_acc_index){
	multi_items all_items[10];
	char ts1[16],ts2[16],ts3[16],override[2],high[4],low[4],max[4],block[2],time[4],wan_mac[18];//ada
	int ret;
	char no[3];   
	ret=CheckTechsuppConf(conf);
	if(ret)
		return ret;
		
	strcpy(all_items[0].key,"ts1ip");	
	sprintf(ts1,"%d.%d.%d.%d",conf->ts1ip[0],conf->ts1ip[1],conf->ts1ip[2],conf->ts1ip[3]);
	all_items[0].value=ts1;

	strcpy(all_items[1].key,"ts2ip");
	sprintf(ts2,"%d.%d.%d.%d",conf->ts2ip[0],conf->ts2ip[1],conf->ts2ip[2],conf->ts2ip[3]);
	all_items[1].value=ts2;
	
	strcpy(all_items[2].key,"ts3ip");
	sprintf(ts3,"%d.%d.%d.%d",conf->ts3ip[0],conf->ts3ip[1],conf->ts3ip[2],conf->ts3ip[3]);
	all_items[2].value=ts3;		
	
	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';

	sprintf(all_items[3].key,"%soverridesetting",no);
	sprintf(override,"%d",conf->overridesetting);
	all_items[3].value=override;

	sprintf(all_items[4].key,"%shmark",no);
	sprintf(high,"%d",conf->hmark);
	all_items[4].value=high;

	sprintf(all_items[5].key,"%slmark",no);
	sprintf(low,"%d",conf->lmark);
	all_items[5].value=low;

	sprintf(all_items[6].key,"%smaxsession",no);
	sprintf(max,"%d",conf->maxsession);
	all_items[6].value=max;

	sprintf(all_items[7].key,"%sblockenable",no);
	sprintf(block,"%d",conf->blockenable);
	all_items[7].value=block;

	sprintf(all_items[8].key,"%sblocktime",no);
	sprintf(time,"%d",conf->blocktime);
	all_items[8].value=time;
	
/*	sprintf(all_items[9].key,"%smac",no);
	sprintf(wan_mac,"%02x:%02x:%02x:%02x:%02x:%02x",
        	(unsigned char)conf->mac[0],(unsigned char)conf->mac[1],(unsigned char)conf->mac[2],(unsigned char)conf->mac[3],(unsigned char)conf->mac[4],(unsigned char)conf->mac[5]);
	all_items[9].value=wan_mac;*/
        strcpy(all_items[9].key,"mac");
	sprintf(wan_mac,"%02x:%02x:%02x:%02x:%02x:%02x",
        	(unsigned char)conf->mac[0],(unsigned char)conf->mac[1],(unsigned char)conf->mac[2],(unsigned char)conf->mac[3],(unsigned char)conf->mac[4],(unsigned char)conf->mac[5]);
	all_items[9].value=wan_mac;  

	ret=PRO_SetMultiItemStr(Section,all_items,10,SYSCONF);

	if(ret)
	{ 	       
		return ret;
	} 	       
	return 0;
}


