// UNZIP.H - Unzip code bastardized from Erwins hack of gzip

#ifndef __UNZIP_H
#define __UNZIP_H
#include "upgrade.h"

typedef unsigned char  uch;
typedef unsigned short ush;
typedef unsigned long  ulg;
typedef void *voidp;
#define memzero(s, n)     memset ((voidp)(s), 0, (n))



typedef struct __attribute__((packed)) {
    DWORD      dwSignature;  // 0
    WORD          wVersion;  // 4
    WORD   wGeneralPurpose;  // 6
    WORD           wMethod;  // 8
    WORD             wTime;  // 10
    WORD             wDate;  // 12
    DWORD            dwCrc;  // 14
    DWORD       dwCompSize;  // 18
    DWORD     dwUncompSize;  // 22
    WORD   wFilenameLength;  // 26
    WORD      wExtraLength;  // 28
    BYTE         bFilename;  // 30
} ZIPHEADER;

/* Huffman code lookup table entry--this entry is four bytes for machines
   that have 16-bit pointers (e.g. PC's in the small or medium model).
   Valid extra bits are 0..13.  e == 15 is EOB (end of block), e == 16
   means that v is a literal, 16 < e < 32 means that v is a pointer to
   the next table, which codes e - 16 bits, and lastly e == 99 indicates
   an unused code.  If a code with e == 99 is looked up, this implies an
   error in the data. */
struct huft {
  uch e;                /* number of extra bits or operation */
  uch b;                /* number of bits in this code or subcode */
  union {
    ush n;              /* literal, length base, or distance base */
    struct huft *t;     /* pointer to next level of table */
  } v;
};

// Input and output files
extern FILE*   fin;
extern FILE*   fout;

// Procedure prototypes

//    int UnZip(const char* inname, unsigned long offset, const char* outname);
	int unzip(const char**data, unsigned long offset,unsigned long size,int uptype);

	int inflate();
	int inflate_block(int* e);
	int inflate_dynamic();
	int inflate_fixed();
	int inflate_stored();
	int inflate_codes(struct huft* tl, struct huft* td, int bl, int bd);
	int huft_free(struct huft *t);
	int huft_build(unsigned *b, unsigned n, unsigned s, ush *d, ush *e, struct huft **t, int *m);
	ulg updcrc(uch *s,unsigned n);
	void write_buffer(voidp buf, unsigned int);
	void flush_window();
	int get_byte();

#endif // __UNZIP_H

//[EOF]
