#include <stdio.h>
#include <netinet/in.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include "upgrade.h"

int 	erraseall_flag=1;//if (erraseall_flag) erase all

int check_updata(const char **data,int uptype)
{
//	int i;
	int fd;
	char buf[PID_STRUCT_LEN];	
	const PID_S *pImgPID,*pMtdPID;
	char *start=NULL;
	
	if(!data)
		return -1;
		
	/* check PID */
//    if(uptype == THTTP_UPGRADE){
//        if ((start=strstr(&data[0][0], "Content-Disposition")) == NULL) {
//            return -1; 
//        }
//	    while(  (*(start + 0) != 0x0d) ||
//		        (*(start + 1) != 0x0a) ||
//		        (*(start + 2) != 0x0d) ||
//		        (*(start + 3) != 0x0a)) {
//		/* find the first 0d0a pair */
//		    start++;
//	    }
//
//    	start+=4;
//    	pImgPID=(const PID_S *)start;
//    }
//    else if(uptype == TFTP_UPGRADE){
    	pImgPID=(const PID_S *)&data[0][0];
//    }
	
/*	printf("pImgPID->version_control=0x%x,pImgPID->protocol_id=0x%x,pImgPID->download_flag=0x%x\n",
		ntohl(pImgPID->version_control),ntohs(pImgPID->protocol_id),ntohs(pImgPID->download_flag));
	printf("pImgPID->hw_id=0x");
	for(i=0;i<32;i++){
		printf("%x",pImgPID->hw_id[i]);
	}
	printf("\npImgPID->signature=");
	for(i=0;i<7;i++){
		printf("%c",pImgPID->signature[i]);
	}	
	printf("\n");
*/	
	fd=open("/dev/mtd0",O_RDONLY);
	if(fd<0){
		if(uptype==TFTP_UPGRADE || uptype == THTTP_UPGRADE){
			printf("open mtd0 error\n");
		}		
		return -1;
	}
	lseek(fd,PID_OFFSET,SEEK_SET);
	if(read(fd,buf,PID_LEN)!=PID_LEN){
		close(fd);
		if(uptype==TFTP_UPGRADE || uptype == THTTP_UPGRADE)
			printf("read mtd0 error\n");
		return -1;
	}
	pMtdPID=(PID_S *)buf;
	close(fd);
/*	
	printf("pMtdPID->version_control=0x%x,pMtdPID->protocol_id=0x%x,pMtdPID->download_flag=0x%x\n",
		(pMtdPID->version_control),(pMtdPID->protocol_id),(pMtdPID->download_flag));
	printf("pMtdPID->hw_id=0x");
	for(i=0;i<32;i++){
		printf("%x",pMtdPID->hw_id[i]);
	}	
	printf("\n");
*/		

    if ( CheckPID(pImgPID,pMtdPID) != CHECK_SUCCESS ) { /* Check PID fail. */
        return -1;
    }
    
#if 0
	/* check signature */
	if(memcmp(pImgPID->signature,PID_SIGNATURE,7))
		return -1;
	/* check hw id */
	if(memcmp(pImgPID->hw_id,pMtdPID->hw_id,6)) /* Only check the first 6 bytes is OK. */
		return -1;		

	/* check product id */
	if(ntohs(pImgPID->protocol_id) !=pMtdPID->protocol_id)
		return -1;	
#endif /* #if 0 */

	/* check erase all flag */
	if (ntohs(pImgPID->download_flag)==PID_DOWNLOAD_FLAG){
		erraseall_flag = 1;
	}
	else{
	    erraseall_flag = 0;
	}
	return 0;

}

/****************************************************************************
 * FUNCTION   :  CheckPID()                                                 *
 *                                                                          *
 * INPUT      :  pImgPID ==> PID point to image file.                       *
 *               pMtdPID ==> PID point to flash.                            *
 *                                                                          *
 * OUTPUT     :  CHECK_SUCCESS       ==>    OK, you can upgrade.            *
 *               CHECK_SIG_FAIL      ==>    Singal dismatch.                *
 *               CHECK_VER_FAIL      ==>    PID version dismatch.           *
 *               CHECK_HW_FAIL       ==>    HW id dismatch.                 *
 *               CHECK_PRODUCT_FAIL  ==>    Product id dismatch.            *
 *               CHECK_FUNC_FAIL     ==>    Function id dismatch.           *
 *               CHECK_PROTO_FAIL    ==>    Protocol id dismatch.           *
 *               CHECK_ERROR         ==>    Unknown Error                   *
 ****************************************************************************/
int CheckPID(const PID_S *pImgPID , const PID_S *pMtdPID){
    int result=0;
        
    if(!pImgPID || !pMtdPID){
        result = CHECK_ERROR;
        goto return_lable;
    }
    
	/* check signature */
	if(memcmp(pImgPID->signature,PID_SIGNATURE,7)){
	    result = CHECK_SIG_FAIL;
	    goto return_lable;
	}
	
    switch (ntohs(pMtdPID->version_control)) {
    case 0x01:
        if (memcmp(pMtdPID->hw_id,pImgPID->hw_id,6)) {
            result = CHECK_HW_FAIL;
            goto return_lable;
        }
        break;
    case 0x02:
        if (pMtdPID->version_control != pImgPID->version_control){
            result = CHECK_VER_FAIL;
            goto return_lable;
        }        
        
        if (pMtdPID->upgrade_control == 0){ /* No need to check anything. */
            result = CHECK_SUCCESS;
            goto return_lable;
        }
        
        if (pMtdPID->upgrade_control & BIT_PCBA){
            if (memcmp(pMtdPID->hw_id,pImgPID->hw_id,32)) {
                result = CHECK_HW_FAIL;
                goto return_lable;
           }
        }
                
        if (pMtdPID->upgrade_control & BIT_FUNC_ID){
            if (memcmp(pMtdPID->function_id,pImgPID->function_id,6)) {
                result = CHECK_FUNC_FAIL;
                goto return_lable;
            }
        }
        
        if (pMtdPID->upgrade_control & BIT_PROD_ID){
            if (pMtdPID->product_id != pImgPID->product_id) {
                result = CHECK_PRODUCT_FAIL;
                goto return_lable;
            }
        }
        
        if (pMtdPID->upgrade_control & BIT_PROT_ID){
            if (pMtdPID->protocol_id != pImgPID->protocol_id) {
                result = CHECK_PROTO_FAIL;
                goto return_lable;
            }
        }        
        break;
     default:
        result = CHECK_ERROR;
        goto return_lable;
    }

return_lable:
    return result;
}

