#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <time.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <signal.h>
#include "PRO_file.h"
#include "PRO_GetStr.h"
#include "PRO_GetInt.h"
#include "PRO_SetStr.h"
#include "PRO_SetMultiItemStr.h"
#include "wan.h"
#include "h_var.h"
#include <arpa/inet.h>
#include "system.h"
#include "mkdnsconf.h"
#include "mkpoeconf.h"
#include "dev_opt.h"
#include "lan.h"
#include "fw.h"

SINGLE_PPPOE_CONF single_pppoe_conf;
DHCP_CONF dhcp_conf;
#ifdef _WAN_MODEM_
MODEM_CONF mdm_conf;
#endif
LOCAL_CONF local_conf; //ada

extern int mkdnsconf_main(void);
extern int mkpoeconf_main(void);

/*
 * purpose: ingnore the space from IP address(ascii mod)
 * input: sstr - the src string
 * 	  len - src string len
 * output: dstr - dest string
 */
void omitIpSpace(char *dstr,char *sstr,int len)
{
	int i,j;

	j = 0;
	for(i = 0;i<len;i++){
		if(sstr[i] == ' ' )
			continue;
		else
			dstr[j++] = sstr[i];
	}
	dstr[j] = '\0';
}

#ifdef _MULTI_PPPOE_
static char MultiPPPoESection[]="Multi PPPoE";
int ReadMultiPPPoESettings(MULTI_PPPOE_CONF *pMConf)
{
	FILE *fh;
	char key[32];
	char ip[16];
	int i;
	PPPOE_CONF *pConf;
	if(!pMConf)
		return WAN_ReadPPPoEErr;
	
	fh=fopen(SYSCONF,"rt");
	if(!fh)
		return WAN_ReadWANConfErr;
	rewind(fh);


	
	for(i=0; i<MAX_PPPOE_SESSION; i++){
		sprintf(key,"poe_session_%d",i);
		PRO_GetInt(MultiPPPoESection,key,(int *)&(pMConf->session[i]),fh);
	}
	
	for(i=0; i<MAX_PPPOE_ACCOUNT; i++){
		pConf=&pMConf->account[i];
		
		sprintf(key,"poe_ac_name_%d",i);
		PRO_GetStr(MultiPPPoESection,key,pConf->poe_ac_name,WAN_MaxACNameLen,fh);
	
		sprintf(key,"poe_conn_type_%d",i);
		PRO_GetInt(MultiPPPoESection,key,(int *)&pConf->conn_type,fh);
	
		sprintf(key,"poe_user_%d",i);
		PRO_GetStr(MultiPPPoESection,key,pConf->poe_user,WAN_MaxUserLen,fh);
	
		sprintf(key,"poe_pass_%d",i);
		PRO_GetStr(MultiPPPoESection,key,pConf->poe_pass,WAN_MaxPassLen,fh);
	
		sprintf(key,"poe_idle_%d",i);
		PRO_GetInt(MultiPPPoESection,key,(int *)&pConf->poe_idle,fh);
	
		sprintf(key,"poe_lan_type_%d",i);
		PRO_GetInt(MultiPPPoESection,key,(int *)&(pConf->poe_lan_type),fh);
	
		sprintf(key,"poe_udp_en_%d",i);
		PRO_GetInt(MultiPPPoESection,key,(int *)&(pConf->poe_udp),fh);
	
		sprintf(key,"poe_udp_len_%d",i);
		PRO_GetInt(MultiPPPoESection,key,(int *)&pConf->poe_udp_len,fh);
	
		sprintf(key,"poe_dns_type_%d",i);
		PRO_GetInt(MultiPPPoESection,key,(int *)&(pConf->poe_dns_type),fh);
	
		sprintf(key,"poe_traffic_%d",i);
		PRO_GetInt(MultiPPPoESection,key,(int *)&(pConf->poe_traffic),fh);
	
		sprintf(key,"poe_netbios_%d",i);
		PRO_GetInt(MultiPPPoESection,key,(int *)&(pConf->poe_netbios),fh);
	
		sprintf(key,"poe_dns1_%d",i);
		PRO_GetStr(MultiPPPoESection,key,ip,16,fh);
		extract_ip(ip,(unsigned char *)&pConf->poe_dns_1);
	
		sprintf(key,"poe_dns2_%d",i);
		PRO_GetStr(MultiPPPoESection,key,ip,16,fh);
		extract_ip(ip,(unsigned char *)&pConf->poe_dns_2);
	
		sprintf(key,"poe_ip_%d",i);
		PRO_GetStr(MultiPPPoESection,key,ip,16,fh);
		extract_ip(ip,(unsigned char *)&pConf->poe_ip);
	
		sprintf(key,"poe_mask_%d",i);
		PRO_GetStr(MultiPPPoESection,key,ip,16,fh);
		extract_ip(ip,(unsigned char *)&pConf->poe_mask);

	}
	fclose(fh);
	return WAN_OK;
}

int CheckMultiPPPoESettings(MULTI_PPPOE_CONF *pConf, int no)
{

	return WAN_OK;

}


int SaveMultiPPPoESettings(MULTI_PPPOE_CONF *pMConf, int no)
{
	multi_items	all_items[PC_ITEM_NUM+MAX_PPPOE_SESSION];
	char ip[16],mask[16],dns_1[16],dns_2[16],udp_len[8],session[MAX_PPPOE_SESSION][3];
	char conn_type[2], idle[8], lan_type[2], udp[2],dns_type[2], traffic[2], netbios[2];
	int ret,i;
	unsigned char* p;
	PPPOE_CONF *pConf;
        if(!pMConf  || no< 0 || no>MAX_PPPOE_ACCOUNT)
		return WAN_SavePPPoEErr;
	pConf=&pMConf->account[no];
	ret=CheckMultiPPPoESettings(pMConf,no);
	if(ret){
		return ret;
	}


	sprintf(all_items[PC_AC_NAME].key,"poe_ac_name_%d",no);
	all_items[PC_AC_NAME].value=pConf->poe_ac_name;

	sprintf(all_items[PC_CONN_TYPE].key,"poe_conn_type_%d",no);
	sprintf(conn_type,"%d",pConf->conn_type);
	all_items[PC_CONN_TYPE].value=conn_type;

	sprintf(all_items[PC_USER].key,"poe_user_%d",no);
	all_items[PC_USER].value=pConf->poe_user;

	sprintf(all_items[PC_PASS].key,"poe_pass_%d",no);
	all_items[PC_PASS].value=pConf->poe_pass;

	sprintf(all_items[PC_IDLE].key,"poe_idle_%d",no);
	sprintf(idle,"%d",pConf->poe_idle);
	all_items[PC_IDLE].value=idle;

	sprintf(all_items[PC_LAN_TYPE].key,"poe_lan_type_%d",no);
	sprintf(lan_type,"%d",pConf->poe_lan_type);
	all_items[PC_LAN_TYPE].value=lan_type;

	sprintf(all_items[PC_UDP].key,"poe_udp_en_%d",no);
	sprintf(udp,"%d",pConf->poe_udp);
	all_items[PC_UDP].value=udp;

	sprintf(all_items[PC_UDP_LEN].key,"poe_udp_len_%d",no);
	sprintf(udp_len,"%d",pConf->poe_udp_len);
	all_items[PC_UDP_LEN].value=udp_len;

	sprintf(all_items[PC_DNS_TYPE].key,"poe_dns_type_%d",no);
	sprintf(dns_type,"%d",pConf->poe_dns_type);
	all_items[PC_DNS_TYPE].value=dns_type;

	sprintf(all_items[PC_TRAFFIC].key,"poe_traffic_%d",no);
	sprintf(traffic,"%d",pConf->poe_traffic);
	all_items[PC_TRAFFIC].value=traffic;

	sprintf(all_items[PC_NETBIOS].key,"poe_netbios_%d",no);
	sprintf(netbios,"%d",pConf->poe_netbios);
	all_items[PC_NETBIOS].value=netbios;

	p=(unsigned char *)&pConf->poe_dns_1;
	sprintf(all_items[PC_DNS1].key,"poe_dns1_%d",no);
	sprintf(dns_1,"%u.%u.%u.%u",*p,*(p+1),*(p+2),*(p+3));
	all_items[PC_DNS1].value=dns_1;
	
	p=(unsigned char *)&pConf->poe_dns_2;
	sprintf(all_items[PC_DNS2].key,"poe_dns2_%d",no);
	sprintf(dns_2,"%u.%u.%u.%u",*p,*(p+1),*(p+2),*(p+3));
	all_items[PC_DNS2].value=dns_2;

	p=(unsigned char *)&pConf->poe_ip;
	sprintf(all_items[PC_IP].key,"poe_ip_%d",no);
	sprintf(ip,"%u.%u.%u.%u",*p,*(p+1),*(p+2),*(p+3));
	all_items[PC_IP].value=ip;
	
	p=(unsigned char *)&pConf->poe_mask;
	sprintf(all_items[PC_MASK].key,"poe_mask_%d",no);
	sprintf(mask,"%u.%u.%u.%u",*p,*(p+1),*(p+2),*(p+3));
	all_items[PC_MASK].value=mask;
	
	for(i=0; i<MAX_PPPOE_SESSION; i++){
		sprintf(all_items[PC_ITEM_NUM+i].key,"poe_session_%d",i);
		sprintf(session[i],"%d",pMConf->session[i]);
		all_items[PC_ITEM_NUM+i].value=session[i];
	}
	ret=PRO_SetMultiItemStr(MultiPPPoESection,all_items,PC_ITEM_NUM+MAX_PPPOE_SESSION, SYSCONF);
	if(ret){
		return WAN_SavePPPoEErr;
	}
	
	return WAN_OK;
}

int get_session_from_account(int account_no)
{
	MULTI_PPPOE_CONF mpoe_conf;
	int i;
	ReadMultiPPPoESettings(&mpoe_conf);	
	for(i=0; i<MAX_PPPOE_SESSION; i++){
		if(account_no==mpoe_conf.session[i]){
			return i;
		}
	}
	return -1;
}
int get_account_from_session(int session_no)
{
	MULTI_PPPOE_CONF mpoe_conf;
	if(session_no>=0&&session_no<MAX_PPPOE_SESSION){
		ReadMultiPPPoESettings(&mpoe_conf);
		return mpoe_conf.session[session_no];
	}
	return -1;
}

#define TrfIPSection "TRF_IP"
int ReadTrfIPSettings(TRF_IP_CONF *pConf, int poe_acc_index)
{
	FILE *fh;
	char key[20],value[30],*p;
	int i;
	if(!pConf||poe_acc_index<0||poe_acc_index>=MAX_PPPOE_ACCOUNT)
		return WAN_ReadTrfIPErr;
	fh=fopen(SYSCONF,"rt");
	if(!fh)
		return WAN_ReadTrfIPErr;
	memset(pConf,0,sizeof(TRF_IP_CONF));
	
	sprintf(key,"%dtrf_ip_num",poe_acc_index);
	PRO_GetInt(TrfIPSection,key,(int *)&pConf->trf_ip_num,fh);
	pConf->trf_ip_num=(pConf->trf_ip_num>MAX_TRF_IP)?MAX_TRF_IP:pConf->trf_ip_num;
	
	sprintf(key,"%dtrf_ip_set",poe_acc_index);
	PRO_GetInt(TrfIPSection,key,(int *)&pConf->trf_ip_set,fh);

	for(i=0; i<MAX_TRF_IP; i++){
		value[0]='\0';
		sprintf(key,"%dtrf_ip%d",poe_acc_index,i);
		PRO_GetStr(TrfIPSection,key,value,30,fh);
		if(!*value)
			continue;
		if((p=strchr(value,'-'))!=NULL){
			*p='\0';
			pConf->trf_ip[i].type=TRF_IP_TYPE_RANGE;
			pConf->trf_ip[i].ip_end=atoi(p+1);
		}else if((p=strchr(value,'/'))!=NULL){
			*p='\0';
			pConf->trf_ip[i].type=TRF_IP_TYPE_MASK;			
			pConf->trf_ip[i].mask=atoi(p+1);
		}else
			pConf->trf_ip[i].type=TRF_IP_TYPE_SINGLE;			
		extract_ip(value,(unsigned char *)&pConf->trf_ip[i].ip);
	}
	
	fclose(fh);
	return WAN_OK;
}

int SaveTrfIPSettings(TRF_IP_CONF *pConf, int poe_acc_index)
{
	multi_items	all_items[2+MAX_TRF_IP];
	char num[3],set[10],trf_ip[MAX_TRF_IP][25];
	int i;
	if(!pConf||poe_acc_index<0||poe_acc_index>=MAX_PPPOE_ACCOUNT)
		return WAN_SaveTrfIPErr;
		
	sprintf(all_items[0].key,"%dtrf_ip_num",poe_acc_index);
	sprintf(num,"%d",pConf->trf_ip_num);
	all_items[0].value=num;
	
	sprintf(all_items[1].key,"%dtrf_ip_set",poe_acc_index);
	sprintf(set,"%d",pConf->trf_ip_set);
	all_items[1].value=set;	
	
	for(i=0; i<MAX_TRF_IP; i++){
		sprintf(all_items[2+i].key,"%dtrf_ip%d",poe_acc_index,i);	
		if(!pConf->trf_ip[i].ip)
			trf_ip[i][0]='\0';
		else{	
			switch(pConf->trf_ip[i].type){
			case TRF_IP_TYPE_RANGE:
				sprintf(trf_ip[i],"%s-%d", inet_ntoa(*(struct in_addr *)&(pConf->trf_ip[i].ip)),pConf->trf_ip[i].ip_end);
				break;
			case TRF_IP_TYPE_MASK:
				sprintf(trf_ip[i],"%s/%d", inet_ntoa(*(struct in_addr *)&(pConf->trf_ip[i].ip)),pConf->trf_ip[i].mask);
				break;	
			case TRF_IP_TYPE_SINGLE:
			default:
				sprintf(trf_ip[i],"%s", inet_ntoa(*(struct in_addr *)&(pConf->trf_ip[i].ip)));		
				break;			
			}
		}
		all_items[2+i].value=trf_ip[i];			
	}
	if(PRO_SetMultiItemStr(TrfIPSection,all_items,2+MAX_TRF_IP, SYSCONF))
		return WAN_SaveTrfIPErr;
	return WAN_OK;	
}

#define TrfURLSection "TRF_URL"
int ReadTrfURLSettings(TRF_URL_CONF *pConf, int poe_acc_index)
{
	FILE *fh;
	char key[20];
	int i;
	if(!pConf||poe_acc_index<0||poe_acc_index>=MAX_PPPOE_ACCOUNT)
		return WAN_ReadTrfURLErr;
	fh=fopen(SYSCONF,"rt");
	if(!fh)
		return WAN_ReadTrfURLErr;
	memset(pConf,0,sizeof(TRF_URL_CONF));
	
	sprintf(key,"%dtrf_url_num",poe_acc_index);
	PRO_GetInt(TrfURLSection,key,(int *)&pConf->trf_url_num,fh);
	
	sprintf(key,"%dtrf_url_set",poe_acc_index);
	PRO_GetInt(TrfURLSection,key,(int *)&pConf->trf_url_set,fh);	
	
	for(i=0; i<MAX_TRF_URL; i++){
		sprintf(key,"%dtrf_url%d",poe_acc_index,i);
		PRO_GetStr(TrfURLSection,key,pConf->trf_url[i].url,TRF_URL_MAX_LEN,fh);
	}
	fclose(fh);
	return WAN_OK;	
}

int SaveTrfURLSettings(TRF_URL_CONF *pConf, int poe_acc_index)
{
	multi_items	all_items[2+MAX_TRF_URL];
	char num[3],set[10];
	int i;
	if(!pConf||poe_acc_index<0||poe_acc_index>=MAX_PPPOE_ACCOUNT)
		return WAN_SaveTrfURLErr;
		
	sprintf(all_items[0].key,"%dtrf_url_num",poe_acc_index);
	sprintf(num,"%d",pConf->trf_url_num);
	all_items[0].value=num;
	
	sprintf(all_items[1].key,"%dtrf_url_set",poe_acc_index);
	sprintf(set,"%d",pConf->trf_url_set);
	all_items[1].value=set;			
	
	for(i=0; i<MAX_TRF_IP; i++){
		sprintf(all_items[2+i].key,"%dtrf_url%d",poe_acc_index,i);	
		all_items[2+i].value=pConf->trf_url[i].url;					
	}	
	if(PRO_SetMultiItemStr(TrfURLSection,all_items,2+MAX_TRF_URL, SYSCONF))
		return WAN_SaveTrfURLErr;
	return WAN_OK;	
	
}

#define TrfPORTSection "TRF_PORT"
int ReadTrfPORTSettings(TRF_PORT_CONF *pConf, int poe_acc_index)
{
	FILE *fh;
	char key[20],port[12],*p;
	int i;
	if(!pConf||poe_acc_index<0||poe_acc_index>=MAX_PPPOE_ACCOUNT)
		return WAN_ReadTrfPORTErr;
	fh=fopen(SYSCONF,"rt");
	if(!fh)
		return WAN_ReadTrfPORTErr;
	memset(pConf,0,sizeof(TRF_PORT_CONF));
	
	sprintf(key,"%dtrf_port_num",poe_acc_index);
	PRO_GetInt(TrfPORTSection,key,(int *)&pConf->trf_port_num,fh);
	
	sprintf(key,"%dtrf_port_set",poe_acc_index);
	PRO_GetInt(TrfPORTSection,key,(int *)&pConf->trf_port_set,fh);	
	
	for(i=0; i<MAX_TRF_PORT; i++){
		sprintf(key,"%dtrf_port%d",poe_acc_index,i);
		PRO_GetStr(TrfPORTSection,key,port,12,fh);
		if((p=strchr(port,'-'))!=NULL){
			*p=0;
			pConf->trf_port[i].port_e=atoi(p+1);
		}
		pConf->trf_port[i].port_s=atoi(port);
	}
	fclose(fh);
	return WAN_OK;	
}

int SaveTrfPORTSettings(TRF_PORT_CONF *pConf, int poe_acc_index)
{
	multi_items	all_items[2+MAX_TRF_URL];
	char num[3],set[10],port[MAX_TRF_PORT][20];
	int i;
	if(!pConf||poe_acc_index<0||poe_acc_index>=MAX_PPPOE_ACCOUNT)
		return WAN_SaveTrfPORTErr;
		
	sprintf(all_items[0].key,"%dtrf_port_num",poe_acc_index);
	sprintf(num,"%d",pConf->trf_port_num);
	all_items[0].value=num;
	
	sprintf(all_items[1].key,"%dtrf_port_set",poe_acc_index);
	sprintf(set,"%d",pConf->trf_port_set);
	all_items[1].value=set;			
	
	for(i=0; i<MAX_TRF_PORT; i++){
		sprintf(all_items[2+i].key,"%dtrf_port%d",poe_acc_index,i);
		if(!pConf->trf_port[i].port_s)
			port[i][0]='\0';
		else
			sprintf(port[i],"%d-%d",pConf->trf_port[i].port_s,pConf->trf_port[i].port_e);	
		all_items[2+i].value=port[i];					
	}	
	if(PRO_SetMultiItemStr(TrfPORTSection,all_items,2+MAX_TRF_PORT, SYSCONF))
		return WAN_SaveTrfPORTErr;
	return WAN_OK;	
	
}

#endif//_MULTI_PPPOE_

char IpTypeStr2Char(char *type){
    char i = str_db_search(IPDNSTypeDB,type);

    if(i>=TYPE_DYNAMIC && i<TYPE_MAX){
        return i;
    }
    return 0;
}

char *IpTypeChar2Str(char type){
    if(type>=TYPE_DYNAMIC && type<TYPE_MAX){
        return IPDNSTypeDB[(BYTE)type];
    }
    return NULL;
}



static char SinglePPPoESection[]="Single PPPoE";
/*===================================================================*
 * FUNCTION    : ReadSinglePPPoESettings                             *
 *                                                                   *
 * INPUT       : FILE point                                          *
 *               Single PPPoE conf point                             *
 *                                                                   *
 * OUTPUT      : WAN_OK ==> Successful                               *
 *               Other  ==> Fail                                     *
 *                                                                   *
 * Description : Read Single PPPoE settings to pConf                 *
 *                                                                   *
 *===================================================================*/
int ReadSinglePPPoESettings(SINGLE_PPPOE_CONF *pConf)
{
	char key[32];
	char ip[16];
	char type[40];
    FILE *fh;

	if(!pConf)
		return WAN_ReadPPPoEErr;

	fh=fopen(SYSCONF,"rt");

	if(!fh)
		return WAN_ReadWANConfErr;

	rewind(fh);

	sprintf(key,"ac_name");
	PRO_GetStr(SinglePPPoESection,key,pConf->accountName,PPPOE_ACCOUNT_NAME_LEN-1,fh);

	sprintf(key,"user");
	PRO_GetStr(SinglePPPoESection,key,pConf->userName,PPPOE_USER_NAME_LEN-1,fh);

	sprintf(key,"pass");
	PRO_GetStr(SinglePPPoESection,key,pConf->password,PPPOE_PASSWORD_LEN-1,fh);

	sprintf(key,"dialMode");
	PRO_GetInt(SinglePPPoESection,key,(int *)&pConf->dialMode,fh);

	sprintf(key,"dod_idle");
	PRO_GetInt(SinglePPPoESection,key,(int *)&pConf->DOD_idleTime,fh);

	sprintf(key,"manu_idle");
	PRO_GetInt(SinglePPPoESection,key,(int *)&pConf->Manual_idelTime,fh);

	sprintf(key,"ipType");
	PRO_GetStr(SinglePPPoESection,key,type,sizeof(type),fh);
	pConf->ipType = IpTypeStr2Char(type);

	sprintf(key,"dnsType");
	PRO_GetStr(SinglePPPoESection,key,type,sizeof(type),fh);
	pConf->dnsType = IpTypeStr2Char(type);

	sprintf(key,"ac_name");
	PRO_GetStr(SinglePPPoESection,key,pConf->accountName,PPPOE_ACCOUNT_NAME_LEN-1,fh);

	sprintf(key,"pri_dns");
	PRO_GetStr(SinglePPPoESection,key,ip,16,fh);
	extract_ip(ip,(unsigned char *)&pConf->dns[0]);

	sprintf(key,"sec_dns");
	PRO_GetStr(SinglePPPoESection,key,ip,16,fh);
	extract_ip(ip,(unsigned char *)&pConf->dns[1]);

	sprintf(key,"ip");
	PRO_GetStr(SinglePPPoESection,key,ip,16,fh);
	extract_ip(ip,(unsigned char *)&pConf->ipAddress);

	sprintf(key,"mask");
	PRO_GetStr(SinglePPPoESection,key,ip,16,fh);
	extract_ip(ip,(unsigned char *)&pConf->netMask);
	fclose(fh);
	return WAN_OK;
}

int CheckSinglePPPoESettings(SINGLE_PPPOE_CONF *pConf)
{

	return WAN_OK;

}


int SaveSinglePPPoESettings(SINGLE_PPPOE_CONF *pConf)
{
	multi_items	all_items[SPC_ITEM_NUM];
	char ip[16],mask[16],dns_1[16],dns_2[16];
	char dialMode[2], dod_idle[8],manual_idle[8];
	char ipType[40],dns_type[8];
	int ret;

	ret=CheckSinglePPPoESettings(pConf);
	if(ret){
		return ret;
	}

	sprintf(all_items[SPC_AC_NAME].key,"ac_name");
	all_items[SPC_AC_NAME].value=pConf->accountName;

	sprintf(all_items[SPC_USER_NAME].key,"user");
	all_items[SPC_USER_NAME].value=pConf->userName;

	sprintf(all_items[SPC_PASSWORD].key,"pass");
	all_items[SPC_PASSWORD].value=pConf->password;

	sprintf(all_items[SPC_DIAL_MODE].key,"dialMode");
	sprintf(dialMode,"%d",pConf->dialMode);
	all_items[SPC_DIAL_MODE].value=dialMode;

	sprintf(all_items[SPC_DOD_IDLE].key,"dod_idle");
	sprintf(dod_idle,"%d",pConf->DOD_idleTime);
	all_items[SPC_DOD_IDLE].value=dod_idle;

	sprintf(all_items[SPC_MANUAL_IDLE].key,"manu_idle");
	sprintf(manual_idle,"%d",pConf->Manual_idelTime);
	all_items[SPC_MANUAL_IDLE].value=manual_idle;

	sprintf(all_items[SPC_IP_TYPE].key,"ipType");
	sprintf(ipType,"%s",IpTypeChar2Str(pConf->ipType));
	all_items[SPC_IP_TYPE].value=ipType;

	sprintf(all_items[SPC_DNS_TYPE].key,"dnsType");
	sprintf(dns_type,"%s",IpTypeChar2Str(pConf->dnsType));
	all_items[SPC_DNS_TYPE].value=dns_type;


	sprintf(all_items[SPC_IP_ADDR].key,"ip");
	sprintf(ip,"%u.%u.%u.%u",*((unsigned char*)&pConf->ipAddress),*((unsigned char*)&pConf->ipAddress+1),*((unsigned char*)&pConf->ipAddress+2),*((unsigned char*)&pConf->ipAddress+3) );
	all_items[SPC_IP_ADDR].value=ip;

	sprintf(all_items[SPC_NETMASK].key,"mask");
	sprintf(mask,"%u.%u.%u.%u",*((unsigned char*)&pConf->netMask),*((unsigned char*)&pConf->netMask+1),*((unsigned char*)&pConf->netMask+2),*((unsigned char*)&pConf->netMask+3) );
	all_items[SPC_NETMASK].value=mask;

	sprintf(all_items[SPC_DNS1].key,"pri_dns");
	sprintf(dns_1,"%u.%u.%u.%u",*((unsigned char*)&pConf->dns[0]),*((unsigned char*)&pConf->dns[0]+1),*((unsigned char*)&pConf->dns[0]+2),*((unsigned char*)&pConf->dns[0]+3) );
	all_items[SPC_DNS1].value=dns_1;

	sprintf(all_items[SPC_DNS2].key,"sec_dns");
	sprintf(dns_2,"%u.%u.%u.%u",*((unsigned char*)&pConf->dns[1]),*((unsigned char*)&pConf->dns[1]+1),*((unsigned char*)&pConf->dns[1]+2),*((unsigned char*)&pConf->dns[1]+3) );
	all_items[SPC_DNS2].value=dns_2;


	ret=PRO_SetMultiItemStr(SinglePPPoESection,all_items,SPC_ITEM_NUM, SYSCONF);
	if(ret){
		return WAN_SavePPPoEErr;
	}
	return WAN_OK;
}


/*=====================DHCP==================================*/

static char *dhcp_section="DHCP";
int ReadDHCPSettings(DHCP_CONF *pConf)
{
	char key[32];
	char ip[16];
	FILE *fh;

	if(!pConf)
		return WAN_ReadDHCPErr;

	fh=fopen(SYSCONF,"rt");

	if(!fh)
		return WAN_ReadDHCPErr;

	rewind(fh);


	sprintf(key,"dhcp_name");
	PRO_GetStr(dhcp_section,key,pConf->dhcp_name,DHCP_NAME_LEN,fh);

	sprintf(key,"domain_name");
	PRO_GetStr(dhcp_section,key,pConf->domain_name,DOMAIN_NAME_LEN,fh);

	sprintf(key,"dhcpc_type");
	PRO_GetChar(dhcp_section,key,(char *)&pConf->dhcpc_type,fh);

	sprintf(key,"dhcp_dns_type");
	PRO_GetChar(dhcp_section,key,(char *)&pConf->dhcp_dns_type,fh);

	sprintf(key,"ipAddress");
	PRO_GetStr(dhcp_section,key,ip,16,fh);
	extract_ip(ip,(char *)&pConf->ipAddress);

	sprintf(key,"netMask");
	PRO_GetStr(dhcp_section,key,ip,16,fh);
	extract_ip(ip,(char *)&pConf->netMask);

	sprintf(key,"Gateway");
	PRO_GetStr(dhcp_section,key,ip,16,fh);
	extract_ip(ip,(char *)&pConf->Gateway);

	sprintf(key,"dns1");
	PRO_GetStr(dhcp_section,key,ip,16,fh);
	extract_ip(ip,(char *)&pConf->dns);

	sprintf(key,"dns2");
	PRO_GetStr(dhcp_section,key,ip,16,fh);
	extract_ip(ip,(char *)&pConf->dns[1]);

	sprintf(key,"dns3");
	PRO_GetStr(dhcp_section,key,ip,16,fh);
	extract_ip(ip,(char *)&pConf->dns[2]);
	fclose(fh);
	return 0;
}

int CheckDHCPSettings(DHCP_CONF *pConf)
{
	return WAN_OK;
}

int SaveDHCPSettings(DHCP_CONF *pConf)
{
	multi_items	all_items[DHCP_ITEM_NUM];
    char dhcpc_type[2];
    char dhcp_dns_type[2], ipAddress[16], netMask[16], Gateway[16], dns1[16], dns2[16], dns3[16];
	int ret;

	ret=CheckDHCPSettings(pConf);
	if(ret){
		return ret;
	}

	sprintf(all_items[DHCP_NAME].key,"dhcp_name");
	all_items[DHCP_NAME].value=pConf->dhcp_name;

	sprintf(all_items[DHCP_DOMAIN_NAME].key,"domain_name");
	all_items[DHCP_DOMAIN_NAME].value=pConf->domain_name;

	sprintf(all_items[DHCP_TYPE].key,"dhcpc_type");
	sprintf(dhcpc_type,"%d",pConf->dhcpc_type);
	all_items[DHCP_TYPE].value=dhcpc_type;

	sprintf(all_items[DHCP_DNS_TYPE].key,"dhcp_dns_type");
	sprintf(dhcp_dns_type,"%d",pConf->dhcp_dns_type);
	all_items[DHCP_DNS_TYPE].value=dhcp_dns_type;

	sprintf(all_items[DHCP_IP_ADDR].key,"ipAddress");
	sprintf(ipAddress,"%u.%u.%u.%u",*((unsigned char*)&pConf->ipAddress),*((unsigned char*)&pConf->ipAddress+1),*((unsigned char*)&pConf->ipAddress+2),*((unsigned char*)&pConf->ipAddress+3) );
	all_items[DHCP_IP_ADDR].value=ipAddress;

	sprintf(all_items[DHCP_NETMASK].key,"netMask");
	sprintf(netMask,"%u.%u.%u.%u",*((unsigned char*)&pConf->netMask),*((unsigned char*)&pConf->netMask+1),*((unsigned char*)&pConf->netMask+2),*((unsigned char*)&pConf->netMask+3) );
	all_items[DHCP_NETMASK].value=netMask;

	sprintf(all_items[DHCP_GATEWAY].key,"Gateway");
	sprintf(Gateway,"%u.%u.%u.%u",*((unsigned char*)&pConf->Gateway),*((unsigned char*)&pConf->Gateway+1),*((unsigned char*)&pConf->Gateway+2),*((unsigned char*)&pConf->Gateway+3) );
	all_items[DHCP_GATEWAY].value=Gateway;

	sprintf(all_items[DHCP_DNS1].key,"dns1");
	sprintf(dns1,"%u.%u.%u.%u",*((unsigned char*)&pConf->dns[0]),*((unsigned char*)&pConf->dns[0]+1),*((unsigned char*)&pConf->dns[0]+2),*((unsigned char*)&pConf->dns[0]+3) );
	all_items[DHCP_DNS1].value=dns1;

	sprintf(all_items[DHCP_DNS2].key,"dns2");
	sprintf(dns2,"%u.%u.%u.%u",*((unsigned char*)&pConf->dns[1]),*((unsigned char*)&pConf->dns[1]+1),*((unsigned char*)&pConf->dns[1]+2),*((unsigned char*)&pConf->dns[1]+3) );
	all_items[DHCP_DNS2].value=dns2;

	sprintf(all_items[DHCP_DNS3].key,"dns3");
	sprintf(dns3,"%u.%u.%u.%u",*((unsigned char*)&pConf->dns[2]),*((unsigned char*)&pConf->dns[2]+1),*((unsigned char*)&pConf->dns[2]+2),*((unsigned char*)&pConf->dns[2]+3) );
	all_items[DHCP_DNS3].value=dns3;

	ret=PRO_SetMultiItemStr(dhcp_section,all_items,DHCP_ITEM_NUM, SYSCONF);
	if(ret){
		return WAN_SaveDHCPErr;
	}
	return WAN_OK;
}

/*===================================================================*
 * FUNCTION    : GetLeaseAndRemainTime                               *
 *                                                                   *
 * INPUT       : lease time point                                    *
 *               remain time point                                   *
 *                                                                   *
 * OUTPUT      : WAN_OK ==> Successful                               *
 *               Other  ==> Fail                                     *
 *                                                                   *
 * Description : read lease time and remain time from /var/udhcp.time*
 *                                                                   *
 *===================================================================*/

#define TIME_FILE       "/var/udhcpc.time"
int GetLeaseAndRemainTime(unsigned long *lease_p,unsigned long *remain_p){
    FILE *fp,*fh;
    unsigned long start,now;

    if(!lease_p || !remain_p){
        return WAN_ReadDHCPErr;
    }

    *lease_p = *remain_p = 0;

    fp = fopen(TIME_FILE,"r");
    if(!fp){
        return WAN_ReadDHCPErr;
    }

    if(fscanf(fp,"start:%lu lease:%lu\n",&start,lease_p) != 2){
        fclose(fp);
        return WAN_ReadDHCPErr;
    }

	start=0;
	fh = fopen("/var/ntptime","r");
    if(!fh){
        return WAN_ReadDHCPErr;
    }
    if(fscanf(fh,"ntptime:%lu\n",&start) !=1){
		fclose(fh);
        return WAN_ReadDHCPErr;
    }
    now=time(0);
    *remain_p = *lease_p - (now - start);
    fclose(fp);
    fclose(fh);
    return WAN_OK;
}


/************************************** modem *********************************************/
#ifdef _WAN_MODEM_
static char *modem_section="MODEM";
int ReadModemSettings(MODEM_CONF *pConf)
{

    FILE *fh;
	char key[32];
	char ip[16];

	if(!pConf)
		return WAN_ReadModemErr;

	fh=fopen(SYSCONF,"rt");

	if(!fh)
		return WAN_ReadModemErr;

	rewind(fh);


	sprintf(key,"mdm_modem_name");
	PRO_GetStr(modem_section,key,pConf->mdm_modem_name,MDM_MODEM_NAME_LEN,fh);

	sprintf(key,"mdm_user_name");
	PRO_GetStr(modem_section,key,pConf->mdm_user_name,MDM_USER_NAME_LEN,fh);

	sprintf(key,"mdm_password");
	PRO_GetStr(modem_section,key,pConf->mdm_password,MDM_PASSWORD_LEN,fh);

	sprintf(key,"mdm_service_name");
	PRO_GetStr(modem_section,key,pConf->mdm_service_name,MDM_SERVICE_NAME_LEN,fh);

	sprintf(key,"mdm_telephone");
	PRO_GetStr(modem_section,key,pConf->mdm_telephone,MDM_TELEPHONE_LEN,fh);

	sprintf(key,"mdm_at_cmd");
	PRO_GetStr(modem_section,key,pConf->mdm_at_cmd,MDM_AT_CMD_LEN,fh);

	sprintf(key,"mdm_dialMode");
	PRO_GetInt(modem_section,key,(int *)&pConf->mdm_dialMode,fh);

	sprintf(key,"mdm_DOD_idleTime");
	PRO_GetInt(modem_section,key,(int *)&pConf->mdm_DOD_idleTime,fh);

	sprintf(key,"mdm_Manual_idelTime");
	PRO_GetInt(modem_section,key,(int *)&pConf->mdm_Manual_idelTime,fh);

	sprintf(key,"mdm_pppd_retry_enable");
	PRO_GetInt(modem_section,key,(int *)&pConf->mdm_pppd_retry_enable,fh);

	sprintf(key,"mdm_dns_enable");
	PRO_GetInt(modem_section,key,(int *)&pConf->mdm_dns_enable,fh);

	sprintf(key,"mdm_dns1");
	PRO_GetStr(modem_section,key,ip,16,fh);
	extract_ip(ip,(char *)&pConf->mdm_dns1);

	sprintf(key,"mdm_dns2");
	PRO_GetStr(modem_section,key,ip,16,fh);
	extract_ip(ip,(char *)&pConf->mdm_dns2);

	sprintf(key,"mdm_modem_int");
	PRO_GetStr(modem_section,key,pConf->mdm_modem_int,MDM_MODEM_INT_LEN,fh);

	sprintf(key,"mdm_speed");
	PRO_GetInt(modem_section,key,(int *)&pConf->mdm_speed,fh);
	fclose(fh);
	return 0;
}

int SaveModemSettings(MODEM_CONF *pConf)
{
	multi_items	all_items[MDM_ITEM_NUM];
	char mdm_dialMode[3],mdm_DOD_idleTime[3],mdm_Manual_idelTime[3],retry_enable[2],dns_enable[2],dns1[16],dns2[16],speed[10];
	int ret;

	sprintf(all_items[MDM_MODEM_NAME].key,"mdm_modem_name");
	all_items[MDM_MODEM_NAME].value=pConf->mdm_modem_name;

	sprintf(all_items[MDM_USER_NAME].key,"mdm_user_name");
	all_items[MDM_USER_NAME].value=pConf->mdm_user_name;

	sprintf(all_items[MDM_PASSWORD].key,"mdm_password");
	all_items[MDM_PASSWORD].value=pConf->mdm_password;

	sprintf(all_items[MDM_SERVICE_NAME].key,"mdm_service_name");
	all_items[MDM_SERVICE_NAME].value=pConf->mdm_service_name;

	sprintf(all_items[MDM_TELEPHONE].key,"mdm_telephone");
	all_items[MDM_TELEPHONE].value=pConf->mdm_telephone;

	sprintf(all_items[MDM_AT_CMD].key,"mdm_at_cmd");
	all_items[MDM_AT_CMD].value=pConf->mdm_at_cmd;

	sprintf(all_items[MDM_DIAL_MODE].key,"mdm_dialMode");
	sprintf(mdm_dialMode,"%d",pConf->mdm_dialMode);
	all_items[MDM_DIAL_MODE].value=mdm_dialMode;

	sprintf(all_items[MDM_DOD_IDLE].key,"mdm_DOD_idleTime");
	sprintf(mdm_DOD_idleTime,"%d",pConf->mdm_DOD_idleTime);
	all_items[MDM_DOD_IDLE].value=mdm_DOD_idleTime;

	sprintf(all_items[MDM_MANUAL_IDLE].key,"mdm_Manual_idelTime");
	sprintf(mdm_Manual_idelTime,"%d",pConf->mdm_Manual_idelTime);
	all_items[MDM_MANUAL_IDLE].value=mdm_Manual_idelTime;

	sprintf(all_items[MDM_PPPD_RETRY_ENABLE].key,"mdm_pppd_retry_enable");
	sprintf(retry_enable,"%d",pConf->mdm_pppd_retry_enable);
	all_items[MDM_PPPD_RETRY_ENABLE].value=retry_enable;

	sprintf(all_items[MDM_DNS_ENABLE].key,"mdm_dns_enable");
	sprintf(dns_enable,"%d",pConf->mdm_dns_enable);
	all_items[MDM_DNS_ENABLE].value=dns_enable;

	sprintf(all_items[MDM_DNS1].key,"mdm_dns1");
	sprintf(dns1,"%u.%u.%u.%u",*((unsigned char*)&pConf->mdm_dns1),*((unsigned char*)&pConf->mdm_dns1+1),*((unsigned char*)&pConf->mdm_dns1+2),*((unsigned char*)&pConf->mdm_dns1+3) );
	all_items[MDM_DNS1].value=dns1;

	sprintf(all_items[MDM_DNS2].key,"mdm_dns2");
	sprintf(dns2,"%u.%u.%u.%u",*((unsigned char*)&pConf->mdm_dns2),*((unsigned char*)&pConf->mdm_dns2+1),*((unsigned char*)&pConf->mdm_dns2+2),*((unsigned char*)&pConf->mdm_dns2+3) );
	all_items[MDM_DNS2].value=dns2;

	sprintf(all_items[MDM_MODEM_INT].key,"mdm_modem_int");
	all_items[MDM_MODEM_INT].value=pConf->mdm_modem_int;

	sprintf(all_items[MDM_SPEED].key,"mdm_speed");
	sprintf(speed,"%d",pConf->mdm_speed);
	all_items[MDM_SPEED].value=speed;

	ret=PRO_SetMultiItemStr(modem_section,all_items,MDM_ITEM_NUM, SYSCONF);
	if(ret){
		return WAN_SaveModemErr;
	}
	return WAN_OK;
}
#endif
/* **************************************************************************
 *  This function extract all the PPP log from file and return to
 *  buf from the caller.
 *  log file name is "var/log/ppp.log"
 *  one log format is such as
 *          "Nov 30 00:06:42 Brecis pppd[671]: PPP LOG Using interface ppp0"
 *  extract the time and log context.
 * **************************************************************************/
#define PPP_LOG_FILE "/var/log/ppp%d.log"
void GetPPPoELog(char *buf_out, int session)
{
	FILE *fp;
	int len=0;
	int s;
	char ppp_logfile[20];
	if(session<0&&session>MAX_PPPOE_SESSION)
		session=0;
	sprintf(ppp_logfile, PPP_LOG_FILE, session);
	fp=fopen(ppp_logfile,"r");
	if(!fp)
		return;

	while((s=fgetc(fp))!=EOF){
#if 1
		switch((char)s){
		default:
			buf_out[len]=(char)s;
			len++;
			break;
		case '>':
			strcat(&buf_out[len],"&gt;");
			len+=4;
			break;
		case '<':
			strcat(&buf_out[len],"&lt;");
			len+=4;
			break;
		case '&':
			strcat(&buf_out[len],"&amp;");
			len+=5;
			break;
		case '"':
			strcat(&buf_out[len],"&quot;");
			len+=6;
			break;
			
		}
#else
		buf_out[len]=(char)s;
		len++;
#endif
		if(len>MAX_POELOG_LEN-2)
			break;
    }
	buf_out[MAX_POELOG_LEN-1]='\0';
    fclose(fp);
	
}
void ClearPPPoELog(int session)
{
	FILE *fp;
	char ppp_logfile[20];
        if(session<0&&session>MAX_PPPOE_SESSION)
		session=0;
	sprintf(ppp_logfile, PPP_LOG_FILE, session);
	fp=fopen(ppp_logfile,"w");
	fclose(fp);
}

/*   ************************************************************************ */
//ada
static char *local_section="LOCAL";
int ReadLocalSettings(LOCAL_CONF *pConf)
{
        FILE *fh;
	char key[32];
	char ip[16];

	if(!pConf)
		return WAN_ReadLocalConfErr;

	fh=fopen(SYSCONF,"rt");

	if(!fh)
		return WAN_ReadLocalConfErr;

	rewind(fh);
	
	sprintf(key,"Local_IP");
	PRO_GetStr(local_section,key,ip,16,fh);
	extract_ip(ip,(unsigned char *)&pConf->Local_IP);

	sprintf(key,"Local_Mask");
	PRO_GetStr(local_section,key,ip,16,fh);
	extract_ip(ip,(unsigned char *)&pConf->Local_Mask);	

	sprintf(key,"Local_Gateway");
	PRO_GetStr(local_section,key,ip,16,fh);
	extract_ip(ip,(unsigned char *)&pConf->Local_Gateway);

	sprintf(key,"Local_dns");
	PRO_GetStr(local_section,key,ip,16,fh);
	extract_ip(ip,(unsigned char *)&pConf->Local_dns);
	
	fclose(fh);
	return 0;
}

int CheckLocalSettings(LOCAL_CONF *pConf)
{
	return WAN_OK;
}

int SaveLocalSettings(LOCAL_CONF *pConf)
{
	multi_items	all_items[4];
	char ip[16],mask[16],gateway[16],dns[16];
	int ret;
	
	sprintf(all_items[0].key,"Local_IP");
	sprintf(ip,"%u.%u.%u.%u",*((unsigned char*)&pConf->Local_IP),*((unsigned char*)&pConf->Local_IP+1),*((unsigned char*)&pConf->Local_IP+2),*((unsigned char*)&pConf->Local_IP+3) );
	all_items[0].value=ip;
	
	sprintf(all_items[1].key,"Local_Mask");
	sprintf(mask,"%u.%u.%u.%u",*((unsigned char*)&pConf->Local_Mask),*((unsigned char*)&pConf->Local_Mask+1),*((unsigned char*)&pConf->Local_Mask+2),*((unsigned char*)&pConf->Local_Mask+3) );
	all_items[1].value=mask;
	
	sprintf(all_items[2].key,"Local_Gateway");
	sprintf(gateway,"%u.%u.%u.%u",*((unsigned char*)&pConf->Local_Gateway),*((unsigned char*)&pConf->Local_Gateway+1),*((unsigned char*)&pConf->Local_Gateway+2),*((unsigned char*)&pConf->Local_Gateway+3) );
	all_items[2].value=gateway;		

	sprintf(all_items[3].key,"Local_dns");
	sprintf(dns,"%u.%u.%u.%u",*((unsigned char*)&pConf->Local_dns),*((unsigned char*)&pConf->Local_dns+1),*((unsigned char*)&pConf->Local_dns+2),*((unsigned char*)&pConf->Local_dns+3) );
	all_items[3].value=dns;	
	
	ret=PRO_SetMultiItemStr(local_section,all_items,4, SYSCONF);
	if(ret){
		return WAN_SaveLocalConfErr;
	}
	return WAN_OK;
}

#define WAN_IF	ETH_WAN
#define DHCP_PIDFILE "/var/run/dhcp.running"
#define UDHCPC_PID_FILE "/var/run/udhcpc.pid"
#define PAP_SECRETS "/etc/ppp/pap-secrets"
#define CHAP_SECRETS "/etc/ppp/chap-secrets"
#define RESOLV_FILE "/etc/resolv.conf"
#define HOSTS_FILE	"/var/hosts"
#define DOMAIN_FILE	"/var/domain"

int StartWan(void)
{
	SYSTEM_CONF sys_conf;
	SINGLE_PPPOE_CONF spoe_conf;
	MULTI_PPPOE_CONF mpoe_conf;
	PPPOE_CONF *pConf;
	int ret=0,i;
	char cmd[50];
	ret=ReadSystemSettings(&sys_conf);
	if(ret)
		return ret;

	sprintf(cmd,"%s %s >/dev/null 2>&1", CMD_NAT_SH, "enable");
	switch(sys_conf.Connection){
    	case CONNECTION_DHCP:
			StartWanDHCP();
			break;
		case CONNECTION_SINGLE_PPPOE:
			ReadSinglePPPoESettings(&spoe_conf);
			CreatSPPPoEFile(&spoe_conf);
			AddBackupDNS(-1);
			if(spoe_conf.dialMode!=MANUALLY)
			StartWanSPPPoE();
			if(TYPE_UNNUMBERED == spoe_conf.ipType){
				sprintf(cmd,"%s %s >/dev/null 2>&1", CMD_NAT_SH, "disable");	
			}	
			break;
		case CONNECTION_MULTI_PPPOE:
			ReadMultiPPPoESettings(&mpoe_conf);
			for(i=0;i<MAX_PPPOE_SESSION;i++){
				if(mpoe_conf.session[i]==-1)
					continue;
				pConf=&mpoe_conf.account[mpoe_conf.session[i]];
				CreatMPPPoEFile(pConf,i);
				AddBackupDNS(mpoe_conf.session[i]);
			}
			StartWanMPPPoE(0);
			break;
		case CONNECTION_LOCAL_OFFICE:
			StartWanLocal();
			sprintf(cmd,"%s %s >/dev/null 2>&1", CMD_NAT_SH, "disable");	
			break;
		default:
        	break;
	}
	system(cmd);
	return 0;
}

int StopWan(void)
{
	SYSTEM_CONF sys_conf;
	int ret=0;
	FILE *fp;
	fp=fopen(RESOLV_FILE,"w");
	if(fp)
		fclose(fp);
	ret=ReadSystemSettings(&sys_conf);
	if(ret)
		return ret;
	switch(sys_conf.Connection){
    	case CONNECTION_DHCP:
			StopWanDHCP();
			break;
		case CONNECTION_SINGLE_PPPOE:
			StopWanSPPPoE();
			system("/bin/killall pppd 2>/dev/null");
			break;
		case CONNECTION_MULTI_PPPOE:
			StopWanMPPPoE(0);
			StopWanMPPPoE(1);
			break;
		case CONNECTION_LOCAL_OFFICE:
			StopWanLocal();
		default:
			break;
	}
	return 0;
}
int StartWanDHCP(void)
{
	DHCP_CONF dhcpc_conf;
	char wan_ip[16]={0},wan_mask[16]={0},wan_broad[16]={0},wan_gw[16]={0};
	DWORD broadcast;
	FILE *fp;
	char cmd[128]={0};
	int ret=0;

	if(access(UDHCPC_PID_FILE,F_OK)==0)
		return 0;
	ret = ReadDHCPSettings(&dhcpc_conf);
	if(ret)
		return ret;
	if((fp=fopen(RESOLV_FILE,"w"))!=NULL){
		if(dhcpc_conf.dhcp_dns_type){
			fprintf(fp,"nameserver %u.%u.%u.%u\n",
					*((unsigned char*)&dhcpc_conf.dns[0]),
					*((unsigned char*)&dhcpc_conf.dns[0]+1),
					*((unsigned char*)&dhcpc_conf.dns[0]+2),
					*((unsigned char*)&dhcpc_conf.dns[0]+3) );
			}
			fclose(fp);
		AddBackupDNS(-1);
		}
	if((fp=fopen(DOMAIN_FILE,"w"))!=NULL){
		fprintf(fp,"%s",dhcpc_conf.domain_name);
		fclose(fp);
	}
	unlink(WANIP_UPTIMEFILE);
	if(dhcpc_conf.dhcpc_type==0){
		int timer=0;
		sprintf(cmd,"/sbin/udhcpc -p %s  >/dev/null 2>&1 &",UDHCPC_PID_FILE);
		system(cmd);
		while(1){
			if(access(WANIP_UPTIMEFILE, F_OK)==0)		
				break;
			sleep(1);
			timer++;
			if(timer>10)
				break;
		}
	}
	else{
		sprintf(wan_ip,"%u.%u.%u.%u",
			*((unsigned char*)&dhcpc_conf.ipAddress),
			*((unsigned char*)&dhcpc_conf.ipAddress+1),
			*((unsigned char*)&dhcpc_conf.ipAddress+2),
			*((unsigned char*)&dhcpc_conf.ipAddress+3) );
		sprintf(wan_mask,"%u.%u.%u.%u",
			*((unsigned char*)&dhcpc_conf.netMask),
			*((unsigned char*)&dhcpc_conf.netMask+1),
			*((unsigned char*)&dhcpc_conf.netMask+2),
			*((unsigned char*)&dhcpc_conf.netMask+3) );
		sprintf(wan_gw,"%u.%u.%u.%u",
			*((unsigned char*)&dhcpc_conf.Gateway),
			*((unsigned char*)&dhcpc_conf.Gateway+1),
			*((unsigned char*)&dhcpc_conf.Gateway+2),
			*((unsigned char*)&dhcpc_conf.Gateway+3) );

		broadcast = dhcpc_conf.ipAddress & dhcpc_conf.netMask;
		sprintf(wan_broad,"%u.%u.%u.%u",
			*((unsigned char*)&broadcast),
			*((unsigned char*)&broadcast+1),
			*((unsigned char*)&broadcast+2),
			*((unsigned char*)&broadcast+3) );

		if(strcmp(wan_ip,"0.0.0.0") && strcmp(wan_mask, "0.0.0.0") && strcmp(wan_gw, "0.0.0.0")){
			sprintf(cmd,"/sbin/ifconfig %s %s netmask %s broadcast %s >/dev/null 2>&1",WAN_IF,wan_ip,wan_mask,wan_broad);
			system(cmd);
			sprintf(cmd,"/sbin/route del default dev %s >/dev/null 2>&1",WAN_IF);
			system(cmd);
			sprintf(cmd,"/sbin/route add default gw %s dev %s >/dev/null 2>&1",wan_gw,WAN_IF);
			system(cmd);
			sprintf(cmd,"echo %s %s >/var/hosts",wan_ip, dhcpc_conf.domain_name);
			system(cmd);
			fp=fopen(WANIP_UPTIMEFILE,"w+");
			if(fp){
				fprintf(fp,"%ld",time(0));
				fclose(fp);
			}
		}
	}


	afterWanUp();
	return 0;
}

int StopWanDHCP(void)
{
	DHCP_CONF dhcpc_conf;
	char cmd[60];
	FILE *fp;
	int ret=0,pid;

	ret = ReadDHCPSettings(&dhcpc_conf);
	if(ret)
		return ret;

	if(dhcpc_conf.dhcpc_type==0){
		if((fp=fopen(UDHCPC_PID_FILE,"r"))!=NULL){
			/* release first */
			pid=0;
			fscanf(fp,"%d",&pid);
			fclose(fp);
			if(pid)
				kill((pid_t)pid,SIGUSR2);
		}
		system("/bin/killall udhcpc >/dev/null 2>&1");
	}
	sprintf(cmd,"/sbin/ifconfig %s 0.0.0.0  >/dev/null 2>&1",WAN_IF);
	system(cmd);
	if((fp=fopen(RESOLV_FILE,"w"))!=NULL)
		fclose(fp);
	remove(WANIP_UPTIMEFILE);
	afterWanDown();
	return 0;
}

#define ADSL_PIDFILE  "/var/run/pppoe-adsl%d.pid"
#define PPPD_PIDFILE 	"/var/run/ppp%d.pid"
#define PPPOE_PIDFILE 	"/var/run/pppoe-adsl%d.pid.pppoe"
#define PPPOE_CMDFILE 	"/var/pppoe%d.cmd"
#define IP_STR_LEN      (sizeof("255.255.255.255"))
int CreatSPPPoEFile(SINGLE_PPPOE_CONF *pConf)
{
	FILE *fp;
	char DEMAND[6]={0}, IDLE_TIME[6]={0}, PEERDNS[12]={0}, LOCAL_IP[IP_STR_LEN]={0};
	char demand_option[128]={0},pppoe_cmd[128]={0}, ppp_options[256]={0};

	char pppoe_pidfile[40], pppoe_cmdfile[20], ppp_logfile[20];
	sprintf(pppoe_pidfile, PPPOE_PIDFILE, 0);
	sprintf(pppoe_cmdfile, PPPOE_CMDFILE, 0);
	sprintf(ppp_logfile, PPP_LOG_FILE,0);
	fp=fopen(pppoe_cmdfile,"w");
	if(!fp)
		return -1;

	/* DNSTYPE */
	if(TYPE_FIXED == pConf->dnsType){
		FILE *fh;
		strcpy(PEERDNS,"");
		fprintf(fp,"DNSTYPE=%s\n", dnsType[DNSTYPE_SPECIFY]);
		if((fh=fopen(RESOLV_FILE,"w"))!=NULL){
			fprintf(fh,"nameserver %u.%u.%u.%u\n",
				*((unsigned char*)&pConf->dns[0]),
				*((unsigned char*)&pConf->dns[0]+1),
				*((unsigned char*)&pConf->dns[0]+2),
				*((unsigned char*)&pConf->dns[0]+3) );	
			fclose(fh);
		}
	}
	else{
		strcpy(PEERDNS,"usepeerdns");
		fprintf(fp,"DNSTYPE=%s\n", dnsType[DNSTYPE_SERVER]);
	}

	/* LOCAL_IP */
	 if(pConf->ipType != TYPE_DYNAMIC){
		sprintf(LOCAL_IP,"%u.%u.%u.%u",
				*((unsigned char*)&pConf->ipAddress),*((unsigned char*)&pConf->ipAddress+1),
				*((unsigned char*)&pConf->ipAddress+2),*((unsigned char*)&pConf->ipAddress+3) );
	}
	else{
		*LOCAL_IP = '\0';
	}

	/* DEMAND */
	if(DOD == pConf->dialMode){
		sprintf(DEMAND,"%d",pConf->DOD_idleTime*60);
	}
	else{
		sprintf(DEMAND,"%s","no");
	}

	fprintf(fp,"DIAL_ON_DEMAND=%s\n",DEMAND);

	/* IDLE_TIME (This option valid only when DEMAND is "no") */
	if(MANUALLY == pConf->dialMode){
		sprintf(IDLE_TIME,"%d",pConf->Manual_idelTime*60);
	}
	else{
		sprintf(IDLE_TIME,"%d",0);
	}

	if(!strcmp(DEMAND,"no")){
		sprintf(demand_option,"idle %s",IDLE_TIME);
	}
	else{
		sprintf(demand_option,
				"demand persist idle %s %s ipcp-accept-remote ipcp-accept-local connect true noipdefault ktune",
				DEMAND,LOCAL_IP);
	}

	fprintf(fp,"DEMAND=\"%s\"\n",demand_option);

	/* PPPOE_CMD */
	sprintf(pppoe_cmd,"/sbin/pppoe -p %s -I %s -T 60 -U -m 1412", pppoe_pidfile, WAN_IF);
	fprintf(fp,"PPPOE_CMD=\"%s\"\n",pppoe_cmd);

	/* PPP_STD_OPTIONS */
	sprintf(ppp_options,
			"noipdefault noauth default-asyncmap defaultroute hide-password %s mtu 1492 mru 1492 noaccomp noccp nobsdcomp nodeflate nopcomp novj novjccomp user %s lcp-echo-interval 20 lcp-echo-failure 3 %s: logfile %s",
			PEERDNS,pConf->userName,LOCAL_IP, ppp_logfile);
	fprintf(fp,"PPP_STD_OPTIONS=\"%s\"\n",ppp_options);

	fclose(fp);

	fp=fopen(PAP_SECRETS,"w");
	if(!fp)
		return -1;
	fprintf(fp,"%s * %s",pConf->userName,pConf->password);
	fclose(fp);

	fp=fopen(CHAP_SECRETS,"w");
	if(!fp)
		return -1;
	fprintf(fp,"%s * %s",pConf->userName,pConf->password);
	fclose(fp);
	return 0;
}

int StartWanSPPPoE(void)
{
	SINGLE_PPPOE_CONF poe_conf;
	FILE *fp;
	char adsl_pidfile[30];
	
	int ret=0;
	sprintf(adsl_pidfile, ADSL_PIDFILE, 0);
	if((fp=fopen(adsl_pidfile,"r"))!=NULL){
		fclose(fp);
		return 0;
	}
	ret = ReadSinglePPPoESettings(&poe_conf);
	if(ret)
		return ret;

	system("/sbin/route del default >/dev/null 2>&1");


	ClearPPPoELog(0);
	system("/usr/sbin/adsl start 0  >/dev/null 2>&1");

	
	afterWanUp();
	return 0;
}



int StopWanSPPPoE(void)
{
	FILE *fp;
     	char adsl_pidfile[30];
		
	sprintf(adsl_pidfile, ADSL_PIDFILE, 0);
     	if((fp=fopen(adsl_pidfile,"r"))!=NULL){
		fclose(fp);	
	}else
		return 0;

	system("/usr/sbin/adsl stop 0  >/dev/null 2>&1");
	if((fp=fopen(RESOLV_FILE,"w"))!=NULL)
		fclose(fp);
	afterWanDown();
	return 0;
}

	
int write_dns(char *file, char *dns)
{
#define RESOLV_TMP_FILE "/var/resolv.conf.prev"
	FILE *fp;
	char str_dns[40],cmd[128];
	if(!file||!dns)
		return -1;
	if((fp=fopen(file,"r"))==NULL)
		return -1;
	while(fgets(str_dns,sizeof(str_dns),fp)){
		if(!strcmp(str_dns,dns)){
			fclose(fp);
			return 0;
		}
	}	
	fclose(fp);
	sprintf(cmd,"/bin/cp %s %s -f 2>/dev/null",file,RESOLV_TMP_FILE);
	system(cmd);	
	fp=fopen(file,"w");
	if(fp){
	        fprintf(fp, "%s", dns);
	        fclose(fp);
	}
	sprintf(cmd,"/bin/cat %s >>%s 2>/dev/null",RESOLV_TMP_FILE,file);
	system(cmd);
	return 0;
}

int CreatMPPPoEFile(PPPOE_CONF *pConf, int session)
{
	FILE *fp;
	char DEMAND[6]={0}, IDLE_TIME[6]={0}, PEERDNS[12]={0}, LOCAL_IP[IP_STR_LEN]={0};
	char demand_option[128]={0},pppoe_cmd[128]={0}, ppp_options[256]={0};
	char pppoe_pidfile[40], pppoe_cmdfile[20], ppp_logfile[20];
	sprintf(pppoe_pidfile, PPPOE_PIDFILE, session);
	sprintf(pppoe_cmdfile, PPPOE_CMDFILE, session);
	sprintf(ppp_logfile, PPP_LOG_FILE, session);
	fp=fopen(pppoe_cmdfile,"w");
	if(!fp)
		return -1;
	/* DNSTYPE */
	if(MPOE_DNS_FIXED == pConf->poe_dns_type){
		char dns[40];
		strcpy(PEERDNS,"");
		fprintf(fp,"DNSTYPE=%s\n", dnsType[DNSTYPE_SPECIFY]);
			if(pConf->poe_dns_2){	
				sprintf(dns,"nameserver %u.%u.%u.%u\n",
					*((unsigned char*)&pConf->poe_dns_2),
					*((unsigned char*)&pConf->poe_dns_2+1),
					*((unsigned char*)&pConf->poe_dns_2+2),
					*((unsigned char*)&pConf->poe_dns_2+3) );
				write_dns(RESOLV_FILE,dns);
			}
			if(pConf->poe_dns_1){
				sprintf(dns,"nameserver %u.%u.%u.%u\n",
					*((unsigned char*)&pConf->poe_dns_1),
					*((unsigned char*)&pConf->poe_dns_1+1),
					*((unsigned char*)&pConf->poe_dns_1+2),
					*((unsigned char*)&pConf->poe_dns_1+3) );
				write_dns(RESOLV_FILE,dns);
			}
		
	}
	else{
		strcpy(PEERDNS,"usepeerdns");
		fprintf(fp,"DNSTYPE=%s\n", dnsType[DNSTYPE_SERVER]);
	}

	/* LOCAL_IP */
	*LOCAL_IP = '\0';


	/* DEMAND */
	if(MPOE_CONN_DEMAND == pConf->conn_type){
		sprintf(DEMAND,"%d",pConf->poe_idle*60);
	}
	else{
		sprintf(DEMAND,"%s","no");
	}

	fprintf(fp,"DIAL_ON_DEMAND=%s\n",DEMAND);

	/* IDLE_TIME (This option valid only when DEMAND is "no") */
	if(MPOE_CONN_NORMAL == pConf->conn_type){
		sprintf(IDLE_TIME,"%d",pConf->poe_idle*60);
	}
	else{
		sprintf(IDLE_TIME,"%d",0);
	}

	if(!strcmp(DEMAND,"no")){
		sprintf(demand_option,"idle %s",IDLE_TIME);
	}
	else{
		sprintf(demand_option,
				"demand persist idle %s %s ipcp-accept-remote ipcp-accept-local connect true noipdefault ktune",
				DEMAND,LOCAL_IP);
	}

	fprintf(fp,"DEMAND=\"%s\"\n",demand_option);



	/* PPPOE_CMD */
	sprintf(pppoe_cmd,"/sbin/pppoe -p %s -I %s -T 60 -U -m 1412", pppoe_pidfile, WAN_IF);
	fprintf(fp,"PPPOE_CMD=\"%s\"\n",pppoe_cmd);

	/* PPP_STD_OPTIONS */
	sprintf(ppp_options,
		"noipdefault noauth default-asyncmap defaultroute hide-password %s mtu 1492 mru 1492 noaccomp noccp nobsdcomp nodeflate nopcomp novj novjccomp user %s lcp-echo-interval 20 lcp-echo-failure 3 %s: unit %d logfile %s",
			 PEERDNS,pConf->poe_user,LOCAL_IP, session, ppp_logfile);
	fprintf(fp,"PPP_STD_OPTIONS=\"%s\"\n",ppp_options);

	fclose(fp);
	return 0;
}

int StartWanMPPPoE(int session)
{
	MULTI_PPPOE_CONF mpoe_conf;
	PPPOE_CONF *pConf;
	FILE *fp;
	char adsl_pidfile[30];
	int acc_no;
	char sys_cmd[50];
	int ret=0;

	if(session<0&&session>=MAX_PPPOE_SESSION)
		return -1;	
	ret = ReadMultiPPPoESettings(&mpoe_conf);
	if(ret)
		return ret;

	if((acc_no=mpoe_conf.session[session])==-1)
		return -1;
	sprintf(adsl_pidfile, ADSL_PIDFILE, session);
	if((fp=fopen(adsl_pidfile,"r"))!=NULL){
		fclose(fp);
		return 0;
	}
	system("/sbin/route del default >/dev/null 2>&1");
	pConf=&mpoe_conf.account[acc_no];


	fp=fopen(PAP_SECRETS,"w");
	if(!fp)
		return -1;
	fprintf(fp,"%s * %s", pConf->poe_user,pConf->poe_pass);
	fclose(fp);

	fp=fopen(CHAP_SECRETS,"w");
	if(!fp)
		return -1;
	fprintf(fp,"%s * %s", pConf->poe_user,pConf->poe_pass);
	fclose(fp);
	ClearPPPoELog(session);
	sprintf(sys_cmd, "/usr/sbin/adsl start %d  >/dev/null 2>&1", session);
	system(sys_cmd);

	afterWanUp();
	return 0;
}

int StopWanMPPPoE(int session)
{
	FILE *fp;
     	char adsl_pidfile[30];
	char sys_cmd[50];
        if(session<0&&session>=MAX_PPPOE_SESSION)
		return -1;
	sprintf(adsl_pidfile, ADSL_PIDFILE, session);
     	if((fp=fopen(adsl_pidfile,"r"))!=NULL){
		fclose(fp);	
	}else
		return 0;

	sprintf(sys_cmd, "/usr/sbin/adsl stop %d  >/dev/null 2>&1", session);
	system(sys_cmd);
	afterWanDown();
	return 0;
}

int StartWanLocal()
{
	FILE *fp;
	char cmd[128];
	char wan_ip[16]={0},wan_mask[16]={0},wan_broad[16]={0},wan_gw[16]={0};
	unsigned long broadcast;

	ReadLocalSettings(&local_conf);
	sprintf(wan_ip,"%u.%u.%u.%u",
		*((unsigned char*)&local_conf.Local_IP),
		*((unsigned char*)&local_conf.Local_IP+1),
		*((unsigned char*)&local_conf.Local_IP+2),
		*((unsigned char*)&local_conf.Local_IP+3) );
	sprintf(wan_mask,"%u.%u.%u.%u",
		*((unsigned char*)&local_conf.Local_Mask),
		*((unsigned char*)&local_conf.Local_Mask+1),
		*((unsigned char*)&local_conf.Local_Mask+2),
		*((unsigned char*)&local_conf.Local_Mask+3) );
	sprintf(wan_gw,"%u.%u.%u.%u",
		*((unsigned char*)&local_conf.Local_Gateway),
		*((unsigned char*)&local_conf.Local_Gateway+1),
		*((unsigned char*)&local_conf.Local_Gateway+2),
		*((unsigned char*)&local_conf.Local_Gateway+3) );

	broadcast = local_conf.Local_IP & local_conf.Local_Mask;
	sprintf(wan_broad,"%u.%u.%u.%u",
		*((unsigned char*)&broadcast),
		*((unsigned char*)&broadcast+1),
		*((unsigned char*)&broadcast+2),
		*((unsigned char*)&broadcast+3) );

	if(strcmp(wan_ip,"0.0.0.0") && strcmp(wan_mask, "0.0.0.0") && strcmp(wan_gw, "0.0.0.0")){
		sprintf(cmd,"/sbin/ifconfig %s %s netmask %s broadcast %s >/dev/null 2>&1",WAN_IF,wan_ip,wan_mask,wan_broad);
		system(cmd);
		sprintf(cmd,"/sbin/route del default dev %s >/dev/null 2>&1",WAN_IF);
		system(cmd);
		sprintf(cmd,"/sbin/route add default gw %s dev %s >/dev/null 2>&1",wan_gw,WAN_IF);
		system(cmd);
	}
	if((fp=fopen(RESOLV_FILE,"w"))!=NULL){
		fprintf(fp,"nameserver %u.%u.%u.%u\n",
				*((unsigned char*)&local_conf.Local_dns),
				*((unsigned char*)&local_conf.Local_dns+1),
				*((unsigned char*)&local_conf.Local_dns+2),
				*((unsigned char*)&local_conf.Local_dns+3) );
		fclose(fp);
		AddBackupDNS(-1);
	}
	fp=fopen(WANIP_UPTIMEFILE,"w+");
	if(fp){
		fprintf(fp,"%ld",time(0));
		fclose(fp);
	}	
	afterWanUp();
	return 0;
}

int StopWanLocal()
{
	char cmd[80];
	sprintf(cmd,"/sbin/ifconfig %s 0.0.0.0 >/dev/null 2>&1",WAN_IF);
	system(cmd);
	remove(WANIP_UPTIMEFILE);
	afterWanDown();
	return 0;
}

void afterWanUp()
{
	FILE *fp;
	int pid;
	fp=fopen(UPNPD_PIDFILE, "r");
	if(fp){
		pid=0;
		fscanf(fp,"%d",&pid);
		fclose(fp);
		if(pid){
			kill((pid_t)pid, SIGUSR1);
		}
	}else
		StartUPnP();	
	system("/sbin/ez-ipupdate &");
}
void afterWanDown()
{
	FILE *fp;
	int pid;

	fp=fopen(UPNPD_PIDFILE, "r");
	if(fp){
		pid=0;
		fscanf(fp,"%d",&pid);
		fclose(fp);
		if(pid){
			kill((pid_t)pid, SIGUSR1);
		}
	}	
	system("killall ez-ipupdate 2>/dev/null");
}

void cgi_fork_do()
{
	setsid();
	close(0);
	close(1);
	close(2);
	chdir("/");
	umask(0);
	signal(SIGCLD,SIG_IGN);
}
