#ifndef __WAN_H__
#define __WAN_H__

#define _MULTI_PPPOE_
#ifdef _MULTI_PPPOE_

#define	WAN_MaxIPLen	        16
#define	WAN_MaxUserLen	        48
#define	WAN_MaxPassLen	        15
#define	WAN_MaxACNameLen	    21

#define MAX_PPPOE_ACCOUNT 5
#define MAX_PPPOE_SESSION 2

enum{
	PC_AC_NAME,
	PC_CONN_TYPE,
	PC_USER,
	PC_PASS,
	PC_IDLE,
	PC_LAN_TYPE,
	PC_UDP,
	PC_UDP_LEN,
	PC_DNS_TYPE,
	PC_TRAFFIC,
	PC_NETBIOS,
	PC_DNS1,
	PC_DNS2,
	PC_IP,
	PC_MASK,
	PC_ITEM_NUM
};

typedef struct{
	char poe_ac_name[WAN_MaxACNameLen];	
	char conn_type; //0 - normal, 1 - keep alive, 2 - dial on demand
#define MPOE_CONN_NORMAL 	0
#define MPOE_CONN_KEEP 		1
#define MPOE_CONN_DEMAND 	2
	char poe_user[WAN_MaxUserLen];
	char poe_pass[WAN_MaxPassLen];
	unsigned int  poe_idle;			
	char poe_lan_type; // 0 - disable, 1 -  enable
	char poe_udp; //0 - disable, 1 - enable
	unsigned int poe_udp_len;
	char poe_dns_type; //0 - dynamic, 1 - fixed
#define MPOE_DNS_DYNAMIC 	0
#define MPOE_DNS_FIXED 		1
	char poe_traffic;  //0 - disable, 1 - enable
	char poe_netbios;  //0 - disable, 1 - enable
	int poe_dns_1;
	int poe_dns_2;
	int poe_ip;
	int poe_mask;
}PPPOE_CONF;

typedef struct{
	PPPOE_CONF          account[MAX_PPPOE_ACCOUNT];
	int session[MAX_PPPOE_SESSION];
}MULTI_PPPOE_CONF;


#define MAX_TRF_IP             10
#define MAX_TRF_URL            10
#define MAX_TRF_PORT           10

typedef struct{
#define TRF_IP_TYPE_SINGLE            0
#define TRF_IP_TYPE_RANGE             1
#define TRF_IP_TYPE_MASK              2
    char type;
    unsigned int ip;
    unsigned int ip_end;
    unsigned int mask;
}TRF_IP_CONF_s;

typedef struct{
	int trf_ip_num;
	int trf_ip_set;
	TRF_IP_CONF_s trf_ip[MAX_TRF_IP];
}TRF_IP_CONF;

#define TRF_URL_MAX_LEN 128
typedef struct {
    char url[TRF_URL_MAX_LEN];
}TRF_URL_CONF_s;

typedef struct{
	int trf_url_num;
	int trf_url_set;
	TRF_URL_CONF_s trf_url[MAX_TRF_URL];
}TRF_URL_CONF;

typedef struct{
	unsigned int port_s;
    unsigned int port_e;
}TRF_PORT_CONF_s;

typedef struct{
	int trf_port_num;
	int trf_port_set;
	TRF_PORT_CONF_s trf_port[MAX_TRF_PORT];
}TRF_PORT_CONF;

int ReadMultiPPPoESettings(MULTI_PPPOE_CONF *pMConf);
int SaveMultiPPPoESettings(MULTI_PPPOE_CONF *pMConf, int no);

int get_session_from_account(int account_no);/* return  -1 for no set, 0 for pri session, 1 for sec session */
int get_account_from_session(int session_no);/* return 1~MAX_PPPOE_ACCOUNT if ok, return -1 for no set */

int ReadTrfIPSettings(TRF_IP_CONF *pConf, int poe_acc_index);
int SaveTrfIPSettings(TRF_IP_CONF *pConf, int poe_acc_index);

int ReadTrfURLSettings(TRF_URL_CONF *pConf, int poe_acc_index);
int SaveTrfURLSettings(TRF_URL_CONF *pConf, int poe_acc_index);

int ReadTrfPORTSettings(TRF_PORT_CONF *pConf, int poe_acc_index);
int SaveTrfPORTSettings(TRF_PORT_CONF *pConf, int poe_acc_index);
#endif //_MULTI_PPPOE_

/*======================Macro Descript================================*/

/* This value should be move to other directory , should not in cgi. */
#define PPPOE_ACCOUNT_NAME_LEN          21
#define PPPOE_USER_NAME_LEN             49
#define PPPOE_PASSWORD_LEN              49
#define PPPOE_IDLE_MIN                  0
#define PPPOE_IDLE_DEFAULT              15
#define PPPOE_IDLE_MAX                  99


#define DHCP_NAME_LEN           51
#define DOMAIN_NAME_LEN         81


#define	WAN_OK					0			//Succeed
#define	WAN_SaveWANConfErr		-1			//Fail to save WAN settings.
#define	WAN_ReadWANConfErr		-2			//Fail to read WAN settings.
#define	WAN_ReadPPPoEErr		-3			//Fail to read PPPoE settings.
#define	WAN_SavePPPoEErr		-4			//Fail to read PPPoE settings.
#define	WAN_ReadDHCPErr 		-5			//Fail to read DHCP settings.
#define	WAN_SaveDHCPErr	    	-6			//Fail to read DHCP settings.
#define	WAN_ReadModemErr 		-7			//Fail to read Modem settings.
#define	WAN_SaveModemErr	    -8			//Fail to read Modem settings.
#define WAN_ReadTrfIPErr		-9
#define WAN_SaveTrfIPErr		-10
#define WAN_ReadTrfURLErr		-11
#define WAN_SaveTrfURLErr		-12
#define WAN_ReadTrfPORTErr		-13
#define WAN_SaveTrfPORTErr		-14
#define	WAN_SaveLocalConfErr		-15			//ada
#define	WAN_ReadLocalConfErr		-16	                //ada

#define DOD_IP "10.64.64.64"
/*======================Struct Descript================================*/

enum{
    ALWAYSON,
    DOD,
    MANUALLY,
    DIAL_NONE,
    DIAL_MODE_NUM
};

enum{
    SPC_AC_NAME,
    SPC_USER_NAME,
    SPC_PASSWORD,
    SPC_DIAL_MODE,
    SPC_IP_TYPE,
    SPC_DNS_TYPE,
    SPC_DOD_IDLE,
    SPC_MANUAL_IDLE,
    SPC_IP_ADDR,
    SPC_NETMASK,
    SPC_DNS1,
    SPC_DNS2,
    SPC_ITEM_NUM
};

typedef struct{    
    char accountName[PPPOE_ACCOUNT_NAME_LEN];
    char userName[PPPOE_USER_NAME_LEN];
    char password[PPPOE_PASSWORD_LEN];
    int dialMode;                              /* ALWAYS_ON,DOD,MANUALLY */
    char ipType;
    char dnsType;
    int DOD_idleTime;
    int Manual_idelTime;
    int ipAddress;
    int netMask;
    int dns[2];
}SINGLE_PPPOE_CONF;

extern SINGLE_PPPOE_CONF single_pppoe_conf;

enum{
    TYPE_DYNAMIC,
    TYPE_FIXED,
    TYPE_UNNUMBERED,
    TYPE_UNNUMBERED_PRIVATE,
    TYPE_MAX
};


enum{
    DHCP_NAME,
    DHCP_DOMAIN_NAME,
    DHCP_TYPE,
    DHCP_DNS_TYPE,
    DHCP_IP_ADDR,
    DHCP_NETMASK,
    DHCP_GATEWAY,
    DHCP_DNS1,
    DHCP_DNS2,
    DHCP_DNS3,
    DHCP_ITEM_NUM
};
typedef struct{
    char dhcp_name[DHCP_NAME_LEN];
    char domain_name[DOMAIN_NAME_LEN];
    char dhcpc_type;
    char dhcp_dns_type;
    int ipAddress;
    int netMask;
    int Gateway;
    int dns[3];    /* reserver three dns server IP for user */
}DHCP_CONF;

extern DHCP_CONF dhcp_conf;
/******************modem define, struct, function********************************/
#ifdef _WAN_MODEM_

#define MDM_MODEM_NAME_LEN 20
#define MDM_USER_NAME_LEN 61
#define MDM_PASSWORD_LEN 26
#define MDM_SERVICE_NAME_LEN 26
#define MDM_TELEPHONE_LEN 16
#define MDM_AT_CMD_LEN 56
#define MDM_MODEM_INT_LEN 100
enum{
	MDM_MODEM_NAME,
	MDM_USER_NAME,
	MDM_PASSWORD,
	MDM_SERVICE_NAME,
	MDM_TELEPHONE,
	MDM_AT_CMD,
	MDM_DIAL_MODE,
	MDM_DOD_IDLE,
	MDM_MANUAL_IDLE,
	MDM_PPPD_RETRY_ENABLE,
	MDM_DNS_ENABLE,
	MDM_DNS1,
	MDM_DNS2,
	MDM_MODEM_INT,
	MDM_SPEED,
    MDM_ITEM_NUM
};
typedef struct{
    char mdm_modem_name[MDM_MODEM_NAME_LEN];
    char mdm_user_name[MDM_USER_NAME_LEN];
    char mdm_password[MDM_PASSWORD_LEN];
    char mdm_service_name[MDM_SERVICE_NAME_LEN];
    char mdm_telephone[MDM_TELEPHONE_LEN];
    char mdm_at_cmd[MDM_AT_CMD_LEN];
   	int  mdm_dialMode;
    int  mdm_DOD_idleTime;
    int  mdm_Manual_idelTime;   	
   	int  mdm_pppd_retry_enable;
   	int  mdm_dns_enable;
    int  mdm_dns1;   
    int  mdm_dns2; 
    char mdm_modem_int[MDM_MODEM_INT_LEN];
    int  mdm_speed;
}MODEM_CONF;
extern MODEM_CONF mdm_conf;

int ReadModemSettings(MODEM_CONF *pConf);
int SaveModemSettings(MODEM_CONF *pConf);
#endif
/**************************************************************************/
//ada
typedef struct{
   int   Local_IP;
   int   Local_Mask;
   int   Local_Gateway;
   int   Local_dns;
} LOCAL_CONF;

extern LOCAL_CONF local_conf;

/*======================Function Descript================================*/

int ReadSinglePPPoESettings(SINGLE_PPPOE_CONF *pConf);
int SaveSinglePPPoESettings(SINGLE_PPPOE_CONF *pConf);

char IpTypeStr2Char(char *type);
char *IpTypeChar2Str(char type);

int ReadDHCPSettings(DHCP_CONF *pConf);
int SaveDHCPSettings(DHCP_CONF *pConf);
int GetLeaseAndRemainTime(unsigned long *lease_p,unsigned long *remain_p);
#define MAX_POELOG_LEN 5000
void GetPPPoELog(char *buf_out,int session);
void ClearPPPoELog(int session);

int ReadLocalSettings(LOCAL_CONF *pConf);  //ada
int SaveLocalSettings(LOCAL_CONF *pConf);  //ada

int StartWanDHCP(void);
int StartWanSPPPoE(void);
int StopWanDHCP(void);
int StopWanSPPPoE(void);
int StartWan(void);
int StopWan(void);
int StartWanMPPPoE(int session);
int StopWanMPPPoE(int session);
int StartWanLocal();
int StopWanLocal();
void afterWanUp();
void afterWanDown();
int CreatSPPPoEFile(SINGLE_PPPOE_CONF *pConf);
int CreatMPPPoEFile(PPPOE_CONF *pConf,int session);
#define WANIP_UPTIMEFILE "/var/run/ip.uptime"
#define WANPPP0_UPTIMEFILE "/var/run/ppp0.uptime"
#define WANPPP1_UPTIMEFILE "/var/run/ppp1.uptime"


#endif /* _WAN_H_ */
