#include <unistd.h>
#include <sys/time.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include "led.h"
#include "flash.h"
/* add for flash config*/
#include "../libsys/system.h"
#include "wset_by_xml.h"

#define DEF_CONF_FILE       "/htdocs/netgear.cfg"
#define timerinterval(tvp, uvp)     \
( ((tvp)->tv_sec - (uvp)->tv_sec)*1000000 + ((tvp)->tv_usec - (uvp)->tv_usec) )

enum{
    STATE_NORMAL,
    STATE_PRESSED    
};

/*add for flash config*/
int get_lan_mac(char *buf)
{
	FILE *fp;
	char tmp[1024];
	char *pt;
	pt=tmp;
	
	if((fp=fopen("/proc/prom_env","r"))==NULL)
		return 0;
	fread(tmp,1,1024,fp);
	fclose(fp);
	
	if((pt=strstr(tmp,"ethaddr0"))){
		strncpy(buf,pt+9,18); //test=sscanf(pt,"%*s=%x",buf);
        }
	 
	return 0;
}

int COMMAND(const char *format, ...)
{
	char buf[1024]="";
	va_list arg;
	FILE *fp;
	va_start(arg, format);
	vsnprintf(buf,1024, format, arg);
	va_end(arg);
	fp=fopen("/var/cmd_agent","w");
	if(fp==NULL)
		return 1;
	fwrite(buf,1024,1,fp);
	fclose(fp);
	usleep(1);
#ifdef _PC_TEST_
        system(buf);
#endif /* _PC_TEST_ */        
	return 0;
}
/*add for flash config*/
void flashErr(void)
{
#if 0
    turnOffLED(LED_STATUS);
    usleep(200000);
    turnOnLED(LED_STATUS);
//    int j;
//    for(j=0;j<2;j++)
//    {
//        turnOnLED(LED_STATUS);
//        usleep(200000);
//        turnOffLED(LED_STATUS);
//        usleep(200000);
//    }
#endif
	 system ("echo u100>/proc/led");
	 sleep(200000);
}

int main(int argc, char **argv){
    struct timeval firstTime, beginTime, now; /* for restore */
    struct timeval pressTime; /* for reset */
    int state = STATE_NORMAL;
    static int usbdisk_enable = 0;
    int mount_count = 0;
    
    timerclear(&firstTime);
    timerclear(&pressTime);
    
    printf("line<%d>\n",__LINE__);

    initPushButton();
    system ("echo u3>/proc/led");
#if 0
//    initLED(LED_LAN_RESET);
    initLED(LED_POWER);
    initLED(LED_STATUS);
    initLED(LED_WLAN);
#ifdef _TZ50_
    initLED(LED_RF_RESET);
    initLED(LED_RF_STATUS);
    initLED(LED_SPIS);
#endif
//    turnOffLED(LED_LAN_RESET);
//    turnOnLED(LED_LAN_RESET);
#ifdef _TZ50_
    turnOnLED(LED_RF_RESET);
    turnOnLED(LED_RF_STATUS);
    turnOnLED(LED_SPIS);
#endif
    turnOnLED(LED_POWER);
    turnOffLED(LED_STATUS);
#endif

    /* When we begin? */
    gettimeofday(&beginTime,NULL);
  printf("line<%d>\n",__LINE__);
    while(1){
        gettimeofday(&now,NULL);
        
        if(timerinterval(&now,&beginTime) > 5000000 ){ /* If run more than 5 seconds , can not restore anymore. */
            break;
        }       
        
        if( ButtonIsPushed() ) {
            
            if(!timerisset(&firstTime)){
                gettimeofday(&firstTime,NULL);
            }
            else{
                gettimeofday(&now,NULL);
                
                if( timerinterval(&now,&firstTime) > 1000000 ){ /* hold for more then 1 seconds. */
                    /* Do restore. */
                    printf("Do restore....\n");
                    //initLED(LED_STATUS);    
                    //turnOnLED(LED_STATUS);  
                    system ("echo u2>/proc/led");                 
                    flash_write_config(DEF_CONF_FILE,MTD_CONFIG);
                    
                    //turnOffLED(LED_STATUS);
                    system("/bin/reboot");
                    break;
                }
            }
        }
        else{
            if( timerisset(&firstTime) ){
                timerclear(&firstTime);
            }
        }
    
    } /* while(1) */
    
  printf("line<%d>\n",__LINE__);
    /* Process support reset. */
    while(1){        
        usleep(500000);
        if( ButtonIsPushed() ) {
            
            if( STATE_NORMAL == state ){                
                /* Change state to pressed and recorder the press time. */
                state = STATE_PRESSED;                
                gettimeofday(&pressTime,NULL);                
            }
            state = STATE_PRESSED;
        }
        else{
            /* Now button is released */
            if( STATE_PRESSED == state ){
                gettimeofday(&now,NULL);
                if(timerinterval(&now,&pressTime) > 500000 && timerinterval(&now,&pressTime)<5000000 ) { /* press button more than 0.5 seconds */
                    printf("Do restart...\n");
                    system("/bin/reboot");
                    break;
                }else if(timerinterval(&now,&pressTime) > 5000000 ){
                    printf("/bin/umount /var/usbdisk/\n");
                    system("/sbin/rc samba stop >/dev/null 2>&1");
                    system("/bin/umount /var/usbdisk/");
                    system("rm -rf /var/usbdisk");
                    //turnOffLED(LED_STATUS);
                }
                state = STATE_NORMAL;
            }
        } /* if( ButtonIsPushed() ) */
        if(!access("/proc/usbd",F_OK)){
            if(usbdisk_enable == 0){
                FILE*fp_w;
                char* buf;
                int file_len;
                
                //turnOnLED(LED_STATUS);
		system ("echo u2>/proc/led"); 
                usbdisk_enable = 1;
                mount_count = 0;
                printf("/bin/mount -t vfat /dev/sda1 /var/usbdisk/\n");
                system("mkdir /var/usbdisk");
//                system("umask 000");
                system("cp /proc/partitions /var/partitions -f");
                if((file_len=readFileBin("/var/partitions",&buf)) > 0){
                    if(strstr(buf,"sda4")){
printf("find sda4 in partitions\n");
                        system("/bin/mount -tvfat /dev/sda /var/usbdisk/ -o uid=501,gid=501,umaks=006,rw");
                    }
                    else{
printf("can't find sda4 in partitiions\n");
                        system("/bin/mount -tvfat /dev/sda1 /var/usbdisk/ -o uid=501,gid=501,umaks=006,rw");
                    }
                    free(buf);
                }
                system("/sbin/rc samba start >/dev/null 2>&1");
/*add for flash config*/
printf("begin of flash config\n");
config_flash:
                if(!access("/var/usbdisk/SMRTNTKY/WSETTING.WFC",F_OK)){
                    if((file_len=readFileBin("/var/usbdisk/SMRTNTKY/WSETTING.WFC",&buf)) > 0)
                    {
                    	char full_file_name[42]="";
                    	char temp_name_buf[20]="";
                    	char back_file_name[13]="";
                    	
                    	int  rcode; //WSET_SUCCESS,WSET_FAIL,WSET_NOT_SUPPORT...
                    	INT16  sup_rcode; // bitset to identify which element
                    	int i=0,j=0;
//                    	int  fread_num=0;
//                    	if(fread_num=fread(buf,1,MAX_FILE_LEN,fp_r))
//                    	
printf("read file\n");
                    	rcode=wset_xml(buf,&sup_rcode);
printf("config xml\n");
                    	get_lan_mac(temp_name_buf);
                    		//get the later 8 ascii-hex of the lan mac
                    	while(temp_name_buf[i]&& j<12 && i < 20)
                    	{
                    		if(temp_name_buf[i]!= ':')
                    			back_file_name[j++]=temp_name_buf[i++];
                    		else i++;
                    	}
    				    sprintf(full_file_name,"/var/usbdisk/SMRTNTKY/DEVICE/%s.WFC",&back_file_name[4]);    		
//    				FILE* test_f=fopen("/var/usbdisk/smrtntky/device/1.txt","w+t");
printf("write result file\n");
//    				fwrite(full_file_name,1,1000,test_f);
//    				fclose(test_f);
                    	if((fp_w=fopen(full_file_name,"w")))
                    	{
                    		int ret,j=0;
                    		ret=wlan_config_write(fp_w,back_file_name,rcode,sup_rcode);
                    		fclose(fp_w);
                    		if( rcode == WSET_SUCCESS && ret==0)
                    		{
                    			for(;j<3;j++)
                    			{
                    				//initLED(LED_STATUS);    
                       				//turnOffLED(LED_STATUS);  
                       				delay(1);         
                       				//turnOnLED(LED_STATUS);
						system ("echo u2>/proc/led"); 
                       				delay(1); 
                        		}
//                        		turnOffLED(LED_STATUS);
                                system("/sbin/rc wlan restart&");
                    		}
                    		else
                    		{
                    		    flashErr();
                    		    //for(j=0;j<2;j++)
                    		    //{
                                //    turnOnLED(LED_STATUS);
                                //    usleep(200000);
                                //    turnOffLED(LED_STATUS);
                                //    usleep(200000);
                                //}
                            }
                    	}         		
                	    free(buf);
                        delay(1);
                    }
                }
                else{
                    printf("Config file not exists.\n");
                    if(mount_count == 0){
                        char *data;
                        printf("mount again!\n");
                        if((file_len=readFileBin("/var/partitions",&data)) > 0){
                            if(strstr(data,"sda4")){
printf("find sda4 in partitions\n");
                                system("/bin/mount -tvfat /dev/sda /var/usbdisk/ -o uid=501,gid=501,umaks=006,rw");
                            }
                            else{
printf("can't find sda4 in partitiions\n");
                                system("/bin/mount -tvfat /dev/sda1 /var/usbdisk/ -o uid=501,gid=501,umaks=006,rw");
                            }
                            free(data);
                        }
//                        system("/bin/mount -tvfat /dev/sda1 /var/usbdisk/ -o uid=501,gid=501,umaks=006,rw");
                        mount_count++;
                        goto config_flash;
                    }
                    flashErr();
                }
/*add for flash config*/
            }
        }
        else{                                                        
            if(usbdisk_enable == 1){
                usbdisk_enable = 0;
                printf("/bin/umount /var/usbdisk/\n");
                system("/sbin/rc samba stop >/dev/null 2>&1");
                system("/bin/umount /var/usbdisk/");
                system("rm -rf /var/usbdisk");
                //turnOffLED(LED_STATUS);
            }
        }
    } /* while(1) */
    return 0;
}
