#ifndef _FLASH_H_
#define _FLASH_H_


/* We should reference to /drivers/mtd/maps/chip-board.c */

#define	MTD_BOOT                0x01
#define	MTD_CONFIG              0x02
#define	MTD_KERNEL              0x04
#define MTD_SYSTEM              0x08
#define	MTD_MAIN                (MTD_KERNEL|MTD_SYSTEM)

#define BOOT_SIZE               0x00040000
#define CONFIG_SIZE             0x00020000
#define KERNEL_SIZE             0x00100000
#define SYSTEM_SIZE             0x002a0000
#define MAIN_SIZE               (KERNEL_SIZE+SYSTEM_SIZE)

#define	PARTITION_NUM	        4

/* E28F128 - 128*128k */
#define BLOCK_SIZE              0x00020000

int flash_erase_mtd(int which);


int flash_get_configf_size(int which);


int flash_read_config(int which,char *fname,ssize_t size);


int flash_write_config(char *fname,int which);


int flash_write_buf(const char *buf, ssize_t size, int which);



#define	FL_OPEN_DEV_ERR		1
#define	FL_READ_DEV_ERR		2
#define	FL_WRITE_DEV_ERR	3
#define	FL_ERASE_ERR		4
#define	FL_NOT_CONFIG_DEV	5
#define	FL_TOO_LONG_SIZE	6
#define	FL_BAD_CONFIG		7
#define	FL_NO_ENOUGH_MEM	8
#define	FL_OPEN_FILE_ERR	9
#define	FL_WRITE_FILE_ERR	10
#define	FL_BUF_EMPTY		11

#endif
