
#include "wset_by_xml.h"
#include "led.h"


static char configId[36+1];
static char BSSID[32+1];
static char connectionType[4+1];
static char auth[10];
static char encrType[4+1];
static char key[26+1];
static char key_no[1+1];
static char key_Auto[1+1];
static char enable_1x[1+1];
static char eap_method[17+1];
static char channel_2Dot4[2+1];
static char channel_5Dot0[2+1];
static char device_mode[14+1];


static struct variable_s variable[]={
{"configId",get_configId,NULL,configId},
{"ssid",get_ssid,set_ssid,BSSID},
{"connectionType",get_connectionType,NULL,connectionType},
{"authentication",get_auth,set_auth,auth},
{"encryption",get_encrType,set_encrType,encrType},
{"keyIndex",get_key_no,set_key_no,key_no},
{"networkKey",get_key,set_key,key},
{"keyProvidedAutomatically",get_keyAuto,NULL,key_Auto},
{"ieee802Dot1xEnabled",get_1xEnable,NULL,enable_1x},
{"eapMethod",get_eapMethod,NULL,eap_method},
{"channel2Dot4",get_channel_2Dot4,set_channel_2Dot4,channel_2Dot4},
{"channel5Dot0",get_channel_5Dot0,NULL,channel_5Dot0},
{"deviceMode",get_device_mode,NULL,device_mode},
0
};




int get_wg_name(char* buf)
{
	char* data;
	int file_len;
	if(file_len=readFileBin("/var/smb.conf",&data))
	{
		char* wg_name=NULL;
		wg_name=strstr(data,"workgroup =");
		if(wg_name)
		{
			wg_name+=11;
			while(*wg_name!='\n' && *wg_name!='\r')
				*buf++=*wg_name++;
			*buf='\0';
		}
		else
			return 0;
		free(data);
	}
	else
		return 0;
	return 1;
}

void get_wlan_mac(char* buf)
{
	system("/sbin/iwconfig eth2>/var/wlan_cfg.txt");
	char* data;
	int file_len;
	int i=0;
	if(file_len=readFileBin("/var/wlan_cfg.txt",&data))
	{
		system("/bin/rm -f /var/wlan_cfg.txt");
		char* macAddr=strstr(data,"MAC Address:");
		if(macAddr)
		{
			macAddr+=12;
			macAddr=strpbrk(macAddr,":");
			macAddr+=3;
			while(*macAddr!='\n' && *macAddr!='\r')
			{
				if(*macAddr!=':')
					*buf++=*macAddr++;
				else
					macAddr++;
			}
			*buf='\0';
		}
		free(data);
       }
}

int get_wan_ip(char *buf)
{
	system("/sbin/ifconfig eth1>/var/wan_cfg.txt");
	char* data;
	int file_len;
	
	if(file_len=readFileBin("/var/wan_cfg.txt",&data))
	{
		system("/bin/rm -f /var/wan_cfg.txt");
		char* wanIP=strstr(data,"inet addr:");
		if(wanIP)
		{
			wanIP+=10;
			while(*wanIP!=' ')
				*buf++=*wanIP++;
			*buf='\0';
		}
		else return 0;
		free(data);
	}
	else return 0;
	return 1;
}

int get_wan_mac(char* buf)
{
	system("/sbin/ifconfig eth1>/var/wan_cfg.txt");
	char* data;
	int file_len;
	
	if(file_len=readFileBin("/var/wan_cfg.txt",&data))
	{
		system("/bin/rm -f /var/wan_cfg.txt");
		char* wanMac=strstr(data,"HWaddr ");
		if(wanMac)
		{
			wanMac+=13;
			while(*wanMac!='\n' && *wanMac!='\r' && *wanMac!=' ')
			{
				if(*wanMac!=':')
					*buf++=*wanMac++;
				else
					wanMac++;
			}
			*buf='\0';
		}
		else return 0;
	}
	else return 0;
	return 1;
}


int get_fw_version(char *buf)
{
	BYTE tmp[512];
	VCI_TABLE Pid;
	PID  *pid_p=NULL;
	int fd1,ret=0;
        memset(tmp,'\0',512);
	
	fd1=open("/dev/mtd0",0/*O_RDONLY*/);
	if(fd1<0)
		return 0;
	ret=lseek(fd1,64*1024-63,SEEK_SET);
	if(ret!=64*1024-63){
		close(fd1);
		return 0;
	}
	if(read(fd1,(BYTE *)&Pid,sizeof(VCI_TABLE))!=sizeof(VCI_TABLE)){
		close(fd1);
		return 0;
	}
	close(fd1);
	memcpy(tmp,(BYTE *)&Pid.VerControl,VCI_LEN);
	pid_p = (PID *)tmp;
	sprintf(buf, "Version %d.%d Release %02d", ((pid_p->wFwVersion & 0xf000)>>12), ((pid_p->wFwVersion & 0x0f00)>>8), (pid_p->wFwVersion & 0xff));
	return 0;
	
}

int get_configId(char* value)
{
	if(strlen(value)>36)
		return 0;
	else return 1;
}

int get_keyAuto(char* value)
{
	if(strcmp(value,"1") && strcmp(value,"0"))
		return 0;
	else	return 1;
}

int get_1xEnable(char* value)
{
	
	if( strcmp(value,"0") && strcmp(value,"1"))
		return 0;
	else	return 1;
}

int get_eapMethod(char* value)
{
	if(strcmp(value,"EAP-TLS") && strcmp(value,"PEAP-EAP-MSCHAPv2") && strcmp(value,"PEAP-EAP-TLS"))
		return 0;
	else	return 1;
}




int get_ssid(char* value)
{
	if(strlen(value)>32)
		return 0;
	else
		return 1;
}

int set_ssid(char* value)
{
	nvram_set("wifi_ssid",value);
	return 0;
}



//set_connectionType(IBSS or ESS) is NULL

int get_connectionType(char* value)
{
	if(strcmp(value,"ESS") && strcmp(value,"IBSS"))
		return 0;
	else	return 1;
	
}

int get_auth(char* value)
{
	if( strcmp(value,"open") && strcmp(value,"shared") && strcmp(value,"WPA-NONE")  \ 
       	    && strcmp(value,"WPA") && strcmp(value,"WPAPSK") && strcmp(value,"WPA2") && strcmp(value,"WPA2PSK"))
		return 0;
	else	return 1;
}

int set_auth(char* value)
{
	if(strcmp(value,"open")==0)
		nvram_set("wifi_auth_type","1");
	else if(strcmp(value,"shared")==0)
		nvram_set("wifi_auth_type","2");
	else if(strcmp(value,"WPA-NONE")==0)
		nvram_set("wifi_auth_type","0");

	//now wgt634 only support just 3 authentications, later update
	else
	      ;//break;
	return 0;
}


int get_encrType(char* value)
{
	if(strcmp(value,"none") && strcmp(value,"WEP") && strcmp(value,"TKIP") && strcmp(value,"AES"))
		return 0;
        return 1;	
}


int set_encrType(char* value)
{
	if(strcmp(value,"none")==0)
	{
		nvram_set("wifi_wep_on","0");
		nvram_set("wifi_key_len","0");
	}
		
	else if(strcmp(value,"WEP")==0)
		nvram_set("wifi_wep_on","1");
		
	else 
	    ;
	
	return 0;
}

int is_all_hex(char* value)
{
	while(*value)
	{
		char v = *value++;
		if (!( (v >= '0' && v <= '9')|| (v >= 'A' && v <= 'F') || (v >= 'a' && v <= 'f')))
			return 0;
	}
	return 1;
}


int get_key(char* value)
{
	int l=strlen(value);
	if( ((l==10 || l==26) && is_all_hex(value) ) || (l==5 || l==13  ) )
	{
			if(strcmp(key_Auto,"0")==0 && strcmp(enable_1x,"0")==0 )
				return 1;
			else
				return 0;
	}
	else return 0;	
}

int set_key(char* value)
{
	char set_value[26+1];
	int key_len=strlen(value);
	if(key_len ==5 || key_len==13)
	{
		int i=0;
		
		while(value[i]!='\0')
		{
			sprintf(set_value+2*i,"%x",value[i]);
			i++;
		}
		set_value[2*i]='\0';
		strcpy(value,set_value);
			
	}
	
	if(strcmp(key_no,"1")==0)
		nvram_set("wifi_key1",value);
	else if(strcmp(key_no,"2")==0)
		nvram_set("wifi_key2",value);
	else if(strcmp(key_no,"3")==0)
		nvram_set("wifi_key3",value);
	else if(strcmp(key_no,"4")==0)
		nvram_set("wifi_key4",value);
	else
	{
		nvram_set("wifi_def_key","1");
		nvram_set("wifi_key1",value);
	}
	nvram_set("wifi_key_len",(key_len==10 || key_len==5)?"64":"128");
	nvram_set("wifi_wep_on","1");
	return 0;
}

int get_key_no(char* value)
{
	if(strcmp(value,"1") && strcmp(value,"2") &&  strcmp(value,"3") &&  strcmp(value,"4"))
		return 0;
	else
		return 1;
}

int set_key_no(char* value)
{
	nvram_set("wifi_def_key",value);
	return 0;
}


int get_channel_2Dot4(char* value)
{
	int channel=atoi(value);
	if( channel > 14 || channel < 1 )
		return 0;
	else return 1;
}

int set_channel_2Dot4(char* value)
{
	nvram_set("wifi_channel",value);
	return 0;
}

int get_channel_5Dot0(char* value)
{
	return 1;
}

int get_device_mode(char* value)
{
	if(strcmp(value,"Infrastructure") && strcmp(value,"Bridge") && strcmp(value,"Repeater")&& strcmp(value,"Station"))
		return 0;
	else	return 1;
}

int required_option_match()
{
	if( !strlen(configId) || !strlen(BSSID) || !strlen(connectionType) || !strlen(auth) \
	    || !strlen(encrType) ||! strlen(key) || !strlen(key_Auto) || !strlen(enable_1x))
	   	return 0;
	else 	return 1;
}

INT16 wgtsup_match()
{
	INT16 rcode=0x0000;
	if(strlen(connectionType) && strcmp(connectionType,"IBSS")==0) 
		rcode=rcode | BitConnType ;
	if(strlen(auth) && strcmp(auth,"open") && strcmp(auth,"shared") && strcmp(auth,"WPA-NONE") )
		rcode=rcode | BitAuthType;
	if(strlen(encrType) && strcmp(encrType,"none")&& strcmp(encrType,"WEP")) 
		rcode=rcode | BitEncrType;
	if(strlen(key_Auto) && strcmp(key_Auto,"1")==0 )
		rcode=rcode | BitKeyAuto;
	if(strlen(enable_1x) && strcmp(enable_1x,"1")==0) 
		rcode=rcode | BitEnable1x;
	if(strlen(channel_5Dot0))
		rcode=rcode | BitChan5Dot0;
	if(strlen(device_mode) && strcmp(device_mode,"Infrastructure"))
	    	rcode=rcode | BitDeviceMode;
	char buf[20]="";
	sprintf(buf,"%lx",rcode);
	return rcode;
}

int rules_match()
{

	if(strncmp(connectionType,"IBSS",4)==0) //RULE 1
	{
		if(!(strcmp(auth,"open")==0 || strcmp(auth,"shared")==0 || strcmp(auth,"WPA-NONE")==0) \
		    || !strcmp(key_Auto,"1") || !strcmp(enable_1x,"1"))
			return 0;
	}
	if(strcmp(encrType,"none") && strcmp(enable_1x,"0") && !strlen(key))  //RULE 2
		return 0;
	if(strlen(key)!=0 && (strcmp(key_Auto,"1")==0 || strcmp(enable_1x,"1")==0)) //RULE 3
		return 0;   
	//RULE 4 have embedded into get_key() function;
	if(strcmp(enable_1x,"1")==0   \
	        && (strcmp(key_Auto,"0")==0 || strlen(key)!=0 \
	            ||( strcmp(eap_method,"EAP-TLS") && strcmp(eap_method,"PEAP-EAP-MSCHAPv2") && strcmp(eap_method,"PEAP-EAP-TLS"))))
	        return 0;  
	return 1;
}


int wset_xml(char* filebuf,INT16* sup_rcode)
{
	*sup_rcode=0;
	struct variable_s * k;
	
	memset(configId,0,37);
	memset(BSSID,0,33);
	memset(connectionType,0,5);
	memset(auth,0,10);
	memset(encrType,0,5);
	memset(key,0,27);
	memset(key_no,0,2);
	memset(key_Auto,0,2);
	memset(enable_1x,0,2);
	memset(eap_method,0,18);
	memset(channel_2Dot4,0,3);
	memset(channel_5Dot0,0,3);
	memset(device_mode,0,15);
printf("wset_xml\n");
	if(tag_value_set(filebuf)==0) //all existed values have been set in variable
	{	
		/*FILE *fp;int i=0;
                char buf_value[1000]="";
                if(fp=fopen("/var/usbdisk/SMRTNTKY/DEVICE/value.txt","w+t"))
               	{
                	sprintf(buf_value,"ssid<%s>\nconnectionType<%s>\nauth<%s>\nencrType<%s>\nkey<%s>\nkey_no<%s>\nkey_Auto<%s>\nenable_1x<%s>\neap_method<%s>\n",BSSID,connectionType,auth,encrType,key,key_no,key_Auto,enable_1x,eap_method);
                	fwrite(buf_value,1,1000,fp);
                	fclose(fp);
               	}*/
		if(!required_option_match())
{
printf("miss required config\n");
			return WSET_LACK_REQUIRED;
}
		if(*sup_rcode=wgtsup_match())
{
printf("config not support\n");
			return WSET_NOT_SUPPORT;
}
		
		if(!rules_match())
{
printf("rules not match\n");
			return WSET_RULES_DISMATCH;
}
printf("set config\n");
		for(k=variable;k->tag_name;k++)
		{
printf("name=%s,value=%s\n",k->tag_name,k->tag_value);
			if(strlen(k->tag_value)  && k->r2tfun(k->tag_value) && k->t2rfun!=NULL)  //if comform to the rules
{
printf("%s set value %s\n",k->tag_name,k->tag_value);
	 			k->t2rfun(k->tag_value);
}
	 		else if(strlen(k->tag_value) && !k->r2tfun(k->tag_value))
{
printf("%s value %s invalid\n",k->tag_name,k->tag_value);
	 			return WSET_SCHEMA_INVALID;
}
	 	}
		nvram_commit();
//		turnOnLED(LED_STATUS);
//                delay(2); 
//                turnOffLED(LED_STATUS);
		return WSET_SUCCESS;
	}
	else{
printf("config invalid\n");
		return WSET_SCHEMA_INVALID;
}
}

int wlan_config_write(FILE* fp,char* lan_mac,int status,INT16 sup_rcode)
{
	int ret=0;
	int sup_buf_count=0,buf_count=0;
	char not_sup_buf[120]="";
	char fw_ver_buf[25]="";
	char wGroup_name[20]="";
	char wlan_mac[8+1]="";
	char wan_ip[16]="";
	char wan_mac[9]="";
	char configAuthorId[36+1]="";
	strncpy(configAuthorId,configId,24);
	sprintf(configAuthorId+24,"%s",lan_mac);
	get_fw_version(fw_ver_buf);
	get_wlan_mac(wlan_mac);
	if(sup_rcode & BitConnType)
		sup_buf_count+=sprintf(not_sup_buf+sup_buf_count,"%s ",variable[CONNTYPE].tag_value);

	if(sup_rcode & BitAuthType)
		sup_buf_count+=sprintf(not_sup_buf+sup_buf_count,"%s ",variable[AUTHENTICATION].tag_value);
	
	if(sup_rcode & BitEncrType)
		sup_buf_count+=sprintf(not_sup_buf+sup_buf_count,"%s ",variable[ENCRYPTION].tag_value);
	
	if(sup_rcode & BitKeyAuto)
		sup_buf_count+=sprintf(not_sup_buf+sup_buf_count,"%s ",variable[KEYPROVIDEDAUTOMATICALLY].tag_value);
	
	if(sup_rcode & BitEnable1x)
		sup_buf_count+=sprintf(not_sup_buf+sup_buf_count,"%s ",variable[IEEE802DOT1XENABLED].tag_value);
		
	if(sup_rcode & BitChan5Dot0)
		sup_buf_count+sprintf(not_sup_buf+sup_buf_count,"%s ",variable[CHANNEL5DOT0].tag_value);
		
	if(sup_rcode & BitDeviceMode)
		sup_buf_count+=sprintf(not_sup_buf+sup_buf_count,"%s ",variable[DEVICEMODE].tag_value);
	
	
	int len=-1;
	char buf[MAX_FILE_LEN]="";
	buf_count+=sprintf(buf+buf_count,"<?xml version=\"1.0\"?>\r\n");
	buf_count+=sprintf(buf+buf_count,"<device xmlns=\"http://www.microsoft.com/provisioning/DeviceProfile/2004\">\r\n");
	buf_count+=sprintf(buf+buf_count,"\t<configId>%s</configId>\r\n",configId);
	if(status==WSET_NOT_SUPPORT || status==WSET_SCHEMA_INVALID || status==WSET_LACK_REQUIRED || status==WSET_RULES_DISMATCH)
	{
	    buf_count+=sprintf(buf+buf_count,"<configError>");
	    if(status==WSET_NOT_SUPPORT)
	    {
			buf_count+=sprintf(buf+buf_count,"%sNot supported by this Device",not_sup_buf);
			ret=1;
	    }
	    else if(status==WSET_SCHEMA_INVALID || status==WSET_LACK_REQUIRED || status==WSET_RULES_DISMATCH)
	    {
			buf_count+=sprintf(buf+buf_count,"SchemaInvalid");
			ret=1;
	    }
	    buf_count+=sprintf(buf+buf_count,"</configError>\r\n");
	}
	buf_count+=sprintf(buf+buf_count,"\t<manufacturer>Sercomm</manufacturer>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<manufacturerURL>www.sernet.com.cn</manufacturerURL>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<deviceStatus>deviceStatus???</deviceStatus>\r\n");
	buf_count+=sprintf(buf+buf_count,"\t<modelName>wgt634</modelName>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<modelURL>%s</modelURL>\r\n",nvram_safe_get("lan_ipaddr"));
	buf_count+=sprintf(buf+buf_count,"\t<serialNumber>%s</serialNumber>\r\n",lan_mac);
	buf_count+=sprintf(buf+buf_count,"\t<deviceType>Access_Point</deviceType>\r\n");
	buf_count+=sprintf(buf+buf_count,"\t<firmwareVersion>%s</firmwareVersion>\r\n",fw_ver_buf);
	//buf_count+=sprintf(buf+buf_count,"<presentationURL>presentationURL???</presentationURL>\r\n");
	//buf_count+=sprintf(buf+buf_count,"<additionalInstallInformation>additionalInstallInformation???</additionalInstallInformation>\r\n");
	
	//workgroup
//	buf_count+=sprintf(buf+buf_count,"<workgroup>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<deviceName>deviceName???</deviceName>\r\n");
	/****************TO WIRTE**************************/
//	if(get_wg_name(wGroup_name))
//		buf_count+=sprintf(buf+buf_count,"<workgroupName>%s</workgroupName>\r\n",wGroup_name);
//	/**************************************************/
//	buf_count+=sprintf(buf+buf_count,"<deviceDescription>deviceDescription???</deviceDescription>\r\n");
//	buf_count+=sprintf(buf+buf_count,"</workgroup>\r\n");
//	
//	//lan interface
//	buf_count+=sprintf(buf+buf_count,"<networkInterface>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<IPv4Address>%s</IPv4Address>\r\n",nvram_safe_get("lan_ipaddr"));
//	buf_count+=sprintf(buf+buf_count,"<macAddress>%s</macAddress>\r\n",&lan_mac[4]);
//	buf_count+=sprintf(buf+buf_count,"<interfaceStatus>active</interfaceStatus>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<mediaType>802.3</mediaType>\r\n<speed>100000000</speed>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<DHCP>1</DHCP>\r\n");
//	buf_count+=sprintf(buf+buf_count,"</networkInterface>\r\n");
//	
//	//wan interface
//	buf_count+=sprintf(buf+buf_count,"<networkInterface>\r\n");
//	if(get_wan_ip(wan_ip))
//	  	buf_count+=sprintf(buf+buf_count,"<IPv4Address>%s</IPv4Address>\r\n",wan_ip);
//	if(get_wan_mac(wan_mac))
//		buf_count+=sprintf(buf+buf_count,"<macAddress>%s</macAddress>\r\n",wan_mac);
//	buf_count+=sprintf(buf+buf_count,"<interfaceStatus>active</interfaceStatus>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<mediaType>802.3</mediaType>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<speed>100000000</speed>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<DHCP>0</DHCP>\r\n");
//	buf_count+=sprintf(buf+buf_count,"</networkInterface>\r\n");
//	
//	//wlan interface
//	buf_count+=sprintf(buf+buf_count,"<networkInterface>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<IPv4Address>%s</IPv4Address>\r\n",nvram_safe_get("lan_ipaddr"));
//	buf_count+=sprintf(buf+buf_count,"<macAddress>%s</macAddress>\r\n",wlan_mac);
//	buf_count+=sprintf(buf+buf_count,"<interfaceStatus>active</interfaceStatus>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<mediaType>802.11</mediaType>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<speed>%s</speed>\r\n",nvram_safe_get("wifi_dot11_mode")==1?"11000000":"54000000");
//	buf_count+=sprintf(buf+buf_count,"<DHCP>1</DHCP>\r\n");
//	buf_count+=sprintf(buf+buf_count,"</networkInterface>\r\n");
//	
//	//authentication
//	buf_count+=sprintf(buf+buf_count,"<wifiAuthentication>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<open>%s</open>\r\n",strcmp(auth,"open")==0?"1":"0");
//	buf_count+=sprintf(buf+buf_count,"<shared>%s</shared>\r\n",strcmp(auth,"shared")==0?"1":"0");
//	buf_count+=sprintf(buf+buf_count,"<WPA-NONE>%s</WPA-NONE>\r\n",strcmp(auth,"WPA-NONE")==0?"1":"0");
//	buf_count+=sprintf(buf+buf_count,"<WPA>0</WPA>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<WPAPSK>0</WPAPSK>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<WPA2>0</WPA2>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<WPA2PSK>0</WPA2PSK>\r\n");
//	buf_count+=sprintf(buf+buf_count,"</wifiAuthentication>\r\n");
//		
//	//encryption
//	buf_count+=sprintf(buf+buf_count,"<wifiEncryption>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<none>%s</none>\r\n",strcmp(encrType,"none")==0?"1":"0");
//	buf_count+=sprintf(buf+buf_count,"<WEP>%s</WEP>\r\n",strcmp(encrType,"WEP")==0?"1":"0");
//	buf_count+=sprintf(buf+buf_count,"<TKIP>0</TKIP>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<AES>0</AES>\r\n");
//	buf_count+=sprintf(buf+buf_count,"</wifiEncryption>\r\n");
//	
//	//wifiInfrastructure
//	buf_count+=sprintf(buf+buf_count,"<wifiInfrastructure>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<ssid>%s</ssid>\n<macAddress>%s</macAddress>\r\n",BSSID,&lan_mac[4]);
//	buf_count+=sprintf(buf+buf_count,"<visibleNetworkType>%s</visibleNetworkType>\r\n",atoi(nvram_safe_get("wifi_dot11_mode"))==1?"ieee802Dot11b":"ieee802Dot11g");
////printf("channel is %s\n",channel_2Dot4);
////printf("wifi_channel is %s\n",nvram_safe_get("wifi_channel"));
//	buf_count+=sprintf(buf+buf_count,"<channel>%s</channel>\r\n",/*strlen(channel_2Dot4)!=0?channel_2Dot4:*/nvram_safe_get("wifi_channel"));
//	buf_count+=sprintf(buf+buf_count,"</wifiInfrastructure>\r\n");
//	
//	//wifiAccessPoint
//	buf_count+=sprintf(buf+buf_count,"<wifiAccessPoint>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<ieee802Dot11a>0</ieee802Dot11a>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<ieee802Dot11b>%s</ieee802Dot11b>\r\n",atoi(nvram_safe_get("wifi_dot11_mode"))==1?"1":"0");
//	buf_count+=sprintf(buf+buf_count,"<ieee802Dot11g>%s</ieee802Dot11g>\r\n",atoi(nvram_safe_get("wifi_dot11_mode"))==1?"0":"1");
//	buf_count+=sprintf(buf+buf_count,"<securityType>\r\n");
//	buf_count+=sprintf(buf+buf_count,"<basic>1</basic>\r\n<WPA>0</WPA>\r\n<WPA2>0</WPA2>\r\n");
//	buf_count+=sprintf(buf+buf_count,"</securityType>\r\n");
//	buf_count+=sprintf(buf+buf_count,"</wifiAccessPoint>\r\n");
	
	buf_count+=sprintf(buf+buf_count,"</device>");
	len=fwrite(buf,1,buf_count,fp);
	if(len)
		ret=0;
	else ret=1;
	return ret;			
}
int tag_value_set(char* filebuf)
{
	int i=0;
	char* entry,*entry_buf;
	char conduct_buf[MAX_FILE_LEN]="";
	char temp_tag[128];
	struct variable_s* k= variable;
printf("tag_value_set\n");
	for(;k->tag_name;k++,i++)
	{
printf("find tag_name %s",k->tag_name);
		memset(temp_tag,0,128);
		sprintf(temp_tag,"<%s",k->tag_name);
		memset(conduct_buf,0,MAX_FILE_LEN);
		strcpy(conduct_buf,filebuf);
		entry=strstr(conduct_buf,temp_tag);
		
		if(entry==NULL)
{
printf("can't find entry \"%s\"\n",k->tag_name);
			continue;
}
		if(tag_parse(entry,k->tag_value)==D_ERROR) 
{
printf("tag_parse failed\n");
			return 1;
}
	}
	return 0;
}



int tag_parse(char* buf,char* v)
{
	char* tag,*end_t,*end_s,*tag_name,*tag_value,*tag_end;
	struct variable_s * k = variable;
	char element_end[25]="";
	tag_name=tag_end=buf;
	if((tag=strchr(tag_end,'<'))==0)
		return D_ERROR;
    tag++;
    if((end_t=strchr(tag,'>'))){
        *end_t++ ='\0';
printf("parse tag %s",tag);
        if((end_s=strchr(tag,' '))){
printf("find space\n");
            *end_s ='\0';
        }
    }
	else
	 	return D_ERROR;
printf("tag=%s\n",tag);

	while(tag && *tag)
	{
		if(!strncmp(tag,"xmlns",5))
	 	  	;
	 	if(!strncmp(tag,"dt",2))
	 	 	;
	 	else
	 		tag_name=tag;
	 	tag=strpbrk(tag," \t");
	 	if(tag)
	 		*tag++='\0';
	 }
	 tag_value=end_t;
	 sprintf(element_end,"</%s>",tag_name);
printf("element_end=%s",element_end);
	 if((tag_end=strstr(tag_value,element_end)))
	 	*tag_end++='\0';
	 else
	 	return D_ERROR;
	 
	 strcpy(v,tag_value);
	 return D_SUCCESS;	
}

