#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nvram.h"
#include "../libsys/system.h"
struct variable_s{
   char* tag_name;
   int (*r2tfun)(char* value);//put the value of the tag_name to the module
   int(*t2rfun)(char* value);//set the value into the NVRAM
   char* tag_value;  
   };
 

enum{
WSET_SUCCESS,
WSET_SCHEMA_INVALID,
WSET_LACK_REQUIRED,
WSET_RULES_DISMATCH,
WSET_NOT_SUPPORT
/*WSET_NOT_SUP_CONNTYPE,
WSET_NOT_SUP_AUTHTYPE,
WSET_NOT_SUP_ENCRTYPE,
WSET_NOT_SUP_KEYAUTO,
WSET_NOT_SUP_ENABLE1X,
WSET_NOT_SUP_EAPMETH,
WSET_NOT_SUP_CHAN5DOT0,
WSET_NOT_SUP_DEVICEMODE*/
};

enum{
D_SUCCESS,
D_ERROR
};
#define BitConfigId 0x0001
#define BitSsid     0x0002
#define BitConnType 0x0004
#define BitAuthType 0x0008
#define BitEncrType 0x0010
#define BitNtKey    0x0020
#define BitKeyIndex 0x0040
#define BitKeyAuto  0x0080
#define BitEnable1x 0x0100
#define BitEapMeth  0x0200
#define BitChan2Dot4 0x0400
#define BitChan5Dot0 0x0800
#define BitDeviceMode 0x1000

#define CONFIGID  0
#define SSID      1
#define CONNTYPE  2
#define AUTHENTICATION 3
#define ENCRYPTION  4
#define KEYINDEX  5
#define NETWORKKEY  6
#define KEYPROVIDEDAUTOMATICALLY   7
#define IEEE802DOT1XENABLED   8
#define EAPMETHOD   9
#define CHANNEL2DOT4  10
#define CHANNEL5DOT0  11
#define DEVICEMODE  12

#define MAX_FILE_LEN 32767

int get_configId(char* value);

int get_ssid(char* value);
int set_ssid(char* value);

int get_connectionType(char* value);

int get_auth(char* value);
int set_auth(char* value);

int get_encrType(char* value);
int set_encrType(char* value);

int get_key(char* value);
int set_key(char* value);

int get_key_no(char* value);
int set_key_no(char* value);

int get_keyAuto(char* value);

int get_1xEnable(char* value);

int get_eapMethod(char* value);

int get_channel_2Dot4(char* value);
int set_channel_2Dot4(char* value);

int get_channel_5Dot0(char* value);
int get_device_mode(char* value);

INT16 wgtsup_match();
int rules_match();
int tag_value_set(char* filebuf);
int tag_parse(char* buf,char* v);

int wset_xml(char* filebuf,INT16* sup_rcode);
int wlan_config_write(FILE* fp,char* lan_mac,int status,INT16 sup_rcode);
