#include "udhcp_cfg.h"
#include "lan_cfg.h"
#include "httpd_cfg.h"
#include "syslog_cfg.h"
#include "rt_route.h"
#include "rt_util.h"
#include "rt_rip.h"
#include "ddns_cfg.h"
#include "wan.h"
#include "wan_basic.h"
#include "ntp_cfg.h"
#include "wireless.h"
#include "fw_cfg.h"
#include "upnp_cfg.h"
#include "smbd_cfg.h"

typedef int (*RcFun)(void);

typedef struct apfun_tab{
        char *name;
	RcFun 	startfun;
	RcFun	stopfun;
	RcFun	createfun;
}apfun_tab;

/* note The ap_name must different */
//new application add in those table				
static apfun_tab ap_fun_tab[]={
{"lan",start_lan,NULL,init_lan},
{"wlan",start_wireless,stop_wireless,NULL},//start_wifi,stop_wifi,save_wifi},
{"httpd",start_httpd,stop_httpd,create_httpd_cfg},
{"syslogd",start_syslog,stop_syslog,create_syslog},
{"dhcpd",start_dhcp_server,stop_dhcp_server,create_dhcp_server_cfg},
{"ntp",start_ntp,stop_ntp,NULL},
#if 0
{"upnp",start_upnp,stop_upnp,NULL},
#endif
{"route",start_static_route,stop_static_route,NULL},
//{"samba",start_smbd,stop_smbd,create_smb_cfg},
//{"ripd",start_rip_daemon,stop_rip_daemon,create_rip_daemon_cfg},
{NULL,NULL,NULL,NULL}
};

static apfun_tab wan_fun_tab[]={
{"wan_basic",start_wan_basic,stop_wan_basic,NULL}, /* ntp dproxy mtu upnp */
{"firewall",start_firewall,stop_firewall,create_firewall_cfg},
//{"ddns",start_ddns_update,NULL,NULL},
{NULL,NULL,NULL,NULL}
};
