#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <net/if.h>
#include "nvram.h"
#include "rc.h"
#define MAIL_SUBJECT "NETGEAR Security Log"
#define SYSLOG_CONF "/etc/syslog.conf"
int create_syslog()
{
	FILE *fp;
	char tmp[1024];
	char buf[128];
	char *pt=nvram_safe_get("wan_macaddr");
	
	if(strlen(pt)>0){
		strcpy(buf,pt);
	}
        else{	
            int sockd;
            struct ifreq ifr;
            sockd = socket(AF_INET, SOCK_STREAM, 0);
            if(sockd == -1){
		strcpy(buf,"00:01:02:03:04:05");
            }
            else{
                strcpy(ifr.ifr_name, "eth1" );
                if(ioctl(sockd, SIOCGIFHWADDR, &ifr) < 0) {
		    strcpy(buf,"00:01:02:03:04:05");
                }
                else{
                    sprintf(buf, "%02x:%02x:%02x:%02x:%02x:%02x",
                           ifr.ifr_hwaddr.sa_data[0],ifr.ifr_hwaddr.sa_data[1], 
                           ifr.ifr_hwaddr.sa_data[2],ifr.ifr_hwaddr.sa_data[3], 
                           ifr.ifr_hwaddr.sa_data[4],ifr.ifr_hwaddr.sa_data[5]); 
                    }
	}
	
#if 0
	if((fp=fopen("/proc/sys/dev/adam2/environment","r"))!=NULL){
		
		fread(tmp,1024,1,fp);
		fclose(fp);
		if((pt=strstr(tmp,"macb")))
			sscanf(pt,"%*s %s",buf);
		else
			strcpy(buf,"00:01:02:03:04:05");
	}else
		strcpy(buf,"00:01:02:03:04:05");
#endif /* 0 */            
        }
		
	if((fp=fopen(SYSLOG_CONF,"w+"))==NULL) return -1;
	fprintf(fp,"mail_enable=%s\n",nvram_safe_get("mail_enable"));
	fprintf(fp,"mail_log_full=%s\n",nvram_safe_get("mail_logfull"));
	fprintf(fp,"mail_server=%s\n",nvram_safe_get("mail_server"));
	fprintf(fp,"mail_receiver=%s\n",nvram_safe_get("mail_recipient"));
	fprintf(fp,"mail_subject=%s [%s]\n",MAIL_SUBJECT,buf+9);
	fprintf(fp,"mail_subject_alert=%s [%s]\n","NETGEAR *Security Alert*",buf+9);
	fprintf(fp,"mail_keyword=%s %s %s\n"
			,(*(nvram_safe_get("mail_dos"))=='1')?"[DOS]":""
			,(*(nvram_safe_get("mail_portscan"))=='1')?"[PORT SCAN]":""
			,(*(nvram_safe_get("mail_block"))=='1')?"[BLOCK]":"");
	fprintf(fp,"TZ=%s\n",nvram_safe_get("time_zone"));
	fprintf(fp,"daylight=%s\n",nvram_safe_get("time_daylight"));
		
	if(*nvram_get("log_type")=='1'){
		struct in_addr in;
		unsigned long lan=inet_network(nvram_get("lan_ipaddr"));
		unsigned long mask=inet_network(nvram_get("lan_netmask"));
		in.s_addr=htonl(lan|~mask);
		fprintf(fp,"log_remote_ip=%s\n",inet_ntoa(in));
	}else if(*nvram_get("log_type")=='2')
		fprintf(fp,"log_remote_ip=%s\n",nvram_safe_get("log_remote_ip"));
	fprintf(fp,"log_auth=%s\n",nvram_safe_get("log_login"));
	fprintf(fp,"log_syslog=%s\n",nvram_safe_get("log_gateway"));
		
	if(*(nvram_safe_get("log_dos"))=='1' 
			|| (*(nvram_safe_get("log_block"))=='1')){
		fprintf(fp,"log_local0=1\n");
		fprintf(fp,"log_keyword=%s %s\n"
			,(*(nvram_safe_get("log_dos"))=='1')?"[DOS] [PORT SCAN]":""
			,(*(nvram_safe_get("log_block"))=='1')?"[BLOCK]":"");

	}

	fclose(fp);
	return 0;	
}

int start_syslog()
{
	create_syslog();
	usleep(1);
	//system("/bin/killall -SIGUSR2 syslogd");
	system("/sbin/syslogd -f /etc/syslog.conf");
	system("/sbin/klogd");			
	return 0;
}
int stop_syslog() 
{
	system("/bin/killall syslogd");
	system("/bin/killall klogd");
	//sleep(1);
	return 0;
}
