#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "nvram.h"
#include "rt_util.h"
#include "rt_route.h"

#define ROUTE_ADD   1
#define ROUTE_DEL   0


int handle_static_route(int type)
{
	FILE *fp;
	char *ptr,*route=nvram_safe_get("rt_static_route");
	char token=0x01;
	sroute rt;
	char cmd[128];		
	char buf[32];
	int ip_1,ip_2,ip_3,ip_4;
	memset(&buf[0],'\0',32);
	memset(&cmd[0],'\0',128);

 
	 if((fp=fopen(ROUTEDB,"w+"))==NULL)
	    return -1;
                                                        

       
 	for(ptr=strtok(route,&token);ptr;ptr=strtok(NULL,&token)){
		
	sscanf(ptr,"%[^:]:%[^:]:%[^:]:%[^:]:%d:%d:%d",
			rt.name,
			rt.dst,
			rt.mask,
			rt.gw,
			&rt.metric,
			&rt.priv,
			&rt.active
			);
		
		if(rt.active==1)
			{
			
			if (type == ROUTE_ADD)
				{
				sscanf(rt.mask,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);

				strcpy(buf,rt.dst);
		
				if(ip_2==0&&ip_3==0&&ip_4==0)
					{
					sscanf(rt.dst,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);
					sprintf(buf,"%d.0.0.0",ip_1);
					}
				if(ip_3==0&&ip_4==0)
					{
					sscanf(rt.dst,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);
					sprintf(buf,"%d.%d.0.0",ip_1,ip_2);
					}
				if(ip_4==0)
					{
					sscanf(rt.dst,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);
					sprintf(buf,"%d.%d.%d.0",ip_1,ip_2,ip_3);
					}
				sprintf(cmd,"/sbin/route add -net %s netmask %s gw %s metric %d", buf, rt.mask, rt.gw, rt.metric);
				}
			else if (type == ROUTE_DEL)
				{
				sscanf(rt.mask,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);

				strcpy(buf,rt.dst);
		
				if(ip_2==0&&ip_3==0&&ip_4==0)
					{
					sscanf(rt.dst,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);
					sprintf(buf,"%d.0.0.0",ip_1);
					}
				if(ip_3==0&&ip_4==0)
					{
					sscanf(rt.dst,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);
					sprintf(buf,"%d.%d.0.0",ip_1,ip_2);
					}
				if(ip_4==0)
					{
					sscanf(rt.dst,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);
					sprintf(buf,"%d.%d.%d.0",ip_1,ip_2,ip_3);
					}
		
				sprintf(cmd,"/sbin/route del -net %s netmask %s gw %s metric %d", buf, rt.mask, rt.gw, rt.metric);
				}
			
			/* keep record for ripd not to announce these route because their private flags are set */
			if(rt.priv==1)  
				fprintf(fp,"%s %d %s\n",buf,rt_mask_convert(rt.mask),rt.gw);
			
			}//end of active 
		else{  //not active
			if (type == ROUTE_DEL)
				{
				sscanf(rt.mask,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);

				strcpy(buf,rt.dst);
		
				if(ip_2==0&&ip_3==0&&ip_4==0)
					{
					sscanf(rt.dst,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);
					sprintf(buf,"%d.0.0.0",ip_1);
					}
				if(ip_3==0&&ip_4==0)
					{
					sscanf(rt.dst,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);
					sprintf(buf,"%d.%d.0.0",ip_1,ip_2);
					}
				if(ip_4==0)
					{
					sscanf(rt.dst,"%d.%d.%d.%d",&ip_1,&ip_2,&ip_3,&ip_4);
					sprintf(buf,"%d.%d.%d.0",ip_1,ip_2,ip_3);
					}
		
				sprintf(cmd,"/sbin/route del -net %s netmask %s gw %s metric %d", buf, rt.mask, rt.gw, rt.metric);
				}
			}
		//printf("command == %s\n", cmd);
		system(cmd);		
	}//end of parse every route

        fclose(fp);			
	if(ptr) free(ptr);
	if(route) free(route);

	return 0;
}


int start_static_route(void)
{

  int ret=0;

 ret=handle_static_route(ROUTE_ADD);

 return ret;
}

int stop_static_route(void)
{
 
 int ret=0;


 ret=handle_static_route(ROUTE_DEL);


 return 0;
}

