#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "rt_util.h"
#include "nvram.h"

//#define DEBUG 1
//#define DEMO  1


int rt_is_active(char *name, int *result)
{
	int ret=0;
	sroute rt;	
	
	ret=rt_search(&rt,name);
	
	if(ret==0)
		*result = rt.active;
	else if(ret==1)
		return 1;
	else {
		//print("should never come here\n");
		return 1;
		}

	return 0;

}

int rt_is_private(char *name, int *result)
{
	int ret=0;
	sroute rt;	
	
	ret=rt_search(&rt,name);
	
	if(ret==0)
		*result = rt.priv;
	else if(ret==1)
		return 1;
	else {
		//print("should never come here\n");
		return 1;
		}

	return 0;
}


int rt_search(sroute *rt,char *name)
{
	//char buf[512];
	char *ptr;
	int flag=0;
	char *route;	

	route=nvram_safe_get("rt_static_route");


	for(ptr=strtok(route," ");ptr;ptr=strtok(NULL," "))
		{
		
		//print("%s\n",ptr);
		sscanf(ptr,"%[^:]:%[^:]:%[^:]:%[^:]:%d:%d:%d",
			rt->name,
			rt->dst,
			rt->mask,
			rt->gw,
			&rt->metric,
			&rt->priv,
			&rt->active
			);
		
		if(strcmp(name,rt->name)==0)
			{
			//print("identical\n");
			flag=1; // indicate found! 
			break;
			}
		}
		
	if(flag==0)
		{
		
		//print("no such route name can be found!\n");
		return 1;
				
		}
	
	return 0;
}
#if 1
int rt_mask_convert(char *netmask)
{
	in_addr_t out;
	int i;

        out=inet_network(netmask);

	for(i=0;i<32;i++)
	{
		/* if we still not reach the end of 1's continue to shift left */
		if(out==0)
			return i;
		else
       			out <<= 1;
	}
	return 0;
}
#endif
#if DEMO
int main(void)
{

	char buf[128];
	int err=0,type,ret=0;
	
	print("input route's name:\n");
	scanf("%s",buf);
	print("which parameter do you want to inspect? 1:active 2:private\n");
	scanf("%d",&type);
	
	if(type==1)
		{
		err=rt_is_active(buf,&ret);	
		if(err==1)
			{
			puts("can't found route or abnormal condition occours");		
			exit(0);
			}
		if(ret==0)
			puts("not active\n");
		if(ret==1)
			puts("active\n");
		}
	if(type==2)
		{
		err=rt_is_private(buf,&ret);	
		if(err==1)
			{
			puts("can't found route or abnormal condition occours");
			exit(0);			
			}
		if(ret==0)
			puts("not private\n");
		if(ret==1)
			puts("private\n");
		}
	
	return 0;
}
#endif
