#ifndef _RT_UTL_
#define _RT_UTL_

/* General struct for static route */

typedef struct route{
	char name[30]; 		/* route's name           */
	char dst[16];		/* destination IP address */
	char mask[16];		/* netmask 		  */
	char gw[16];		/* gateway IP address     */
	int metric;		/* metric	          */	
	int priv;		/* private:1 public:0     */
	int active;		/* active:1  inactive:0   */
	}sroute;


/* 
 * using route's name as index keyword to check if 
 * this static route is active or not 
 * @param	name	route's name , has to be completely identical
 *		result	0/1 inactive/active
 * return	0 success 1 error
 */
int rt_is_active(char *name, int *result);

/* 
 * using route's name as index keyword to check if 
 * this static route is private or not 
 * @param	name	route's name , has to be completely identical
 *		result	0/1 public/private
 * return	0 success 1 error
 */
int rt_is_private(char *name, int *result);

/* 
 * using route's name as index keyword to grab the overall 
 * data of this static route 
 * @param	name	route's name , has to be completely identical
 *		rt	overall data of certain route
 * return	0 success 1 error
 */
int rt_search(sroute *rt,char *name);

/*
 * a small program to convert string dot netmask into number 
 * for example : 255.255.0.0   -> 16
 * 		 255.255.128.0 -> 17
 * @param 	netmask 	netmask in string dot format
 * return 	netmask in number format
 */
int rt_mask_convert(char *netmask);

#endif 
