#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "upnp_cfg.h"
#include "nvram.h"

#define SYS_UPNP	"/sbin/upnpd"

/*
 * start upnp daemon function
 * @return	0 success otherwise error
 */
int start_upnp(void)
{

	int ret=0;
	char buf[128];
	char *wan_ifname=nvram_safe_get("wan_ifname");
//	char *wan_mode=nvram_safe_get("wan_mode");
	char *lan_if=nvram_safe_get("lan_if");
	char *upnp_enable=nvram_safe_get("upnp_enable");
	char *upnp_adv_time=nvram_safe_get("upnp_adv_time");
	char *upnp_ttl=nvram_safe_get("upnp_ttl");

	stop_upnp();

	system("/bin/killall -9 upnpd");
	
	if(*upnp_enable=='1')
	{
		/* pre-set multicast route */
	//	memset(buf,0,128);	
		sprintf(buf,"route add -net 239.0.0.0 netmask 255.0.0.0 %s",lan_if);
		system(buf);	
	//	memset(buf,0,128);
#if 0
		/* when upnpd start without wan interface, we pass a "none" interface
		   to the command line */
	   
		if(strcmp(wan_mode,"pppoe")==0||strcmp(wan_mode,"pppoa")==0)
			strcpy(wan_ifname,"ppp0");
		else if (strcmp(wan_mode,"ipoa"))
			strcpy(wan_ifname,"atm0");
		else
			strcpy(wan_ifname,"eth1");	
#endif 	
		sprintf(buf,"%s %s %s %s %s&",SYS_UPNP,wan_ifname,lan_if,upnp_adv_time,upnp_ttl);
		/* starting program */
		system(buf);
	}
		
 	return ret;
}

/*
 * stop upnp daemon function
 * @return	0 success otherwise error
 */
int stop_upnp(void)
{
	int ret=0;
//	char buf[128];

//	memset(buf,0,128);	
//        sprintf(buf,"/sbin/iptables -t nat -D PREROUTING -i %s -p tcp --dport 50431 -j REDIRECT --to-ports 80",nvram_safe_get("lan_if"));
//	system(buf);	

	system("/bin/killall upnpd");
	sleep(1);
	//memset(buf,0,128);	
//	sprintf(buf,"route del -net 239.0.0.0 netmask 255.0.0.0 %s",nvram_safe_get("lan_if"));
//	system(buf);	
	return ret;
}
