/*
 */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <linux/un.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "wan.h"		/* definations */
#include "nvram.h"
#include "rc.h"
/*
 *   IPoA setup step
 *   3 ./atmarpd -b
 *   4 ./atmarp -c atm0
 *   5 ./ifconfig atm0 10.0.0.3 up
 *   6 ./atmarp -s 10.0.0.4 0.vpi.vci
 *   */

void ipoa_test(int vpi,int vci)
{
	char cmd[128];
	int i=3;
	unlink("/var/ipoa_server");
	system("/sbin/atmarpd -b");
	usleep(10);
	system("/sbin/atmarp -c atm0");
	usleep(10);
	system("/sbin/ifconfig atm0 1.1.1.100 up");
	usleep(10);
	while(i-- && access("/var/ipoa_server",F_OK)!=0){
		sprintf(cmd,"/sbin/atmarp -s 1.1.1.%d 0.%d.%d",i,vpi,vci);
		system(cmd);
		sleep(1);
	}
	system("/sbin/ifconfig atm0 0.0.0.0 down");
	system("/bin/killall atmarpd");
	
	if(access("/var/ipoa_server",F_OK)==0){
		FILE *fp;
		unsigned long int server_ip,lan_ip,netmask;
		char tmp[128]="";
		
		fp=fopen("/var/ipoa_server","r");
		if(fp==NULL)
			return ;
		fread(tmp,128,1,fp);
		fclose(fp);
		
		server_ip=inet_network(tmp);
		lan_ip=inet_network(nvram_get("ipoa_ipaddr"));
		netmask=inet_network(nvram_get("ipoa_netmask"));
		/* if ipoa server and local is'nt in the same subnet ,run 1483r*/	
		if((server_ip&netmask) != (lan_ip&netmask))	
			nvram_set("ipoa_mode","1483");

		else	
			nvram_set("ipoa_mode","1577");

	}else
		nvram_set("ipoa_mode","1483");
}

/* ipoa always fix ip */
int start_ipoa(void)
{
	int vpi=0;
	int vci=0;
	char gateway[16];
	vpi=atoi(nvram_get("wan_vpi"));
	vci=atoi(nvram_get("wan_vci"));
	if(vpi==0 && vci==0)
		return 0;
	if(strlen(nvram_safe_get("ipoa_mode"))==0){
		ipoa_test(vpi,vci);
	}
	/* 1577 */
	if(strcmp(nvram_safe_get("ipoa_mode"),"1577")==0){
		FILE *fp;
		char tmp[128]="";
		ipoa_test(vpi,vci);
		fp=fopen("/var/ipoa_server","r");
		if(fp==NULL)
			return 0;
		fread(tmp,128,1,fp);
		fclose(fp);
		
		if(strchr(tmp,'.')==NULL)
			return 0;
		
		/* gateway */
		strcpy(gateway,tmp);
		
		system("/sbin/atmarpd -b");
		system("/sbin/atmarp -c atm0");
		SYSTEM("/sbin/ifconfig atm0 %s netmask %s  up"
			  ,nvram_get("ipoa_ipaddr")
			  ,nvram_get("ipoa_netmask"));
		SYSTEM("/sbin/atmarp -s %s 0.%s.%s"
			  ,gateway
			  ,nvram_get("wan_vpi")
			  ,nvram_get("wan_vci"));
		nvram_set("wan_ifname","atm0");
	}else{
		/* 1483 route */
		SYSTEM("/sbin/br2684ctl -c 0 -e %d -t UBR -a 0.%s.%s&"
			,atoi(nvram_safe_get("wan_encap"))+3
			,nvram_safe_get("wan_vpi")
			,nvram_safe_get("wan_vci"));
		nvram_set("wan_ifname","ixp1");
		strcpy(gateway,nvram_safe_get("ipoa_gateway"));

	}
	
	system("/bin/cp /proc/uptime /var/wan_uptime");
	system("/sbin/rc service restart&");
	SYSTEM("/sbin/ifconfig %s %s netmask %s", nvram_safe_get("wan_ifname"), \
	       nvram_safe_get("ipoa_ipaddr"), nvram_safe_get("ipoa_netmask"));
	SYSTEM(ROUTE" del default");
	
	if(strlen(gateway)<4)	
			return 0;
	
	SYSTEM(ROUTE" add default gw %s", gateway);

	return 0;
}

int start_dhcpc(void)
{
	sleep(1);
	SYSTEM(KILLALL" udhcpc >/dev/null 2>&1");
	if(strcmp(nvram_safe_get("wan_fix_dns"),"1")==0){
		SYSTEM("/sbin/udhcpc -i %s -s /etc/udhcpc.fix.script&"
				,nvram_safe_get("wan_ifname"));
	}else{
		printf("start dhcpc: wanifname<%s>\n",nvram_safe_get("wan_ifname"));
		SYSTEM("/sbin/udhcpc -i %s -s /etc/udhcpc.script&"
				,nvram_safe_get("wan_ifname"));
	}
	return 0;
}

int start_ip(void) {
	SYSTEM("/sbin/ifconfig %s %s netmask %s", nvram_safe_get("wan_ifname"), \
	       nvram_safe_get("fix_ipaddr"), nvram_safe_get("fix_netmask"));
	SYSTEM(ROUTE" del default");
	SYSTEM(ROUTE" add default gw %s", nvram_safe_get("fix_gateway"));
	SYSTEM("/sbin/rc service restart >/dev/null 2>&1");
	SYSTEM("/bin/cp /proc/uptime /var/wan_uptime >/dev/null 2>&1");
	return 0;
}

#define LCP_INTERVAL "lcp-echo-failure 3 lcp-echo-interval 10 &"
#define PLUGIN_PPPOE	0
#define PLUGIN_PPPOA	1
void set_pppd_cmd(char *cmd, int plugin, int init) {
	char peerdns[12]="";
	char idle[32]="";
	char fixip[18]="";
	int idletime=0;
	
	if(atoi(nvram_get("wan_fix_dns"))==0)
	                strcpy(peerdns, "usepeerdns");	
	/* pppoe */
	if (plugin == PLUGIN_PPPOE) {
	/* 
	 * if(atoi(nvram_get("pppoe_idle"))!=0 && atoi(nvram_get("wan_dod"))) 
	 *  sprintf(idle,"idle %d demand", atoi(nvram_get("pppoe_idle"))*60);
	 */
		/* idle time */
		if(nvram_get("pppoe_idle")==NULL)
			idletime=0;
		else
			idletime=atoi(nvram_get("pppoe_idle"));
		
		if(idletime!=0)
			sprintf(idle,"idle %d", idletime*60);
        	if(*nvram_get("wan_dod")=='1'){
		       if(!init && idletime!=0)
				strcat(idle, " demand");
			system("/bin/cp /usr/etc/ppp/ip-up-demand /etc/ppp/ip-up >/dev/null 2>&1");
		}else{
			if(idletime!=0)
			       	system("/bin/cp /usr/etc/ppp/ip-up /etc/ppp/ip-up >/dev/null 2>&1");
			else
				system("/bin/cp /usr/etc/ppp/ip-up-demand /etc/ppp/ip-up >/dev/null 2>&1");
		}
	        system("cd /etc/ppp; chmod +x *");
		
		if(*nvram_safe_get("wan_iptype")=='F'){
			sprintf(fixip,"%s:",nvram_safe_get("pppoe_ipaddr"));
		}
		
		sprintf(cmd, PPPD" plugin pppoe ixp1 user %s password %s %s nodetach defaultroute %s %s maxfail 10 "LCP_INTERVAL
				,nvram_safe_get("pppoe_username")
				,nvram_safe_get("pppoe_password")
				,fixip
				,peerdns
				,idle);
				//SYSTEM("echo start pppd-pppoe idle<%s> cmd %s\n",idle,cmd);
	/* pppoa */
	} else if (plugin == PLUGIN_PPPOA) {
	/* 
	 * if(atoi(nvram_get("pppoa_idle"))!=0 && atoi(nvram_get("wan_dod"))) 
	 * sprintf(idle,"idle %d demand", atoi(nvram_get("pppoa_idle")));
	 */
		/* idle time */
		idletime=atoi(nvram_get("pppoa_idle"));
		
		if(idletime!=0)
			sprintf(idle,"idle %d", atoi(nvram_get("pppoa_idle"))*60);
		
		if(*nvram_get("wan_dod")=='1'){
		       if(!init && idletime!=0)
			       	strcat(idle, " demand");
		       system("/bin/cp /usr/etc/ppp/ip-up-demand /etc/ppp/ip-up");
		}else{

			if(idletime!=0)
		       		system("/bin/cp /usr/etc/ppp/ip-up /etc/ppp/ip-up");
			else
				system("/bin/cp /usr/etc/ppp/ip-up-demand /etc/ppp/ip-up");
		}
		system("chmod +x /etc/ppp/ip-up");
		/* fix ip */
		if(*nvram_safe_get("wan_iptype")=='F'){
			sprintf(fixip,"%s:",nvram_safe_get("pppoa_ipaddr"));
		}
		
		sprintf(cmd, PPPD" plugin pppoa %s.%s user %s password %s %s nodetach defaultroute %s %s maxfail 10 %s qos UBR "LCP_INTERVAL
				,nvram_get("wan_vpi")
				,nvram_get("wan_vci")
				,nvram_get("pppoa_username")
				,nvram_get("pppoa_password")
				,fixip
				,(*(nvram_get("wan_encap"))=='0')?"llc-encaps":"vc-encaps"
				,peerdns
				,idle
				);
		sleep(1);
	}
}

int start_pppoa(int init) {
	char cmd[1024]="";
	set_pppd_cmd(cmd, PLUGIN_PPPOA, init);
	system(cmd);
	return 0;
}

int start_pppoe(int init) {
	char cmd[1024]="";
	set_pppd_cmd(cmd, PLUGIN_PPPOE, init);
	SYSTEM("/bin/echo \"%s\" >/var/aaa",cmd);
	system(cmd);
	return 0;
}

int start_wan(int init) {
	char *mode;
	char *mac;
	char *data;
	int timeout=10;
	mode = nvram_safe_get("wan_mode");

        //printf("wan mode is %s\n", mode);
	/* stop wan */
	myPipe("ps",&data);
	while(strstr(data,"pppd")!=NULL
			|| strstr(data,"br2684ctl")!=NULL
			|| strstr(data,"wizard")!=NULL
			|| strstr(data,"udhcpc")!=NULL){
		system("/bin/killall wizard >/dev/null 2>&1");
		stop_wan();
		sleep(1);
		myPipe("ps",&data);
		timeout--;
		if(timeout==0) 
			break;
	}
        //stop_wan();
	free(data);

	if(strlen(mode)<=1)
		return 0;
	
	if(*mode=='p')
		nvram_set("wan_ifname","ppp0");
	else if(strcmp(mode,"ipoa")==0)
		nvram_set("wan_ifname","atm0");
	else
		nvram_set("wan_ifname","ixp1");
	
	/* fix dns */
	if(*nvram_safe_get("wan_fix_dns") == '1') {
		if(strlen(nvram_safe_get("wan_dns1"))>6)
			SYSTEM(ECHO" \"nameserver %s\" > /etc/resolv.conf"
					,nvram_safe_get("wan_dns1"));
		if(strlen(nvram_safe_get("wan_dns2"))>6)
			SYSTEM(ECHO" \"nameserver %s\" >> /etc/resolv.conf"
					,nvram_safe_get("wan_dns2"));
	}
	

	if(strcmp(mode, "pppoa")==0) {
		start_pppoa(init);
		return 0;
	}
	if(strcmp(mode,"ipoa")==0) {
		start_ipoa();
		return 0;
	}
	
	/*
	 *  note: change wan_encap n+3 to be route mode 
	 */
	
#if 0
	/* enable atm bridge */
	SYSTEM("/sbin/br2684ctl -c 0 -e %s -t UBR -a 0.%s.%s&"
			,nvram_safe_get("wan_encap")
			,nvram_safe_get("wan_vpi")
			,nvram_safe_get("wan_vci"));
	sleep(1);	
	
#endif 
	if(strcmp(mode, "bridge")==0){
		system("/sbin/brctl addif br0 ixp1");
		return 0;
	}
	
		/* start wan */	
	if(strcmp(mode, "pppoe")==0){
		start_pppoe(init);
	}else{
 		/* MAC spoofing */
		if(init)
		{
			unsigned char tmp_mac[6],def_mac[]="";
			//int m;
			GetMACAdd("ixp0",tmp_mac);
			//tmp_mac[6]='\0';
			//m=tmp_mac[0]*16^5+tmp_mac[1]*16^4+tmp_mac[2]*16^3+tmp_mac[3]*16^2+tmp_mac[4]*16+tmp_mac[5];
			//glb_dbg("tmp<%s> mac<0x%x>\n",tmp_mac,m);
			//sprintf(tmp_mac,"%d",m);
			if((char)tmp_mac[5]==0x0f) tmp_mac[4]+=1;
			else tmp_mac[5]+=1;

			sprintf(def_mac,"%02x:%02x:%02x:%02x:%02x:%02x",
				tmp_mac[0],tmp_mac[1],tmp_mac[2],tmp_mac[3],tmp_mac[4],tmp_mac[5]);
			nvram_set("wan_macaddr",def_mac);
		}
		mac=nvram_get("wan_macaddr_new");
		if(mac==NULL || strlen(mac)==0) 
		     mac=nvram_get("wan_macaddr");
		     		   
		if(mac!=NULL) 
		{
			SYSTEM("/sbin/ifconfig ixp1 down");
			//*(mac+strlen(mac)-1)+=1;
			SYSTEM("/sbin/ifconfig ixp1 hw ether %s ",mac);
		}
		if(strcmp(mode, "dhcpc")==0){
			start_dhcpc();
		}else if(strcmp(mode, "ip")==0){
			start_ip();
		}
		/* mtu size*/
		//printf("wan_mtu<%d>\n", nvram_get("wan_mtu"));
		//SYSTEM("/sbin/ifconfig ixp1 mtu %s",nvram_get("wan_mtu"));
	}
	return 0;
}

int stop_wan(void) {
	system("/bin/rm /var/wan_uptime >/dev/null 2>&1");
	system("/sbin/rc service stop >/dev/null 2>&1");
//	system("/sbin/brctl delif br0 eth1");
	system("/bin/echo \"#!/bin/sh\" > /etc/ppp/ip-down");
	system("/bin/echo \"/bin/rm /var/wan_uptime\">> /etc/ppp/ip-down");
	system(KILLALL" pppd >/dev/null 2>&1");
	system(KILLALL" udhcpc >/dev/null 2>&1");
	//system("/sbin/ifconfig ixp1 0.0.0.0");
	SYSTEM("/sbin/ifconfig %s 0.0.0.0 >/dev/null 2>&1",nvram_get("wan_ifname"));
//	system(KILLALL" br2684ctl");
//	system(KILLALL" atmarpd");
	return 0;
}
