/*
 *	Wireless Tools
 *
 *		Jean II - HPLB 97->99 - HPL 99->01
 *
 * Main code for "iwconfig". This is the generic tool for most
 * manipulations...
 * You need to link this code against "iwlib.c" and "-lm".
 *
 * This file is released under the GPL license.
 *     Copyright (c) 1997-2002 Jean Tourrilhes <jt@hpl.hp.com>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
       # include <sys/ipc.h>
       # include <sys/msg.h>
#include "wifi.h"		/* definations */

void msgkill(void) {
	FILE *fp;
	char buf[4092];
	char *sp;
	char *se;
	char aline[1020];
	int id;

	fp=fopen("/proc/sysvipc/msg", "r");
	fread(buf, 4092, 1, fp);
		
	if((sp=strstr(buf, "\n"))==NULL)
		return ;
	sp+=1;
	while((se=strstr(sp, "\n"))!=NULL){
		strcpy(aline, "");
		strncat(aline, sp, se-sp);
		sscanf(aline, "%*s %d", &id);
		if((msgctl(id, IPC_RMID, NULL)) <0) {
			return;
		}
		printf("msgctl queue id(%d) removed\n", id);
		sp=se+1;
	}
			
	fclose(fp);
	
}

int main(int argc, char **argv)
{
	if(argc < 2 ){
		puts("wifi <init|start|down|Save|command|msgkill> [cmdline]");
		return -1;
	}
	switch (argv[1][0]) {
		case 'i':
			printf("wifi_init: %d\n", wifi_init());
			break;
		case 's':
			printf("wifi_start: %d\n", start_wifi());
			break;
		case 'd':
			stop_wifi();
			system("killall dhcpd");
			break;
		case 'S':
			wifi_save();
			break;
		case 'c':
			if(argc < 3) 
				break;
			wlan_socket_cmd(argv[2]);
			break;
		case 'm':
			msgkill();
			break;
		default:
			puts("wifi <init|start|down|Save|command> [cmdline]");
	}
  	return 0;
}
