/*
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <linux/un.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "wifi.h"		/* definations */
#include "nvram.h"
#include "802_11Defs.h"
#define DO_ACT

static tWHAL_NVRAM_STRUCT whal_nvramShadow;
int add_mac_list(int on, char *list) {
	char *s=list;
	unsigned char mac[6];
	int i;
	char tmp[18];
	int fd;

	if((fd=open(ACL_BIN, O_CREAT|O_TRUNC|O_WRONLY)) < 0)
		return -1;
	if(!on) {
		close(fd);
		return 0;
	}
	tmp[17]='\0';
	while(strlen(s)>=17) {
		for(i=0;i<17;i++) {
			tmp[i]=*(s++);
		}
		sscanf(tmp, "%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:",
				&mac[0], &mac[1], &mac[2], &mac[3], &mac[4],&mac[5]);
		write(fd, mac, 6);
		while(*(s++)!='\1') 
			if(strlen(s) < 17)
				break;
	}
	close(fd);
	return 0;
}
#if 0
void iw_setup(wifi_t conf) {
 	char cmd[1024];
	
	if(!conf.if_on)
		return;


      	/* ---------- Set encryption stuff ---------- */
	if(conf.key_len!=0) {
		sprintf(cmd, IWCONFIG" %s key [1] %s", conf.ifname, conf.key1);
		system(cmd);
		sprintf(cmd, IWCONFIG" %s key [2] %s", conf.ifname, conf.key2);
		system(cmd);
		sprintf(cmd, IWCONFIG" %s key [3] %s", conf.ifname, conf.key3);
		system(cmd);
		sprintf(cmd, IWCONFIG" %s key [4] %s", conf.ifname, conf.key4);
		system(cmd);
		sprintf(cmd, IWCONFIG" %s key [%u]", conf.ifname, conf.def_key);
		system(cmd);
	} else { 
		sprintf(cmd, IWCONFIG" %s key off", conf.ifname);
		system(cmd);
	}
		
      	/* ---------- Set Access List ---------- */
	if(conf.access_control) {
		/* flush MAC access control list */
		sprintf(cmd, IWPRIV" %s maccmd 3", conf.ifname);
		system(cmd);
		/* allow policy for ACL */
		sprintf(cmd, IWPRIV" %s maccmd 1", conf.ifname);
		system(cmd);
		/* add mac list */
		sprintf(cmd, IWPRIV" %s addmac", conf.ifname);
		add_mac_list(cmd, nvram_get("wifi_access_list"));
		/* kick all authenticated stations */
		sprintf(cmd, IWPRIV" %s maccmd 4", conf.ifname);
		system(cmd);
	}
	else {
		/* open policy for ACL */
		sprintf(cmd, IWPRIV" %s maccmd 0", conf.ifname);
		system(cmd);
	}
	
      	/* ---------- Set Broadcast SSID ---------- */
	if(conf.broadcast_ssid)
		sprintf(cmd, PRISM2_PARAM" %s enh_sec 0", conf.ifname);
	else
		sprintf(cmd, PRISM2_PARAM" %s enh_sec 3", conf.ifname);
	system(cmd);
}
#endif
char *digital_to_keystring(char *dig_key, int keylen) {
	char *keystr=NULL;

	if((keylen==64) && (strlen(dig_key)>=10)){
		keystr=malloc(6);
		sscanf(dig_key, "%02hhx%02hhx%02hhx%02hhx%02hhx", &keystr[0], \
		       &keystr[1], &keystr[2], &keystr[3], &keystr[4]);
		keystr[5]='\0';
	}
	if((keylen==128) && (strlen(dig_key)>=26)){
		keystr=malloc(14);
		sscanf(dig_key, \
		       "%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx", \
		       &keystr[0], &keystr[1], &keystr[2], &keystr[3], \
		       &keystr[4], &keystr[5], &keystr[6], &keystr[7], \
		       &keystr[8], &keystr[9], &keystr[10], &keystr[11], \
		       &keystr[12]);
		keystr[13]='\0';
	}
	if(keystr==NULL) {
		keystr=malloc(1);
		keystr[0]='\0';
	}
	return keystr;
}

#define WIFI_AUTH_DEF "3"
int parse_config(wifi_t *conf) {
	conf->if_on=(unsigned char)atoi(nvram_get("wifi_if_on"));
	strcpy(conf->ssid, nvram_get("wifi_ssid"));
	conf->channel=(unsigned char)atoi(nvram_get("wifi_channel"));
	if(conf->channel == 0 || conf->channel > 14)
		return -1;
	conf->auth_type=(unsigned char)atoi(nvram_get("wifi_auth_type"));
	if((conf->auth_type<1) || (conf->auth_type>3)) {
		conf->auth_type = atoi(WIFI_AUTH_DEF);
		nvram_set("wifi_auth_type", WIFI_AUTH_DEF);
	}
	conf->wep_on=(unsigned char)atoi(nvram_get("wifi_wep_on"));
	conf->key_len=(unsigned char)atoi(nvram_get("wifi_key_len"));
	conf->def_key=(unsigned char)atoi(nvram_get("wifi_def_key"));
	strcpy(conf->key[0], digital_to_keystring(nvram_get("wifi_key1"), conf->key_len));
	strcpy(conf->key[1], digital_to_keystring(nvram_get("wifi_key2"), conf->key_len));
	strcpy(conf->key[2], digital_to_keystring(nvram_get("wifi_key3"), conf->key_len));
	strcpy(conf->key[3], digital_to_keystring(nvram_get("wifi_key4"), conf->key_len));
	conf->access_control=(unsigned char)atoi(nvram_get("wifi_access_control"));
	conf->broadcast_ssid=(unsigned char)atoi(nvram_get("wifi_broadcast_ssid"));
	printf("conf->broadcast_ssid = %d \n", conf->broadcast_ssid);
	return 0;
}

/**************************************************************************
 *             void whal_nvram_setDefaults(void)                          *
 **************************************************************************
 * DESCRIPTION:  Restore NVRAM defaults                                   *
 *                                                                        *
 **************************************************************************/
void ti_set_defaults(void)
{
	int i;
	FILE *fp;
	char tmp[1024];
	char *pt;
	unsigned char mac[6]="\x00\x50\xF1\x12\x00\x00";
	fp=fopen("/proc/sys/dev/adam2/environment","r");
	if(fp!=NULL){
		fread(tmp,1024,1,fp);
		fclose(fp);
		if((pt=strstr(tmp,"maca"))!=NULL)
			sscanf(pt,"%*s %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx"
			,&mac[0], &mac[1], &mac[2], &mac[3], &mac[4],&mac[5]);
	}
   whal_nvramShadow.uiNVRAMMagic = WHAL_NVRAM_MAGIC;
   memcpy(whal_nvramShadow.dot11MacAddress,mac,6);
   whal_nvramShadow.dot11SsIDLength = DEF_SSID_LENGTH;
   memcpy(whal_nvramShadow.dot11SsID,DEF_SSID,DEF_SSID_LENGTH);
   whal_nvramShadow.dot11AuthenticationResponceTimeOut = DEF_AUTH_RESP_TO_MS;
   whal_nvramShadow.dot11PrivacyOptionImplemented      = DEF_PRIV_IMPLEMENTED;

   if(DEF_DOT11_MODE == DOT11_MODE_B_ONLY)
   {   
	   whal_nvramShadow.wOperRateLength                    = DEF_OPER_RATE_LEN;
	   strncpy(whal_nvramShadow.dot11OperationalRateSet,
										 DEF_OPER_RATE_SET,CCK_PBCC_RATES_MAX);
	   
	   whal_nvramShadow.wOperAdditionalRateLength          = DEF_OPER_ADDITIONAL_RATE_LEN_B_ONLY;
	   strncpy(whal_nvramShadow.dot11OperationalAdditionalRateSet,
										 DEF_OPER_ADDITIONAL_RATE_SET_B_ONLY,OFDM_RATES_MAX);	

	   whal_nvramShadow.wOperOFDMRateLength                = DEF_OPER_OFDM_RATE_LEN;
	   strncpy(whal_nvramShadow.dot11OperationalOFDMRateSet,
										 DEF_OPER_OFDM_RATE_SET,OFDM_RATES_MAX);

	   whal_nvramShadow.dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE_B;
	   whal_nvramShadow.dot11PreambleMode  = DEF_PREAMBLE_MODE_B_AND_MIXED;
	   whal_nvramShadow.dot11SlotTimeMode  = DEF_SLOTTIME_MODE_B_ONLY;
	   whal_nvramShadow.dot11ERPProtectionMode = DEF_PROTECTION_MODE_B_ONLY;
	   whal_nvramShadow.dot11ERPProtectionType = DEF_PROTECTION_TYPE_B_ONLY;
   }
   else if(DEF_DOT11_MODE == DOT11_MODE_B_ONLY_PLUS)
   {
	   whal_nvramShadow.wOperRateLength                    = DEF_OPER_RATE_LEN_PLUS_PBCC;
	   strncpy(whal_nvramShadow.dot11OperationalRateSet,
										 DEF_OPER_RATE_SET_PLUS_PBCC,CCK_PBCC_RATES_MAX);
	   
	   whal_nvramShadow.wOperAdditionalRateLength          = DEF_OPER_ADDITIONAL_RATE_LEN_B_ONLY;
	   strncpy(whal_nvramShadow.dot11OperationalAdditionalRateSet,
										 DEF_OPER_ADDITIONAL_RATE_SET_B_ONLY,OFDM_RATES_MAX);	

	   whal_nvramShadow.wOperOFDMRateLength                = DEF_OPER_OFDM_RATE_LEN;
	   strncpy(whal_nvramShadow.dot11OperationalOFDMRateSet,
										 DEF_OPER_OFDM_RATE_SET,OFDM_RATES_MAX);

	   whal_nvramShadow.dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE_B_PLUS_AND_MIXED;
	   whal_nvramShadow.dot11PreambleMode  = DEF_PREAMBLE_MODE_B_AND_MIXED;
	   whal_nvramShadow.dot11SlotTimeMode  = DEF_SLOTTIME_MODE_B_ONLY;
	   whal_nvramShadow.dot11ERPProtectionMode = DEF_PROTECTION_MODE_B_ONLY;
	   whal_nvramShadow.dot11ERPProtectionType = DEF_PROTECTION_TYPE_B_ONLY;	   
   }
   else if(DEF_DOT11_MODE == DOT11_MODE_MIXED)
   {
	   whal_nvramShadow.wOperRateLength                    = DEF_OPER_RATE_LEN_PLUS_PBCC;
	   strncpy(whal_nvramShadow.dot11OperationalRateSet,
										 DEF_OPER_RATE_SET_PLUS_PBCC,CCK_PBCC_RATES_MAX);

	   whal_nvramShadow.wOperAdditionalRateLength          = DEF_OPER_OFDM_RATE_LEN;
	   strncpy(whal_nvramShadow.dot11OperationalAdditionalRateSet,
										 DEF_OPER_OFDM_RATE_SET,OFDM_RATES_MAX);

	   whal_nvramShadow.wOperOFDMRateLength                = DEF_OPER_ADDITIONAL_RATE_LEN_MIXED;
	   strncpy(whal_nvramShadow.dot11OperationalOFDMRateSet,
										 DEF_OPER_ADDITIONAL_RATE_SET_MIXED,OFDM_RATES_MAX);
	   
	   whal_nvramShadow.dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE_B_PLUS_AND_MIXED;
	   whal_nvramShadow.dot11PreambleMode  = DEF_PREAMBLE_MODE_B_AND_MIXED;
	   whal_nvramShadow.dot11SlotTimeMode  = DEF_SLOTTIME_MODE_G_AND_MIXED;
	   whal_nvramShadow.dot11ERPProtectionMode = DEF_PROTECTION_MODE_G_AND_MIXED;
	   whal_nvramShadow.dot11ERPProtectionType = DEF_PROTECTION_TYPE_G_AND_MIXED;
   }
   else /* g only  mode */
   {
	   whal_nvramShadow.wOperRateLength                    = DEF_OPER_RATE_LEN;
	   strncpy(whal_nvramShadow.dot11OperationalRateSet,
										 DEF_OPER_RATE_SET,CCK_PBCC_RATES_MAX);

	   whal_nvramShadow.wOperAdditionalRateLength          = DEF_OPER_OFDM_RATE_LEN;
	   strncpy(whal_nvramShadow.dot11OperationalAdditionalRateSet,
										 DEF_OPER_OFDM_RATE_SET,OFDM_RATES_MAX);	

	   whal_nvramShadow.wOperOFDMRateLength                = DEF_OPER_ADDITIONAL_RATE_LEN_G_ONLY;
	   strncpy(whal_nvramShadow.dot11OperationalOFDMRateSet,
										 DEF_OPER_ADDITIONAL_RATE_SET_G_ONLY,OFDM_RATES_MAX);
	   
	   whal_nvramShadow.dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE_G_ONLY;
	   whal_nvramShadow.dot11PreambleMode  = DEF_PREAMBLE_MODE_G_ONLY;
	   whal_nvramShadow.dot11SlotTimeMode  = DEF_SLOTTIME_MODE_G_AND_MIXED;
	   whal_nvramShadow.dot11ERPProtectionMode = DEF_PROTECTION_MODE_G_AND_MIXED;
	   whal_nvramShadow.dot11ERPProtectionType = DEF_PROTECTION_TYPE_G_AND_MIXED;
   }
   

   whal_nvramShadow.dot11BeaconPeriod = DEF_BEACON_PERIOD;
   whal_nvramShadow.dot11DTIMPeriod   = DEF_DTIM_PERIOD;
   
   whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].authAlgo 
                                                      = DEF_AUTH_ALGO0; 
   whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].enable   
                                                      = DEF_AUTH_ALG0_ENABLE; 
   whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].authAlgo 
                                                      = DEF_AUTH_ALGO1; 
   whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].enable   
                                                      = DEF_AUTH_ALG1_ENABLE; 
   for (i = 0; i < DOT11_DEFS_KEY_NAL_LEN; i++)
   {
	   memset(whal_nvramShadow.pbWEP_DefsKeysVal[i].keyValue, 0, WEP_KEY_LEN_MAX);
	   whal_nvramShadow.pbWEP_DefsKeysVal[i].keyLen = DEF_WEP_KEY_LEN;
   }
   memset(whal_nvramShadow.KeyMapping,0,
                             sizeof(tWEP_KEY_MAPPING_ENTRY) * DOT11_MAX_KEY_MAPPING_LEN);
   for (i = 0; i < DEF_WEP_KEY_MAPPING_LEN; i++)
	   whal_nvramShadow.KeyMapping[i].MappingValue.keyLen = DEF_WEP_KEY_LEN;
   whal_nvramShadow.dot11PrivacyInvoked  = DEF_PRIV_INVOKED;
   whal_nvramShadow.dot11WEPDefaultKeyID = DEF_WEP_KEY_ID;
   whal_nvramShadow.dot11WEPKeyMappingLength = DEF_WEP_KEY_MAPPING_LEN;
   whal_nvramShadow.dot11ExcludeUnencripted  = DEF_EXCLUDE_UNENCRIPTED;
   whal_nvramShadow.dot11RTSTreshold =  DEF_RTS_TRESHOLD;
   whal_nvramShadow.dot11ShortRetryLimit = DEF_SHORT_RETRY_LIMIT;
   whal_nvramShadow.dot11LongRetryLimit  = DEF_LONG_RETRY_LIMIT;
   whal_nvramShadow.dot11FragmentationTreshold   = DEF_FRAGMENTATION_TRESHOLD;
   whal_nvramShadow.dot11MaxTransmitMSDULifetime = DEF_MAX_TX_MPDU_LIFETIME;
   whal_nvramShadow.dot11MaxReceiveLifetime      = DEF_MAX_RX_MPDU_LIFETIME;
   strncpy(whal_nvramShadow.dot11ManufacturerID,DEF_MANUF_ID,PROD_ID_LEN);
   strncpy(whal_nvramShadow.dot11ProductID,DEF_PROD_ID,PROD_ID_LEN);
   strncpy(whal_nvramShadow.dot11manufacturerOUI,
                            DEF_MANUF_OUI,DOT11_MANUFACTURER_OUI_LENGTH);
   strncpy(whal_nvramShadow.dot11manufacturerName,
                                           DEF_MANUF_NAME,PROD_ID_LEN);
   strncpy(whal_nvramShadow.dot11manufacturerProductName,
                                           DEF_MANUF_PROD_NAME,PROD_ID_LEN);
   strncpy(whal_nvramShadow.dot11manufacturerProductVersion,
                                           DEF_MANUF_PROD_VER,PROD_ID_LEN);
   whal_nvramShadow.dot11channel  = DEF_CHANNEL;
   whal_nvramShadow.dot11Agile  = DEF_AGILE;
   /*whal_nvramShadow.dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE;*/
   whal_nvramShadow.RateFallback  = DEF_RATE_FALLBACK;
   whal_nvramShadow.RateAdaptation  = DEF_RATE_ADAPTATION;
   /*whal_nvramShadow.dot11PreambleMode  = DEF_PREAMBLE_MODE;*/
   /*whal_nvramShadow.dot11SlotTimeMode  = DEF_SLOTTIME_MODE;*/
   whal_nvramShadow.dot11Mode = DEF_DOT11_MODE;
   whal_nvramShadow.Lastdot11Mode = DEF_DOT11_MODE;
   whal_nvramShadow.CwMinMode = DEF_CWMIN_MODE;
   whal_nvramShadow.dot11DynamicAlgTimeout = DEF_DYN_ALG_TIMEOUT;
   whal_nvramShadow.RadioCalibrateOption = DEF_RADIO_CALIBRATE_OPTION;
   whal_nvramShadow.RadioCalibrateInterval = DEF_RADIO_CALIBRATE_INTERVAL;


   /*whal_nvramShadow.dot11ERPProtectionMode = DEF_PROTECTION_MODE;*/
   /*whal_nvramShadow.dot11ERPProtectionType = DEF_PROTECTION_TYPE;*/
   whal_nvramShadow.dot11ERPProtectionTI = DEF_PROTECTION_TI;

   whal_nvramShadow.RespRateMode = DEF_RESP_RATE_MODE;

   whal_nvramShadow.secRSN_Enable = DEF_RSN_ENABLE;
   whal_nvramShadow.secUnicastSuitesTable[0].suite 
                                                      = DEF_UNICAST_SUITE0; 
   whal_nvramShadow.secUnicastSuitesTable[0].enable   
                                                      = DEF_UNICAST_SUITE0_ENABLE; 
   whal_nvramShadow.secUnicastSuitesTable[1].suite 
                                                      = DEF_UNICAST_SUITE1; 
   whal_nvramShadow.secUnicastSuitesTable[1].enable   
                                                      = DEF_UNICAST_SUITE1_ENABLE; 
   whal_nvramShadow.secMulticastSuite = DEF_MULTICAST_SUITE;
   whal_nvramShadow.secAuthSuitesTable[0].suite 
                                                      = DEF_AUTH_SUITE0; 
   whal_nvramShadow.secAuthSuitesTable[0].enable   
                                                      = DEF_AUTH_SUITE0_ENABLE; 
   for (i = 0; i < SEC_TEMPORAL_KEY_LEN; i++)
	whal_nvramShadow.secTemporalKey[i] = DEF_TEMPORAL_KEY_VALUE + i;

   whal_nvramShadow.ReportLevel  = DEF_REPORT_LEVEL;
   memset(whal_nvramShadow.whalArea, 0, sizeof(whal_nvramShadow.whalArea));
   
   whal_nvramShadow.CurrFeatureSet = DEF_FEATURE_SET;
   whal_nvramShadow.enable4x  = DEF_ENABLE_4X;
   whal_nvramShadow.enableConcat  = DEF_ENABLE_CONCAT;
   whal_nvramShadow.enableAckEmul  = DEF_ENABLE_ACK_EMUL;
   whal_nvramShadow.enable4xMixMode  = DEF_ENABLE_4X_MIX_MODE;

   strncpy(whal_nvramShadow.pb_password,
                             DEF_CONSOLE_PASSWORD,WLAN_PROD_PASSWORD_LEN);
   whal_nvramShadow.uiConsolePwdMagic = WHAL_CONSOLE_PWD_MAGIC;
   
   /********************
    * TestApp defaults *
    ********************/
   whal_nvramShadow.ta_radioscope_com_option = TA_RADIOSCOPE_COMOPT_DEFAULT;
   whal_nvramShadow.ta_startup_option = TA_STARTUP_OPT_NORMAL;

	 // MAC access list
	 whal_nvramShadow.accessListEnabled = 0;
	 whal_nvramShadow.accessListType = 0; // white list
	 memset(whal_nvramShadow.accessList, 0, MAC_ADDR_LEN*MGMT_ACCESS_LIST_SIZE);

   //return whalNVRAMWrite();
}/* END whal_nvram_setDefaults() */

void msgkill(void) {
	FILE *fp;
	char buf[4092];
	char *sp;
	char *se;
	char aline[1020];
	int id;

	fp=fopen("/proc/sysvipc/msg", "r");
	fread(buf, 4092, 1, fp);
		
	if((sp=strstr(buf, "\n"))==NULL)
		return ;
	sp+=1;
	while((se=strstr(sp, "\n"))!=NULL){
		strcpy(aline, "");
		strncat(aline, sp, se-sp);
		sscanf(aline, "%*s %d", &id);
		if((msgctl(id, IPC_RMID, NULL)) <0) {
			return;
		}
		printf("msgctl queue id(%d) removed\n", id);
		sp=se+1;
	}
			
	fclose(fp);
	
}

int stop_wifi(void) {
	system("/usr/sbin/brctl delif br0 tiwlan0");
	system("/usr/sbin/brctl delif br0 eth0");
	system("/usr/sbin/brctl addif br0 eth0");
	system(IFCONFIG" tiwlan0 down");
	system(KILLALL" -2 user_drv");
	sleep(1);
	system(KILLALL" -9 user_drv");
	sleep(1);
	system(RMMOD" tiwlan");
	sleep(1);
	msgkill();	
	return 0;
}

int nvram_save(wifi_t conf) {
	int fd;
	int i;

	/* Initial Default Values */	
	ti_set_defaults();

	/* setup SSID */
	whal_nvramShadow.dot11SsIDLength = strlen(conf.ssid);
	memcpy(whal_nvramShadow.dot11SsID,conf.ssid,strlen(conf.ssid));
	
	/* setup Channel */
	whal_nvramShadow.dot11channel=conf.channel;
	
	/* setup Auth Type */ 
#if 0
   	whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].authAlgo = MIB_OPEN_SYSTEM; 
	(conf.auth_type & WIFI_AUTH_OPEN) ? \
		(whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].enable = TRUE) : \
		(whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].enable = FALSE);
#endif
	if(conf.auth_type & WIFI_AUTH_OPEN) {
   		whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].authAlgo = MIB_OPEN_SYSTEM; 
		whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].enable = TRUE;
   		whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].authAlgo = MIB_SHARED_KEY; 
		(conf.auth_type & WIFI_AUTH_SKEY) ? \
		(whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].enable = TRUE) : \
		(whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].enable = FALSE);
	} else {
   		whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].authAlgo = MIB_SHARED_KEY; 
		(conf.auth_type & WIFI_AUTH_SKEY) ? \
		(whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].enable = TRUE) : \
		(whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].enable = FALSE);
	}

	/* setup WEP Staff */
	if(conf.wep_on) 
		whal_nvramShadow.dot11ExcludeUnencripted=TRUE;
	

	if(conf.def_key && conf.key_len && (conf.wep_on || !(conf.auth_type & WIFI_AUTH_OPEN))) {
   		for (i = 0; i < DOT11_DEFS_KEY_NAL_LEN; i++) 
	   		if((whal_nvramShadow.pbWEP_DefsKeysVal[i].keyLen=strlen(conf.key[i])) > 0) 
	   			memcpy(whal_nvramShadow.pbWEP_DefsKeysVal[i].keyValue, conf.key[i], whal_nvramShadow.pbWEP_DefsKeysVal[i].keyLen);
   		whal_nvramShadow.dot11WEPDefaultKeyID = conf.def_key-1;
		whal_nvramShadow.dot11PrivacyOptionImplemented=TRUE;
		if(conf.wep_on) 
			whal_nvramShadow.dot11PrivacyInvoked=TRUE;
	}
	
	/* output nvram.bin */
	if((fd=open(WIFI_BIN, O_CREAT | O_WRONLY)) <0) 
		return -1;
	write(fd, &whal_nvramShadow, sizeof(tWHAL_NVRAM_STRUCT));
	close(fd);

	/* save acl.bin file */
	if(add_mac_list(conf.access_control, nvram_get("wifi_access_list"))!=0)
		return -1;
	/* save wifi.ssid */
	if((fd=open(WIFI_SSID, O_CREAT | O_WRONLY)) <0) 
		return -1;
	write(fd, &conf.broadcast_ssid, 1);
	close(fd);
	return 0;
}

int wlan_up() {
#if 1	
	if(system(TIWLAN_KRENEL_MODULE)!=0)
		return -1;
	sleep(1);
#endif
	if(system(TIWLAN_USER_DRV)!=0)
		return -1;
	sleep(1);
	if(system(IFCONFIG" tiwlan0 0.0.0.0")!=0)
		return -1;
	system("/usr/sbin/brctl addif br0 tiwlan0");
	system("/bin/cp /proc/uptime /var/wlan_uptime");
	return 0;
}

/*
 * wifi_init: Initial Wireless LAN 
 * Return Value: 0=Success  others=Fail
 */
#define WIFI_PARSE_ERR	-1
#define WIFI_SAVE_ERR	-2
#define WIFI_UP_ERR	-3
#if 0
int wifi_save(void) {
  	wifi_t conf;
  
  	/* read configure file */
  	if(parse_config(&conf)) {
      		puts("parse_config error!");
		return WIFI_PARSE_ERR;
  	}
	if(nvram_save(conf)!=0) {
      		puts("nvram save fail!");
		return WIFI_SAVE_ERR;
	}
  	return 0;
}
#endif
int start_wifi(void) {
  	wifi_t conf;
	
	if (*(nvram_safe_get("wifi_present"))=='0') 
		return 0;
	
//	wlan_down();
  	/* read configure file */
  	if(parse_config(&conf)) {
      		puts("parse_config error!");
		return WIFI_PARSE_ERR;
  	}
	if(conf.if_on) {
		if(nvram_save(conf)!=0) {
      			puts("nvram save fail!");
			return WIFI_SAVE_ERR;
		}
		if(wlan_up()!=0) {
      			puts("wifi up fail!");
			return WIFI_UP_ERR;
		}
	}
  	return 0;
}

int wifi_init(void)
{
#if 0 
  	wifi_t conf;
  	/* read configure file */
  	if(parse_config(&conf)) {
      		puts("parse_config error!");
		return WIFI_PARSE_ERR;
  	}
	if(conf.if_on) {
		if(nvram_save(conf)!=0) {
      			puts("nvram save fail!");
			return WIFI_SAVE_ERR;
		}
		if(wlan_up()!=0) {
      			puts("wifi up fail!");
			return WIFI_UP_ERR;
		}
	}
	else {
#endif
		if(system(TIWLAN_KRENEL_MODULE)!=0) 
			return WIFI_UP_ERR;
		system(RMMOD" tiwlan");
#if 0
	}
#endif
  	return 0;
}
int wlan_socket_cmd(char *cmd) {
	int sin_fd, sout_fd;
	struct sockaddr_un sin_addr, sout_addr;
	char tmp[128];
	struct pollfd mypoll;	
	int res;

	/* prepare input socket structure -- sin */
	if ((sin_fd = socket(AF_LOCAL, SOCK_DGRAM, 0)) < 0) {
		return -1;
	}

	memset(&sin_addr, sizeof(struct sockaddr_un), 0);
	sin_addr.sun_family = AF_LOCAL;

	strncpy(sin_addr.sun_path, JOEL_SOCKET_IN, UNIX_PATH_MAX - 1);
	if (connect(sin_fd, (struct sockaddr*)&sin_addr, sizeof(struct sockaddr_un)) != 0) {
		return -1;
	}
	
	unlink(JOEL_SOCKET_OUT);
	/* prepare output socket structure -- sin */
	if ((sout_fd = socket(AF_LOCAL, SOCK_DGRAM, 0)) < 0) {
		return -1;
	}

	memset(&sout_addr, sizeof(struct sockaddr_un), 0);
	sout_addr.sun_family = AF_LOCAL;
	strncpy(sout_addr.sun_path, JOEL_SOCKET_OUT, UNIX_PATH_MAX - 1);
 	if (bind(sout_fd, (struct sockaddr *)&sout_addr, sizeof(struct sockaddr_un)) != 0) {
		return -1;
       	}

	mypoll.fd=sout_fd;
	mypoll.events = POLLIN;

	/* send command */
	write(sin_fd, cmd, strlen(cmd));
	while (1) { 
		res = poll(&mypoll, 1, -1); 
		switch (res) { 
			case -1: 
				puts("joel_cmd: poll() failed");
				return -1; 
			case 0: // timeout 
				puts("poll time out");
				break; 
			default: 
				if (mypoll.revents & POLLIN) {
				//int len =  sizeof(struct sockaddr_un);
					while((res = read(sout_fd, tmp, 17))==17){
						tmp[res]='\0';
						printf("%s\n",tmp);
					}
					return 0;
				}
				break;
		}
	}
	
	return 0;
}
