/*
 *wireless setting for CGI
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <linux/un.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "../../../rw_flash/led.h"
#include "wireless.h"
#include "nvram.h"

extern int SYSTEM(const char *format, ...);

#if 0
#include <stdarg.h>
void mBUG(char *format,...){
 va_list args;
    FILE *fp;

    fp = fopen("/var/cgitest","a+");
    if(!fp){
        return;
    }
    va_start(args,format);
    vfprintf(fp,format,args);
    va_end(args);
    fprintf(fp,"\n");
    fflush(fp);
    fclose(fp);
    system("/bin/chmod 777 /var/cgitest");

}
#endif
#if 0
static tWHAL_NVRAM_STRUCT whal_nvramShadow;
int add_mac_list(int on, char *list) {
	char *s=list;
	unsigned char mac[6];
	int i;
	char tmp[18];
	int fd;

	if(!on) {
		unlink(ACL_BIN);
		return 0;
	}
	if((fd=open(ACL_BIN, O_CREAT|O_TRUNC|O_WRONLY)) < 0)
		return -1;
	tmp[17]='\0';
	while(strlen(s)>=17) {
		for(i=0;i<17;i++) {
			tmp[i]=*(s++);
		}
		sscanf(tmp, "%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:",
				&mac[0], &mac[1], &mac[2], &mac[3], &mac[4],&mac[5]);
		write(fd, mac, 6);
		while(*(s++)!='\1') 
			if(strlen(s) < 17)
				break;
	}
	close(fd);
	return 0;
}
#if 0
void iw_setup(wifi_t conf) {
 	char cmd[1024];
	
	if(!conf.if_on)
		return;


      	/* ---------- Set encryption stuff ---------- */
	if(conf.key_len!=0) {
		sprintf(cmd, IWCONFIG" %s key [1] %s", conf.ifname, conf.key1);
		system(cmd);
		sprintf(cmd, IWCONFIG" %s key [2] %s", conf.ifname, conf.key2);
		system(cmd);
		sprintf(cmd, IWCONFIG" %s key [3] %s", conf.ifname, conf.key3);
		system(cmd);
		sprintf(cmd, IWCONFIG" %s key [4] %s", conf.ifname, conf.key4);
		system(cmd);
		sprintf(cmd, IWCONFIG" %s key [%u]", conf.ifname, conf.def_key);
		system(cmd);
	} else { 
		sprintf(cmd, IWCONFIG" %s key off", conf.ifname);
		system(cmd);
	}
		
      	/* ---------- Set Access List ---------- */
	if(conf.access_control) {
		/* flush MAC access control list */
		sprintf(cmd, IWPRIV" %s maccmd 3", conf.ifname);
		system(cmd);
		/* allow policy for ACL */
		sprintf(cmd, IWPRIV" %s maccmd 1", conf.ifname);
		system(cmd);
		/* add mac list */
		sprintf(cmd, IWPRIV" %s addmac", conf.ifname);
		add_mac_list(cmd, nvram_get("wifi_access_list"));
		/* kick all authenticated stations */
		sprintf(cmd, IWPRIV" %s maccmd 4", conf.ifname);
		system(cmd);
	}
	else {
		/* open policy for ACL */
		sprintf(cmd, IWPRIV" %s maccmd 0", conf.ifname);
		system(cmd);
	}
	
      	/* ---------- Set Broadcast SSID ---------- */
	if(conf.broadcast_ssid)
		sprintf(cmd, PRISM2_PARAM" %s enh_sec 0", conf.ifname);
	else
		sprintf(cmd, PRISM2_PARAM" %s enh_sec 3", conf.ifname);
	system(cmd);
}
#endif
char *digital_to_keystring(char *dig_key, int keylen) {
	char *keystr=NULL;

	if((keylen==64) && (strlen(dig_key)>=10)){
		keystr=malloc(6);
		sscanf(dig_key, "%02hhx%02hhx%02hhx%02hhx%02hhx", &keystr[0], \
		       &keystr[1], &keystr[2], &keystr[3], &keystr[4]);
		keystr[5]='\0';
	}
	if((keylen==128) && (strlen(dig_key)>=26)){
		keystr=malloc(14);
		sscanf(dig_key, \
		       "%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx", \
		       &keystr[0], &keystr[1], &keystr[2], &keystr[3], \
		       &keystr[4], &keystr[5], &keystr[6], &keystr[7], \
		       &keystr[8], &keystr[9], &keystr[10], &keystr[11], \
		       &keystr[12]);
		keystr[13]='\0';
	}
	if(keystr==NULL) {
		keystr=malloc(1);
		keystr[0]='\0';
	}
	return keystr;
}

#define WIFI_AUTH_DEF "3"
int parse_config(wifi_t *conf) {
	conf->if_on=(unsigned char)atoi(nvram_get("wifi_if_on"));
	strcpy(conf->ssid, nvram_get("wifi_ssid"));
	conf->channel=(unsigned char)atoi(nvram_get("wifi_channel"));
	if(conf->channel == 0 || conf->channel > 14)
		return -1;
	conf->auth_type=(unsigned char)atoi(nvram_get("wifi_auth_type"));
	if((conf->auth_type<1) || (conf->auth_type>3)) {
		conf->auth_type = atoi(WIFI_AUTH_DEF);
		nvram_set("wifi_auth_type", WIFI_AUTH_DEF);
	}
	conf->wep_on=(unsigned char)atoi(nvram_get("wifi_wep_on"));
	conf->key_len=(unsigned char)atoi(nvram_get("wifi_key_len"));
	conf->def_key=(unsigned char)atoi(nvram_get("wifi_def_key"));
	strcpy(conf->key[0], digital_to_keystring(nvram_get("wifi_key1"), conf->key_len));
	strcpy(conf->key[1], digital_to_keystring(nvram_get("wifi_key2"), conf->key_len));
	strcpy(conf->key[2], digital_to_keystring(nvram_get("wifi_key3"), conf->key_len));
	strcpy(conf->key[3], digital_to_keystring(nvram_get("wifi_key4"), conf->key_len));
	conf->access_control=(unsigned char)atoi(nvram_get("wifi_access_control"));
	conf->broadcast_ssid=(unsigned char)atoi(nvram_get("wifi_broadcast_ssid"));
	conf->dot11_mode=(unsigned char)atoi(nvram_safe_get("wifi_dot11_mode"));
	return 0;
}

/**************************************************************************
 *             void whal_nvram_setDefaults(void)                          *
 **************************************************************************
 * DESCRIPTION:  Restore NVRAM defaults                                   *
 *                                                                        *
 **************************************************************************/
int ti_set_defaults(UINT8 woneIndex, wifi_t conf)
{
	int i;
#if 0
   UINT32 serial=0;
#endif
   UINT8 def_dot11_mode = 0; 
   UINT8 idx; 
   	FILE *fp;
	char tmp[1024];
	char *pt;
	unsigned char mac[6]="\x00\x50\xF1\x12\x00\x00";

	fp=fopen("/proc/sys/dev/adam2/environment","r");
	if(fp!=NULL){
		fread(tmp,1024,1,fp);
		fclose(fp);
		if((pt=strstr(tmp,"maca"))!=NULL)
			sscanf(pt,"%*s %02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx"
			,&mac[0], &mac[1], &mac[2], &mac[3], &mac[4],&mac[5]);
	}

	
   whal_nvramShadow.vhcfParams.vhcfEnable = FALSE;
   for(idx = 0; idx < MAX_VHCF_CLASSIFIERS ; idx++)
   {
	  whal_nvramShadow.vhcfParams.vhcfClassifier[idx].Protocol = VHCF_PROT_NONE;
	  whal_nvramShadow.vhcfParams.vhcfClassifier[idx].DestPort = 0;
	  whal_nvramShadow.vhcfParams.vhcfClassifier[idx].DestIp   = 0;
   }
    whal_nvramShadow.numSupWone = DEF_NUM_WONE_SUP;
	whal_nvramShadow.uiNVRAMMagic = WHAL_NVRAM_MAGIC;
	/* Joel Note: Use LAN MAC from Adam2 */
   //memcpy(whal_nvramShadow.dot11MacAddress,DEF_DEVICE_MAC,6);
   memcpy(whal_nvramShadow.dot11MacAddress,mac,6);
   /* We don't use SerialNumber to define MAC */
#if 0
   sscanf(whal_nvramShadow.SerialNumber, "%x", &serial); 
   whal_nvramShadow.dot11MacAddress[4] = (serial&0x0000FF00)>>8;
   whal_nvramShadow.dot11MacAddress[5] = (serial&0x000000FF);
#endif

   whal_nvramShadow.dot11SsIDLength = DEF_SSID_LENGTH;
   memcpy(whal_nvramShadow.dot11SsID,DEF_SSID,DEF_SSID_LENGTH);
   whal_nvramShadow.dot11SsID[DEF_SSID_LENGTH] = 0;
   /* Hidden SSID */
   whal_nvramShadow.hiddenSsid = DEF_HIDDEN_SSID;
   /* Multiple SSID */
   whal_nvramShadow.multipleSsidFlag = DEF_MULTIPLE_SSID_FLAG;
   memset(whal_nvramShadow.multipleSsidTable,0,NUM_MULTIPLE_SSID*WHAL_SSID_STRING_LEN);
   if (strlen(whal_nvramShadow.SerialNumber) >= 4)
   {
      whal_nvramShadow.dot11SsID[DEF_SSID_LENGTH] = '\0';
	  strncat(whal_nvramShadow.dot11SsID, whal_nvramShadow.SerialNumber, 4);
      whal_nvramShadow.dot11SsIDLength += 4;
   }
   
   whal_nvramShadow.dot11AuthenticationResponceTimeOut = DEF_AUTH_RESP_TO_MS;
   whal_nvramShadow.dot11PrivacyOptionImplemented      = DEF_PRIV_IMPLEMENTED;

   if(woneIndex == 0)  /* 802.11 B/G */
   {
   whal_nvramShadow.wone_info[woneIndex].dot11channel  = DEF_CHANNEL;
       whal_nvramShadow.wone_info[woneIndex].dot11Band = RADIO_BAND_2_4GHZ;
       def_dot11_mode = conf.dot11_mode;
       whal_nvramShadow.wone_info[woneIndex].usageTime = DEF_WONE_0_USAGE_TIME;
   }
   else /* 802.11 a */
   {
       whal_nvramShadow.wone_info[woneIndex].dot11channel  = DEF_A_CHANNEL;
       whal_nvramShadow.wone_info[woneIndex].dot11Band = RADIO_BAND_5GHZ;
       def_dot11_mode = DEF_DOT11_A_MODE;
       whal_nvramShadow.wone_info[woneIndex].usageTime = DEF_WONE_1_USAGE_TIME;
   }
   
    switch (def_dot11_mode)
   {   
    case     DOT11_MODE_B_ONLY:
	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRateLength  = DEF_OPER_RATE_LEN;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRate,
										 DEF_OPER_RATE_SET,CCK_PBCC_RATES_MAX);
	   
	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRateLength = DEF_OPER_ADDITIONAL_RATE_LEN_B_ONLY;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRate,
										 DEF_OPER_ADDITIONAL_RATE_SET_B_ONLY,OFDM_RATES_MAX);	

	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRateLength = DEF_OPER_OFDM_RATE_LEN;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRate,
										 DEF_OPER_OFDM_RATE_SET,OFDM_RATES_MAX);

	   whal_nvramShadow.wone_info[woneIndex].dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE_B;
	   whal_nvramShadow.wone_info[woneIndex].dot11PreambleMode  = DEF_PREAMBLE_MODE_B;
	   whal_nvramShadow.wone_info[woneIndex].dot11SlotTimeMode  = DEF_SLOTTIME_MODE_B_ONLY;
	   whal_nvramShadow.dot11SlotTimeThreshold  = DEF_SLOTTIME_THRESHOLD_B_AND_MIXED;
	   whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionMode = DEF_PROTECTION_MODE_B_ONLY;
	   whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionType = DEF_PROTECTION_TYPE_B_ONLY;
        break;
    case    DOT11_MODE_B_ONLY_PLUS:

	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRateLength = DEF_OPER_RATE_LEN_PLUS_PBCC;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRate,
										 DEF_OPER_RATE_SET_PLUS_PBCC,CCK_PBCC_RATES_MAX);
	   
	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRateLength  = DEF_OPER_ADDITIONAL_RATE_LEN_B_ONLY;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRate,
										 DEF_OPER_ADDITIONAL_RATE_SET_B_ONLY,OFDM_RATES_MAX);	

	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRateLength = DEF_OPER_OFDM_RATE_LEN;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRate,
										 DEF_OPER_OFDM_RATE_SET,OFDM_RATES_MAX);

	   whal_nvramShadow.wone_info[woneIndex].dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE_B_PLUS_AND_MIXED;
	   whal_nvramShadow.wone_info[woneIndex].dot11PreambleMode  = DEF_PREAMBLE_MODE_B;
	   whal_nvramShadow.wone_info[woneIndex].dot11SlotTimeMode  = DEF_SLOTTIME_MODE_B_ONLY;
	   whal_nvramShadow.dot11SlotTimeThreshold  = DEF_SLOTTIME_THRESHOLD_B_AND_MIXED;
	   whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionMode = DEF_PROTECTION_MODE_B_ONLY;
	   whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionType = DEF_PROTECTION_TYPE_B_ONLY;	   
        break;
    case    DOT11_MODE_MIXED:

	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRateLength = DEF_OPER_RATE_LEN_PLUS_PBCC;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRate,
										 DEF_OPER_RATE_SET_PLUS_PBCC,CCK_PBCC_RATES_MAX);

	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRateLength = DEF_OPER_OFDM_RATE_LEN;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRate,
										 DEF_OPER_OFDM_RATE_SET,OFDM_RATES_MAX);

	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRateLength = DEF_OPER_ADDITIONAL_RATE_LEN_MIXED;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRate,
										 DEF_OPER_ADDITIONAL_RATE_SET_MIXED,OFDM_RATES_MAX);
	   
	   whal_nvramShadow.wone_info[woneIndex].dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE_B_PLUS_AND_MIXED;
	   whal_nvramShadow.wone_info[woneIndex].dot11PreambleMode  = DEF_PREAMBLE_MODE_G_AND_MIXED;
	   whal_nvramShadow.wone_info[woneIndex].dot11SlotTimeMode  = DEF_SLOTTIME_MODE_G_AND_MIXED;
	   whal_nvramShadow.dot11SlotTimeThreshold  = DEF_SLOTTIME_THRESHOLD_B_AND_MIXED;
	   whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionMode = DEF_PROTECTION_MODE_G_AND_MIXED;
	   whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionType = DEF_PROTECTION_TYPE_G_AND_MIXED;
        break;
    case    DOT11_MODE_OFDM_ONLY:

       if(whal_nvramShadow.wone_info[woneIndex].dot11Band == RADIO_BAND_5GHZ)
       whal_nvramShadow.wone_info[woneIndex].dot11channel = DEF_CHANNEL;
	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRateLength                    = DEF_OPER_RATE_LEN;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRate,
										 DEF_OPER_RATE_SET,CCK_PBCC_RATES_MAX);

	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRateLength = DEF_OPER_OFDM_RATE_LEN;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRate,
										 DEF_OPER_OFDM_RATE_SET,OFDM_RATES_MAX);	

	   whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRateLength = DEF_OPER_ADDITIONAL_RATE_LEN_G_ONLY;
	   strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRate,
										 DEF_OPER_ADDITIONAL_RATE_SET_G_ONLY,OFDM_RATES_MAX);
	   
	   whal_nvramShadow.wone_info[woneIndex].dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE_G_ONLY;
	   whal_nvramShadow.wone_info[woneIndex].dot11PreambleMode  = DEF_PREAMBLE_MODE_G_AND_MIXED;
	   whal_nvramShadow.wone_info[woneIndex].dot11SlotTimeMode  = DEF_SLOTTIME_MODE_G_AND_MIXED;
	   whal_nvramShadow.dot11SlotTimeThreshold  = DEF_SLOTTIME_THRESHOLD_G_ONLY;
	   whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionMode = DEF_PROTECTION_MODE_G_AND_MIXED;
	   whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionType = DEF_PROTECTION_TYPE_G_AND_MIXED;
        break;
    case     DOT11_MODE_A_ONLY:
        whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRateLength 
                               = 0;
        strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalRateSet.dot11CckRate,
                                          "",0);

        whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRateLength = DEF_OPER_ADDITIONAL_RATE_LEN_A;
        strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalAdditionalRateSet.dot11OfdmRate,
                                          DEF_OPER_ADDITIONAL_RATE_SET_A,DEF_OPER_ADDITIONAL_RATE_LEN_A);	

        whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRateLength = 0;
        strncpy(whal_nvramShadow.wone_info[woneIndex].dot11OperationalOFDMRateSet.dot11OfdmRate,
                                          "",0);

        whal_nvramShadow.wone_info[woneIndex].dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE_G_ONLY;
        whal_nvramShadow.wone_info[woneIndex].dot11PreambleMode  = PREAMBLE_MODE_LONG;
        whal_nvramShadow.wone_info[woneIndex].dot11SlotTimeMode  = SLOTTIME_MODE_ENABLED;
        whal_nvramShadow.dot11SlotTimeThreshold  = DEF_SLOTTIME_THRESHOLD_G_ONLY; 
            whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionMode = PROTECTION_MODE_DISABLED;
        whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionType = DEF_PROTECTION_TYPE_G_AND_MIXED;
        break;
    default:
   }

   whal_nvramShadow.dot11BeaconPeriod = DEF_BEACON_PERIOD;
   whal_nvramShadow.dot11DTIMPeriod   = DEF_DTIM_PERIOD;
   
   whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].authAlgo 
                                                      = DEF_AUTH_ALGO0; 
   whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].enable   
                                                      = DEF_AUTH_ALG0_ENABLE; 
   whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].authAlgo 
                                                      = DEF_AUTH_ALGO1; 
   whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].enable   
                                                      = DEF_AUTH_ALG1_ENABLE; 
   for (i = 0; i < DOT11_DEFS_KEY_NAL_LEN; i++)
   {
	   memset(whal_nvramShadow.pbWEP_DefsKeysVal[i].keyValue, 0, WEP_KEY_LEN_MAX);
	   whal_nvramShadow.pbWEP_DefsKeysVal[i].keyLen = DEF_WEP_KEY_LEN;
   }
   memset(whal_nvramShadow.KeyMapping,0,
                             sizeof(tWEP_KEY_MAPPING_ENTRY) * DOT11_MAX_KEY_MAPPING_LEN);
   for (i = 0; i < DEF_WEP_KEY_MAPPING_LEN; i++)
	   whal_nvramShadow.KeyMapping[i].MappingValue.keyLen = DEF_WEP_KEY_LEN;
   whal_nvramShadow.dot11PrivacyInvoked  = DEF_PRIV_INVOKED;
   whal_nvramShadow.dot11WEPDefaultKeyID = DEF_WEP_KEY_ID;
   whal_nvramShadow.dot11WEPKeyMappingLength = DEF_WEP_KEY_MAPPING_LEN;
   whal_nvramShadow.dot11ExcludeUnencripted  = DEF_EXCLUDE_UNENCRIPTED;
   whal_nvramShadow.dot11RTSTreshold =  DEF_RTS_TRESHOLD;
   whal_nvramShadow.dot11ShortRetryLimit = DEF_SHORT_RETRY_LIMIT;
   whal_nvramShadow.dot11LongRetryLimit  = DEF_LONG_RETRY_LIMIT;
   whal_nvramShadow.dot11FragmentationTreshold   = DEF_FRAGMENTATION_TRESHOLD;
   whal_nvramShadow.dot11MaxTransmitMSDULifetime = DEF_MAX_TX_MPDU_LIFETIME;
   whal_nvramShadow.dot11MaxReceiveLifetime      = DEF_MAX_RX_MPDU_LIFETIME;
   strncpy(whal_nvramShadow.dot11ManufacturerID,DEF_MANUF_ID,PROD_ID_LEN);
   strncpy(whal_nvramShadow.dot11ProductID,DEF_PROD_ID,PROD_ID_LEN);
   strncpy(whal_nvramShadow.dot11manufacturerOUI,
                            DEF_MANUF_OUI,DOT11_MANUFACTURER_OUI_LENGTH);
   strncpy(whal_nvramShadow.dot11manufacturerName,
                                           DEF_MANUF_NAME,PROD_ID_LEN);
   strncpy(whal_nvramShadow.dot11manufacturerProductName,
                                           DEF_MANUF_PROD_NAME,PROD_ID_LEN);
   strncpy(whal_nvramShadow.dot11manufacturerProductVersion,
                                           DEF_MANUF_PROD_VER,PROD_ID_LEN);
   whal_nvramShadow.dot11Agile  = DEF_AGILE;
   /*whal_nvramShadow.dot11PBCCAlgorithmMode  = DEF_PBCC_ALGORITHM_MODE;*/
   whal_nvramShadow.RateFallback  = DEF_RATE_FALLBACK;
   //whal_nvramShadow.RateFallback  = 1;
   whal_nvramShadow.wone_info[woneIndex].RateAdaptation  = DEF_RATE_ADAPTATION;
   /*whal_nvramShadow.dot11PreambleMode  = DEF_PREAMBLE_MODE;*/
   /*whal_nvramShadow.dot11SlotTimeMode  = DEF_SLOTTIME_MODE;*/
   whal_nvramShadow.wone_info[woneIndex].dot11Mode = def_dot11_mode;
   whal_nvramShadow.wone_info[woneIndex].Lastdot11Mode = def_dot11_mode;
   whal_nvramShadow.wone_info[woneIndex].CwMinMode = DEF_CWMIN_MODE;
   whal_nvramShadow.dot11DynamicAlgTimeout = DEF_DYN_ALG_TIMEOUT;
   whal_nvramShadow.RadioCalibrateOption = DEF_RADIO_CALIBRATE_OPTION;
   whal_nvramShadow.RadioCalibrateInterval = DEF_RADIO_CALIBRATE_INTERVAL;


   /*whal_nvramShadow.dot11ERPProtectionMode = DEF_PROTECTION_MODE;*/
   /*whal_nvramShadow.dot11ERPProtectionType = DEF_PROTECTION_TYPE;*/
   whal_nvramShadow.wone_info[woneIndex].dot11ERPProtectionTI = DEF_PROTECTION_TI;

   whal_nvramShadow.RespRateMode = DEF_RESP_RATE_MODE;

   whal_nvramShadow.ReportLevel  = DEF_REPORT_LEVEL;
   memset(whal_nvramShadow.whalArea, 0, sizeof(whal_nvramShadow.whalArea));
   
   whal_nvramShadow.enableEnergyDetect = DEF_ENERGY_DETECT;

   whal_nvramShadow.enableRestartWA       = DEF_ENABLE_RESTART_WA;
   whal_nvramShadow.RxFreeMemOptionWA     = DEF_WA_RX_FREE_MEM_OPTION;
   whal_nvramShadow.BeaconNotSentOptionWA = DEF_WA_BCN_NOT_SENT_OPTION;
   whal_nvramShadow.TxStuckOptionWA       = DEF_WA_TX_STUCK_OPTION;
   whal_nvramShadow.ConsFcsErrOptionWA    = DEF_WA_CONS_FCS_ERR_OPTION;

   whal_nvramShadow.CurrFeatureSet = DEF_FEATURE_SET;
   whal_nvramShadow.enable4x  = DEF_ENABLE_4X;
   whal_nvramShadow.enableConcat  = DEF_ENABLE_CONCAT;
   whal_nvramShadow.enableAckEmul  = DEF_ENABLE_ACK_EMUL;
   whal_nvramShadow.enable4xMixMode  = DEF_ENABLE_4X_MIX_MODE;

   whal_nvramShadow.wpaMode  = DEF_WPA_MODE;
   whal_nvramShadow.passPhraseMode = DEF_PSK_MODE;
   memset(whal_nvramShadow.pskHex, 0, 32);
   whal_nvramShadow.defaultCipher = DEF_CIPHER;
   whal_nvramShadow.GTKInterval = DEF_GTK_INTERVAL;
   whal_nvramShadow.pskPwdLength = DEF_PSK_PWD_LENGTH;
   memcpy(whal_nvramShadow.pskPwd, DEF_PSK_PWD, DEF_PSK_PWD_LENGTH);
   whal_nvramShadow.radiusSecretLength = DEF_RADIUS_SECRET_LEN;
   memcpy(whal_nvramShadow.radiusSecret, DEF_RADIUS_SECRET, DEF_RADIUS_SECRET_LEN);
   whal_nvramShadow.radiusPort = DEF_RADIUS_PORT;

   whal_nvramShadow.radiusIpAddr[0] = DEF_RADIUS_IP_ADDR_1;
   whal_nvramShadow.radiusIpAddr[1] = DEF_RADIUS_IP_ADDR_2;
   whal_nvramShadow.radiusIpAddr[2] = DEF_RADIUS_IP_ADDR_3;
   whal_nvramShadow.radiusIpAddr[3] = DEF_RADIUS_IP_ADDR_4;

   whal_nvramShadow.defaultGateway[0] = DEF_GATEWAY_1;
   whal_nvramShadow.defaultGateway[1] = DEF_GATEWAY_2;
   whal_nvramShadow.defaultGateway[2] = DEF_GATEWAY_3;
   whal_nvramShadow.defaultGateway[3] = DEF_GATEWAY_4;


   strncpy(whal_nvramShadow.pb_password,
                             DEF_CONSOLE_PASSWORD,WLAN_PROD_PASSWORD_LEN);
   whal_nvramShadow.uiConsolePwdMagic = WHAL_CONSOLE_PWD_MAGIC;

   /* 802.11d and 802.11h support */

   whal_nvramShadow.dot11MultiDomainCapabilityEnable = FALSE;
   whal_nvramShadow.dot11SpectrumManagementRequired  = FALSE;
   whal_nvramShadow.whalEnableLegacyStations         = FALSE;
   whal_nvramShadow.dot11CurrentRegDomain            = REG_DOMAIN_FCC;
   whal_nvramShadow.dot11LocalPowerConstraint = 0;
   whal_nvramShadow.whalMaxTxPowerLevel = 1;
   whal_nvramShadow.txPowerLevels_a[0] = 11;    /* levels of dBm - original: 11.3 */
   whal_nvramShadow.txPowerLevels_a[1] = 10;    /* levels of dBm - original: 10   */
   whal_nvramShadow.txPowerLevels_a[2] = 9;     /* levels of dBm - original: 9.5  */
   whal_nvramShadow.txPowerLevels_a[3] = 7;     /* levels of dBm - original: 6.6  */
   whal_nvramShadow.txPowerLevels_a[4] = 5;     /* levels of dBm - original: 4.6  */
   whal_nvramShadow.txPowerLevels_g[0] = 19;    /* levels of dBm - original: 18.9 */
   whal_nvramShadow.txPowerLevels_g[1] = 18;    /* levels of dBm - original: 18.2 */
   whal_nvramShadow.txPowerLevels_g[2] = 16;    /* levels of dBm - original: 16.4 */
   whal_nvramShadow.txPowerLevels_g[3] = 15;    /* levels of dBm - original: 14.5 */
   whal_nvramShadow.txPowerLevels_g[4] = 14;    /* levels of dBm - original: 14.5 */
   strcpy(whal_nvramShadow.dot11CountryString,"US ");           /* ??? */
   whal_nvramShadow.dot11PrivateRegulatoryDomain = 0;
   whal_nvramShadow.numOfRanges_802_11_a = 0;
   memset(whal_nvramShadow.rangeElements_a,0,sizeof(tChannelRangeElementStruct)*MAX_NUM_OF_RANGES_A);
   whal_nvramShadow.numOfRanges_802_11_b = 0;
   memset(whal_nvramShadow.rangeElements_b,0,sizeof(tChannelRangeElementStruct)*MAX_NUM_OF_RANGES_B);
   
   /********************
    * TestApp defaults *
    ********************/
   whal_nvramShadow.ta_radioscope_com_option = TA_RADIOSCOPE_COMOPT_DEFAULT;
   whal_nvramShadow.ta_startup_option = TA_STARTUP_OPT_NORMAL;

	 /* MAC access list */
	 whal_nvramShadow.accessListEnabled = 0;
	 whal_nvramShadow.accessListType = 0; /* white list */
	 memset(whal_nvramShadow.accessList, 0, MAC_ADDR_LEN*MGMT_ACCESS_LIST_SIZE);
	 
	whal_nvramShadow.WlanServiceState = DEF_WLAN_OPERATING_STATE;

    whal_nvramShadow.bootCounter = 0;


    return 0;
   //return whalNVRAMWrite();
}/* END whal_nvram_setDefaults() */


void msgkill(void) {
	FILE *fp;
	char buf[4092];
	char *sp;
	char *se;
	char aline[1020];
	int id;

	fp=fopen("/proc/sysvipc/msg", "r");
	fread(buf, 4092, 1, fp);
		
	if((sp=strstr(buf, "\n"))==NULL)
		return ;
	sp+=1;
	while((se=strstr(sp, "\n"))!=NULL){
		strcpy(aline, "");
		strncat(aline, sp, se-sp);
		sscanf(aline, "%*s %d", &id);
		if((msgctl(id, IPC_RMID, NULL)) <0) {
			return;
		}
		printf("msgctl queue id(%d) removed\n", id);
		sp=se+1;
	}
			
	fclose(fp);
	
}

int stop_wifi(void) {
    turnOffLED(LED_WLAN);
	system("/sbin/brctl delif br0 eth2");
//	system("/sbin/brctl delif br0 eth0");
//	system("/sbin/brctl addif br0 eth0");
	system(IFCONFIG" eth2 down");
//	system(KILLALL" -2 user_drv");
//	sleep(1);
//	system(KILLALL" -9 user_drv");
//	sleep(1);
	//system(RMMOD" tiwlan");
	sleep(1);
	msgkill();	
	return 0;
}

int nvram_save(wifi_t conf) {
	int fd;
	int i;
	int wone_index;

	/* Initial Default Values */	
      	for(wone_index = 0;wone_index < MAX_WONE_NET; wone_index++)
      	{
	  	ti_set_defaults(wone_index, conf);
      	}

	/* setup SSID */
	whal_nvramShadow.dot11SsIDLength = strlen(conf.ssid);
	memcpy(whal_nvramShadow.dot11SsID,conf.ssid,strlen(conf.ssid));
	
	/* setup Channel */
	whal_nvramShadow.wone_info[0].dot11channel=conf.channel;
	
	/* setup Auth Type */ 
	if(conf.auth_type == WIFI_AUTH_AUTO) {
		whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].enable = TRUE;
	} else if(conf.auth_type == WIFI_AUTH_SKEY) {
		whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].authAlgo = MIB_SHARED_KEY; 
		whal_nvramShadow.dot11AuthenticationAlgorithmTable[0].enable = TRUE; 
		whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].authAlgo = MIB_OPEN_SYSTEM; 
		whal_nvramShadow.dot11AuthenticationAlgorithmTable[1].enable = FALSE;
	}

	/* setup WEP Staff */
	if(conf.wep_on) 
		whal_nvramShadow.dot11ExcludeUnencripted=TRUE;
	

	if(conf.def_key && conf.key_len && (conf.wep_on || !(conf.auth_type & WIFI_AUTH_OPEN))) {
   		for (i = 0; i < DOT11_DEFS_KEY_NAL_LEN; i++) 
	   		if((whal_nvramShadow.pbWEP_DefsKeysVal[i].keyLen=strlen(conf.key[i])) > 0) 
	   			memcpy(whal_nvramShadow.pbWEP_DefsKeysVal[i].keyValue, conf.key[i], whal_nvramShadow.pbWEP_DefsKeysVal[i].keyLen);
   		whal_nvramShadow.dot11WEPDefaultKeyID = conf.def_key-1;
		whal_nvramShadow.dot11PrivacyOptionImplemented=TRUE;
		if(conf.wep_on) 
			whal_nvramShadow.dot11PrivacyInvoked=TRUE;
	}

   	/* Hidden SSID */
   	whal_nvramShadow.hiddenSsid = 1-conf.broadcast_ssid;
	
	/* output nvram.bin */
	if((fd=open(WIFI_BIN, O_CREAT | O_WRONLY)) <0) 
		return -1;
	write(fd, &whal_nvramShadow, sizeof(tWHAL_NVRAM_STRUCT));
	close(fd);

	/* save acl.bin file */
	if(add_mac_list(conf.access_control, nvram_get("wifi_access_list"))!=0)
		return -1;
#if 0
	/* save wifi.ssid */
	if((fd=open(WIFI_SSID, O_CREAT | O_WRONLY)) <0) 
		return -1;
	write(fd, &conf.broadcast_ssid, 1);
	close(fd);
#endif
	return 0;
}

int wlan_up() {
#if 1	
//	if(system(TIWLAN_KRENEL_MODULE)!=0)
//		return -1;
//	sleep(1);
#endif
//	if(system(TIWLAN_USER_DRV)!=0)
//		return -1;
//	sleep(1);
//	if(system(IFCONFIG" eth2 0.0.0.0")!=0)
//		return -1;
    system("/sbin/ifconfig eth2 0.0.0.0");
	system("/sbin/ifconfig eth2 promisc");
//	SYSTEM("/sbin/ifconfig %s 0.0.0.0",nvram_safe_get("lan_if"));
//	SYSTEM("/sbin/ifconfig %s promisc",nvram_safe_get("lan_if"));
//	system("/sbin/brctl addbr br0");
//	SYSTEM("/sbin/brctl addif br0 %s",nvram_safe_get("lan_if"));
	system("/sbin/brctl ad	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changesdif br0 eth2");
//	SYSTEM("/sbin/ifconfig br0 %s netmask %s broadcast %s"
//	        ,nvram_safe_get("lan_ipaddr")          
//			,nvram_safe_get("lan_netmask")         
//			,nvram_safe_get("lan_bipaddr"));       
if(strcmp(nvram_safe_get("wifi_if_on"),"1")==0)
  {
        SYSTEM("/sbin/iwconfig eth2 essid %s",nvram_safe_get("wifi_ssid"));
        SYSTEM("/sbin/iwconfig eth2 channel %s",nvram_safe_get("wifi_channel"));
        if(strcmp(nvram_safe_get("wifi_auth_type"),"1")==0)
        {
           system("/sbin/iwconfig eth2 auth open");
        }
        else if(strcmp(nvram_safe_get("wifi_auth_type"),"2")==0)
        {
           system("/sbin/iwcon	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changesfig eth2 auth share");
        }
        else
        {
           system("/sbin/iwconfig eth2 auth both");
        }
        
        if(!strcmp(nvram_safe_get("wifi_key_len"),"64")||!strcmp(nvram_safe_get("wifi_key_len"),"128"))
        {
           system("/sbin/iwconfig eth2 wep on");
           if(strcmp(nvram_safe_get("wifi_def_key"),"1")==0)
           {
           	system("/sbin/iwconfig eth2 keyid 0");  
                SYSTEM("/sbin/iwconfig eth2 key 0 0x%s",nvram_safe_get("wifi_key1"));
           }
           else if(strcmp(nvram_safe_get("wifi_def_key"),"2")==0)
           {
           	system("/sbin/iwconfig eth2 keyid 1");
                SYSTEM("/sbin	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changes/iwconfig eth2 key 1 0x%s",nvram_safe_get("wifi_key2"));
           }
           else if(strcmp(nvram_safe_get("wifi_def_key"),"3")==0)
           {
                system("/sbin/iwconfig eth2 keyid 2");
                SYSTEM("/sbin/iwconfig eth2 key 2 0x%s",nvram_safe_get("wifi_key3"));
           }
           else
           {
                system("/sbin/iwconfig eth2 keyid 3");
                SYSTEM("/sbin/iwconfig eth2 key 3 0x%s",nvram_safe_get("wifi_key4"));
           }
        }
        else
            system("/sbin/iwconfig eth2 wep off");
   }        	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changes
	system("/bin/cp /proc/uptime /var/wlan_uptime");
	return 0;
}

/*
 * wifi_init: Initial Wireless LAN 
 * Return Value: 0=Success  others=Fail
 */
#define WIFI_PARSE_ERR	-1
#define WIFI_SAVE_ERR	-2
#define WIFI_UP_ERR	-3
#if 0
int wifi_save(void) {
  	wifi_t conf;
  	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changes
  	/* read configure file */
  	if(parse_config(&conf)) {
      		puts("parse_config error!");
		return WIFI_PARSE_ERR;
  	}
	if(nvram_save(conf)!=0) {
      		puts("nvram save fail!");
		return WIFI_SAVE_ERR;
	}
  	return 0;
}
#endif

int save_wifi(void) {
  	wifi_t conf;
  	if(parse_config(&conf)) {
      		puts("parse_config error!");
		return WIFI_PA	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changesRSE_ERR;
  	}
	if(nvram_save(conf)!=0) {
      		puts("nvram save fail!");
		return WIFI_SAVE_ERR;
	}
	return 0;
}

int start_wifi(void) {
  	wifi_t conf;
	
//	if (*(nvram_safe_get("wifi_present"))=='0') 
//		return 0;
	printf("start_wifi\n");
//	wlan_down();
  	/* read configure file */
//  	if(parse_config(&conf))	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changes {
//      		puts("parse_config error!");
//		return WIFI_PARSE_ERR;
//  	}
//	if(conf.if_on) {
//		if(nvram_save(conf)!=0) {
//      			puts("nvram save fail!");
//			return WIFI_SAVE_ERR;
//		}
		if(wlan_up()!=0) {
      			puts("wifi up fail!");
			return WIFI_UP_ERR;
		}	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changes
//	}
    turnOnLED(LED_WLAN);
  	return 0;
}

int wifi_init(void)
{
#if 0 
  	wifi_t conf;
  	/* read configure file */
  	if(parse_config(&conf)) {
      		puts("parse_config error!");
		return WIFI_PARSE_ERR;
  	}
	if(conf.if_on) {	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changes
		if(nvram_save(conf)!=0) {
      			puts("nvram save fail!");
			return WIFI_SAVE_ERR;
		}
		if(wlan_up()!=0) {
      			puts("wifi up fail!");
			return WIFI_UP_ERR;
		}
	}
	else {
#endif
//		if(system(TIWLAN_KRENEL_MODULE)!=0) 
//			return WIFI_UP_ERR;
//		system(RMMOD" tiwlan");
#if 0
	}
#endif
  	return 0;	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changes
}
int wlan_socket_cmd(char *cmd) {
	int sin_fd, sout_fd;
	struct sockaddr_un sin_addr, sout_addr;
	char tmp[128];
	struct pollfd mypoll;	
	int res;

	/* prepare input socket structure -- sin */
	if ((sin_fd = socket(AF_LOCAL, SOCK_DGRAM, 0)) < 0) {
		return -1;
	}

	memset(&sin_addr, sizeof(struct sockaddr_un), 0);
	sin_addr.sun_family = AF_LOCAL;

	strncpy(sin_addr.sun_path, JOEL_SOCKET_IN, UNIX_PATH_MAX - 1);
	if (connect(sin_fd, (struct sockaddr*)&sin_addr, sizeof(struct sockaddr_un)) != 0) {
		return -1;
	}
	
	unlink(JOEL_SOCKET_OUT);
	/* prepare output socket structure -- sin */
	if ((sout_fd = socket(AF_LOCAL, SOCK_DGRAM, 0)) < 0) {
		return -1;
	}

	memset(&sout_addr, sizeof(struct sockaddr_un), 0);
	sout_addr.sun_family = AF_LOCAL;
	strncpy(sout_addr.sun_path, JOEL_SOCKET_OUT, UNIX_PATH_MAX - 1);
 	if (bind(sout_fd, (struct sockaddr *)&sout_addr, sizeof(struct sockaddr_un)) != 0) {
		return -1;
       	}

	mypoll.fd=sout_fd;
	mypoll.events = POLLIN;

	/* send command */
	write(sin_fd, cmd, strl	SYSTEM(ANISDKTOOL" -cga >/dev/console");	// commit changes en(cmd));
	while (1) { 
		res = poll(&mypoll, 1, -1); 
		switch (res) { 
			case -1: 
				puts("joel_cmd: poll() failed");
				return -1; 
			case 0: // timeout 
				puts("poll time out");
				break; 
			default: 
				if (mypoll.revents & POLLIN) {
				//int len =  sizeof(struct sockaddr_un);
					while((res = read(sout_fd, tmp, 17))==17){
						tmp[res]='\0';
						printf("%s\n",tmp);
					}
					return 0;
				}
				break;
		}
	}
	
	return 0;
}
#endif //if 0
#define ANISDKTOOL "/var/airgo/usr/sbin/aniSdkTool"
#define MAX_SSID_SIZE	32
/*
*function:prefix_with_slash()
*add slash '\' at the head of every characters in the src string, src should be '\0' terminated.
*and dst buf size must be strlen(src)*2+1, this function will not and can not check these limitation 
*need the caller do these validation checking
*/
static void prefix_with_slash(unsigned char *src, unsigned char *dst)
{
	int i=0;
	while(src[i]!='\0')
	{
		dst[i*2]='\\';
		dst[i*2+1]=src[i];
		i++;
	}
	dst[i*2]='\0';
}

static void set_wireless_common(void)
{
	int allow80211b;
	int protect_en;
	unsigned char *region;
	unsigned char countryCode[] = "US";
        unsigned char formatedSSID[MAX_SSID_SIZE*2+1];
	unsigned char *ssid=nvram_get("wifi_ssid");
#if 0
	int i;
	
	/* 
	 * need to escape chars in ssid with a backslash \ 
	 * since the ssid could be *()!@****
	 * but we cannot pass this string directly to the shell
	 * since it will expand it and that is NOT what we want
	 */
	i = 0;	
	while(ssid[i] != '\0' && i < MAX_SSID_SIZE)
	{
		formatedSSID[i*2]='\\';
		formatedSSID[i*2+1]=ssid[i];
		i++;
	}	
	formatedSSID[i*2]='\0';
#endif
	if(strlen(ssid)<=MAX_SSID_SIZE)
		prefix_with_slash(ssid,formatedSSID);	
		
	//mBUG("%s",formatedSSID);
	if(nvram_get("protect_en") == NULL)
		protect_en=1;
	else
		protect_en=atoi(nvram_get("protect_en"));
		
	if (nvram_get("wifi_dot11_mode") == NULL)
		allow80211b = 1;	// allow 11b if not set in nvram
	else
		allow80211b = atoi(nvram_get("wifi_dot11_mode"));
		
	if (allow80211b)
	{
		SYSTEM(ANISDKTOOL" -s admcrit 0 1 >/dev/console");
	}
	else
	{
		// No 802.11b allowed
		SYSTEM(ANISDKTOOL" -s admcrit 0 0 >/dev/console");
	}
	
	// convert region to country code	
	region = nvram_get("wifi_region");
	
	//SYSTEM ("echo region = %s\n", region);
	
	if (strcasecmp (region, "Africa") == 0)//, strlen("Africa") == 0) )
	{
		strcpy(countryCode, "ZA");  // south africa (arbitary)
	}
	else if (strcasecmp (region, "Asia") == 0)//, strlen("Asia") == 0) 
		strcpy(countryCode, "CN");	// china (arbitary)
	else if (strcasecmp (region, "Australia") == 0)//, strlen("Australia") == 0) 
		strcpy(countryCode, "AU"); 
	else if (strcasecmp (region, "Canada") == 0)//, strlen("Canada") == 0) 
		strcpy(countryCode, "CA");
	else if (strcasecmp (region, "Europe") == 0)//, strlen("Europe") == 0)
		strcpy(countryCode, "GB");   //  UK (arbitary)
	else if (strcasecmp (region, "Israel") == 0)//,strlen("Israel") == 0)
		strcpy(countryCode, "IL");   
	else if (strcasecmp (region, "Japan") == 0)//, strlen("Japan") == 0)
		strcpy(countryCode, "JP");   
	else if (strcasecmp (region, "Mexico") == 0)//, strlen("Mexico") == 0)
		strcpy(countryCode, "MX");   
	else if (strcasecmp (region, "South America") == 0)//,strlen("South America") == 0) 
		strcpy(countryCode, "CL");  // Chile (arbitary)
      
	//SYSTEM ("echo Country Code = %s\n", countryCode);
	//while()
	
	SYSTEM(ANISDKTOOL" -s wom 0 %s >/dev/console", countryCode);
	SYSTEM(ANISDKTOOL" -s ssid %s >/dev/console", formatedSSID);
        SYSTEM(ANISDKTOOL" -s chn 0 %d >/dev/console", (unsigned char)atoi(nvram_get("wifi_channel")));
	//SYSTEM(ANISDKTOOL" -s chnset 0 2 >/dev/console");	
	SYSTEM(ANISDKTOOL" -s supssid 0 %d >/dev/console",!(unsigned char)atoi(nvram_get("wifi_broadcast_ssid")));
	SYSTEM(ANISDKTOOL" -s gprot 0 %d >/dev/console",protect_en);

	// diable wme (wireless extensions for airgo -- causes linksys tool
	// to report encryption is on incorrectly
	SYSTEM(ANISDKTOOL" -s wme 0 0 >/dev/console");

	
	//SYSTEM("ifconfig wlan0 %s",(unsigned char)atoi(nvram_get("wifi_on"))==1?"up":"down");
        //SYSTEM(ANISDKTOOL" -s rte 0 0 1 108 >/dev/console ");
}
#define MAX_PSK_LEN 64
static void set_wireless_security(void)
{      // SYSTEM("security type<%d> >/dev/console ",(unsigned char)atoi(nvram_get("wifi_wep_on")));
	switch((unsigned char)atoi(nvram_get("wifi_wep_on")))
	{       
		default:
		case 0://disable encrypt
		{      
			SYSTEM(ANISDKTOOL" -s wpa 0 >/dev/console");
			SYSTEM(ANISDKTOOL" -s wep 0 >/dev/console");
			SYSTEM(ANISDKTOOL" -s open 1 >/dev/console");
			break;
		}
		case 1://wep
		{
			unsigned char key_len=(((unsigned char)atoi(nvram_get("wifi_key_len")))==64)?5:13;
			unsigned char def_key_id=(unsigned char)atoi(nvram_get("wifi_def_key"));
			char def_key_name[16];
			sprintf(def_key_name,"wifi_key%d",def_key_id);
			SYSTEM(ANISDKTOOL" -s wpa 0 >/dev/console");
			SYSTEM(ANISDKTOOL" -s open 0 >/dev/console");
			SYSTEM(ANISDKTOOL" -s wep 1 %d %d %s %s %s %s >/dev/console",
			 	 key_len,                                        /*key len*/
				 def_key_id,/* def key id*/
				 strlen(nvram_get("wifi_key1"))?nvram_get("wifi_key1"):"NULL" ,//strlen((def_key_name))?nvram_get(def_key_name):"NULL",/*key 1*/
				 strlen(nvram_get("wifi_key2"))?nvram_get("wifi_key2"):"NULL" ,/*key2*/
				 strlen(nvram_get("wifi_key3"))?nvram_get("wifi_key3"):"NULL",/*key 3*/
				 strlen(nvram_get("wifi_key4"))?nvram_get("wifi_key4"):"NULL" /*key 4*/
				 );
			break;
		}
		case 2://wpa psk
		{	unsigned char formatedpsk[MAX_PSK_LEN*2+1];
			unsigned char *psk=nvram_get("wifi_psk_pwd");
			if(strlen(psk)<=MAX_PSK_LEN)
				prefix_with_slash(psk,formatedpsk);	
			SYSTEM(ANISDKTOOL" -s open 0 >/dev/console");
			SYSTEM(ANISDKTOOL" -s wep 0 >/dev/console");
			SYSTEM(ANISDKTOOL" -s wpa 1 1 1 >/dev/console");
			SYSTEM(ANISDKTOOL" -s psk %s >/dev/console",formatedpsk);//nvram_get("wifi_psk_pwd"));

			break;
		}
		case 3://wpa 8021x
		{	
			SYSTEM(ANISDKTOOL" -s open 0 >/dev/console");	
			SYSTEM(ANISDKTOOL" -s wep 0 >/dev/console");
			SYSTEM(ANISDKTOOL" -s wpa 1 1 1 >/dev/console");
			SYSTEM(ANISDKTOOL" -s radsrv 300 10 1 %s %d %s >/dev/console",
					nvram_get("radius_server1"),/*server ip*/
					nvram_get("radius_port")==NULL?0:atoi(nvram_get("radius_port")),/*server port*/
					nvram_get("login_key")
					);
			SYSTEM(ANISDKTOOL" -s psk %s >/dev/console ",nvram_get("login_key"));
			break;
		}	
	}
}

static int wireless_commit(void)
{
        //SYSTEM("echo 921");
	SYSTEM(ANISDKTOOL" -s cga >/dev/console ");//commit configuration to driver
	//SYSTEM("echo 923");
	//SYSTEM(ANISDKTOOL" -s cga >/dev/console ");//commit configuration to driver
}

int start_wireless(void)
{
	SYSTEM(ANISDKTOOL" -a rstdef >/dev/console");

	set_wireless_common();

	set_wireless_security();
	//printf("before wireless_commit\n");
	wireless_commit();
	return 1;
} 

int stop_wireless(void)
{
	return 1;
}
