#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <signal.h>
#include <stdio.h>
#include <arpa/inet.h>
#include <linux/socket.h>
#include <linux/if_ether.h>
#include <linux/reboot.h>
#include <sys/reboot.h>
#include <net/if.h>	
#include <errno.h>
#include "flash.h"
#include "led.h"

#define NODE_ADDRESS          0xbfc0ffb0           /* Hardware address */

int erase_all=0; 
char hw_mac[6];
typedef	void	VOID ;
typedef	char	CHAR;
typedef	unsigned	char	BYTE;
typedef	unsigned	short	WORD;
typedef	unsigned	long	DWORD;
typedef	int	INT;
//typedef	short	INT;
typedef	unsigned	int	UINT;
//typedef	unsigned	short	UINT;
typedef	long	LONG;
typedef	unsigned long	ULONG;

//#define _DEBUG_
#define INTERFACE	"eth0"
#define TIMEOUT		4
#define xchgs(x) (WORD)((((WORD)((WORD)x)&0x0ff)<<8)|(((WORD)((WORD)x)&0x0ff00)>>8))
#define PACKET_SIZE         512

#ifdef _MIPS_
union unalign
{
	DWORD	dw;
	WORD	w;
} __attribute__((packed));

static inline WORD GetWord(VOID * buf)
{
	union unalign	*u = buf;

	return u->w;
}

static inline DWORD GetDword(VOID * buf)
{
	union unalign	*u = buf;

	return u->dw;
}

static inline VOID SetWord(void * buf, WORD wValue)
{
	union unalign	*u = buf;

	u->w = wValue;
}

static inline VOID SetDword(void * buf, DWORD dwValue)
{
	union unalign	*u = buf;

	u->dw = dwValue;
}
#endif
#define  MIN_PACKET_LENGTH  64
#define  DL_ACK_LEN 80
#define PACK
#define PACKED __attribute__((packed))

typedef struct{
	BYTE dbDestAddress[6];
	BYTE dbSrcAddress[6];
	WORD dwID;
	WORD dwCmd;
	WORD dwSeq;
	WORD dwOff;
	WORD dwSeg;
	WORD dwLen;
	BYTE dbData[512];
}PACKED DOWNLOADHead;

typedef struct S_HWID {
#ifdef _BIG_ENDIAN_
  /*----- Interface --------------------------*/
  BYTE  fPrn      :2;  /* Printer */
  BYTE  fMIO      :1;  /* MIO */
  BYTE  fChinese  :1;  /* Chinese */
  BYTE  fSCSI     :2;  /* SCSI */
  BYTE  fPrnIn    :2;  /* Printer port in */

  BYTE  fNetworkNo:4;  /* Number of network */
  BYTE  fSerialNo :4;  /* Number of serial port */

  /*----- System -----------------------------*/
  BYTE  fRomType  :1;  /* 0= Fladsh, 1= OTROM */
  BYTE  fRAM      :3;  /* 000= 32K, 001= 128K, 010= 256K, 011= 1024K */
  BYTE  fNVRAM    :2;  /* 00= 256B, 01= 512B, 10= 8192B */
  BYTE  fRsv_2    :2;
  
  BYTE  fCPU      :3;  /* 000= 188, 001= 186, 010= 386DX */

  BYTE  fSpeed    :2;  /*      188/186   386DX
                           00   12MHz    16MHz
                           01   16MHz    25MHz
                           10   25MHz    33MHz
                           11   40MHz    40MHz  */
  BYTE  fRomSize  :3;  /* 000= 64K, 001= 128K, 010= 256K, 011= 512K */

  /*----- Card number ------------------------*/
  BYTE  bVersion  :4;
  BYTE  bRsv_1    :4;

  BYTE  fProduct2 :4;
  BYTE  fDetail   :4;

  BYTE  fProduct0 :4;
  BYTE  fProduct1 :4;
#else
  /*----- Card number ------------------------*/
  BYTE  fProduct1 :4;
  BYTE  fProduct0 :4;

  BYTE  fDetail   :4;
  BYTE  fProduct2 :4;

  BYTE  bRsv_1    :4;
  BYTE  bVersion  :4;

  /*----- System -----------------------------*/
  BYTE  fRomSize  :3;  /* 000= 64K, 001= 128K, 010= 256K, 011= 512K */
  BYTE  fSpeed    :2;  /*      188/186   386DX
                           00   12MHz    16MHz
                           01   16MHz    25MHz
                           10   25MHz    33MHz
                           11   40MHz    40MHz  */
  BYTE  fCPU      :3;  /* 000= 188, 001= 186, 010= 386DX */

  BYTE  fRsv_2    :2;
  BYTE  fNVRAM    :2;  /* 00= 256B, 01= 512B, 10= 8192B */
  BYTE  fRAM      :3;  /* 000= 32K, 001= 128K, 010= 256K, 011= 1024K */
  BYTE  fRomType  :1;  /* 0= Fladsh, 1= OTROM */

  /*----- Interface --------------------------*/
  BYTE  fSerialNo :4;  /* Number of serial port */
  BYTE  fNetworkNo:4;  /* Number of network */

  BYTE  fPrnIn    :2;  /* Printer port in */
  BYTE  fSCSI     :2;  /* SCSI */
  BYTE  fChinese  :1;  /* Chinese */
  BYTE  fMIO      :1;  /* MIO */
  BYTE  fPrn      :2;  /* Printer */
#endif

  WORD  wRsv_3;

  /*----- description ------------------------*/
  BYTE  bComment[23];

} PACKED HWID;

typedef struct S_PID {

  /*----- PID version ------------------------*/
  WORD  wPidVersion;        /* Motorola format */

  /*----- D/L control ------------------------*/
  BYTE  fReserved;
#ifdef _BIG_ENDIAN_
  BYTE  fRsv        :  4;
  BYTE  fChkFunction:  1;
  BYTE  fChkProtocol:  1;
  BYTE  fChkProduct:   1;
  BYTE  fChkHw:        1;
#else
  BYTE  fChkHw:        1;
  BYTE  fChkProduct:   1;
  BYTE  fChkProtocol:  1;
  BYTE  fChkFunction:  1;
  BYTE  fRsv        :  4;
#endif
  /*----- Hardware ID ------------------------*/
  HWID  hw;

  /*----- Reserver ---------------------------*/
  WORD  wRsv;

  /*----- Product ID & mask ------------------*/
  WORD  wProductID;         /* Motorola format */
  WORD  wProductMask;       /* Motorola format */

  /*----- Protocol ID & mask -----------------*/
  WORD  wProtocolID;        /* Motorola format */
  WORD  wProtocolMask;      /* Motorola format */

  /*----- Function ID & mask -----------------*/
  WORD  wFunctionID;        /* Motorola format */
  WORD  wFunctionMask;      /* Motorola format */

  /*----- F/W version ------------------------*/
  WORD  wFwVersion;         /* Motorola format */

  /*----- Code address -----------------------*/
  WORD  wSegment;           /* Intel format */
  WORD  wOffset;            /* Intel format */

} PACKED PID;

DOWNLOADHead dlHead;
INT openintf(CHAR *);
INT recv_packet(INT);
VOID cleanup(INT);
INT s,fd=-1;

INT GetMACAdd(CHAR *interface,BYTE dbMACAddress[6]);

typedef  struct  VCI  {
    WORD    VerControl;
    WORD    DownControl;
    BYTE    Hid[32];
    WORD    Hver;
    WORD    ProdID;
    WORD    ProdIDmask;
    WORD    ProtID;
    WORD    ProtIDmask;
    WORD    FuncID;
    WORD    FuncIDmask;
    WORD    Fver;
    WORD    Cseg;
	WORD    Csize;
} PACKED VCI_TABLE;

#define  VCI_LEN         56
#define PRODUCTID_OFFSET	(4*1024*1024-3*64*1024-16)
INT Get_Version(BYTE *buf)
{
	VCI_TABLE Pid;
	WORD * dwTemp=NULL;
	BYTE tmp[6];
	INT fd1,ret=0;

	fd1=open("/dev/mtd0",O_RDONLY);
	if(fd1<0)
		return -1;
	ret=lseek(fd1,64*1024-63,SEEK_SET);
	if(ret!=64*1024-63){
		close(fd1);
		return -1;
	}
	if(read(fd1,(BYTE *)&Pid,sizeof(VCI_TABLE))!=sizeof(VCI_TABLE)){
		close(fd1);
		return -1;
	}
	close(fd1);	
	
	fd1=open("/dev/mtd2",O_RDONLY);
	if(fd1<0)
		return -1;
	ret=lseek(fd1,PRODUCTID_OFFSET,SEEK_SET);
	if(ret!=PRODUCTID_OFFSET){
		close(fd1);
		return -1;
	}
	if(read(fd1,tmp,sizeof(tmp))!=sizeof(tmp)){
		close(fd1);
		return -1;
	}
	close(fd1);	
	
	dwTemp = (WORD *)(tmp);
	Pid.ProdID = *dwTemp;
	dwTemp = (WORD *)(tmp+2);
	Pid.ProtID = *dwTemp;
	dwTemp = (WORD *)(tmp+4);
	Pid.Fver = *dwTemp;	
	
	memcpy(buf,(BYTE *)&Pid.VerControl,VCI_LEN);
	return VCI_LEN;
}

INT openintf(CHAR *d)
{
	INT fd_1;
	struct ifreq ifr;
	INT s_1;
	
	fd_1=socket(AF_INET, SOCK_PACKET, htons(0x8888));
	if(fd_1 < 0){
		perror("Can't get SOCK_PACKET socket.");
		exit(0);
	}
	strcpy(ifr.ifr_name, d);
	s_1=ioctl(fd_1, SIOCGIFFLAGS, &ifr);
	if(s_1 < 0) {
		close(fd);
		perror("Can't get flags.");
		exit(0);
	}
	ifr.ifr_flags |= IFF_PROMISC;
	s_1=ioctl(fd_1, SIOCSIFFLAGS, &ifr);
	if(s_1 < 0)
		perror("Can't set promiscuous mode.");
		
	return fd_1;
}

static int LockFile(void)
{
	int lock_fd;

	lock_fd = open("/var/lock/flash.lck",O_WRONLY|O_CREAT|O_EXCL,0666);
	if(lock_fd == -1)
		return -1;
	close(lock_fd);	
	return 0;
}

static void UnLockFile(void)
{
	unlink("/var/lock/flash.lck");
}

INT recv_packet(int sock)
{

	INT x,ret=0,erasing=0,sendret=0;
	fd_set	fdset;
	BYTE tempBuf[6];
	BYTE dbData[512];	
	BYTE  start_recv=0;//,erase_all=0;
	ULONG packet_num=0;	
    static int firstDownloadSeq = 0;
    static int preDownloadSeq;
//    static int firstAssignSeq = 0;
//    static int preAssignSeq;
    static int firstEraseCmd = 0;
    int seq;
	
	Get_Version((VOID *)dbData);	
	GetMACAdd(INTERFACE,tempBuf);
	fd=-1;
	while(1) {
	//	alarm(TIMEOUT);
		FD_ZERO(&fdset);
		FD_SET(sock, &fdset);
		if ( select(sock+1, &fdset, (fd_set *)NULL, (fd_set *)NULL, NULL) < 0 )
			return -1;
		if ( FD_ISSET(s, &fdset) ){ 
			memset(&dlHead,'\0',sizeof(dlHead));
			x=read(s, (DOWNLOADHead *)&dlHead, sizeof(dlHead));
			if(x > 1){
				if ( ((WORD)dlHead.dwID == (WORD)0x0000)||((WORD)dlHead.dwID == (WORD)0x8888) ) {
		            CHAR *buf;
					DOWNLOADHead *psBuf;
					struct sockaddr sa; 
					INT packet_len=0,num=0;
					
		            if(memcmp(dlHead.dbDestAddress,"\xff\xff\xff\xff\xff\xff",6))  {
		            	if(memcmp(dlHead.dbDestAddress,tempBuf,6))
		            		return -1;
		            }
					sa.sa_family = AF_INET; 
					strcpy(sa.sa_data, INTERFACE); 
            
					packet_len=sizeof(DOWNLOADHead);	
					buf=malloc(packet_len); 
					if(!buf)
						return -1;
					memset(buf,'\0',packet_len);
					psBuf = (DOWNLOADHead *)buf;
					memset((BYTE*)&psBuf->dbData ,'\0',DL_ACK_LEN);
					memcpy (psBuf->dbDestAddress,dlHead.dbSrcAddress,6);
					psBuf->dwID    = dlHead.dwID;
					psBuf->dwCmd   = dlHead.dwCmd;
					psBuf->dwSeq   = dlHead.dwSeq;
					psBuf->dwOff   = dlHead.dwOff;
					psBuf->dwSeg   = dlHead.dwSeg;
					switch (htons(xchgs(dlHead.dwCmd))) { 
						case 0x0000:	
							//Get_Version((VOID *)&psBuf->dbData);
							memcpy(psBuf->dbData,dbData,sizeof(dbData));
							//memcpy(psBuf->dbData,(BYTE *)&dumpPID,sizeof(PID));
							psBuf->dwLen = htons(xchgs(sizeof(PID)));
							memcpy(psBuf->dbSrcAddress,tempBuf,6);
							ret=sendto(sock, buf, packet_len - sizeof(psBuf->dbData) + sizeof(PID) ,0,&sa,sizeof(sa));
							if(ret!=packet_len - sizeof(psBuf->dbData) + sizeof(PID))
								printf("Write Fail, err=%s\n",strerror(errno));
							break;
						case 0x0001:
						case 0x0005:
#ifdef _DEBUG_						
							printf("Receive CMD 0x0005\n");
#endif				
										/* Flash LED */
							ret=LockFile();
							if(ret)	
								return -1;															
							if(!firstEraseCmd){
								firstEraseCmd=1;
								system("/sbin/flashled & 2>/dev/null");
								system("/sbin/kill-all-app.sh utility >/dev/null");
							}								
							memcpy(psBuf->dbSrcAddress,tempBuf,6);
							psBuf->dwLen = htons(xchgs(2));
							ret=sendto(sock, buf, packet_len - sizeof(psBuf->dbData) + 2 ,0,&sa,sizeof(sa));
							if(erasing)
								break;
							erase_all=0;
							if(htons(xchgs(dlHead.dwCmd))==0x0005)
								erase_all=1;
							psBuf->dwLen = htons(xchgs(2));
							if(fd>0){
								close(fd);
								fd=-1;
							}
							erasing=1; //Erase in progress.
							ret=0;
							if(erase_all){
								int tfd;
								tfd=open("/dev/mtd0", O_RDONLY);
								if(tfd>=0){
									lseek(tfd, NODE_ADDRESS, SEEK_SET);
								        read(tfd, hw_mac, sizeof(hw_mac));
#ifdef _DEBUG_
									printf("hw_mac=%02x:%02x:%02x:%02x:%02x:%02x\n",
										hw_mac[0],hw_mac[1],hw_mac[2],hw_mac[3],hw_mac[4],hw_mac[5]);
#endif
									close(tfd);
								}
								ret=flash_erase_mtd(MTD_BOOT|MTD_CONFIG|MTD_MAIN);
#ifdef _DEBUG_							
								if(ret)
									printf("Fail to erase boot partition,ret=%d\n",ret);
#endif							
							}	
							else{						
								ret=flash_erase_mtd(MTD_MAIN);
#ifdef _DEBUG_								
								if(ret)
									printf("Fail to erase main partition,ret=%d\n",ret);								
#endif				
							}							
							if(ret||start_recv){
								psBuf->dbData[0]=1;
								erasing=0;
							}
							else
								erasing=2; //Erase ok.
							memcpy(psBuf->dbSrcAddress,tempBuf,6);
							psBuf->dwLen = htons(xchgs(2));
							sendret=sendto(sock, buf, packet_len - sizeof(psBuf->dbData) + 2 ,0,&sa,sizeof(sa));
							if(sendret!=packet_len - sizeof(psBuf->dbData) + 2)
								printf("sendto fail, err=%s\n",strerror(errno));
#ifdef _DEBUG_									
							if(!sendret){
								printf("Send packet successfully!\n");
							}
							if(!ret){
							    printf("Erase Flahs successfully!\n");
							}							
#endif
							break;
						case 0x0002:
#ifdef _DEBUG_						
							printf("Receive CMD 0x0002\n");
#endif							
							erasing=0;
							psBuf->dwLen = htons(xchgs(2));
							memcpy(psBuf->dbSrcAddress,tempBuf,6);							
                            
                            seq = htons(xchgs(psBuf->dwSeq));
#ifdef _DEBUG_
                            printf("in line [%d] seq is %d , firstDownloadSeq is %d preDownloadSeq is %d packet_num is %lu.\n",
                                __LINE__,seq, firstDownloadSeq, preDownloadSeq, packet_num);
#endif

                            if(firstDownloadSeq == 0){ /* The first packet received. */
                                firstDownloadSeq = seq;
                                preDownloadSeq = firstDownloadSeq;
                            }
                            else{
                                if( preDownloadSeq == seq ){ /* download packet retransmit , ingore it. */
#ifdef _DEBUG_
                                    printf("It seems that we received a retransmit packet,ignore it.\n");
#endif
                                    break;
                                }
                            }                            
                            
                            if( seq < preDownloadSeq){ /* Sequence move around. */
                                firstDownloadSeq -= 0x10000;
                            }
                            
                            preDownloadSeq = seq;
                            
                            packet_num = seq - firstDownloadSeq + 1; /* Start with 1. */
#ifdef _DEBUG_
                            printf("in line [%d] seq is %d , firstDownloadSeq is %d preDownloadSeq is %d packet_num is %lu.\n",
                                __LINE__,seq, firstDownloadSeq, preDownloadSeq, packet_num);
#endif
                            /* start_recv is MTD_BOOT , means now should download BOOT area. */
							if(erase_all){

								if(packet_num>=(BOOT_SIZE/PACKET_SIZE+1)){ 
								    /* BOOTROM finished, should download config area now. */	
									if((start_recv!=MTD_CONFIG)&&(fd>0)){
										fsync(fd);
										close(fd);
										fd=-1;
									}
									start_recv=MTD_CONFIG;
								}else{
									start_recv=MTD_BOOT;

									if(packet_num==(NODE_ADDRESS/PACKET_SIZE+1)){	
										memcpy(&(dlHead.dbData[NODE_ADDRESS%PACKET_SIZE]),hw_mac,6);
									}
								}
							}
							if(packet_num>=((BOOT_SIZE + CONFIG_SIZE)/PACKET_SIZE+1)){
							    /* BOOTROM and Config finished, should download main area. */
								if((start_recv!=MTD_MAIN)&&(fd>0)){
									fsync(fd);
									close(fd);
									fd=-1;
								}
								start_recv=MTD_MAIN;															}
#ifdef _DEBUG_							
							printf("Receive %luth packet\n",packet_num);
#endif
							if(fd<0){
								if(start_recv==MTD_BOOT){
									fd=open("/dev/mtd0",O_RDWR);
									if(fd<0){
										psBuf->dbData[0]=1;
										sendto(sock, buf, packet_len - sizeof(psBuf->dbData) + 2,0,&sa,sizeof(sa));	
										UnLockFile();
										return -1;
									}
#ifdef _DEBUG_									
									else
										printf("Open /dev/mtd0 successfully\n");
#endif										
								}
								else if(start_recv==MTD_CONFIG){
									fd=open("/dev/mtd1",O_RDWR);
									if(fd<0){
										psBuf->dbData[0]=1;
										sendto(sock, buf, packet_len - sizeof(psBuf->dbData) + 2,0,&sa,sizeof(sa));	
										UnLockFile();
										return -1;
									}
#ifdef _DEBUG_									
									else
										printf("Open /dev/mtd1 successfully\n");
#endif																												
								}
								else if(start_recv==MTD_MAIN){
									fd=open("/dev/mtd2",O_RDWR);
									if(fd<0){
										psBuf->dbData[0]=1;
										sendto(sock, buf, packet_len - sizeof(psBuf->dbData) + 2,0,&sa,sizeof(sa));	
										UnLockFile();
										return -1;
									}
#ifdef _DEBUG_										
									else
										printf("Open /dev/mtd2 successfully\n");	
#endif																										
								}
							
							} /* if(fd<0) */
							
							if(packet_num <= (BOOT_SIZE + CONFIG_SIZE + MAIN_SIZE)/PACKET_SIZE && fd > 0){
							    ULONG delta = packet_num - 1;
							    switch(start_recv){
								    case MTD_BOOT: /* BOOT */
								        delta = packet_num - 1;
								        break;
								    case MTD_CONFIG: /* CONFIG */
								        delta = packet_num - 1 - BOOT_SIZE/PACKET_SIZE;
								        break;
								    case MTD_MAIN: /* MAIN CODE */
								        delta = packet_num - 1 - (BOOT_SIZE + CONFIG_SIZE)/PACKET_SIZE;
								        break;
							    }
#ifdef _DEBUG_
							    printf("dalta=%d\n",delta);
#endif
#if 1
							    ret=lseek( fd, delta * PACKET_SIZE, SEEK_SET );
                            	if( ret != delta * PACKET_SIZE ){
                                    psBuf->dbData[0]=1;
#ifdef _DEBUG_
                                    printf("Fail to seek %lu.\n",delta*512);
                                    printf("err=%s\n",strerror(errno));
#endif
								}
#endif
								num=write(fd,dlHead.dbData,htons(xchgs(dlHead.dwLen)));
								if(num<0){
#ifdef _DEBUG_										
									printf("Fail to write %d byte buffer of %lu packet\n",htons(xchgs(dlHead.dwLen)),packet_num);
									printf("err=%s\n",strerror(errno));
#endif									
									psBuf->dbData[0]=1;
								}
#ifdef _DEBUG_									
								else
									printf("Write %lu packet successfully\n",packet_num);
#endif							
							}
							if(fd>0)
								fsync(fd);
							ret=sendto(sock, buf, packet_len - sizeof(psBuf->dbData) + 2,0,&sa,sizeof(sa));
							if(ret!=packet_len - sizeof(psBuf->dbData) + 2)
								printf("sendto fail, err=%s\n",strerror(errno));	
							if(psBuf->dbData[0]==1){
								if(fd>0)
									close(fd);	
								UnLockFile();		
								return -1;
							}		
	
							break;
						case 0x0003:
#ifdef _DEBUG_							
							printf("Receive CMD 0x0003\n");
#endif							
							start_recv=0;
							packet_num=0;
							if(fd>0){
								close(fd);
								fd=-1;
							}	
							erasing=0;			
							UnLockFile();			
							memcpy(psBuf->dbSrcAddress,tempBuf,6);
							ret=sendto(sock, buf, packet_len - sizeof(psBuf->dbData) ,0,&sa,sizeof(sa));
							if(ret!=packet_len - sizeof(psBuf->dbData))
								printf("sendto fail, err=%s\n",strerror(errno));
							else
								system("/bin/reboot &>/dev/null");			
							break;
						case 0x0004:
							start_recv=0;
							packet_num=0;		
#ifdef _DEBUG_													
							printf("Receive CMD 0x0004\n");
#endif							
							if(fd>0){
								close(fd);
								fd=-1;
							}
							erasing=0;
							psBuf->dwLen = htons(xchgs(2));
							memcpy(psBuf->dbSrcAddress,tempBuf,6);
							ret=sendto(sock, buf, packet_len - sizeof(psBuf->dbData) + 2,0,&sa,sizeof(sa));
							if(ret!=packet_len - sizeof(psBuf->dbData) + 2)
								printf("sendto fail, err=%s\n",strerror(errno));								
							break;
						case 0x0080:
							//AssignAddr(dlHead);
							memcpy(psBuf->dbSrcAddress,tempBuf,6);
							ret=sendto(sock, buf, packet_len - sizeof(psBuf->dbData) + 2,0,&sa,sizeof(sa));
							if(ret!=packet_len - sizeof(psBuf->dbData) + 2)
								printf("sendto fail, err=%s\n",strerror(errno));
#ifdef _FT_UTL_		
						case 0x0100:
							break;
						case 0x0101:
								break;
						case 0x0102:
							break;
#endif													
						default:
							break;
					}//switch
					free(buf);
					buf=NULL;
	            }					
			}
		}//if ( FD_ISSET(s, &fdset) ) 
	}//while(1)
	return 0;
}

#if 0
void sig_alarm(int sig)
{
	if(fd>0){
		close(fd);
		fd=-1;
	}
}
#endif

void init(void)
{
	int pid;

	if ((pid = fork()) < 0) {
		printf("Program fork fail\n");
		exit(-1);
	} else if (pid != 0) {
		exit(0);
	}
	setsid();
	chdir("/");
	umask(0);
}

INT main(INT argc, CHAR **argv)
{
	struct sigaction act;
	
	
	s=openintf(INTERFACE);
	init();
	act.sa_handler=cleanup;
	sigemptyset(&act.sa_mask);
	act.sa_flags=0;
	sigaction(SIGINT, &act, NULL);

	act.sa_handler=cleanup;
	sigemptyset(&act.sa_mask);
	act.sa_flags=0;
	sigaction(SIGTERM, &act, NULL);
	
	for(;;){
#if 0		
		system("/bin/killall flashled >/dev/null 2>&1");
		turnOnLED(LED_POWER);
        turnOffLED(LED_STATUS);
#endif        
		recv_packet(s);
	}   
	return 0;
}

VOID cleanup(INT sig)
{
	close(s);
	if(fd>0)
		close(fd);
	exit(0);
}

INT GetMACAdd(CHAR *interface,BYTE dbMACAddress[6])
{
	INT sockd;
	struct ifreq ifr;
		
	sockd = socket(AF_INET, SOCK_STREAM, 0);
	if (sockd == -1) 
		return -1;
	strcpy(ifr.ifr_name, interface);
	if(ioctl(sockd, SIOCGIFHWADDR, &ifr) < 0)
		return -1;
	memcpy(dbMACAddress,ifr.ifr_hwaddr.sa_data,6);
	return 0;
}
