// Return status values
#include "bcmtypes.h"
typedef enum BcmAtmStatus
{
    STS_SUCCESS = 0,
    STS_ERROR,
    STS_STATE_ERROR,
    STS_PARAMETER_ERROR,
    STS_ALLOC_ERROR,
    STS_RESOURCE_ERROR,
    STS_IN_USE,
    STS_VCC_DOWN,
    STS_INTERFACE_DOWN,
    STS_LINK_DOWN,
    STS_NOT_FOUND,
    STS_NOT_SUPPORTED,
    STS_VCAM_MULT_MATCH_ERROR,
    STS_CCAM_MULT_MATCH_ERROR,
    STS_PKTERR_INVALID_VPI_VCI,
    STS_PKTERR_PORT_NOT_ENABLED,
    STS_PKTERR_HEC_ERROR,
    STS_PKTERR_PTI_ERROR,
    STS_PKTERR_RECEIVED_IDLE_CELL,
    STS_PKTERR_CIRCUIT_TYPE_ERROR,
    STS_PKTERR_OAM_RM_CRC_ERROR,
    STS_PKTERR_GFC_ERROR,
    STS_PKTERR_AAL5_AAL0_CRC_ERROR,
    STS_PKTERR_AAL5_AAL0_SHORT_PKT_ERROR,
    STS_PKTERR_AAL5_AAL0_LENGTH_ERROR,
    STS_PKTERR_AAL5_AAL0_BIG_PKT_ERROR,
    STS_PKTERR_AAL5_AAL0_SAR_TIMEOUT_ERROR,
    STS_PKTERR_AAL2F_HEC_ERROR,
    STS_PKTERR_AAL2F_SEQ_NUM_ERROR,
    STS_PKTERR_AAL2F_PARITY_ERROR,
    STS_PKTERR_AAL2F_CRC_ERROR,
    STS_PKTERR_AAL2F_CAM_ERROR,
    STS_PKTERR_AAL2F_BIG_PKT_ERROR,
    STS_PKTERR_AAL2F_RAS_TIMEOUT_ERROR,
    STS_PKTERR_AAL2F_SHORT_PKT_ERROR,
    STS_PKTERR_AAL2F_LENGTH_MISMATCH_ERROR,
    STS_PKTERR_AAL2V_HEC_ERROR,
    STS_PKTERR_AAL2V_SEQ_NUM_ERROR,
    STS_PKTERR_AAL2V_PARITY_ERROR,
    STS_PKTERR_AAL2V_CRC_ERROR,
    STS_PKTERR_AAL2V_CAM_ERROR,
    STS_PKTERR_AAL2V_OSF_MISMATCH_ERROR,
    STS_PKTERR_AAL2V_OSF_ERROR,
    STS_PKTERR_AAL2V_HEC_OVERLAP_ERROR,
    STS_PKTERR_AAL2V_BIG_PKT_ERROR,
    STS_PKTERR_AAL2V_RAS_ERROR,
    STS_PKTERR_AAL2V_UUI_ERROR
} BCMATM_STATUS;

typedef struct AtmVccAddr
{
    UINT32 ulInterfaceId;
    UINT16 usVpi;
    UINT16 usVci;
} ATM_VCC_ADDR, *PATM_VCC_ADDR;

typedef struct
{
    ATM_VCC_ADDR VccAddr;
    UINT32 type;
    BCMATM_STATUS baStatus;
} ATMDRV_OAM_LOOPBACK, *PATMDRV_OAM_LOOPBACK;
#define BCM_DIAG_OAM_SEGMENT 0
#define BCM_DIAG_OAM_END2END 1
#define ATMDRV_MAJOR            205
#define ATMIOCTL_OAM_LOOPBACK_TEST \
    _IOWR(ATMDRV_MAJOR, 15, ATMDRV_OAM_LOOPBACK)
