#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include "default.h"

#include "bcm.h"
#include "bcmtypes.h"

#define OAM_TIMEOUT 150
#define VCI_S 	32
#define VCI_E   90	
#define VPI_S	0
#define VPI_E	10
#define WIZARD_OK	0
#define WIZARD_ERR	1
#define PPPOE		2
#define PPPOA		3
#define IPOA		4
#define DHCP		5

#define _WGM124_


static int vpi=0;
static int vci=0;
static int encap=0; /* 0:llc 1:vc */
static char wan_mode[16]="unknown";

int method_detect(void);
/* pipe */
int myPipe(char *command, char **output)
{
  FILE *fp;
  char buf[4096];
  int len=0;
  
  *output=malloc(1);
  strcpy(*output, "");
  if((fp=popen(command, "r"))==NULL)
     return(-1);
  while((fgets(buf, 4096, fp)) != NULL){
     len=strlen(*output)+strlen(buf);	  
     if((*output=realloc(*output, (sizeof(char) * (len+1))))==NULL)
     return(-1);
      strcat(*output, buf);
  }
  pclose(fp);
  return len;
}
void wan_stop(void)
{
	char *data;
	myPipe("/bin/ps",&data);
	while((strstr(data, "udhcpc")!=NULL) 
		|| (strstr(data, "pppd")!=NULL)) {
		system("/sbin/rc wan stop");
		sleep(1);
		free(data);
		myPipe("/bin/ps",&data);
	}
	free(data);

}

int pppoe_test(void)
{
	char *data;
	int i;	
	
	for(i=0;i<3;i++)
	{
#ifndef _WGM124_
	myPipe("/usr/sbin/pppoe -d -I nas0",&data);
#else
	myPipe("/sbin/pppoe -d -I ixp1",&data);
#endif
	if(strchr(data,':')){
        	free(data);
        	return WIZARD_OK;
              	}
	free(data);
	sleep(1);
	}
	return WIZARD_ERR;
}
#ifndef _WGM124_
int pppoa_test(int encap)
{
	char cmd[1024];
	char *data;
	sprintf(cmd,"/usr/sbin/atmctl operate vcc --add 0.%d.%d aal5 1 unknown --addq 0.%d.%d 200 1",vpi,vci,vpi,vci);
        system(cmd);
	sprintf(cmd,"/usr/sbin/pppd plugin pppoa %d.%d user a password a nodetach %s qos UBR >/tmp/pppoa&",vpi,vci,encap==1?"vc-encaps":"llc-encaps");
	system(cmd);
	sleep(6);
	system("/usr/bin/killall pppd");
	myPipe("/bin/cat /tmp/pppoa",&data);			
	if(strstr(data,"CHAP authentication") || strstr(data,"remote ip") || strstr(data,"PAP authentication")){
		free(data);
		return WIZARD_OK;
	}else{
		free(data);
		return WIZARD_ERR;
	}
	
}
#endif
int default_test(char *country)
{
	int i=0;
#ifndef _WGM124_
	char cmd[1024]="";
#endif
	while(adsl_setting[i].country!=NULL){
		if(strcasecmp(adsl_setting[i].country,country)==0){
			vpi=adsl_setting[i].vpi;
			vci=adsl_setting[i].vci;
			encap=adsl_setting[i].encap;	
			if(adsl_setting[i].mode==0){
#ifndef _WGM124_
				/* start br2684ctl */
				sprintf(cmd,"/usr/sbin/atmctl operate vcc --add 0.%d.%d aal5 1 unknown --addq 0.%d.%d 200 1",vpi,vci,vpi,vci);
				system(cmd);
				sprintf(cmd,"/usr/sbin/br2684ctl -b -c 0 -e %d -a 0.%d.%d",adsl_setting[i].encap,vpi,vci);
				system(cmd);
				usleep(10);
			        system("/sbin/ifconfig nas0 up");
#endif
				i=pppoe_test();
				wan_stop();
				
				if(i==WIZARD_OK)
					strcpy(wan_mode,"pppoe");
				return i;
			}
#ifndef _WGM124_
			else{
				i=pppoa_test(adsl_setting[i].encap);
				wan_stop();

				if(i==WIZARD_OK)
					strcpy(wan_mode,"pppoa");
				return i;

			}
#endif

					
		}
		i++;
	}
	return WIZARD_ERR;
}

int dhcp_test(void)
{
#ifndef _WGM124_
	unlink("/tmp/wan_uptime");
	system("/usr/sbin/udhcpc -i nas0 -s /etc/udhcpc.wizard.script&");
#else
        unlink("/var/wan_uptime");
	system("/sbin/udhcpc -i ixp1 -s /etc/udhcpc.wizard.script&");
#endif
	sleep(1);
#ifndef _WGM124_
	system("/usr/bin/killall udhcpc");
#else
	system("killall udhcpc");
#endif

#ifndef _WGM124_
	if(access("/tmp/wan_uptime",F_OK)==0)
#else 
	if(access("/var/wan_uptime",F_OK)==0)
#endif
		return WIZARD_OK;
	else
		return WIZARD_ERR;
}
#ifdef _WGM124_
int ipoa_test(void)
{
	char cmd[1024];
	int i=3;
	sprintf(cmd,"/usr/sbin/atmctl operate vcc --add 0.%d.%d aal5 1 unknown --addq 0.%d.%d 200 1",vpi,vci,vpi,vci);
                system(cmd);

	unlink("/tmp/ipoa_server");
	system("/usr/sbin/atmarpd -b");
	usleep(10);
	system("/usr/sbin/atmarp -c 1");
	usleep(10);
	system("/sbin/ifconfig atm0 up");
	system("/sbin/ifconfig atm1 1.1.1.100 up");
	usleep(10);
	while(i-- && access("/tmp/ipoa_server",F_OK)!=0){
		sprintf(cmd,"/usr/sbin/atmarp -s 1.1.1.%d 0.%d.%d",i,vpi,vci);
		system(cmd);
		sleep(1);
	}
	system("/sbin/ifconfig atm1 0.0.0.0 down");
	system("/usr/bin/killall atmarpd");
	
	if(access("/tmp/ipoa_server",F_OK)==0)
		return WIZARD_OK;
	else
		return WIZARD_ERR;
}

int pvc_detect(void)
{
	ATMDRV_OAM_LOOPBACK Arg={{0,0,0},BCM_DIAG_OAM_END2END , STS_ERROR};
	int i=0,j=0;
	int fd;
	
	i=8;
	
	fd = open( "/dev/bcmatm0", O_RDWR );
	if( fd == -1 )
		return WIZARD_ERR;
		
	Arg.type = BCM_DIAG_OAM_END2END;
	Arg.baStatus = STS_ERROR;
	
	for(j=VCI_S;j<=VCI_E;j++){
		
		Arg.VccAddr.usVpi=i;
		Arg.VccAddr.usVci=j;
		
		ioctl( fd, ATMIOCTL_OAM_LOOPBACK_TEST, &Arg );
		if (Arg.baStatus == 0){
			vpi=i;
			vci=j;
			return WIZARD_OK;
		}
	}
	for(i=VPI_S;i<=VPI_E;i++){
		
		Arg.VccAddr.usVpi=i;
		
		if(i==8) i++;
		
		for(j=VCI_S;j<=VCI_E;j++){
			Arg.VccAddr.usVci=j;
			ioctl( fd, ATMIOCTL_OAM_LOOPBACK_TEST, &Arg );
		
			if (Arg.baStatus == 0){
				vpi=i;
				vci=j;
				return WIZARD_OK;
			}
		}
	}
	close(fd);
	return WIZARD_ERR;
}
#endif

int method_detect(void)
{
#ifndef _WGM124_
	char cmd[1024]="";
#endif
	for(encap=0;encap<=1;encap++){
#ifndef _WGM124_		
		/* test pppoa */
		if(pppoa_test(encap)==WIZARD_OK){
			strcpy(wan_mode,"pppoa");
			break;
		}
#endif			
		/* stop wan */
		wan_stop();
#ifndef _WGM124_
		/* start br2684ctl */
		sprintf(cmd,"/usr/sbin/atmctl operate vcc --add 0.%d.%d aal5 1 unknown --addq 0.%d.%d 200 1",vpi,vci,vpi,vci);
                system(cmd);
		sprintf(cmd,"/usr/sbin/br2684ctl -b -c 0 -e %d -a 0.%d.%d"
				,encap,vpi,vci);
		system(cmd);
		usleep(10);
	        system("/sbin/ifconfig nas0 up");	
#endif
		/* test pppoe */
		if(pppoe_test()==WIZARD_OK){
			strcpy(wan_mode,"pppoe");
			break;
		}
		/* test dhcp  */
		if(dhcp_test()==WIZARD_OK){
			strcpy(wan_mode,"dhcp");
			break;
		}
		/* stop wan */
		wan_stop();
		
	}
#ifndef _WGM124_		
	if(encap==2 && ipoa_test()==WIZARD_OK){
		encap=0;
		strcpy(wan_mode,"ipoa");
	}
#endif	
	return (encap!=2)?WIZARD_OK:WIZARD_ERR;

}
int main(int argc,char **argv)
{
	FILE *fp;
	
	if(argv[1]==NULL){
		argv[1]=strdup("us");
	}
	
	unlink("/tmp/wizard.out");	
	/* stop wan */
	wan_stop();
	/* start test */
#ifndef _WGM124_
	if(default_test(argv[1])==WIZARD_ERR)
	{

		if(pvc_detect()==WIZARD_OK)
	
        	method_detect();
	}
#endif	
		/* test pppoe */
		if(pppoe_test()==WIZARD_OK){
			strcpy(wan_mode,"pppoe");
		}
		/* test dhcp  */
		else if(dhcp_test()==WIZARD_OK){
			strcpy(wan_mode,"dhcp");
		}

		
	/* stop wan */
	wan_stop();
	/* write output */
	fp=fopen("/tmp/wizard.out","w");
	fprintf(fp,"%d\n%d\n%d\n%s\n",encap,vpi,vci,wan_mode);
	fclose(fp);

	return WIZARD_OK;
}
