#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "default.h"

#define VCI_S 	30
#define VCI_E   100 
#define VPI_S	0
#define VPI_E	30
#define WIZARD_OK	0
#define WIZARD_ERR	1
#define PPPOE		2
#define PPPOA		3
#define IPOA		4
#define DHCP		5


static int vpi=0;
static int vci=0;
static int encap=0; /* 0:llc 1:vc */
static char wan_mode[16]="unknown";

int method_detect(void);
/* pipe */
int myPipe(char *command, char **output)
{
  FILE *fp;
  char buf[4096];
  int len=0;
  
  *output=malloc(1);
  strcpy(*output, "");
  if((fp=popen(command, "r"))==NULL)
     return(-1);
  while((fgets(buf, 4096, fp)) != NULL){
     len=strlen(*output)+strlen(buf);	  
     if((*output=realloc(*output, (sizeof(char) * (len+1))))==NULL)
     return(-1);
      strcat(*output, buf);
  }
  pclose(fp);
  return len;
}
void wan_stop(void)
{
	char *data;
	myPipe("/bin/ps",&data);
	while((strstr(data, "br2684ctl")!=NULL) 
			|| (strstr(data, "pppd")!=NULL)) {
		system("/usr/sbin/rc wan stop");
		sleep(1);
		free(data);
		myPipe("/bin/ps",&data);
	}
	free(data);

}

int pppoe_test(void)
{
	char *data;
	int i;	
	
	for(i=0;i<3;i++)
	{
	myPipe("/usr/sbin/pppoe -d -I nas0",&data);
	if(strchr(data,':')){
        	free(data);
        	return WIZARD_OK;
              	}
	free(data);
	sleep(1);
	}
	return WIZARD_ERR;
}

int pppoa_test(int encap)
{
	char cmd[256];
	char *data;
	sprintf(cmd,"/usr/sbin/pppd plugin pppoa %d.%d user a password a nodetach %s qos UBR >/tmp/pppoa&",vpi,vci,encap==1?"vc-encaps":"llc-encaps");
	system(cmd);
	sleep(6);
	system("/usr/bin/killall pppd");
	myPipe("/bin/cat /tmp/pppoa",&data);			
	if(strstr(data,"CHAP authentication") || strstr(data,"remote ip") || strstr(data,"PAP authentication")){
		free(data);
		return WIZARD_OK;
	}else{
		free(data);
		return WIZARD_ERR;
	}
	
}

int default_test(char *country)
{
	int i=0;
	while(adsl_setting[i].country!=NULL){
		if(strcasecmp(adsl_setting[i].country,country)==0){
			vpi=adsl_setting[i].vpi;
			vci=adsl_setting[i].vci;
			return method_detect();
					
		}
		i++;
	}
	return WIZARD_ERR;
}

int dhcp_test(void)
{
	unlink("/tmp/wan_uptime");
	system("/usr/sbin/udhcpc -i nas0 -s /etc/udhcpc.wizard.script&");
	sleep(1);
	system("/usr/bin/killall udhcpc");
	if(access("/tmp/wan_uptime",F_OK)==0)
		return WIZARD_OK;
	else
		return WIZARD_ERR;
}
int ipoa_test(void)
{
	char cmd[128];
	int i=3;
	unlink("/tmp/ipoa_server");
	system("/usr/sbin/atmarpd -b");
	usleep(10);
	system("/usr/sbin/atmarp -c atm0");
	usleep(10);
	system("/sbin/ifconfig atm0 1.1.1.100 up");
	usleep(10);
	while(i-- && access("/tmp/ipoa_server",F_OK)!=0){
		sprintf(cmd,"/usr/sbin/atmarp -s 1.1.1.%d 0.%d.%d",i,vpi,vci);
		system(cmd);
		sleep(1);
	}
	system("/sbin/ifconfig atm0 0.0.0.0 down");
	system("/usr/bin/killall atmarpd");
	
	if(access("/tmp/ipoa_server",F_OK)==0)
		return WIZARD_OK;
	else
		return WIZARD_ERR;
}

int pvc_detect(void)
{
	int i=0,j=0;
	char cmd[128];
	FILE *fp;
	FILE *output;

	if((output=fopen("/proc/sys/dev/dslmod","w"))==NULL)
		return WIZARD_ERR;	

	/* Joel Note: clean /proc/avalanche/avsar_pvc_table */
	fprintf(output, "e0p32cd6000t");
	fflush(output);
	usleep(2);

	for(i=VPI_S;i<=VPI_E;i++){
		for(j=VCI_S;j<=VCI_E;j++){
			fprintf(output, "e%dp%dc", i, j);
			fflush(output);
			usleep(500);
		}
		
		fp=fopen("/proc/avalanche/avsar_pvc_table","r");	
		fgets(cmd,128,fp);
		fclose(fp);
		sscanf(cmd, "%d,%d", &vpi, &vci);

		if(vci!=0){
	       		if(vci<=VCI_E){
				printf("vpi=%d vci=%d\n", vpi, vci);
				fclose(output);
				return WIZARD_OK;
			}
			/* Joel Note: clean /proc/avalanche/avsar_pvc_table */
			fprintf(output, "e0p32cd6000t");
			fflush(output);
		}
		printf("%d %d\n", i, j);
	}
	fclose(output);
	return WIZARD_ERR;
}

int method_detect(void)
{
	char cmd[128];
	for(encap=0;encap<=1;encap++){
		/* start br2684ctl */
		sprintf(cmd,"/usr/sbin/br2684ctl -b -c 0 -e %d -t UBR -a 0.%d.%d"
				,encap,vpi,vci);
		system(cmd);
		
		/* test pppoe */
		if(pppoe_test()==WIZARD_OK){
			strcpy(wan_mode,"pppoe");
			break;
		}
		/* test dhcp  */
		if(dhcp_test()==WIZARD_OK){
			strcpy(wan_mode,"dhcp");
			break;
		}
		/* stop wan */
		wan_stop();
		
		/* test pppoa */
		if(pppoa_test(encap)==WIZARD_OK){
			strcpy(wan_mode,"pppoa");
			break;
		}
			
		/* stop wan */
		wan_stop();
	}
			
	if(encap==2 && ipoa_test()==WIZARD_OK){
		encap=0;
		strcpy(wan_mode,"ipoa");
	}
	
	return (encap!=2)?WIZARD_OK:WIZARD_ERR;

}
int main(int argc,char **argv)
{
	FILE *fp;
	
	if(argv[1]==NULL){
		argv[1]=strdup("uk");
	}
	
	unlink("/tmp/wizard.out");	
	/* stop wan */
	wan_stop();
	
	if(strcmp(argv[1],"autopvc")==0){
		char cmd[128];
		pvc_detect();
		sprintf(cmd,"/bin/echo \"%d %d\"> /tmp/auto_pvc",vpi,vci);
		system(cmd);
		return 0;
	}
	
	if(strcmp(argv[1],"method")==0){
		FILE *fp;
		vpi=atoi(argv[2]);
		vci=atoi(argv[3]);
		method_detect();
		fp=fopen("/tmp/method","w");
		fprintf(fp,"%s",wan_mode);
		fclose(fp);
		return 0;
	}	

	/* start test */
	if(default_test(argv[1])==WIZARD_ERR){
		if(pvc_detect()==WIZARD_OK){
			method_detect();
		}
	}
	
	/* stop wan */
	wan_stop();
	
	/* write output */
	fp=fopen("/tmp/wizard.out","w");
	fprintf(fp,"%d\n%d\n%d\n%s\n",encap,vpi,vci,wan_mode);
	fclose(fp);
	return WIZARD_OK;
}
